// -------------------------------------------------------------------------------
// 
// 		cwCu		eawff[^ǂݍ݃vO
// 
// 				Ver 3.13b
// 
// -------------------------------------------------------------------------------

#define __DX_MAKE

#include "DxModelRead.h"

#ifndef DX_NON_MODEL
#ifdef DX_LOAD_FBX_MODEL

// CN[h ---------------------------------
#include "DxLog.h"
#include "Windows/DxGuid.h"

#include "fbxsdk.h"

#ifdef DX_USE_NAMESPACE

namespace DxLib
{

#endif // DX_USE_NAMESPACE

// }N` -----------------------------------

// f[^錾 -----------------------------------

// eawf[^\
struct FBX_MODEL
{
	FbxManager					*pManager ;
	FbxIOSettings				*pIOSettings ;
	FbxImporter					*pImporter ;
	FbxScene					*pScene ;
	FbxNode						*pNode ;
} ;

// ֐錾 -------------------------------------

static int AnalyseFbx( MV1_MODEL_R *RModel, FBX_MODEL *Model ) ;														// FBXt@C̉( 0:  -1:s )
static int AnalyseFbxNode( MV1_MODEL_R *RModel, FBX_MODEL *Model, MV1_FRAME_R *ParentFrame, FbxNode *pFbxNode ) ;		// m[h̉( -1:G[ )
static int GetFbxAnimInfo( MV1_MODEL_R *RModel, FBX_MODEL *Model, MV1_FRAME_R *Frame, MV1_ANIMSET_R *AnimSet, MV1_ANIM_R **Anim, int DataType, FbxAnimCurve *FbxCurve, bool Reverse = false, bool DeggToRad = false ) ;	// eawJ[uAj[V擾( -1:G[ )
static MV1_TEXTURE_R *FbxAddTexture( MV1_MODEL_R *RModel, FbxTexture *_FbxTexture ) ;				// eaweNX`ǉ

// vO -----------------------------------

// eaweNX`ǉ
static MV1_TEXTURE_R *FbxAddTexture( MV1_MODEL_R *RModel, FbxTexture *_FbxTexture )
{
	MV1_TEXTURE_R *Texture ;
	FbxFileTexture *pFbxFileTexture ;
	FbxProceduralTexture *pProceduralTexture ;
	int i ;

	pFbxFileTexture = FbxCast< FbxFileTexture >( _FbxTexture ) ;
	pProceduralTexture = FbxCast< FbxProceduralTexture >( _FbxTexture ) ;

	// t@CeNX`ł͂Ȃꍇ̓G[
	if( pFbxFileTexture == NULL )
		return NULL ;

	// fɊɂ̃eNX`̏񂪂ꍇ̓AhXۑ
	Texture = RModel->TextureFirst ;
	for( i = 0 ; i < ( int )RModel->TextureNum && Texture->UserData != _FbxTexture ; i ++, Texture = Texture->DataNext ){}
	if( i != RModel->TextureNum )
		return Texture ;

	// eNX`̒ǉ
	Texture = MV1RAddTexture( RModel, _FbxTexture->GetName(), pFbxFileTexture->GetRelativeFileName(), NULL, FALSE, 0.1f, false ) ;
	if( Texture == NULL )
		return NULL ;

	// eaw̃AhXۑ
	Texture->UserData = _FbxTexture ;

	// bv[hۑ
	Texture->AddressModeU = _FbxTexture->GetWrapModeU() == FbxTexture::eRepeat ? DX_TEXADDRESS_WRAP : DX_TEXADDRESS_CLAMP ;
	Texture->AddressModeV = _FbxTexture->GetWrapModeV() == FbxTexture::eRepeat ? DX_TEXADDRESS_WRAP : DX_TEXADDRESS_CLAMP ;

	// tuXP[ۑ
	Texture->ScaleU = ( float )_FbxTexture->GetScaleU() ;
	Texture->ScaleV = ( float )_FbxTexture->GetScaleV() ;

	// AhXԂ
	return Texture ;
}

// eawJ[uAj[V擾( -1:G[ )
static int GetFbxAnimInfo(
	MV1_MODEL_R *RModel,
	FBX_MODEL *Model,
	MV1_FRAME_R *Frame,
	MV1_ANIMSET_R *AnimSet,
	MV1_ANIM_R **AnimP,
	int DataType,
	FbxAnimCurve *pFbxCurve,
	bool Reverse,
	bool DeggToRad
)
{
	MV1_ANIMKEYSET_R *KeySet ;
	float *KeyLinear ;
	float *KeyTime ;
	MV1_ANIM_R *Anim ;
	float FirstValue ;
	bool AllFirstValue ;
	int i, KeyNum ;

	// J[u NULL 牽Ȃ
	if( pFbxCurve == NULL ) return 0 ;

	// L[牽Ȃ
	KeyNum = pFbxCurve->KeyGetCount() ;
	if( KeyNum == 0 )
		return 0 ;

	// Aj[V܂ǉĂȂꍇ͒ǉ
	if( *AnimP == NULL )
	{
		*AnimP = MV1RAddAnim( RModel, AnimSet ) ;
		if( *AnimP == NULL )
		{
			DXST_ERRORLOGFMT_ADD( ( _T( "Fbx Load : Aj[VIuWFNg̒ǉɎs܂\n" ) ) ) ;
			return -1 ;
		}
	}
	Anim = *AnimP ;

	// L[Zbg̒ǉ
	KeySet = MV1RAddAnimKeySet( RModel, Anim ) ;
	if( KeySet == NULL )
	{
		DXST_ERRORLOGFMT_ADD( ( _T( "Fbx Load : Aj[VL[ZbgIuWFNg̒ǉɎs܂\n" ) ) ) ;
		return -1 ;
	}

	// f[^^CvZbg
	KeySet->DataType = DataType ;

	// L[^Cv͂Ƃ肠`
	KeySet->Type = MV1_ANIMKEY_TYPE_LINEAR ;

	// L[i[邽߂̃̈m
	KeySet->KeyLinear = ( float * )ADDMEMAREA( ( sizeof( float ) + sizeof( float ) ) * KeyNum, &RModel->Mem ) ;
	if( KeySet->KeyLinear == NULL )
	{
		DXST_ERRORLOGFMT_ADD( ( _T( "Fbx Load : Aj[VL[i[邽߂̃̊mۂɎs܂\n" ) ) ) ;
		return -1 ;
	}
	KeySet->KeyTime = ( float * )( KeySet->KeyLinear + KeyNum ) ;

	// ŏ̃L[̒l擾
	AllFirstValue = true ;
	FirstValue = static_cast< float >( pFbxCurve->KeyGetValue( 0 ) ) ;
	if( Reverse   ) FirstValue = -FirstValue ;
	if( DeggToRad ) FirstValue =  FirstValue * DX_PI_F / 180.0f ;

	// L[̐JԂ
	KeyLinear = KeySet->KeyLinear ;
	KeyTime = KeySet->KeyTime ;
	KeySet->TotalTime = 0.0f ;
	for( i = 0 ; i < KeyNum ; i ++ )
	{
		// Ԃ̎擾
		*KeyTime = ( float )pFbxCurve->KeyGetTime( i ).GetFrameCount() ;
		if( KeySet->TotalTime < *KeyTime ) KeySet->TotalTime = *KeyTime ;
		if( *KeyTime < AnimSet->StartTime ) AnimSet->StartTime = *KeyTime ;
		if( *KeyTime > AnimSet->EndTime   ) AnimSet->EndTime   = *KeyTime ;

		// l̎擾
		*KeyLinear = static_cast< float >( pFbxCurve->KeyGetValue( i ) ) ;
		if( Reverse ) *KeyLinear = -*KeyLinear ;
		if( DeggToRad ) *KeyLinear = *KeyLinear * DX_PI_F / 180.0f ;

		// ŏ̃p[^Ɠr
		if( AllFirstValue && FirstValue != *KeyLinear )
			AllFirstValue = false ;

		// ȏ㓯L[Ăꍇ͓
		if( KeySet->Num >= 2 &&
			KeyLinear[ -2 ] == KeyLinear[ -1 ] &&
			KeyLinear[ -1 ] == KeyLinear[  0 ] )
		{
			KeyTime[ -1 ] = KeyTime[ 0 ] ;
		}
		else
		{
			// L[̐Z
			KeySet->Num ++ ;
			KeyLinear ++ ;
			KeyTime ++ ;
		}
	}

	// ŏ̃L[ƑSꍇ̓L[̐Pɂ
	if( AllFirstValue )
	{
		KeySet->Num = 1 ;
	}

	// L[f[^̃TCYZ
	RModel->AnimKeyDataSize += ( sizeof( float ) + sizeof( float ) ) * KeySet->Num ;

	// I
	return 0 ;
}

// m[h̉( -1:G[ )
static int AnalyseFbxNode( MV1_MODEL_R *RModel, FBX_MODEL *Model, MV1_FRAME_R *ParentFrame, FbxNode *pFbxNode )
{
	FbxNode *pFbxChildNode ;
	FbxNodeAttribute *FbxAttr ;
	FbxVector4 *FbxVec ;
	FbxVector4 *FbxShapeVec ;
	FbxMesh *_FbxMesh ;
	FbxLayerElement::EMappingMode FbxMappingMode ;
	FbxLayerElement::EReferenceMode FbxRefMode ;
	FbxBlendShape *_FbxBlendShape ;
	FbxBlendShapeChannel *_FbxBlendShapeChannel ;
	FbxGeometryElementNormal *FbxNormalElem ;
	FbxGeometryElementBinormal *FbxBinormalElem ;
	FbxGeometryElementTangent *FbxTangentElem ;
	FbxGeometryElementVertexColor *FbxVertexColorElem ;
	FbxGeometryElementUV *FbxUVElem ;
	FbxGeometryElementMaterial *FbxMaterialElem ;
	FbxSurfaceMaterial *FbxMaterial, **FbxMaterialDim ;
	FbxSurfaceLambert *FbxLambert ;
	FbxSurfacePhong *FbxPhong ;
	FbxTexture *_FbxTexture ;
	FbxLayeredTexture *_FbxLayeredTexture ;
	FbxSkin *_FbxSkin ;
	FbxShape *_FbxShape ; 
	FbxCluster *_FbxCluster ;
	MV1_FRAME_R *Frame ;
	MV1_MESH_R *Mesh ;
	MV1_MESHFACE_R *MeshFace ;
	MV1_MATERIAL_R *Material ;
	MV1_SKIN_WEIGHT_R *SkinWeight ;
	MV1_SHAPE_R *Shape ;
	MV1_SHAPE_VERTEX_R *ShapeVert ;
	VECTOR *MeshPos ;
	MATRIX ReverseMat ;
	int i, j, k, l, Num, LayerNum, Index, MaterialNum ;

	// FbxNode  NULL gbvm[hZbgAbv
	if( pFbxNode == NULL )
	{
		pFbxNode = Model->pScene->GetRootNode() ;
		Frame = NULL ;
	}
	else
	{
		// t[ǉ
		Frame = MV1RAddFrame( RModel, pFbxNode->GetName(), ParentFrame ) ;
		if( Frame == NULL )
		{
			DXST_ERRORLOGFMT_ADD( ( _T( "Fbx Load : t[IuWFNg̒ǉɎs܂\n" ) ) ) ;
			return -1 ;
		}

		// EWn獶Wnɕϊ邽߂̍s̏
		CreateIdentityMatrix( &ReverseMat ) ;
		ReverseMat.m[ 2 ][ 2 ] = -1.0f ;

		// FBXm[h̃AhXۑ
		Frame->UserData = pFbxNode ;

		// Wϊl̃p[^擾
		{
			FbxVector4 lTmpVector;

			Frame->Translate.x = ( float ) pFbxNode->LclTranslation.Get()[ 0 ] ;
			Frame->Translate.y = ( float ) pFbxNode->LclTranslation.Get()[ 1 ] ;
			Frame->Translate.z = ( float )-pFbxNode->LclTranslation.Get()[ 2 ] ;

			Frame->Scale.x = ( float )pFbxNode->LclScaling.Get()[ 0 ] ;
			Frame->Scale.y = ( float )pFbxNode->LclScaling.Get()[ 1 ] ;
			Frame->Scale.z = ( float )pFbxNode->LclScaling.Get()[ 2 ] ;

			Frame->Rotate.x = ( float )( -pFbxNode->LclRotation.Get()[ 0 ] * DX_PI / 180.0f ) ;
			Frame->Rotate.y = ( float )( -pFbxNode->LclRotation.Get()[ 1 ] * DX_PI / 180.0f ) ;
			Frame->Rotate.z = ( float )(  pFbxNode->LclRotation.Get()[ 2 ] * DX_PI / 180.0f ) ;

			Frame->RotateOrder = ( int )pFbxNode->RotationOrder.Get() ;

			lTmpVector = pFbxNode->GetPreRotation( FbxNode::eSourcePivot ) ;
			Frame->PreRotate.x = ( float )lTmpVector[ 0 ] ;
			Frame->PreRotate.y = ( float )lTmpVector[ 1 ] ;
			Frame->PreRotate.z = ( float )lTmpVector[ 2 ] ;
			if( *( ( DWORD * )&Frame->PreRotate.x ) != 0 || 
				*( ( DWORD * )&Frame->PreRotate.y ) != 0 ||
				*( ( DWORD * )&Frame->PreRotate.z ) != 0 )
			{
				Frame->PreRotate.x = -Frame->PreRotate.x * DX_PI_F / 180.0f ;
				Frame->PreRotate.y = -Frame->PreRotate.y * DX_PI_F / 180.0f ;
				Frame->PreRotate.z =  Frame->PreRotate.z * DX_PI_F / 180.0f ;
				Frame->EnablePreRotate = 1 ;
			}

			lTmpVector = pFbxNode->GetPostRotation( FbxNode::eSourcePivot ) ;
			Frame->PostRotate.x = ( float )lTmpVector[ 0 ] ;
			Frame->PostRotate.y = ( float )lTmpVector[ 1 ] ;
			Frame->PostRotate.z = ( float )lTmpVector[ 2 ] ;
			if( *( ( DWORD * )&Frame->PostRotate.x ) != 0 || 
				*( ( DWORD * )&Frame->PostRotate.y ) != 0 ||
				*( ( DWORD * )&Frame->PostRotate.z ) != 0 )
			{
				Frame->PostRotate.x = -Frame->PostRotate.x * DX_PI_F / 180.0f ;
				Frame->PostRotate.y = -Frame->PostRotate.y * DX_PI_F / 180.0f ;
				Frame->PostRotate.z =  Frame->PostRotate.z * DX_PI_F / 180.0f ;
				Frame->EnablePostRotate = 1 ;
			}
		}

		// Agr[g擾
		FbxAttr = pFbxNode->GetNodeAttribute() ;
		if( FbxAttr )
		{
			// bVm[h̏ꍇ̓bV擾
			if( FbxAttr->GetAttributeType() == FbxNodeAttribute::eMesh )
			{
				// bVǉ
				Mesh = MV1RAddMesh( RModel, Frame ) ;
				if( Mesh == NULL )
				{
					DXST_ERRORLOGFMT_ADD( ( _T( "Fbx Load : bVIuWFNg̒ǉɎs܂\n" ) ) ) ;
					return -1 ;
				}

				// bṼAhX擾
				_FbxMesh = ( FbxMesh * )FbxAttr ;

				// C[̐擾
				LayerNum = _FbxMesh->GetLayerCount() ;

				// ʂ̏擾
				{
					// ʏi[郁̈̊m
					if( MV1RSetupMeshFaceBuffer( RModel, Mesh, _FbxMesh->GetPolygonCount(), 4 ) < 0 )
					{
						DXST_ERRORLOGFMT_ADD( ( _T( "Fbx Load : ʏi[郁̊mۂɎs܂\n" ) ) ) ;
						return -1 ;
					}

					// ʂ̏擾
					MeshFace = Mesh->Faces ;
					for( i = 0 ; i < ( int )Mesh->FaceNum ; i ++, MeshFace ++ )
					{
						// CfbNX̐擾
						MeshFace->IndexNum = _FbxMesh->GetPolygonSize( i ) ;
						if( Mesh->FaceUnitMaxIndexNum < MeshFace->IndexNum )
						{
							if( MV1RSetupMeshFaceBuffer( RModel, Mesh, Mesh->FaceNum, MeshFace->IndexNum ) < 0 )
							{
								DXST_ERRORLOGFMT_ADD( ( _T( "Fbx Load : ʏi[郁̍ĊmۂɎs܂\n" ) ) ) ;
								return -1 ;
							}
							MeshFace = Mesh->Faces + i ;
						}

						// CfbNX擾
						for( j = 0 ; j < ( int )MeshFace->IndexNum ; j ++ )
						{
							MeshFace->VertexIndex[ j ] = _FbxMesh->GetPolygonVertex( i, j ) ;
						}
					}
				}

				// _W̏擾
				{
					// W̐擾
					Mesh->PositionNum = _FbxMesh->GetControlPointsCount() ;

					// Wi[郁̈̊m
					Mesh->Positions = ( VECTOR * )ADDMEMAREA( sizeof( VECTOR ) * Mesh->PositionNum, &RModel->Mem ) ;
					if( Mesh->Positions == NULL )
					{
						DXST_ERRORLOGFMT_ADD( ( _T( "Fbx Load : _Wi[郁̊mۂɎs܂\n" ) ) ) ;
						return -1 ;
					}

					// W̏擾
					MeshPos = Mesh->Positions ;
					FbxVec = _FbxMesh->GetControlPoints() ;
					for( i = 0 ; i < ( int )Mesh->PositionNum ; i ++, FbxVec ++, MeshPos ++ )
					{
						MeshPos->x = ( float ) FbxVec->mData[ 0 ] ;
						MeshPos->y = ( float ) FbxVec->mData[ 1 ] ;
						MeshPos->z = ( float )-FbxVec->mData[ 2 ] ;
					}
				}

				// @̏擾
				{

					// @Gg̐JԂ
					for( i = 0 ; i < _FbxMesh->GetElementNormalCount() ; i ++ )
					{
			            FbxNormalElem = _FbxMesh->GetElementNormal( i ) ;

						// [h̎擾
						FbxRefMode     = FbxNormalElem->GetReferenceMode() ;
						FbxMappingMode = FbxNormalElem->GetMappingMode() ;

						switch( FbxRefMode )
						{
						case FbxGeometryElement::eDirect :
							// @̐擾
							Mesh->NormalNum = FbxNormalElem->GetDirectArray().GetCount() ;

							// @i[郁̈̊m
							Mesh->Normals = ( VECTOR * )ADDMEMAREA( sizeof( VECTOR ) * Mesh->NormalNum, &RModel->Mem ) ;
							if( Mesh->Normals == NULL )
							{
								DXST_ERRORLOGFMT_ADD( ( _T( "Fbx Load : @i[郁̊mۂɎs܂\n" ) ) ) ;
								return -1 ;
							}

							// ڃ[h̏ꍇ͂̂܂ܑ
							for( j = 0 ; ( DWORD )j < Mesh->NormalNum ; j ++ )
							{
								Mesh->Normals[ j ].x = ( float ) FbxNormalElem->GetDirectArray().GetAt( j )[ 0 ] ;
								Mesh->Normals[ j ].y = ( float ) FbxNormalElem->GetDirectArray().GetAt( j )[ 1 ] ;
								Mesh->Normals[ j ].z = ( float )-FbxNormalElem->GetDirectArray().GetAt( j )[ 2 ] ;
							}
							break ;

						case FbxGeometryElement::eIndexToDirect :
							// CfbNX̐擾
							Mesh->NormalNum = FbxNormalElem->GetIndexArray().GetCount() ;

							// @i[郁̈̊m
							Mesh->Normals = ( VECTOR * )ADDMEMAREA( sizeof( VECTOR ) * Mesh->NormalNum, &RModel->Mem ) ;
							if( Mesh->Normals == NULL )
							{
								DXST_ERRORLOGFMT_ADD( ( _T( "Fbx Load : @i[郁̊mۂɎs܂\n" ) ) ) ;
								return -1 ;
							}

							// CfbNX[h̏ꍇ͊ԐڎQƑ
							for( j = 0 ; ( DWORD )j < Mesh->NormalNum ; j ++ )
							{
								Index = FbxNormalElem->GetIndexArray().GetAt( j ) ;
								Mesh->Normals[ j ].x = ( float ) FbxNormalElem->GetDirectArray().GetAt( Index )[ 0 ] ;
								Mesh->Normals[ j ].y = ( float ) FbxNormalElem->GetDirectArray().GetAt( Index )[ 1 ] ;
								Mesh->Normals[ j ].z = ( float )-FbxNormalElem->GetDirectArray().GetAt( Index )[ 2 ] ;
							}
							break ;

						default :
							DXST_ERRORLOGFMT_ADD( ( _T( "Fbx Load : Ή̖@t@X[hgpĂ܂\n" ) ) ) ;
							return -1 ;
						}

						// ʂ̊e_ɑΉ@̏擾
						switch( FbxMappingMode )
						{
						case FbxGeometryElement::eByControlPoint :
							// @CfbNX͒_CfbNXƓȂ
							MeshFace = Mesh->Faces ;
							for( j = 0 ; ( DWORD )j < Mesh->FaceNum ; j ++, MeshFace ++ )
							{
								MeshFace->NormalIndex[ 0 ] = MeshFace->VertexIndex[ 0 ] ;
								MeshFace->NormalIndex[ 1 ] = MeshFace->VertexIndex[ 1 ] ;
								MeshFace->NormalIndex[ 2 ] = MeshFace->VertexIndex[ 2 ] ;
								MeshFace->NormalIndex[ 3 ] = MeshFace->VertexIndex[ 3 ] ;
							}
							break ;

						case FbxGeometryElement::eByPolygonVertex :
							// @CfbNX͕ʌő݂
							MeshFace = Mesh->Faces ;
							k = 0 ;
							for( j = 0 ; ( DWORD )j < Mesh->FaceNum ; j ++, MeshFace ++ )
							{
								for( l = 0 ; ( DWORD )l < MeshFace->IndexNum ; l ++ )
								{
									MeshFace->NormalIndex[ l ] = k ;
									k ++ ;

									// @̐ȂoOf[^̑Ή
									if( k == Mesh->NormalNum )
									{
										k = 0 ;
									}
								}
							}
							break ;

						default :
							DXST_ERRORLOGFMT_ADD( ( _T( "Fbx Load : Ή̖@}bsO[hgpĂ܂\n" ) ) ) ;
							return -1 ;
						}
					}

					// ]@Gg̐JԂ
					for( i = 0 ; i < _FbxMesh->GetElementBinormalCount() ; i ++ )
					{
			            FbxBinormalElem = _FbxMesh->GetElementBinormal( i ) ;

						// [h̎擾
						FbxRefMode     = FbxBinormalElem->GetReferenceMode() ;
						FbxMappingMode = FbxBinormalElem->GetMappingMode() ;

						switch( FbxRefMode )
						{
						case FbxGeometryElement::eDirect :
							// ]@̐@̐ƈقȂĂ疳
							if( Mesh->NormalNum != FbxBinormalElem->GetDirectArray().GetCount() )
							{
								continue ;
							}

							// ]@i[郁̈̊m
							Mesh->Binormals = ( VECTOR * )ADDMEMAREA( sizeof( VECTOR ) * Mesh->NormalNum, &RModel->Mem ) ;
							if( Mesh->Binormals == NULL )
							{
								DXST_ERRORLOGFMT_ADD( ( _T( "Fbx Load : ]@i[郁̊mۂɎs܂\n" ) ) ) ;
								return -1 ;
							}

							// ڃ[h̏ꍇ͂̂܂ܑ
							for( j = 0 ; ( DWORD )j < Mesh->NormalNum ; j ++ )
							{
								Mesh->Binormals[ j ].x = ( float ) FbxBinormalElem->GetDirectArray().GetAt( j )[ 0 ] ;
								Mesh->Binormals[ j ].y = ( float ) FbxBinormalElem->GetDirectArray().GetAt( j )[ 1 ] ;
								Mesh->Binormals[ j ].z = ( float )-FbxBinormalElem->GetDirectArray().GetAt( j )[ 2 ] ;
							}
							break ;

						case FbxGeometryElement::eIndexToDirect :
							// CfbNX̐@̐ƈقȂĂ疳
							if( Mesh->NormalNum != FbxBinormalElem->GetIndexArray().GetCount() )
							{
								continue ;
							}

							// ]@i[郁̈̊m
							Mesh->Binormals = ( VECTOR * )ADDMEMAREA( sizeof( VECTOR ) * Mesh->NormalNum, &RModel->Mem ) ;
							if( Mesh->Binormals == NULL )
							{
								DXST_ERRORLOGFMT_ADD( ( _T( "Fbx Load : ]@i[郁̊mۂɎs܂\n" ) ) ) ;
								return -1 ;
							}

							// CfbNX[h̏ꍇ͊ԐڎQƑ
							for( j = 0 ; ( DWORD )j < Mesh->NormalNum ; j ++ )
							{
								Index = FbxBinormalElem->GetIndexArray().GetAt( j ) ;
								Mesh->Binormals[ j ].x = ( float ) FbxBinormalElem->GetDirectArray().GetAt( Index )[ 0 ] ;
								Mesh->Binormals[ j ].y = ( float ) FbxBinormalElem->GetDirectArray().GetAt( Index )[ 1 ] ;
								Mesh->Binormals[ j ].z = ( float )-FbxBinormalElem->GetDirectArray().GetAt( Index )[ 2 ] ;
							}
							break ;

						default :
							DXST_ERRORLOGFMT_ADD( ( _T( "Fbx Load : Ή̏]@t@X[hgpĂ܂\n" ) ) ) ;
							return -1 ;
						}
					}

					// ڐGg̐JԂ
					for( i = 0 ; i < _FbxMesh->GetElementTangentCount() ; i ++ )
					{
			            FbxTangentElem = _FbxMesh->GetElementTangent( i ) ;

						// [h̎擾
						FbxRefMode     = FbxTangentElem->GetReferenceMode() ;
						FbxMappingMode = FbxTangentElem->GetMappingMode() ;

						switch( FbxRefMode )
						{
						case FbxGeometryElement::eDirect :
							// ڐ̐@̐ƈقȂĂ疳
							if( Mesh->NormalNum != FbxTangentElem->GetDirectArray().GetCount() )
							{
								continue ;
							}

							// ڐi[郁̈̊m
							Mesh->Tangents = ( VECTOR * )ADDMEMAREA( sizeof( VECTOR ) * Mesh->NormalNum, &RModel->Mem ) ;
							if( Mesh->Tangents == NULL )
							{
								DXST_ERRORLOGFMT_ADD( ( _T( "Fbx Load : ڐi[郁̊mۂɎs܂\n" ) ) ) ;
								return -1 ;
							}

							// ڃ[h̏ꍇ͂̂܂ܑ
							for( j = 0 ; ( DWORD )j < Mesh->NormalNum ; j ++ )
							{
								Mesh->Tangents[ j ].x = ( float ) FbxTangentElem->GetDirectArray().GetAt( j )[ 0 ] ;
								Mesh->Tangents[ j ].y = ( float ) FbxTangentElem->GetDirectArray().GetAt( j )[ 1 ] ;
								Mesh->Tangents[ j ].z = ( float )-FbxTangentElem->GetDirectArray().GetAt( j )[ 2 ] ;
							}
							break ;

						case FbxGeometryElement::eIndexToDirect :
							// CfbNX̐@̐ƈقȂĂ疳
							if( Mesh->NormalNum != FbxTangentElem->GetIndexArray().GetCount() )
							{
								continue ;
							}

							// ڐi[郁̈̊m
							Mesh->Tangents = ( VECTOR * )ADDMEMAREA( sizeof( VECTOR ) * Mesh->NormalNum, &RModel->Mem ) ;
							if( Mesh->Tangents == NULL )
							{
								DXST_ERRORLOGFMT_ADD( ( _T( "Fbx Load : ڐi[郁̊mۂɎs܂\n" ) ) ) ;
								return -1 ;
							}

							// CfbNX[h̏ꍇ͊ԐڎQƑ
							for( j = 0 ; ( DWORD )j < Mesh->NormalNum ; j ++ )
							{
								Index = FbxTangentElem->GetIndexArray().GetAt( j ) ;
								Mesh->Tangents[ j ].x = ( float ) FbxTangentElem->GetDirectArray().GetAt( Index )[ 0 ] ;
								Mesh->Tangents[ j ].y = ( float ) FbxTangentElem->GetDirectArray().GetAt( Index )[ 1 ] ;
								Mesh->Tangents[ j ].z = ( float )-FbxTangentElem->GetDirectArray().GetAt( Index )[ 2 ] ;
							}
							break ;

						default :
							DXST_ERRORLOGFMT_ADD( ( _T( "Fbx Load : Ή̐ڐt@X[hgpĂ܂\n" ) ) ) ;
							return -1 ;
						}
					}
				}

				// _J[̏擾
				{
					// _J[Gg̐JԂ
					for( i = 0 ; i < _FbxMesh->GetElementVertexColorCount() ; i ++ )
					{
						FbxVertexColorElem = _FbxMesh->GetElementVertexColor( i ) ;

						// [h̎擾
						FbxMappingMode = FbxVertexColorElem->GetMappingMode() ;
						FbxRefMode = FbxVertexColorElem->GetReferenceMode() ;

						// _J[̎擾
						switch( FbxRefMode )
						{
						case FbxGeometryElement::eDirect :
							// _J[̐擾
							Mesh->VertexColorNum = FbxVertexColorElem->GetDirectArray().GetCount() ;

							// _J[i[郁̈̊m
							Mesh->VertexColors = ( COLOR_F * )ADDMEMAREA( sizeof( COLOR_F ) * Mesh->VertexColorNum, &RModel->Mem ) ;
							if( Mesh->VertexColors == NULL )
							{
								DXST_ERRORLOGFMT_ADD( ( _T( "Fbx Load : _J[i[郁̊mۂɎs܂\n" ) ) ) ;
								return -1 ;
							}

							// ڃ[h̏ꍇ͂̂܂ܑ
							for( j = 0 ; ( DWORD )j < Mesh->VertexColorNum ; j ++ )
							{
								Mesh->VertexColors[ j ].r = ( float )FbxVertexColorElem->GetDirectArray().GetAt( j ).mRed ;
								Mesh->VertexColors[ j ].g = ( float )FbxVertexColorElem->GetDirectArray().GetAt( j ).mGreen ;
								Mesh->VertexColors[ j ].b = ( float )FbxVertexColorElem->GetDirectArray().GetAt( j ).mBlue ;
								Mesh->VertexColors[ j ].a = ( float )FbxVertexColorElem->GetDirectArray().GetAt( j ).mAlpha ;
							}
							break ;

						case FbxGeometryElement::eIndexToDirect :
							// CfbNX̐擾
							Mesh->VertexColorNum = FbxVertexColorElem->GetIndexArray().GetCount() ;

							// _J[i[郁̈̊m
							Mesh->VertexColors = ( COLOR_F * )ADDMEMAREA( sizeof( COLOR_F ) * Mesh->VertexColorNum, &RModel->Mem ) ;
							if( Mesh->VertexColors == NULL )
							{
								DXST_ERRORLOGFMT_ADD( ( _T( "Fbx Load : _J[i[郁̊mۂɎs܂\n" ) ) ) ;
								return -1 ;
							}

							// CfbNX[h̏ꍇ͊ԐڎQƑ
							for( j = 0 ; ( DWORD )j < Mesh->VertexColorNum ; j ++ )
							{
								Index = FbxVertexColorElem->GetIndexArray().GetAt( j ) ;
								Mesh->VertexColors[ j ].r = ( float )FbxVertexColorElem->GetDirectArray().GetAt( Index ).mRed ;
								Mesh->VertexColors[ j ].g = ( float )FbxVertexColorElem->GetDirectArray().GetAt( Index ).mGreen ;
								Mesh->VertexColors[ j ].b = ( float )FbxVertexColorElem->GetDirectArray().GetAt( Index ).mBlue ;
								Mesh->VertexColors[ j ].a = ( float )FbxVertexColorElem->GetDirectArray().GetAt( Index ).mAlpha ;
							}
							break ;

						default :
							DXST_ERRORLOGFMT_ADD( ( _T( "Fbx Load : Ή̒_J[t@X[hgpĂ܂\n" ) ) ) ;
							return -1 ;
						}

						// ʂ̊e_ɑΉ钸_J[̏擾
						switch( FbxMappingMode )
						{
						case FbxGeometryElement::eByControlPoint :
							// _J[CfbNX͒_CfbNXƓȂ
							MeshFace = Mesh->Faces ;
							for( j = 0 ; ( DWORD )j < Mesh->FaceNum ; j ++, MeshFace ++ )
							{
								MeshFace->VertexColorIndex[ 0 ] = MeshFace->VertexIndex[ 0 ] ;
								MeshFace->VertexColorIndex[ 1 ] = MeshFace->VertexIndex[ 1 ] ;
								MeshFace->VertexColorIndex[ 2 ] = MeshFace->VertexIndex[ 2 ] ;
								MeshFace->VertexColorIndex[ 3 ] = MeshFace->VertexIndex[ 3 ] ;
							}
							break ;

						case FbxGeometryElement::eByPolygonVertex :
							// _J[CfbNX͕ʌő݂
							MeshFace = Mesh->Faces ;
							k = 0 ;
							for( j = 0 ; ( DWORD )j < Mesh->FaceNum ; j ++, MeshFace ++ )
							{
								for( l = 0 ; ( DWORD )l < MeshFace->IndexNum ; l ++, k ++ )
									MeshFace->VertexColorIndex[ l ] = k ;
							}
							break ;

						default :
							DXST_ERRORLOGFMT_ADD( ( _T( "Fbx Load : Ή̒_J[}bsO[hgpĂ܂\n" ) ) ) ;
							return -1 ;
						}
					}
				}

				// tȕ擾
				{
					// tuGg̐JԂ
					for( i = 0 ; i < _FbxMesh->GetElementUVCount() ; i ++ )
					{
						FbxUVElem = _FbxMesh->GetElementUV( i ) ;

						// [h̎擾
						FbxMappingMode = FbxUVElem->GetMappingMode() ;
						FbxRefMode = FbxUVElem->GetReferenceMode() ;

						// tuZbgۑ
						Mesh->UVSetName[ i ] = FbxUVElem->GetName() ;

						// tu̎擾
						switch( FbxRefMode )
						{
						case FbxGeometryElement::eDirect :
							// tu̐擾
							Mesh->UVNum[ i ] = FbxUVElem->GetDirectArray().GetCount() ;

							// tui[郁̈̊m
							Mesh->UVs[ i ] = ( FLOAT4 * )ADDMEMAREA( sizeof( FLOAT4 ) * Mesh->UVNum[ i ], &RModel->Mem ) ;
							if( Mesh->UVs[ i ] == NULL )
							{
								DXST_ERRORLOGFMT_ADD( ( _T( "Fbx Load : UVWi[郁̊mۂɎs܂\n" ) ) ) ;
								return -1 ;
							}

							// ڃ[h̏ꍇ͂̂܂ܑ
							for( j = 0 ; ( DWORD )j < Mesh->UVNum[ i ] ; j ++ )
							{
								Mesh->UVs[ i ][ j ].x = ( float )FbxUVElem->GetDirectArray().GetAt( j )[ 0 ] ;
								Mesh->UVs[ i ][ j ].y = 1.0f - ( float )FbxUVElem->GetDirectArray().GetAt( j )[ 1 ] ;
							}
							break ;

						case FbxGeometryElement::eIndexToDirect :
							// CfbNX̐擾
							Mesh->UVNum[ i ] = FbxUVElem->GetIndexArray().GetCount() ;

							// tui[郁̈̊m
							Mesh->UVs[ i ] = ( FLOAT4 * )ADDMEMAREA( sizeof( FLOAT4 ) * Mesh->UVNum[ i ], &RModel->Mem ) ;
							if( Mesh->UVs[ i ] == NULL )
							{
								DXST_ERRORLOGFMT_ADD( ( _T( "Fbx Load : UVWi[郁̊mۂɎs܂\n" ) ) ) ;
								return -1 ;
							}

							// CfbNX[h̏ꍇ͊ԐڎQƑ
							for( j = 0 ; ( DWORD )j < Mesh->UVNum[ i ] ; j ++ )
							{
								Index = FbxUVElem->GetIndexArray().GetAt( j ) ;
								Mesh->UVs[ i ][ j ].x = ( float )FbxUVElem->GetDirectArray().GetAt( Index )[ 0 ] ;
								Mesh->UVs[ i ][ j ].y = 1.0f - ( float )FbxUVElem->GetDirectArray().GetAt( Index )[ 1 ] ;
							}
							break ;

						default :
							DXST_ERRORLOGFMT_ADD( ( _T( "Fbx Load : Ή̂tut@X[hgpĂ܂\n" ) ) ) ;
							return -1 ;
						}

						// ʂ̊e_ɑΉtȕ擾
						switch( FbxMappingMode )
						{
						case FbxGeometryElement::eByControlPoint :
							// tuCfbNX͒_CfbNXƓȂ
							MeshFace = Mesh->Faces ;
							for( j = 0 ; ( DWORD )j < Mesh->FaceNum ; j ++, MeshFace ++ )
							{
								MeshFace->UVIndex[ i ][ 0 ] = MeshFace->VertexIndex[ 0 ] ;
								MeshFace->UVIndex[ i ][ 1 ] = MeshFace->VertexIndex[ 1 ] ;
								MeshFace->UVIndex[ i ][ 2 ] = MeshFace->VertexIndex[ 2 ] ;
								MeshFace->UVIndex[ i ][ 3 ] = MeshFace->VertexIndex[ 3 ] ;
							}
							break ;

						case FbxGeometryElement::eByPolygonVertex :
							// tuCfbNX͕ʌő݂
							MeshFace = Mesh->Faces ;
							k = 0 ;
							for( j = 0 ; ( DWORD )j < Mesh->FaceNum ; j ++, MeshFace ++ )
							{
								for( l = 0 ; ( DWORD )l < MeshFace->IndexNum ; l ++, k ++ )
									MeshFace->UVIndex[ i ][ l ] = k ;
							}
							break ;

						default :
							DXST_ERRORLOGFMT_ADD( ( _T( "Fbx Load : Ή̂tu}bsO[hgpĂ܂\n" ) ) ) ;
							return -1 ;
						}
					}
				}

				// }eȀ擾
				{
					// }eA̐擾
					Mesh->MaterialNum = pFbxNode->GetMaterialCount() ;

					// }eAꍇ̂ݏ
					if( Mesh->MaterialNum != 0 )
					{
						// }eA̐JԂ
						for( i = 0 ; ( DWORD )i < Mesh->MaterialNum ; i ++ )
						{
							// }eÃAhX擾
							FbxMaterial = pFbxNode->GetMaterial( i ) ;

							// fɊɂ̃}eȀ񂪂ꍇ̓AhXۑ
							Material = RModel->MaterialFirst ;
							for( j = 0 ; ( DWORD )j < RModel->MaterialNum && Material->UserData != FbxMaterial ; j ++, Material = Material->DataNext ){}
							if( j != RModel->MaterialNum )
							{
								Mesh->Materials[ i ] = Material ;
							}
							else
							{
								// }eA̒ǉ
								Material = MV1RAddMaterial( RModel, FbxMaterial->GetName() ) ;
								if( Material == NULL )
								{
									DXST_ERRORLOGFMT_ADD( ( _T( "Fbx Load : }eAIuWFNg̒ǉɎs܂\n" ) ) ) ;
									return -1 ;
								}
								Mesh->Materials[ i ] = Material ;

								// eaw̃AhXۑ
								Material->UserData = FbxMaterial ;

								// }eÃ^Cvo[głtHłꍇ͕
								if( FbxMaterial->GetClassId().Is( FbxSurfaceLambert::ClassId ) ||
									FbxMaterial->GetClassId().Is( FbxSurfacePhong::ClassId ) )
								{
									// o[g̏擾
									FbxLambert = ( FbxSurfaceLambert * )FbxMaterial ;

									// {Iȏ擾

									// ArGgJ[
									Material->Ambient.r = ( float )FbxLambert->Ambient.Get()[ 0 ] ;
									Material->Ambient.g = ( float )FbxLambert->Ambient.Get()[ 1 ] ;
									Material->Ambient.b = ( float )FbxLambert->Ambient.Get()[ 2 ] ;
									Material->Ambient.a = 0.0f ;

									// fBt[YJ[
									Material->Diffuse.r = ( float )FbxLambert->Diffuse.Get()[ 0 ] ;
									Material->Diffuse.g = ( float )FbxLambert->Diffuse.Get()[ 1 ] ;
									Material->Diffuse.b = ( float )FbxLambert->Diffuse.Get()[ 2 ] ;
									Material->Diffuse.a = 1.0f ;

									// G~bVuJ[
									Material->Emissive.r = ( float )FbxLambert->Emissive.Get()[ 0 ] ;
									Material->Emissive.g = ( float )FbxLambert->Emissive.Get()[ 1 ] ;
									Material->Emissive.b = ( float )FbxLambert->Emissive.Get()[ 2 ] ;
									Material->Emissive.a = 0.0f ;

									// At@lۑ
	//								Material->Diffuse.a = 1.0f - FbxLambert->TransparencyFactor.Get() ;

									// tH}eȀꍇ̓tH}eȀ擾
									if( FbxMaterial->GetClassId().Is( FbxSurfacePhong::ClassId ) )
									{
										FbxPhong = ( FbxSurfacePhong * )FbxMaterial ;

										// XyLJ[
										Material->Specular.r = ( float )FbxPhong->Specular.Get()[ 0 ] ;
										Material->Specular.g = ( float )FbxPhong->Specular.Get()[ 1 ] ;
										Material->Specular.b = ( float )FbxPhong->Specular.Get()[ 2 ] ;
										Material->Specular.a = 0.0f ;

										// 
	//									Material->Shininess = FbxPhong->Shininess.Get() ;

										// 
	//									Material->Reflection = FbxPhong->ReflectionFactor.Get() ;
										//Material->Power = ( float )FbxPhong->ReflectionFactor.Get() ;
										Material->Power = ( float )FbxPhong->Shininess.Get() ;
									}
								}
								else
								{
									DXST_ERRORLOGFMT_ADD( ( _T( "Fbx Load : Ή̃}eA[hgpĂ܂\n" ) ) ) ;
									return -1 ;
								}

								// gpĂeNX`̏擾
								{
									FbxProperty _FbxProperty ;
									FbxLayeredTexture::EBlendMode BlendMode ;
									int LayeredTexNum, NormalTexNum ;

									// fBt[Y}eAvpeB̎擾
									{
										_FbxProperty = FbxMaterial->FindProperty( FbxSurfaceMaterial::sDiffuse ) ;

										// C[heNX`̏ꍇƂȊOŏ𕪊
										if( _FbxProperty.GetSrcObject< FbxLayeredTexture >( 0 ) != NULL )
										{
											// Qȏ̃C[ɂ͑ΉĂȂ
											if( _FbxProperty.GetSrcObject< FbxLayeredTexture >( 1 ) != NULL )
											{
												DXST_ERRORLOGFMT_ADD( ( _T( "Fbx Load : Diffuse }eA͂PC[ȏɂ͑ΉĂ܂\n" ) ) ) ;
												return -1 ;
											}

											// eNX`̐JԂ
											LayeredTexNum = 1 ;
											for( j = 0 ; j < LayeredTexNum ; j ++ )
											{
												// eNX`̃AhX擾
												_FbxLayeredTexture = _FbxProperty.GetSrcObject< FbxLayeredTexture >( j ) ;

												// C[̒Ɋ܂܂ĂeNX`̐擾
												NormalTexNum = _FbxLayeredTexture->GetSrcObjectCount< FbxTexture >() ;

												// eNX`̐JԂ
												for( k = 0 ; k < NormalTexNum ; k ++ )
												{
													_FbxTexture = _FbxLayeredTexture->GetSrcObject< FbxTexture >( k ) ;
													if( _FbxTexture == NULL ) continue ;

													// fɒǉ
													Material->DiffuseTexs[ Material->DiffuseTexNum ] = FbxAddTexture( RModel, _FbxTexture ) ;
													if( Material->DiffuseTexs[ Material->DiffuseTexNum ] == NULL ) 
													{
														DXST_ERRORLOGFMT_ADD( ( _T( "Fbx Load : Diffuse eNX`IuWFNg̒ǉɎs܂\n" ) ) ) ;
														return -1 ;
													}

													// @擾
													_FbxLayeredTexture->GetTextureBlendMode( k, BlendMode ) ;
													switch( BlendMode )
													{
													case FbxLayeredTexture::eTranslucent : Material->DiffuseTexs[ Material->DiffuseTexNum ]->BlendType = MV1_LAYERBLEND_TYPE_TRANSLUCENT ; break ;
													case FbxLayeredTexture::eAdditive :    Material->DiffuseTexs[ Material->DiffuseTexNum ]->BlendType = MV1_LAYERBLEND_TYPE_ADDITIVE ;    break ;
													case FbxLayeredTexture::eModulate :    Material->DiffuseTexs[ Material->DiffuseTexNum ]->BlendType = MV1_LAYERBLEND_TYPE_MODULATE ;    break ;
													case FbxLayeredTexture::eModulate2 :   Material->DiffuseTexs[ Material->DiffuseTexNum ]->BlendType = MV1_LAYERBLEND_TYPE_MODULATE2 ;   break ;
													}

													// eNX`̐CNg
													Material->DiffuseTexNum ++ ;
												}
											}
										}
										else
										{
											// ʏ̃eNX`̐擾
											Material->DiffuseTexNum = _FbxProperty.GetSrcObjectCount< FbxTexture >() ;

											// gpĂꍇ͏
											if( Material->DiffuseTexNum != 0 )
											{
												// eNX`̐JԂ
												for( j = 0 ; j < Material->DiffuseTexNum ; j ++ )
												{
													// eNX`̃AhX擾
													_FbxTexture = _FbxProperty.GetSrcObject< FbxTexture >( j ) ;

													// fɒǉ
													Material->DiffuseTexs[ j ] = FbxAddTexture( RModel, _FbxTexture ) ;
													if( Material->DiffuseTexs[ j ] == NULL ) 
													{
														DXST_ERRORLOGFMT_ADD( ( _T( "Fbx Load : Diffuse eNX`IuWFNg̒ǉɎs܂\n" ) ) ) ;
														return -1 ;
													}
												}
											}
										}
									}

									// XyL}eAvpeB̎擾
									{
										_FbxProperty = FbxMaterial->FindProperty( FbxSurfaceMaterial::sSpecular ) ;

										// C[heNX`̏ꍇƂȊOŏ𕪊
										LayeredTexNum = _FbxProperty.GetSrcObjectCount< FbxLayeredTexture >() ;
										if( LayeredTexNum )
										{
											// Qȏ̃C[ɂ͑ΉĂȂ
											if( LayeredTexNum > 1 )
											{
												DXST_ERRORLOGFMT_ADD( ( _T( "Fbx Load : Specular }eA͂PC[ȏɂ͑ΉĂ܂\n" ) ) ) ;
												return -1 ;
											}

											// eNX`̐JԂ
											for( j = 0 ; j < LayeredTexNum ; j ++ )
											{
												// eNX`̃AhX擾
												_FbxLayeredTexture = _FbxProperty.GetSrcObject< FbxLayeredTexture >( j ) ;

												// C[̒Ɋ܂܂ĂeNX`̐擾
												NormalTexNum = _FbxLayeredTexture->GetSrcObjectCount< FbxTexture >() ;

												// eNX`̐JԂ
												for( k = 0 ; k < NormalTexNum ; k ++ )
												{
													_FbxTexture = _FbxLayeredTexture->GetSrcObject< FbxTexture >( k ) ;
													if( _FbxTexture == NULL ) continue ;

													// fɒǉ
													Material->SpecularTexs[ Material->SpecularTexNum ] = FbxAddTexture( RModel, _FbxTexture ) ;
													if( Material->SpecularTexs[ Material->SpecularTexNum ] == NULL ) 
													{
														DXST_ERRORLOGFMT_ADD( ( _T( "Fbx Load : Specular eNX`IuWFNg̒ǉɎs܂\n" ) ) ) ;
														return -1 ;
													}

													// @擾
													_FbxLayeredTexture->GetTextureBlendMode( k, BlendMode ) ;
													switch( BlendMode )
													{
													case FbxLayeredTexture::eTranslucent : Material->SpecularTexs[ Material->SpecularTexNum ]->BlendType = MV1_LAYERBLEND_TYPE_TRANSLUCENT ; break ;
													case FbxLayeredTexture::eAdditive :    Material->SpecularTexs[ Material->SpecularTexNum ]->BlendType = MV1_LAYERBLEND_TYPE_ADDITIVE ;    break ;
													case FbxLayeredTexture::eModulate :    Material->SpecularTexs[ Material->SpecularTexNum ]->BlendType = MV1_LAYERBLEND_TYPE_MODULATE ;    break ;
													case FbxLayeredTexture::eModulate2 :   Material->SpecularTexs[ Material->SpecularTexNum ]->BlendType = MV1_LAYERBLEND_TYPE_MODULATE2 ;   break ;
													}

													// eNX`̐CNg
													Material->SpecularTexNum ++ ;
												}
											}
										}
										else
										{
											// ʏ̃eNX`̐擾
											Material->SpecularTexNum = _FbxProperty.GetSrcObjectCount< FbxTexture >() ;

											// gpĂꍇ͏
											if( Material->SpecularTexNum != 0 )
											{
												// eNX`̐JԂ
												for( j = 0 ; j < Material->SpecularTexNum ; j ++ )
												{
													// eNX`̃AhX擾
													_FbxTexture = _FbxProperty.GetSrcObject< FbxTexture >( j ) ;

													// fɒǉ
													Material->SpecularTexs[ j ] = FbxAddTexture( RModel, _FbxTexture ) ;
													if( Material->SpecularTexs[ j ] == NULL ) 
													{
														DXST_ERRORLOGFMT_ADD( ( _T( "Fbx Load : Specular eNX`IuWFNg̒ǉɎs܂\n" ) ) ) ;
														return -1 ;
													}
												}
											}
										}
									}

									// @}bv}eAvpeB̎擾
									{
										_FbxProperty = FbxMaterial->FindProperty( FbxSurfaceMaterial::sNormalMap ) ;

										// C[heNX`̏ꍇƂȊOŏ𕪊
										LayeredTexNum = _FbxProperty.GetSrcObjectCount< FbxLayeredTexture >() ;
										if( LayeredTexNum )
										{
											// Qȏ̃C[ɂ͑ΉĂȂ
											if( LayeredTexNum > 1 )
											{
												DXST_ERRORLOGFMT_ADD( ( _T( "Fbx Load : Bump }eA͂PC[ȏɂ͑ΉĂ܂\n" ) ) ) ;
												return -1 ;
											}

											// eNX`̐JԂ
											for( j = 0 ; j < LayeredTexNum ; j ++ )
											{
												// eNX`̃AhX擾
												_FbxLayeredTexture = _FbxProperty.GetSrcObject< FbxLayeredTexture >( j ) ;

												// C[̒Ɋ܂܂ĂeNX`̐擾
												NormalTexNum = _FbxLayeredTexture->GetSrcObjectCount< FbxTexture >() ;

												// eNX`̐JԂ
												for( k = 0 ; k < NormalTexNum ; k ++ )
												{
													_FbxTexture = _FbxLayeredTexture->GetSrcObject< FbxTexture >( k ) ;
													if( _FbxTexture == NULL ) continue ;

													// fɒǉ
													Material->NormalTexs[ Material->NormalTexNum ] = FbxAddTexture( RModel, _FbxTexture ) ;
													if( Material->NormalTexs[ Material->NormalTexNum ] == NULL ) 
													{
														DXST_ERRORLOGFMT_ADD( ( _T( "Fbx Load : Bump eNX`IuWFNg̒ǉɎs܂\n" ) ) ) ;
														return -1 ;
													}

													// @擾
													_FbxLayeredTexture->GetTextureBlendMode( k, BlendMode ) ;
													switch( BlendMode )
													{
													case FbxLayeredTexture::eTranslucent : Material->NormalTexs[ Material->NormalTexNum ]->BlendType = MV1_LAYERBLEND_TYPE_TRANSLUCENT ; break ;
													case FbxLayeredTexture::eAdditive :    Material->NormalTexs[ Material->NormalTexNum ]->BlendType = MV1_LAYERBLEND_TYPE_ADDITIVE ;    break ;
													case FbxLayeredTexture::eModulate :    Material->NormalTexs[ Material->NormalTexNum ]->BlendType = MV1_LAYERBLEND_TYPE_MODULATE ;    break ;
													case FbxLayeredTexture::eModulate2 :   Material->NormalTexs[ Material->NormalTexNum ]->BlendType = MV1_LAYERBLEND_TYPE_MODULATE2 ;   break ;
													}

													// eNX`̐CNg
													Material->NormalTexNum ++ ;
												}
											}
										}
										else
										{
											// ʏ̃eNX`̐擾
											Material->NormalTexNum = _FbxProperty.GetSrcObjectCount< FbxTexture >() ;

											// gpĂꍇ͏
											if( Material->NormalTexNum != 0 )
											{
												// eNX`̐JԂ
												for( j = 0 ; j < Material->NormalTexNum ; j ++ )
												{
													// eNX`̃AhX擾
													_FbxTexture = _FbxProperty.GetSrcObject< FbxTexture >( j ) ;

													// fɒǉ
													Material->NormalTexs[ j ] = FbxAddTexture( RModel, _FbxTexture ) ;
													if( Material->NormalTexs[ j ] == NULL ) 
													{
														DXST_ERRORLOGFMT_ADD( ( _T( "Fbx Load : Bump eNX`IuWFNg̒ǉɎs܂\n" ) ) ) ;
														return -1 ;
													}
												}
											}
										}
									}
								}
							}
						}

						// eʂɑΉ}eȀ擾
						{
							// }eAGg̐JԂ
						    for( i = 0 ; i < _FbxMesh->GetElementMaterialCount() ; i ++ )
							{
								FbxMaterialElem = _FbxMesh->GetElementMaterial( i ) ;

								// [h̎擾
								FbxMappingMode = FbxMaterialElem->GetMappingMode() ;
								FbxRefMode = FbxMaterialElem->GetReferenceMode() ;

								// }eA̎擾
								switch( FbxRefMode )
								{
								case FbxGeometryElement::eDirect :
									// }eA̐擾
									MaterialNum = pFbxNode->GetMaterialCount() ;

									// }eAi[郁̈̊m
									FbxMaterialDim = ( FbxSurfaceMaterial ** )DXCALLOC( sizeof( FbxSurfaceMaterial * ) * MaterialNum ) ;
									if( FbxMaterialDim == NULL ) 
									{
										DXST_ERRORLOGFMT_ADD( ( _T( "Fbx Load : }eAXgꎞۑobt@̊mۂɎs܂\n" ) ) ) ;
										return -1 ;
									}

									// ڃ[h̏ꍇ͂̂܂ܑ
									for( j = 0 ; j < MaterialNum ; j ++ )
									{
										FbxMaterialDim[ j ] = pFbxNode->GetMaterial( j ) ;
									}
									break ;

								case FbxGeometryElement::eIndexToDirect :
									// CfbNX̐擾
									MaterialNum = FbxMaterialElem->GetIndexArray().GetCount() ;

									// }eAi[郁̈̊m
									FbxMaterialDim = ( FbxSurfaceMaterial ** )DXCALLOC( sizeof( FbxSurfaceMaterial * ) * MaterialNum ) ;
									if( FbxMaterialDim == NULL ) 
									{
										DXST_ERRORLOGFMT_ADD( ( _T( "Fbx Load : }eAXgꎞۑobt@̊mۂɎs܂\n" ) ) ) ;
										return -1 ;
									}

									// CfbNX[h̏ꍇ͊ԐڎQƑ
									for( j = 0 ; j < MaterialNum ; j ++ )
									{
										Index = FbxMaterialElem->GetIndexArray().GetAt( j ) ;
										FbxMaterialDim[ j ] = pFbxNode->GetMaterial( Index ) ;
									}
									break ;

								default :
									DXST_ERRORLOGFMT_ADD( ( _T( "Fbx Load : Ή̃}eAt@X[hgpĂ܂\n" ) ) ) ;
									return -1 ;
								}

								// ʂ̊e_ɑΉ}eȀ擾
								switch( FbxMappingMode )
								{
								case FbxGeometryElement::eByPolygon :
									// P|SɂP}eA
									MeshFace = Mesh->Faces ;
									for( j = 0 ; ( DWORD )j < Mesh->FaceNum ; j ++, MeshFace ++ )
									{
										// 蓖ĂĂ}eAf̂ǂ̃}eAɓ̂𒲂ׂ
										for( k = 0 ; ( DWORD )k < Mesh->MaterialNum && _STRCMP( Mesh->Materials[ k ]->Name, FbxMaterialDim[ j ]->GetName() ) != 0 ; k ++ ){}
										if( k == Mesh->MaterialNum )
										{
											DXST_ERRORLOGFMT_ADD( ( _T( "Fbx Load : m[hɈv}eA܂ł eBY_CONTROL_POINT , %s \n" ), FbxMaterialDim[ j ]->GetName() ) ) ;
											DXFREE( FbxMaterialDim ) ;
											return -1 ;
										}

										// CfbNXۑ
										MeshFace->MaterialIndex = k ;
									}
									break ;

								case FbxGeometryElement::eAllSame :
									// bVŜłP}eA

									// 蓖ĂĂ}eAf̂ǂ̃}eAɓ̂𒲂ׂ
									for( k = 0 ; ( DWORD )k < Mesh->MaterialNum && _STRCMP( Mesh->Materials[ k ]->Name, FbxMaterialDim[ 0 ]->GetName() ) != 0 ; k ++ ){}
									if( k == Mesh->MaterialNum )
									{
										DXFREE( FbxMaterialDim ) ;
										DXST_ERRORLOGFMT_ADD( ( _T( "Fbx Load : m[hɈv}eA܂ł eALL_SAME\n" ) ) ) ;
										return -1 ;
									}

									// ׂẴbVɌCfbNXZbg
									MeshFace = Mesh->Faces ;
									for( j = 0 ; ( DWORD )j < Mesh->FaceNum ; j ++, MeshFace ++ )
									{
										// CfbNXۑ
										MeshFace->MaterialIndex = k ;
									}
									break ;

								default :
									DXFREE( FbxMaterialDim ) ;
									DXST_ERRORLOGFMT_ADD( ( _T( "Fbx Load : Ή̃}eA}bsO[hgpĂ܂\n" ) ) ) ;
									return -1 ;
								}

								DXFREE( FbxMaterialDim ) ;
							}
						}
					}
				}

				// XLbV̏擾
				if( _FbxMesh->GetDeformerCount( FbxDeformer::eSkin ) )
				{
					int PointNum, ClusterCount ;
					int *Point ;
					double *Weight ;
					FbxAMatrix _FbxMatrix ;
					MATRIX InvMatrix ;
					BYTE *PositionFillFlag ;

					// Qȏ̃XLɂ͖Ή
					if( _FbxMesh->GetDeformerCount( FbxDeformer::eSkin ) > 1 )
					{
						DXST_ERRORLOGFMT_ADD( ( _T( "Fbx Load : PbVɕ̃XLbVɂ͑ΉĂ܂\n" ) ) ) ;
						return -1 ;
					}

					// XLbV̎擾
					_FbxSkin = ( FbxSkin * )_FbxMesh->GetDeformer( 0, FbxDeformer::eSkin ) ;

					// NX^̐擾
					ClusterCount = _FbxSkin->GetClusterCount() ;

					// e_ɃEGCglݒ肳ꂽǂmF邽߂̃tOi[邽߂̃̈mۂ
					PositionFillFlag = ( BYTE * )ADDMEMAREA( ( Mesh->PositionNum + 31 ) / 32 * 4, &RModel->Mem ) ;
					if( PositionFillFlag == NULL )
					{
						DXST_ERRORLOGFMT_ADD( ( _T( "Fbx Load : Wɑ΂XLEGCg݂邩ǂmF邽߂̃̈̊mۂɎs܂\n" ) ) ) ;
						return -1 ;
					}
					_MEMSET( PositionFillFlag, 0, ( Mesh->PositionNum + 31 ) / 32 * 4 ) ;

					// Lȏ񂪂NX^擾
					for( i = 0 ; i < ClusterCount ; i ++ )
					{
						FbxAMatrix FbxTransMatrix ;
						MATRIX TransMatrix ;

						_FbxCluster = _FbxSkin->GetCluster( i ) ;
						if( _FbxCluster->GetControlPointIndicesCount() == 0 ) continue ;

						// XLEGCg̒ǉ
						SkinWeight = MV1RAddSkinWeight( RModel ) ;
						Mesh->SkinWeights[ Mesh->SkinWeightsNum ] = SkinWeight ;
						Mesh->SkinWeights[ Mesh->SkinWeightsNum ]->UserData = _FbxCluster ;
						Mesh->SkinWeightsNum ++ ;

						// e_ւ̉ei[邽߂̃̊m
						SkinWeight->DataNum = _FbxCluster->GetControlPointIndicesCount() ;
						SkinWeight->Data = ( MV1_SKIN_WEIGHT_ONE_R * )ADDMEMAREA( sizeof( MV1_SKIN_WEIGHT_ONE_R ) * SkinWeight->DataNum, &RModel->Mem ) ;
						if( SkinWeight->Data == NULL )
						{
							DXST_ERRORLOGFMT_ADD( ( _T( "Fbx Load : XLEGCgi[郁̊mۂɎs܂\n" ) ) ) ;
							return -1 ;
						}

						// e擾
						PointNum = _FbxCluster->GetControlPointIndicesCount() ;
						Point = _FbxCluster->GetControlPointIndices() ;
						Weight = _FbxCluster->GetControlPointWeights() ;
						for( j = 0 ; ( DWORD )j < SkinWeight->DataNum ; j ++ )
						{
							SkinWeight->Data[ j ].TargetVertex = Point[ j ] ;
							SkinWeight->Data[ j ].Weight = ( float )Weight[ j ] ;
							PositionFillFlag[ Point[ j ] / 8 ] |= 1 << ( Point[ j ] & 7 ) ;
						}

						// {[̃[JWɗƂނ߂̍s̎擾
						_FbxCluster->GetTransformLinkMatrix( _FbxMatrix ) ;
						_FbxCluster->GetTransformMatrix( FbxTransMatrix ) ;
						InvMatrix.m[ 0 ][ 0 ] = ( float )_FbxMatrix.Double44()[ 0 ][ 0 ] ;
						InvMatrix.m[ 0 ][ 1 ] = ( float )_FbxMatrix.Double44()[ 0 ][ 1 ] ;
						InvMatrix.m[ 0 ][ 2 ] = ( float )_FbxMatrix.Double44()[ 0 ][ 2 ] ;
						InvMatrix.m[ 0 ][ 3 ] = ( float )_FbxMatrix.Double44()[ 0 ][ 3 ] ;

						InvMatrix.m[ 1 ][ 0 ] = ( float )_FbxMatrix.Double44()[ 1 ][ 0 ] ;
						InvMatrix.m[ 1 ][ 1 ] = ( float )_FbxMatrix.Double44()[ 1 ][ 1 ] ;
						InvMatrix.m[ 1 ][ 2 ] = ( float )_FbxMatrix.Double44()[ 1 ][ 2 ] ;
						InvMatrix.m[ 1 ][ 3 ] = ( float )_FbxMatrix.Double44()[ 1 ][ 3 ] ;

						InvMatrix.m[ 2 ][ 0 ] = ( float )_FbxMatrix.Double44()[ 2 ][ 0 ] ;
						InvMatrix.m[ 2 ][ 1 ] = ( float )_FbxMatrix.Double44()[ 2 ][ 1 ] ;
						InvMatrix.m[ 2 ][ 2 ] = ( float )_FbxMatrix.Double44()[ 2 ][ 2 ] ;
						InvMatrix.m[ 2 ][ 3 ] = ( float )_FbxMatrix.Double44()[ 2 ][ 3 ] ;

						InvMatrix.m[ 3 ][ 0 ] = ( float )_FbxMatrix.Double44()[ 3 ][ 0 ] ;
						InvMatrix.m[ 3 ][ 1 ] = ( float )_FbxMatrix.Double44()[ 3 ][ 1 ] ;
						InvMatrix.m[ 3 ][ 2 ] = ( float )_FbxMatrix.Double44()[ 3 ][ 2 ] ;
						InvMatrix.m[ 3 ][ 3 ] = ( float )_FbxMatrix.Double44()[ 3 ][ 3 ] ;

						TransMatrix.m[ 0 ][ 0 ] = ( float )FbxTransMatrix.Double44()[ 0 ][ 0 ] ;
						TransMatrix.m[ 0 ][ 1 ] = ( float )FbxTransMatrix.Double44()[ 0 ][ 1 ] ;
						TransMatrix.m[ 0 ][ 2 ] = ( float )FbxTransMatrix.Double44()[ 0 ][ 2 ] ;
						TransMatrix.m[ 0 ][ 3 ] = ( float )FbxTransMatrix.Double44()[ 0 ][ 3 ] ;

						TransMatrix.m[ 1 ][ 0 ] = ( float )FbxTransMatrix.Double44()[ 1 ][ 0 ] ;
						TransMatrix.m[ 1 ][ 1 ] = ( float )FbxTransMatrix.Double44()[ 1 ][ 1 ] ;
						TransMatrix.m[ 1 ][ 2 ] = ( float )FbxTransMatrix.Double44()[ 1 ][ 2 ] ;
						TransMatrix.m[ 1 ][ 3 ] = ( float )FbxTransMatrix.Double44()[ 1 ][ 3 ] ;

						TransMatrix.m[ 2 ][ 0 ] = ( float )FbxTransMatrix.Double44()[ 2 ][ 0 ] ;
						TransMatrix.m[ 2 ][ 1 ] = ( float )FbxTransMatrix.Double44()[ 2 ][ 1 ] ;
						TransMatrix.m[ 2 ][ 2 ] = ( float )FbxTransMatrix.Double44()[ 2 ][ 2 ] ;
						TransMatrix.m[ 2 ][ 3 ] = ( float )FbxTransMatrix.Double44()[ 2 ][ 3 ] ;

						TransMatrix.m[ 3 ][ 0 ] = ( float )FbxTransMatrix.Double44()[ 3 ][ 0 ] ;
						TransMatrix.m[ 3 ][ 1 ] = ( float )FbxTransMatrix.Double44()[ 3 ][ 1 ] ;
						TransMatrix.m[ 3 ][ 2 ] = ( float )FbxTransMatrix.Double44()[ 3 ][ 2 ] ;
						TransMatrix.m[ 3 ][ 3 ] = ( float )FbxTransMatrix.Double44()[ 3 ][ 3 ] ;

						CreateInverseMatrix( &TransMatrix, &TransMatrix ) ;
						CreateMultiplyMatrix( &InvMatrix, &InvMatrix, &TransMatrix ) ;

						CreateMultiplyMatrix( &InvMatrix, &ReverseMat, &InvMatrix ) ;
						CreateMultiplyMatrix( &InvMatrix, &InvMatrix, &ReverseMat ) ;

						CreateInverseMatrix( &SkinWeight->ModelLocalMatrix, &InvMatrix ) ;
					}

					// EGCgl蓖ĂĂȂ_炱̃{[̏ɂ
					{
						int i, j, k, CheckNum ;
						int Result ;

						// EGCgl̖_邩`FbN
						CheckNum = Mesh->PositionNum / 32 ;
						for( i = 0 ; i < CheckNum && ( ( DWORD * )PositionFillFlag )[ i ] == 0xffffffff ; i ++ ){}
						Result  = i != CheckNum ? 1 : 0 ;

						CheckNum = Mesh->PositionNum % 32 ;
						for( j = 0 ; j < CheckNum && ( ( ( BYTE * )( &( ( DWORD * )PositionFillFlag )[ i ] ) )[ j / 8 ] & ( 1 << ( j % 8 ) ) ) != 0 ; j ++ ){}
						Result |= j != CheckNum ? 1 : 0 ;

						// 炱̃t[̏ƂẴEGCgǉ
						if( Result == 1 )
						{
							int WeightNoneNum ;
							DWORD CheckData ;
							BYTE CheckDataByte ;

							// ߂ăEGCgl̖_̐𐔂
							WeightNoneNum = 0 ;
							CheckNum = Mesh->PositionNum / 32 ;
							for( i = 0 ; i < CheckNum ; i ++ )
							{
								CheckData = ( ( DWORD * )PositionFillFlag )[ i ] ;
								for( j = 0 ; j < 32 ; j ++ )
								{
									if( ( CheckData & ( 1 << j ) ) == 0 )
									{
										WeightNoneNum ++ ;
									}
								}
							}
							CheckData = ( ( DWORD * )PositionFillFlag )[ i ] ;
							CheckNum = Mesh->PositionNum % 32 ;
							for( j = 0 ; j < CheckNum ; j ++ )
							{
								if( ( ( ( BYTE * )&CheckData )[ j / 8 ] & ( 1 << ( j % 8 ) ) ) == 0 )
								{
									WeightNoneNum ++ ;
								}
							}

							// EGCg̒ǉ
							SkinWeight = MV1RAddSkinWeight( RModel ) ;
							Mesh->SkinWeights[ Mesh->SkinWeightsNum ] = SkinWeight ;
							Mesh->SkinWeights[ Mesh->SkinWeightsNum ]->UserData = NULL ;
							Mesh->SkinWeightsNum ++ ;
							CreateIdentityMatrix( &SkinWeight->ModelLocalMatrix ) ;

							// e_ւ̉ei[邽߂̃̊m
							SkinWeight->DataNum = WeightNoneNum ;
							SkinWeight->Data = ( MV1_SKIN_WEIGHT_ONE_R * )ADDMEMAREA( sizeof( MV1_SKIN_WEIGHT_ONE_R ) * SkinWeight->DataNum, &RModel->Mem ) ;
							if( SkinWeight->Data == NULL )
							{
								DXST_ERRORLOGFMT_ADD( ( _T( "Fbx Load : XLEGCgi[郁̊mۂɎs܂ 2\n" ) ) ) ;
								return -1 ;
							}

							// eZbg
							WeightNoneNum = 0 ;
							CheckNum = Mesh->PositionNum / 8 ;
							k = 0 ;
							for( i = 0 ; i < CheckNum ; i ++ )
							{
								CheckDataByte = PositionFillFlag[ i ] ;
								for( j = 0 ; j < 8 ; j ++, k ++ )
								{
									if( ( CheckDataByte & ( 1 << j ) ) == 0 )
									{
										SkinWeight->Data[ WeightNoneNum ].TargetVertex = k ;
										SkinWeight->Data[ WeightNoneNum ].Weight = 1.0f ;
										WeightNoneNum ++ ;
									}
								}
							}
							CheckDataByte = PositionFillFlag[ i ] ;
							CheckNum = Mesh->PositionNum % 8 ;
							for( j = 0 ; j < CheckNum ; j ++, k ++ )
							{
								if( ( CheckDataByte & ( 1 << j ) ) == 0 )
								{
									SkinWeight->Data[ WeightNoneNum ].TargetVertex = k ;
									SkinWeight->Data[ WeightNoneNum ].Weight = 1.0f ;
									WeightNoneNum ++ ;
								}
							}
						}
					}
				}

				// VFCv̏擾
				if( _FbxMesh->GetDeformerCount( FbxDeformer::eBlendShape ) > 0 )
				{
					int ChannelCount ;

					// Qȏ̃VFCvɂ͖Ή
					if( _FbxMesh->GetDeformerCount( FbxDeformer::eBlendShape ) > 1 )
					{
						DXST_ERRORLOGFMT_ADD( ( _T( "Fbx Load : PbVɕ̃uhVFCvɂ͑ΉĂ܂\n" ) ) ) ;
						return -1 ;
					}

					_FbxBlendShape = ( FbxBlendShape * )_FbxMesh->GetDeformer( 0, FbxDeformer::eBlendShape ) ;

					ChannelCount = _FbxBlendShape->GetBlendShapeChannelCount() ;

					for( i = 0 ; i < ChannelCount ; i ++ )
					{

						_FbxBlendShapeChannel = _FbxBlendShape->GetBlendShapeChannel( i ) ;
						if( _FbxBlendShapeChannel == NULL )
						{
							continue ;
						}

						_FbxShape = _FbxBlendShapeChannel->GetTargetShape( 0 ) ;
						if( _FbxShape == NULL )
						{
							continue ;
						}

						// VFCv̒ǉ
						Shape = MV1RAddShape( RModel, _FbxShape->GetName(), Frame ) ; 

						// ΏۃbṼZbg
						Shape->TargetMesh = Mesh ;

						// @͖
						Shape->ValidVertexNormal = FALSE ;

						// _̐ۑ
						Shape->VertexNum = _FbxShape->GetControlPointsCount() ;

						// _f[^i[郁̈̊m
						Shape->Vertex = ( MV1_SHAPE_VERTEX_R * )ADDMEMAREA( sizeof( MV1_SHAPE_VERTEX_R ) * Shape->VertexNum, &RModel->Mem ) ;
						if( Shape->Vertex == NULL )
						{
							DXST_ERRORLOGFMT_ADD( ( _T( "Fbx Load : VFCv_f[^i[郁̈̊mۂɎs܂\n" ) ) ) ;
							return -1 ;
						}

						// _f[^𖄂߂
						ShapeVert = Shape->Vertex ;
						FbxShapeVec = _FbxShape->GetControlPoints() ;
						FbxVec = _FbxMesh->GetControlPoints() ;
						for( j = 0 ; j < Shape->VertexNum ; j ++, ShapeVert ++, FbxShapeVec ++, FbxVec ++ )
						{
							ShapeVert->TargetPositionIndex = j ;
							ShapeVert->Position.x = ( float ) ( FbxShapeVec->mData[ 0 ] - FbxVec->mData[ 0 ] ) ;
							ShapeVert->Position.y = ( float ) ( FbxShapeVec->mData[ 1 ] - FbxVec->mData[ 1 ] ) ;
							ShapeVert->Position.z = ( float )-( FbxShapeVec->mData[ 2 ] - FbxVec->mData[ 2 ] ) ;
							ShapeVert->Normal.x = 0.0f ;
							ShapeVert->Normal.y = 0.0f ;
							ShapeVert->Normal.z = 0.0f ;
						}
					}
				}
			}
			else
			// Cgm[h̏ꍇ̓Cg擾
			if( FbxAttr->GetAttributeType() == FbxNodeAttribute::eLight )
			{
				FbxLight *_FbxLight ;

				_FbxLight = ( FbxLight * )FbxAttr ;

				// Cg̒ǉ
				Frame->Light = MV1RAddLight( RModel, _FbxLight->GetName() ) ;
				if( Frame->Light == NULL )
				{
					DXST_ERRORLOGFMT_ADD( ( _T( "Fbx Load : CgIuWFNg̒ǉɎs܂\n" ) ) ) ;
					return -1 ;
				}

				// Cg̏擾
				switch( _FbxLight->LightType.Get() )
				{
				case FbxLight::ePoint :
					Frame->Light->Type = MV1_LIGHT_TYPE_POINT ;
					break ;

				case FbxLight::eSpot :
					Frame->Light->Type = MV1_LIGHT_TYPE_SPOT ;
					break ;

				case FbxLight::eDirectional :
					Frame->Light->Type = MV1_LIGHT_TYPE_DIRECTIONAL ;
					break ;
				}
				Frame->Light->Diffuse.r = ( float )_FbxLight->Color.Get()[ 0 ] ;
				Frame->Light->Diffuse.g = ( float )_FbxLight->Color.Get()[ 1 ] ;
				Frame->Light->Diffuse.b = ( float )_FbxLight->Color.Get()[ 2 ] ;
				Frame->Light->Range = ( float )_FbxLight->Intensity.Get() / 10.0f ;
				Frame->Light->Falloff = 0.1f ;
				Frame->Light->Attenuation0 = 1.0f ;
				Frame->Light->Attenuation1 = 0.0f ;
				Frame->Light->Attenuation2 = 0.0f ;
				Frame->Light->Theta = ( float )_FbxLight->InnerAngle.Get() ;
				Frame->Light->Phi = ( float )_FbxLight->OuterAngle.Get() ;
				Frame->Light->FrameIndex = Frame->Index ;
			}
		}
	}

	// q̃m[h͂
	Num = pFbxNode->GetChildCount() ;
	for( i = 0 ; i < Num ; i ++ )
	{
		pFbxChildNode = pFbxNode->GetChild( i ) ;
		if( AnalyseFbxNode( RModel, Model, Frame, pFbxChildNode ) == -1 )
			return -1 ;
	}

	// I
	return 0 ;
}

// FBXt@C̉( 0:  -1:s )
static int AnalyseFbx( MV1_MODEL_R *RModel, FBX_MODEL *Model )
{
	int i, j, k ;
	MV1_MESH_R *Mesh ;
	MV1_FRAME_R *TargetFrame ;
	MV1_SKIN_WEIGHT_R *SkinWeight ;
	void *Node ;

	// m[h̉
	if( AnalyseFbxNode( RModel, Model, NULL, NULL ) == -1 )
	{
		DXST_ERRORLOGFMT_ADD( ( _T( "Fbx Load : m[h̉͂ŃG[܂\n" ) ) ) ;
		return -1 ;
	}

	// XLEGCgɊ֘At[oĂ
	{
		// bV̐JԂ
		Mesh = RModel->MeshFirst ;
		for( i = 0 ; ( DWORD )i < RModel->MeshNum ; i ++, Mesh = Mesh->DataNext )
		{
			// XLEGCg̐JԂ
			for( j = 0 ; ( DWORD )j < Mesh->SkinWeightsNum ; j ++ )
			{
				SkinWeight = Mesh->SkinWeights[ j ] ;

				// UserData  NULL ̏ꍇ̓bVĂt[Ώۃt[
				if( SkinWeight->UserData == NULL )
				{
					TargetFrame = Mesh->Container ;
					SkinWeight->TargetFrame = TargetFrame->Index ;
				}
				else
				{
					// vt[
					Node = ( ( FbxCluster * )SkinWeight->UserData )->GetLink() ;
					TargetFrame = RModel->FrameFirst ;
					for( k = 0 ; ( DWORD )k < RModel->FrameNum && TargetFrame->UserData != Node ; k ++, TargetFrame = TargetFrame->DataNext ){}
					SkinWeight->TargetFrame = k ;
				}
			}
		}
	}

	// Aj[V̉
	{
		int TakeNum ;
		MV1_ANIMSET_R *AnimSet ;
		MV1_ANIM_R *Anim ;
		MV1_FRAME_R *Frame ;
		FbxAnimStack *lFbxAnimStack ;

		// Aj[VZbg̐擾
		TakeNum = Model->pScene->GetSrcObjectCount< FbxAnimStack >() ;

		// Aj[V̐JԂ
		for( i = 0 ; i < TakeNum ; i ++ )
		{
			// eCN擾
			lFbxAnimStack = Model->pScene->GetSrcObject< FbxAnimStack >( i ) ;

			// Aj[V񂪖炱ŏI
			if( lFbxAnimStack == NULL ) continue ;
			if( lFbxAnimStack->GetMemberCount< FbxAnimLayer >() == 0 ) continue ;

			// Aj[VZbgǉ
			AnimSet = MV1RAddAnimSet( RModel, lFbxAnimStack->GetName() ) ;
			if( AnimSet == NULL )
			{
//				DeleteAndClear( FbxTakeName ) ;
				DXST_ERRORLOGFMT_ADD( ( _T( "Fbx Load : Aj[VZbgIuWFNg̒ǉɎs܂\n" ) ) ) ;
				return -1 ;
			}

			// JnƏȈ
			AnimSet->StartTime =  1000000000.0f ;
			AnimSet->EndTime   = -1000000000.0f ;

			FbxAnimLayer *pFbxAnimLayer = lFbxAnimStack->GetMember< FbxAnimLayer >( 0 ) ;

			// Aj[V̏擾
			Frame = RModel->FrameFirst ;
			for( j = 0 ; ( DWORD )j < RModel->FrameNum ; j ++, Frame = Frame->DataNext )
			{
				// eCNm[h̎擾
				FbxNode *pFbxNode = ( FbxNode * )Frame->UserData ;

				// J[uf[^݂vf̃Aj[V擾
				Anim = NULL ;
				if( GetFbxAnimInfo( RModel, Model, Frame, AnimSet, &Anim, MV1_ANIMKEY_DATATYPE_TRANSLATE_X, pFbxNode->LclTranslation.GetCurve( pFbxAnimLayer, FBXSDK_CURVENODE_COMPONENT_X )              ) == -1 ) return -1 ;
				if( GetFbxAnimInfo( RModel, Model, Frame, AnimSet, &Anim, MV1_ANIMKEY_DATATYPE_TRANSLATE_Y, pFbxNode->LclTranslation.GetCurve( pFbxAnimLayer, FBXSDK_CURVENODE_COMPONENT_Y )              ) == -1 ) return -1 ;
				if( GetFbxAnimInfo( RModel, Model, Frame, AnimSet, &Anim, MV1_ANIMKEY_DATATYPE_TRANSLATE_Z, pFbxNode->LclTranslation.GetCurve( pFbxAnimLayer, FBXSDK_CURVENODE_COMPONENT_Z ), true        ) == -1 ) return -1 ;
				if( GetFbxAnimInfo( RModel, Model, Frame, AnimSet, &Anim, MV1_ANIMKEY_DATATYPE_SCALE_X,     pFbxNode->LclScaling.GetCurve(     pFbxAnimLayer, FBXSDK_CURVENODE_COMPONENT_X )              ) == -1 ) return -1 ;
				if( GetFbxAnimInfo( RModel, Model, Frame, AnimSet, &Anim, MV1_ANIMKEY_DATATYPE_SCALE_Y,     pFbxNode->LclScaling.GetCurve(     pFbxAnimLayer, FBXSDK_CURVENODE_COMPONENT_Y )              ) == -1 ) return -1 ;
				if( GetFbxAnimInfo( RModel, Model, Frame, AnimSet, &Anim, MV1_ANIMKEY_DATATYPE_SCALE_Z,     pFbxNode->LclScaling.GetCurve(     pFbxAnimLayer, FBXSDK_CURVENODE_COMPONENT_Z )              ) == -1 ) return -1 ;
				if( GetFbxAnimInfo( RModel, Model, Frame, AnimSet, &Anim, MV1_ANIMKEY_DATATYPE_ROTATE_X,    pFbxNode->LclRotation.GetCurve(    pFbxAnimLayer, FBXSDK_CURVENODE_COMPONENT_X ), true,  true ) == -1 ) return -1 ;
				if( GetFbxAnimInfo( RModel, Model, Frame, AnimSet, &Anim, MV1_ANIMKEY_DATATYPE_ROTATE_Y,    pFbxNode->LclRotation.GetCurve(    pFbxAnimLayer, FBXSDK_CURVENODE_COMPONENT_Y ), true,  true ) == -1 ) return -1 ;
				if( GetFbxAnimInfo( RModel, Model, Frame, AnimSet, &Anim, MV1_ANIMKEY_DATATYPE_ROTATE_Z,    pFbxNode->LclRotation.GetCurve(    pFbxAnimLayer, FBXSDK_CURVENODE_COMPONENT_Z ), false, true ) == -1 ) return -1 ;

				// L[Zbg炱̃m[hɂ̓Aj[VƂ
				if( Anim == NULL )
					continue ;

				// Ԃ̃Zbg
				Anim->MaxTime = AnimSet->EndTime ;

				// m[h̖Oۑ
				Anim->TargetFrameName = MV1RAddString( RModel, Frame->Name ) ;
				Anim->TargetFrameIndex = Frame->Index ;

				// ]I[_[̃Zbg
				Anim->RotateOrder = Frame->RotateOrder ;
			}
		}
	}

	// 
	return 0 ;
}

extern int MV1LoadModelToFBX( const MV1_MODEL_LOAD_PARAM *LoadParam, int ASyncThread )
{
	int NewHandle = -1 ;
	int iFileFormat = -1 ;
	int ErrorFlag = 1 ;
	FBX_MODEL FbxModel ;
	MV1_MODEL_R RModel ;

	// ǂݍ݂悤f[^̏
	MV1InitReadModel( &RModel ) ;
	RModel.MeshFaceRightHand = TRUE ;

	// fƃt@CZbg
	RModel.FilePath = ( TCHAR * )DXALLOC( ( lstrlen( LoadParam->FilePath ) + 1 ) * sizeof( TCHAR ) ) ;
	RModel.Name     = ( TCHAR * )DXALLOC( ( lstrlen( LoadParam->Name     ) + 1 ) * sizeof( TCHAR ) ) ;
	lstrcpy( RModel.FilePath, LoadParam->FilePath ) ;
	lstrcpy( RModel.Name,     LoadParam->Name ) ;

	// FBXff[^O
	_MEMSET( &FbxModel, 0, sizeof( FbxModel ) ) ;

	// SDK}l[W
	FbxModel.pManager = FbxManager::Create();
	if( FbxModel.pManager == NULL )
	{
		DXST_ERRORLOGFMT_ADD( ( _T( "Fbx Load : FBX Manager ̍쐬Ɏs܂\n" ) ) ) ;
		goto FUNCTIONEND ;
	}
	
	// IOSettings NX̍쐬
	FbxModel.pIOSettings = FbxIOSettings::Create( FbxModel.pManager, IOSROOT ) ;
	FbxModel.pManager->SetIOSettings( FbxModel.pIOSettings ) ;

	// vOCpX̐ݒ
	{
		FbxString lPath = FbxGetApplicationDirectory() ;
		FbxModel.pManager->LoadPluginsDirectory( lPath.Buffer() ) ;
	}

	// V[̍쐬
	FbxModel.pScene = FbxScene::Create( FbxModel.pManager, "Scene" ) ;
	if( FbxModel.pScene == NULL )
	{
		DXST_ERRORLOGFMT_ADD( ( _T( "Fbx Load : FBX Scene ̍쐬Ɏs܂\n" ) ) ) ;
		goto FUNCTIONEND ;
	}

	// C|[^[̍쐬
	FbxModel.pImporter = FbxImporter::Create( FbxModel.pManager, "" ) ;
	if( FbxModel.pImporter == NULL )
	{
		DXST_ERRORLOGFMT_ADD( ( _T( "Fbx Load : C|[^[̍쐬Ɏs܂\n" ) ) ) ;
		goto FUNCTIONEND ;
	}

	// FBXtH[}bg̃`FbN 
	if( FbxModel.pManager->GetIOPluginRegistry()->DetectReaderFileFormat( LoadParam->FilePath, iFileFormat ) == false )
		goto FUNCTIONEND ;

	// ǂݍ
	if( FbxModel.pImporter->Initialize( LoadParam->FilePath, iFileFormat, FbxModel.pIOSettings ) == false )
		goto FUNCTIONEND ;

	// eaw`FbN
	if( FbxModel.pImporter->IsFBX() == false )
		goto FUNCTIONEND ;

	// ǂݎ̐ݒ
	FbxModel.pIOSettings->SetBoolProp( IMP_FBX_MATERIAL,		true ) ;
	FbxModel.pIOSettings->SetBoolProp( IMP_FBX_TEXTURE,			true ) ;
	FbxModel.pIOSettings->SetBoolProp( IMP_FBX_LINK,			true ) ;
	FbxModel.pIOSettings->SetBoolProp( IMP_FBX_SHAPE,			true ) ;
	FbxModel.pIOSettings->SetBoolProp( IMP_FBX_GOBO,			true ) ;
	FbxModel.pIOSettings->SetBoolProp( IMP_FBX_ANIMATION,		true ) ;
	FbxModel.pIOSettings->SetBoolProp( IMP_FBX_GLOBAL_SETTINGS, true ) ;

	// C|[g
	if( FbxModel.pImporter->Import( FbxModel.pScene ) == false )
	{
		DXST_ERRORLOGFMT_ADD( ( _T( "Fbx Load : V[̃C|[gɎs܂\n" ) ) ) ;
		goto FUNCTIONEND ;
	}

	// C|[^̍폜
	FbxModel.pImporter->Destroy() ;
	FbxModel.pImporter = NULL ;

	// m[hJ
	if( AnalyseFbx( &RModel, &FbxModel ) == -1 )
		goto FUNCTIONEND ;

	// ff[^nh̍쐬
	NewHandle = MV1LoadModelToReadModel( &LoadParam->GParam, &RModel, LoadParam->CurrentDir, LoadParam->FileReadFunc, ASyncThread ) ;
	if( NewHandle < 0 ) goto FUNCTIONEND ;

	// G[tO|
	ErrorFlag = 0 ;

FUNCTIONEND :

	// G[tOĂ烂fnh
	if( ErrorFlag == 1 && NewHandle != -1 )
	{
		MV1SubModelBase( NewHandle ) ;
		NewHandle = -1 ;
	}

	// C|[^[̉
	if( FbxModel.pImporter )
	{
		FbxModel.pImporter->Destroy() ;
		FbxModel.pImporter = NULL ;
	}

	if( FbxModel.pIOSettings )
	{
		FbxModel.pIOSettings->Destroy() ;
		FbxModel.pIOSettings = NULL ;
	}

	// V[̉
	if( FbxModel.pScene )
	{
		FbxModel.pScene->Destroy() ;
		FbxModel.pScene = NULL ;
	}

	// SDK}l[W̉
	if( FbxModel.pManager )
	{
		FbxModel.pManager->Destroy() ;
		FbxModel.pManager = NULL ;
	}

	// ǂݍ݃f̌n
	MV1TermReadModel( &RModel ) ;

	// nhԂ
	return NewHandle ;
}

#ifdef DX_USE_NAMESPACE

}

#endif // DX_USE_NAMESPACE

#endif

#endif
