cbuffer cbNormal : register( b0 )
{
	float   g_ClipBrightness    : packoffset( c0 ) ;
	float4  g_RGBToY            : packoffset( c1 ) ;
	float4  g_ClipFillColor     : packoffset( c2 ) ;
} ;
	
SamplerState g_SrcSampler       : register( s0 ) ;
Texture2D    g_SrcTexture       : register( t0 ) ;


struct VS_OUTPUT
{
	float4 Position        : POSITION ;
	float2 TexCoords0      : TEXCOORD0 ;
} ;

struct VS_INPUT 
{
	float4 Position        : POSITION ;
	float4 Normal          : NORMAL ;
	float4 Diffuse         : COLOR0 ;
	float4 Specular        : COLOR1 ;
	float2 TexCoords0      : TEXCOORD0 ;
	float2 TexCoords1      : TEXCOORD1 ;
} ;

float4 PS_Less(VS_OUTPUT In) : SV_TARGET0
{   
    float4 Color;

    Color = g_SrcTexture.Sample( g_SrcSampler, In.TexCoords0 ) ;
    clip( dot( g_RGBToY, Color ) - g_ClipBrightness ) ;
	
    return Color;
}

float4 PS_Less_ClipFill(VS_OUTPUT In) : SV_TARGET0
{   
    float4 Color;

    Color = g_SrcTexture.Sample( g_SrcSampler, In.TexCoords0 ) ;
    if( dot( g_RGBToY, Color ) < g_ClipBrightness )
    {
        return g_ClipFillColor;
    }
    else
    {
        return Color;
    }
}

float4 PS_Greater(VS_OUTPUT In) : SV_TARGET0
{   
    float4 Color;

    Color = g_SrcTexture.Sample( g_SrcSampler, In.TexCoords0 ) ;
    clip( g_ClipBrightness - dot( g_RGBToY, Color ) ) ;

    return Color;
}

float4 PS_Greater_ClipFill(VS_OUTPUT In) : SV_TARGET0
{   
    float4 Color;

    Color = g_SrcTexture.Sample( g_SrcSampler, In.TexCoords0 ) ;
    if( dot( g_RGBToY, Color ) > g_ClipBrightness )
    {
        return g_ClipFillColor;
    }
    else
    {
        return Color;
    }
}
