cbuffer cbNormal : register( b0 )
{
	float2 PixelOffset[16] : packoffset( c0 ) ;
} ;

SamplerState g_SrcSampler       : register( s0 ) ;
Texture2D    g_SrcTexture       : register( t0 ) ;

struct VS_OUTPUT
{
	float4 Position        : POSITION ;
	float2 TexCoords0      : TEXCOORD0 ;
} ;

float4 Down_2_PS(VS_OUTPUT In) : SV_TARGET0
{   
    float4 Color;

    Color = g_SrcTexture.Sample( g_SrcSampler, In.TexCoords0 + PixelOffset[0] ) ;

    return Color;
}


float4 Down_4_PS(VS_OUTPUT In) : SV_TARGET0
{   
    float4 Color;

    Color  = g_SrcTexture.Sample( g_SrcSampler, In.TexCoords0 + PixelOffset[0] ) ;
    Color += g_SrcTexture.Sample( g_SrcSampler, In.TexCoords0 + PixelOffset[1] ) ;
    Color += g_SrcTexture.Sample( g_SrcSampler, In.TexCoords0 + PixelOffset[2] ) ;
    Color += g_SrcTexture.Sample( g_SrcSampler, In.TexCoords0 + PixelOffset[3] ) ;

    return Color / 4;
}


float4 Down_8_PS(VS_OUTPUT In) : SV_TARGET0
{   
    float4 Color;

    Color  = g_SrcTexture.Sample( g_SrcSampler, In.TexCoords0 + PixelOffset[0] ) ;
    Color += g_SrcTexture.Sample( g_SrcSampler, In.TexCoords0 + PixelOffset[1] ) ;
    Color += g_SrcTexture.Sample( g_SrcSampler, In.TexCoords0 + PixelOffset[2] ) ;
    Color += g_SrcTexture.Sample( g_SrcSampler, In.TexCoords0 + PixelOffset[3] ) ;
    Color += g_SrcTexture.Sample( g_SrcSampler, In.TexCoords0 + PixelOffset[4] ) ;
    Color += g_SrcTexture.Sample( g_SrcSampler, In.TexCoords0 + PixelOffset[5] ) ;
    Color += g_SrcTexture.Sample( g_SrcSampler, In.TexCoords0 + PixelOffset[6] ) ;
    Color += g_SrcTexture.Sample( g_SrcSampler, In.TexCoords0 + PixelOffset[7] ) ;
    Color += g_SrcTexture.Sample( g_SrcSampler, In.TexCoords0 + PixelOffset[8] ) ;
    Color += g_SrcTexture.Sample( g_SrcSampler, In.TexCoords0 + PixelOffset[9] ) ;
    Color += g_SrcTexture.Sample( g_SrcSampler, In.TexCoords0 + PixelOffset[10] ) ;
    Color += g_SrcTexture.Sample( g_SrcSampler, In.TexCoords0 + PixelOffset[11] ) ;
    Color += g_SrcTexture.Sample( g_SrcSampler, In.TexCoords0 + PixelOffset[12] ) ;
    Color += g_SrcTexture.Sample( g_SrcSampler, In.TexCoords0 + PixelOffset[13] ) ;
    Color += g_SrcTexture.Sample( g_SrcSampler, In.TexCoords0 + PixelOffset[14] ) ;
    Color += g_SrcTexture.Sample( g_SrcSampler, In.TexCoords0 + PixelOffset[15] ) ;

    return Color / 16;
}

