cbuffer cbNormal : register( b0 )
{
	float2 TextureSize     : packoffset( c0  ) ;
	float4 PixelWeight[4]  : packoffset( c1  ) ;
	float2 PixelOffset[16] : packoffset( c5  ) ;
} ;

SamplerState g_SrcSampler       : register( s0 ) ;
Texture2D    g_SrcTexture       : register( t0 ) ;

struct VS_OUTPUT
{
	float4 Position        : POSITION ;
	float2 TexCoords0      : TEXCOORD0 ;
} ;

float4 PS_8pixel(VS_OUTPUT In) : SV_TARGET0
{   
    float4 Color;
	
    Color  = PixelWeight[0].x *   g_SrcTexture.Sample( g_SrcSampler, In.TexCoords0 );
    Color += PixelWeight[0].y * ( g_SrcTexture.Sample( g_SrcSampler, In.TexCoords0 + PixelOffset[  1 ] ) +  g_SrcTexture.Sample( g_SrcSampler, In.TexCoords0 - PixelOffset[  1 ] ) );
    Color += PixelWeight[0].z * ( g_SrcTexture.Sample( g_SrcSampler, In.TexCoords0 + PixelOffset[  2 ] ) +  g_SrcTexture.Sample( g_SrcSampler, In.TexCoords0 - PixelOffset[  2 ] ) );
    Color += PixelWeight[0].w * ( g_SrcTexture.Sample( g_SrcSampler, In.TexCoords0 + PixelOffset[  3 ] ) +  g_SrcTexture.Sample( g_SrcSampler, In.TexCoords0 - PixelOffset[  3 ] ) );
	
    return Color;
}

float4 PS_16pixel(VS_OUTPUT In) : SV_TARGET0
{   
    float4 Color;
	
    Color  = PixelWeight[0].x *   g_SrcTexture.Sample( g_SrcSampler, In.TexCoords0 );
    Color += PixelWeight[0].y * ( g_SrcTexture.Sample( g_SrcSampler, In.TexCoords0 + PixelOffset[  1 ] ) +  g_SrcTexture.Sample( g_SrcSampler, In.TexCoords0 - PixelOffset[  1 ] ) );
    Color += PixelWeight[0].z * ( g_SrcTexture.Sample( g_SrcSampler, In.TexCoords0 + PixelOffset[  2 ] ) +  g_SrcTexture.Sample( g_SrcSampler, In.TexCoords0 - PixelOffset[  2 ] ) );
    Color += PixelWeight[0].w * ( g_SrcTexture.Sample( g_SrcSampler, In.TexCoords0 + PixelOffset[  3 ] ) +  g_SrcTexture.Sample( g_SrcSampler, In.TexCoords0 - PixelOffset[  3 ] ) );
    Color += PixelWeight[1].x * ( g_SrcTexture.Sample( g_SrcSampler, In.TexCoords0 + PixelOffset[  4 ] ) +  g_SrcTexture.Sample( g_SrcSampler, In.TexCoords0 - PixelOffset[  4 ] ) );
    Color += PixelWeight[1].y * ( g_SrcTexture.Sample( g_SrcSampler, In.TexCoords0 + PixelOffset[  5 ] ) +  g_SrcTexture.Sample( g_SrcSampler, In.TexCoords0 - PixelOffset[  5 ] ) );
    Color += PixelWeight[1].z * ( g_SrcTexture.Sample( g_SrcSampler, In.TexCoords0 + PixelOffset[  6 ] ) +  g_SrcTexture.Sample( g_SrcSampler, In.TexCoords0 - PixelOffset[  6 ] ) );
    Color += PixelWeight[1].w * ( g_SrcTexture.Sample( g_SrcSampler, In.TexCoords0 + PixelOffset[  7 ] ) +  g_SrcTexture.Sample( g_SrcSampler, In.TexCoords0 - PixelOffset[  7 ] ) );
	
    return Color;
}

float4 PS_32pixel(VS_OUTPUT In) : SV_TARGET0
{   
    float4 Color;
	
    Color  = PixelWeight[0].x *   g_SrcTexture.Sample( g_SrcSampler, In.TexCoords0 );
    Color += PixelWeight[0].y * ( g_SrcTexture.Sample( g_SrcSampler, In.TexCoords0 + PixelOffset[  1 ] ) +  g_SrcTexture.Sample( g_SrcSampler, In.TexCoords0 - PixelOffset[  1 ] ) );
    Color += PixelWeight[0].z * ( g_SrcTexture.Sample( g_SrcSampler, In.TexCoords0 + PixelOffset[  2 ] ) +  g_SrcTexture.Sample( g_SrcSampler, In.TexCoords0 - PixelOffset[  2 ] ) );
    Color += PixelWeight[0].w * ( g_SrcTexture.Sample( g_SrcSampler, In.TexCoords0 + PixelOffset[  3 ] ) +  g_SrcTexture.Sample( g_SrcSampler, In.TexCoords0 - PixelOffset[  3 ] ) );
    Color += PixelWeight[1].x * ( g_SrcTexture.Sample( g_SrcSampler, In.TexCoords0 + PixelOffset[  4 ] ) +  g_SrcTexture.Sample( g_SrcSampler, In.TexCoords0 - PixelOffset[  4 ] ) );
    Color += PixelWeight[1].y * ( g_SrcTexture.Sample( g_SrcSampler, In.TexCoords0 + PixelOffset[  5 ] ) +  g_SrcTexture.Sample( g_SrcSampler, In.TexCoords0 - PixelOffset[  5 ] ) );
    Color += PixelWeight[1].z * ( g_SrcTexture.Sample( g_SrcSampler, In.TexCoords0 + PixelOffset[  6 ] ) +  g_SrcTexture.Sample( g_SrcSampler, In.TexCoords0 - PixelOffset[  6 ] ) );
    Color += PixelWeight[1].w * ( g_SrcTexture.Sample( g_SrcSampler, In.TexCoords0 + PixelOffset[  7 ] ) +  g_SrcTexture.Sample( g_SrcSampler, In.TexCoords0 - PixelOffset[  7 ] ) );
    Color += PixelWeight[2].x * ( g_SrcTexture.Sample( g_SrcSampler, In.TexCoords0 + PixelOffset[  8 ] ) +  g_SrcTexture.Sample( g_SrcSampler, In.TexCoords0 - PixelOffset[  8 ] ) );
    Color += PixelWeight[2].y * ( g_SrcTexture.Sample( g_SrcSampler, In.TexCoords0 + PixelOffset[  9 ] ) +  g_SrcTexture.Sample( g_SrcSampler, In.TexCoords0 - PixelOffset[  9 ] ) );
    Color += PixelWeight[2].z * ( g_SrcTexture.Sample( g_SrcSampler, In.TexCoords0 + PixelOffset[ 10 ] ) +  g_SrcTexture.Sample( g_SrcSampler, In.TexCoords0 - PixelOffset[ 10 ] ) );
    Color += PixelWeight[2].w * ( g_SrcTexture.Sample( g_SrcSampler, In.TexCoords0 + PixelOffset[ 11 ] ) +  g_SrcTexture.Sample( g_SrcSampler, In.TexCoords0 - PixelOffset[ 11 ] ) );
    Color += PixelWeight[3].x * ( g_SrcTexture.Sample( g_SrcSampler, In.TexCoords0 + PixelOffset[ 12 ] ) +  g_SrcTexture.Sample( g_SrcSampler, In.TexCoords0 - PixelOffset[ 12 ] ) );
    Color += PixelWeight[3].y * ( g_SrcTexture.Sample( g_SrcSampler, In.TexCoords0 + PixelOffset[ 13 ] ) +  g_SrcTexture.Sample( g_SrcSampler, In.TexCoords0 - PixelOffset[ 13 ] ) );
    Color += PixelWeight[3].z * ( g_SrcTexture.Sample( g_SrcSampler, In.TexCoords0 + PixelOffset[ 14 ] ) +  g_SrcTexture.Sample( g_SrcSampler, In.TexCoords0 - PixelOffset[ 14 ] ) );
    Color += PixelWeight[3].w * ( g_SrcTexture.Sample( g_SrcSampler, In.TexCoords0 + PixelOffset[ 15 ] ) +  g_SrcTexture.Sample( g_SrcSampler, In.TexCoords0 - PixelOffset[ 15 ] ) );
	
    return Color;
}

