cbuffer cbNormal : register( b0 )
{
	float3 RGBToY : packoffset( c0 ) ;
} ;

SamplerState g_SrcSampler           : register( s0 ) ;
Texture2D    g_SrcTexture           : register( t0 ) ;

SamplerState g_GradientMapSampler   : register( s1 ) ;
Texture2D    g_GradientMapTexture   : register( t1 ) ;

sampler GradientMapTexture : register( s1 ) ;

struct VS_OUTPUT
{
	float4 Position        : POSITION ;
	float2 TexCoords0      : TEXCOORD0 ;
} ;

float4 GradientMap_PS(VS_OUTPUT In) : SV_TARGET0
{
	float4 Color;

	Color = g_SrcTexture.Sample( g_SrcSampler, In.TexCoords0 ) ;
	return  g_GradientMapTexture.Sample( g_GradientMapSampler, float2( dot( Color.rgb, RGBToY.rgb ), 0 ) ) ;
}

float4 GradientMapRev_PS(VS_OUTPUT In) : SV_TARGET0
{
	float4 Color;

	Color = g_SrcTexture.Sample( g_SrcSampler, In.TexCoords0 ) ;
	return g_GradientMapTexture.Sample( g_GradientMapSampler, float2( 1.0f - dot( Color.rgb, RGBToY.rgb ), 0 ) ) ;
}
