cbuffer cbNormal : register( b0 )
{
	float4 Min_LenRev_AfterMin_AfterMax : packoffset( c0 ) ;
} ;

SamplerState g_SrcSampler       : register( s0 ) ;
Texture2D    g_SrcTexture       : register( t0 ) ;

SamplerState g_GammaSampler     : register( s1 ) ;
Texture2D    g_GammaTexture     : register( t1 ) ;

struct VS_OUTPUT
{
	float4 Position        : POSITION ;
	float2 TexCoords0      : TEXCOORD0 ;
} ;

float4 Level_PS(VS_OUTPUT In) : SV_TARGET0
{
	float4 Color;
	float3 Rgb;
	float Ratio;

	Color = g_SrcTexture.Sample( g_SrcSampler, In.TexCoords0 ) ;

	Rgb.rgb = saturate( ( Color.rgb - Min_LenRev_AfterMin_AfterMax.xxx ) * Min_LenRev_AfterMin_AfterMax.y );

	Ratio = g_GammaTexture.Sample( g_GammaSampler, float2( Rgb.r, 0.0 ) ).r ;
	Color.r = lerp( Min_LenRev_AfterMin_AfterMax.z, Min_LenRev_AfterMin_AfterMax.w, Ratio );

	Ratio = g_GammaTexture.Sample( g_GammaSampler, float2( Rgb.g, 0.0 ) ).r ;
	Color.g = lerp( Min_LenRev_AfterMin_AfterMax.z, Min_LenRev_AfterMin_AfterMax.w, Ratio );

	Ratio = g_GammaTexture.Sample( g_GammaSampler, float2( Rgb.b, 0.0 ) ).r ;
	Color.b = lerp( Min_LenRev_AfterMin_AfterMax.z, Min_LenRev_AfterMin_AfterMax.w, Ratio );

	return Color;
}

