cbuffer cbNormal : register( b0 )
{
	float3 RGBToY     : packoffset( c0 ) ;
	float3 YCbCrToRGB : packoffset( c1 ) ;
} ;

SamplerState g_SrcSampler       : register( s0 ) ;
Texture2D    g_SrcTexture       : register( t0 ) ;

struct VS_OUTPUT
{
	float4 Position        : POSITION ;
	float2 TexCoords0      : TEXCOORD0 ;
} ;

float4 Mono_PS(VS_OUTPUT In) : SV_TARGET0
{
	float4 Color;
	float3 Rgb;

	Color = g_SrcTexture.Sample( g_SrcSampler, In.TexCoords0 ) ;
	Rgb = Color.rgb;

	Rgb.rgb = dot( Rgb, RGBToY );
	Color.rgb = Rgb + YCbCrToRGB;

	return Color;
}
