cbuffer cbNormal : register( b0 )
{
	float4 RGBToY_Cmp : packoffset( c0 ) ;
	float4 LowColor   : packoffset( c1 ) ;
	float4 HighColor  : packoffset( c2 ) ;
} ;

SamplerState g_SrcSampler       : register( s0 ) ;
Texture2D    g_SrcTexture       : register( t0 ) ;

struct VS_OUTPUT
{
	float4 Position        : POSITION ;
	float2 TexCoords0      : TEXCOORD0 ;
} ;

float4 TwoColor_PS(VS_OUTPUT In) : SV_TARGET0
{
	float4 Color;

	Color = g_SrcTexture.Sample( g_SrcSampler, In.TexCoords0 ) ;

	if( dot( Color.rgb, RGBToY_Cmp.rgb ) > RGBToY_Cmp.w )
	{
		Color = HighColor;
	}
	else
	{
		Color = LowColor;
	}

	return Color;
}
