// -------------------------------------------------------------------------------
// 
// 		cwCu		`揈vO( Direct3D11 )wb_t@C
// 
// 				Ver 3.13b
// 
// -------------------------------------------------------------------------------

#ifndef __DXGRAPHICSD3D11_H__
#define __DXGRAPHICSD3D11_H__

#include "../DxCompileConfig.h"

#ifndef DX_NON_DIRECT3D11

// CN[h ------------------------------------------------------------------
#include "../DxLib.h"
#include "../DxGraphics.h"
#include "../DxArchive_.h"
#include "DxGraphicsAPIWin.h"
#include "DxShader_DataType_D3D11.h"
#include "DxShader_PS_D3D11.h"
#include "DxShader_VS_D3D11.h"

#ifdef DX_USE_NAMESPACE

namespace DxLib
{

#endif // DX_USE_NAMESPACE

// }N` --------------------------------------------------------------------

#define GD3D11								GraphicsHardDataDirect3D11

// ǗeNX`ւ̃f[^]pVXezueNX`̐
#define DIRECT3D11_SYSMEMTEXTURE_NUM				(2048)

// ǗeNX`ւ̃f[^]pVXezuT[tFX̐
#define DIRECT3D11_SYSMEMSURFACE_NUM				(2048)

// @\x̐
#define DIRECT3D11_FEATURE_LEVEL_NUM				(7)

// obNobt@̃tH[}bg
#define DIRECT3D11_BACKBUFFER_FORMAT				D_DXGI_FORMAT_R8G8B8A8_UNORM

// 16rbg[xobt@Texture2DtH[}bg
#define DIRECT3D11_DEPTHBUFFER_TEXTURE2D_FORMAT		D_DXGI_FORMAT_R16_TYPELESS

// 16rbg[xobt@DepthStenciltH[}bg
#define DIRECT3D11_DEPTHBUFFER_DEPTHSTENCIL_FORMAT	D_DXGI_FORMAT_D16_UNORM

// ftHgTv[Xe[g̃tB^[[h̐
#define DIRECT3D11_DEFAULTRS_FILTER_NUM						(18)

// ftHgX^CU[Xe[g̃tB[h
#define DIRECT3D11_DEFAULTRS_FILLMODE_WIRE					(0)
#define DIRECT3D11_DEFAULTRS_FILLMODE_SOLID					(1)
#define DIRECT3D11_DEFAULTRS_FILLMODE_NUM					(2)

// ftHgXe[gp̔r[h`
#define DIRECT3D11_DEFAULT_CMP_NEVER						(0)				// FALSE
#define DIRECT3D11_DEFAULT_CMP_LESS							(1)				// Src <  Dest		DrawAlpha <  TestParam
#define DIRECT3D11_DEFAULT_CMP_EQUAL						(2)				// Src == Dest		DrawAlpha == TestParam
#define DIRECT3D11_DEFAULT_CMP_LESSEQUAL					(3)				// Src <= Dest		DrawAlpha <= TestParam
#define DIRECT3D11_DEFAULT_CMP_GREATER						(4)				// Src >  Dest		DrawAlpha >  TestParam
#define DIRECT3D11_DEFAULT_CMP_NOTEQUAL						(5)				// Src != Dest		DrawAlpha != TestParam
#define DIRECT3D11_DEFAULT_CMP_GREATEREQUAL					(6)				// Src >= Dest		DrawAlpha >= TestParam
#define DIRECT3D11_DEFAULT_CMP_ALWAYS						(7)				// TRUE
#define DIRECT3D11_DEFAULT_CMP_NUM							(8)

// sNZVF[_[̃At@eXg[h
#define DIRECT3D11_PS_ALPHATEST_CMP_ALWAYS					(0)				// At@eXgȂ
#define DIRECT3D11_PS_ALPHATEST_CMP_GREATER					(1)				// `At@leXgAt@l傫Ε`
#define DIRECT3D11_PS_ALPHATEST_CMP_OTHER					(2)				// GREATER ȊO̔r[h
#define DIRECT3D11_PS_ALPHATEST_NUM							(3)

// ŒpCvC݊_tH[}bg
#define VERTEXFVF_LAYOUT_2D							(0)			// ( VERTEX2D or VERTEX_2D                \̌` )gXtH[ςݒ_tH[}bg
#define VERTEXFVF_LAYOUT_NOTEX_2D					(1)			// ( VERTEX_NOTEX_2D                      \̌` )CA{bNX`p_tH[}bg
#define VERTEXFVF_LAYOUT_BLENDTEX_2D				(2)			// ( VERTEX_BLENDTEX_2D or VERTEX2DSHADER \̌` )uheNX`tgXtH[ςݒ_tH[}bg
#define VERTEXFVF_LAYOUT_NOTEX_3D					(3)			// ( VERTEX_NOTEX_3D                      \̌` )CA{bNX`p_tH[}bgARcp( o[Wp )
#define VERTEXFVF_LAYOUT_3D							(4)			// ( VERTEX_3D                            \̌` )OtBbNX`p_tH[}bgARcp( o[Wp )
#define VERTEXFVF_LAYOUT_3D_LIGHT					(5)			// ( VERTEX3D                             \̌` )OtBbNX`p_tH[}bg
#define VERTEXFVF_LAYOUT_SHADER_3D					(6)			// ( VERTEX3DSHADER                       \̌` )VF[_[`p_tH[}bg
#define VERTEXFVF_LAYOUT_NUM						(7)

// _obt@̃TCY
#define D3D11DEV_NOTEX_VERTBUFFERSIZE			(63 * 1024)		// 63KB
#define D3D11DEV_TEX_VERTBUFFERSIZE				(64 * 1024)		// 64KB
#define D3D11DEV_BLENDTEX_VERTBUFFERSIZE		(64 * 1024)		// 64KB
#define D3D11DEV_NOTEX_3D_VERTBUFFERSIZE		(64 * 1024)		// 64KB
#define D3D11DEV_TEX_3D_VERTBUFFERSIZE			(64 * 1024)		// 64KB
#define D3D11DEV_NOTEX_VERTMAXNUM				(D3D11DEV_NOTEX_VERTBUFFERSIZE     / sizeof( VERTEX_NOTEX_2D    ))
#define D3D11DEV_TEX_VERTMAXNUM					(D3D11DEV_TEX_VERTBUFFERSIZE       / sizeof( VERTEX_2D          ))
#define D3D11DEV_BLENDTEX_VERTMAXNUM			(D3D11DEV_BLENDTEX_VERTBUFFERSIZE  / sizeof( VERTEX_BLENDTEX_2D ))
#define D3D11DEV_NOTEX_3D_VERTMAXNUM			(D3D11DEV_NOTEX_3D_VERTBUFFERSIZE  / sizeof( VERTEX_NOTEX_3D    ))
#define D3D11DEV_TEX_3D_VERTMAXNUM				(D3D11DEV_TEX_3D_VERTBUFFERSIZE    / sizeof( VERTEX_3D          ))

// e萔obt@̃ZbgWX^ԍ
#define DX_D3D11_VS_CONSTANTBUFFER_COMMON		(0)
#define DX_D3D11_VS_CONSTANTBUFFER_BASE			(1)
#define DX_D3D11_VS_CONSTANTBUFFER_OTHERMATRIX	(2)
#define DX_D3D11_VS_CONSTANTBUFFER_MATRIX		(3)

#define DX_D3D11_PS_CONSTANTBUFFER_COMMON		(0)
#define DX_D3D11_PS_CONSTANTBUFFER_BASE			(1)
#define DX_D3D11_PS_CONSTANTBUFFER_SHADOWMAP	(2)

// \̒` --------------------------------------------------------------------

// Direct3D11p n[hEGA_OpIWi摜eNX`
struct IMAGEDATA_ORIG_HARD_TEX_DIRECT3D11
{
	D_ID3D11Texture2D *				Texture ;								// eNX`
	D_ID3D11ShaderResourceView *	TextureSRV ;							// eNX`pVF[_[\[Xr[

	D_ID3D11Texture2D *				CubeMapTexture ;						// L[u}bveNX`
	D_ID3D11ShaderResourceView *	CubeMapTextureSRV ;						// L[u}bveNX`pVF[_[\[Xr[
	D_ID3D11RenderTargetView *		CubeMapTextureRTV[ CUBEMAP_SURFACE_NUM ] ;	// L[u}bvp_O^[Qbgr[

	D_ID3D11Texture2D *				RenderTarget ;							// _O^[QbgeNX`
	D_ID3D11RenderTargetView *		RenderTargetRTV ;						// _O^[QbgeNX`p_O^[Qbgr[

	D_ID3D11Texture2D *				DepthBuffer ;							// [xobt@
	D_ID3D11DepthStencilView *		DepthBufferDSV ;						// [xobt@pfvXXeVr[

//	D_IDirect3DTexture9	*			MemTexture ;							// D3DPOOL_MANAGED gpłȂ摜peNX`
//	D_IDirect3DSurface9	*			Surface[ CUBEMAP_SURFACE_NUM ] ;		// T[tFX
//	D_IDirect3DSurface9	*			RenderTargetSurface ;					// _O^[QbgT[tFX
//	D_IDirect3DSurface9	*			DepthBuffer ;							// [xobt@
} ;

// Direct3D11p VhE}bv
struct SHADOWMAPDATA_DIRECT3D11
{
	D_ID3D11Texture2D *				DepthTexture ;							// [xlݗpeNX`
	D_ID3D11ShaderResourceView *	DepthTextureSRV ;						// [xlݗpeNX`pVF[_[\[Xr[
	D_ID3D11RenderTargetView *		DepthTextureRTV ;						// [xlݗpeNX`p_O^[Qbgr[

	D_ID3D11Texture2D *				DepthBuffer ;							// [xobt@
	D_ID3D11DepthStencilView *		DepthBufferDSV ;						// [xobt@pfvXXeVr[
} ;

// Direct3D11p _obt@nh
struct VERTEXBUFFERHANDLEDATA_DIRECT3D11
{
	D_ID3D11Buffer					*VertexBuffer ;							// ID3D11Buffer ̃|C^
} ;

// Direct3D11p CfbNXobt@nh
struct INDEXBUFFERHANDLEDATA_DIRECT3D11
{
	D_ID3D11Buffer					*IndexBuffer ;							// ID3D11Buffer ̃|C^
} ;

// Direct3D11p VF[_[nh
struct SHADERHANDLEDATA_DIRECT3D11
{
	union
	{
		D_ID3D11PixelShader			*PixelShader ;							// ID3D11PixelShader ̃|C^
		D_ID3D11VertexShader		*VertexShader ;							// ID3D11VertexShader ̃|C^
	} ;
} ;

// 萔obt@\
struct CONSTANTBUFFER_DIRECT3D11
{
	DWORD								Size ;								// TCY( oCgP )
	D_ID3D11Buffer *					ConstantBuffer ;					// ID3D11Buffer ̃|C^
	void *								SysmemBuffer ;						// 萔obt@ƓTCỸVXẽobt@
	int									ChangeFlag ;						// VXẽobt@ύXAID3DBuffer ւ̔fKvǂ( TRUE:Kv  FALSE:sv )

	CONSTANTBUFFER_DIRECT3D11 *			NextData ;							// Xg\̎̃f[^ւ̃|C^
	CONSTANTBUFFER_DIRECT3D11 *			PrevData ;							// Xg\̑Õf[^ւ̃|C^
} ;

// 萔obt@Ǘ\
struct CONSTANTBUFFER_DIRECT3D11_MANAGE
{
	int									BufferNum ;							// 萔obt@\̂̐
	CONSTANTBUFFER_DIRECT3D11 *			FirstBuffer ;						// ŏ̒萔obt@\̂ւ̃|C^
} ;

// Direct3D11 ̕W`p̃VF[_[Z߂\
struct GRAPHICS_HARDWARE_DIRECT3D11_SHADER_BASE
{
	// W`p̕GȏsȂ_VF[_[
	D_ID3D11VertexShader					*BaseSimple_VS[ VERTEXFVF_LAYOUT_NUM ] ;

	// Œ@\pCvC݊̃sNZVF[_[( eNX`Ȃ )
	// [ ( 0:ʏ`  1:Z`  2:RGB]  3:`PxS{  4:Zς݃uh[h̒ʏ`  5:Zς݃uh[hRGB]  6:Zς݃uh[h̕`Px4{ ) ]
	// [ sNZVF[_[̃At@eXg[h ]
	D_ID3D11PixelShader						*BaseNoneTex_PS[ 7 ][ DIRECT3D11_PS_ALPHATEST_NUM ] ;

	// Œ@\pCvC݊̃sNZVF[_[( eNX` )
	// [ uh摜Ƃ̃uh^Cv( 0:Ȃ  1:DX_BLENDGRAPHTYPE_NORMAL  2:DX_BLENDGRAPHTYPE_WIPE  3:DX_BLENDGRAPHTYPE_ALPHA ) ]
	// [ ( 0:ʏ`  1:Z`  2:RGB]  3:`PxS{  4:Zς݃uh[h̒ʏ`  5:Zς݃uh[hRGB]  6:Zς݃uh[h̕`Px4{ ) ]
	// [ eNX`RGB( 0:Ȃ  1: ) ]
	// [ eNX`Alpha( 0:Ȃ  1: ) ]
	// [ sNZVF[_[̃At@eXg[h ]
	D_ID3D11PixelShader						*BaseUseTex_PS[ 4 ][ 7 ][ 2 ][ 2 ][ DIRECT3D11_PS_ALPHATEST_NUM ] ;

	// }XNp̃sNZVF[_[
	D_ID3D11PixelShader						*MaskEffect_PS ;
} ;

// Direct3D11 ̕WRc`p̃VF[_[Z߂\
struct GRAPHICS_HARDWARE_DIRECT3D11_SHADER_BASE3D
{
	// WRc`psNZPʃCeBO^Cv̒_VF[_[( Xg͔z̍ )
	// [ VhE}bv̗L( 0: 1:L ) ]
	// /* [ bV^Cv( 0:̃bV 1:4{[XLjObV 2:8{[XLjObV ) ] */
	// /* [ ov}bv̗L( 0: 1:L ) ] */
	// [ tHO^Cv ]
	D_ID3D11VertexShader					*Base3D_PixelLighting_VS[ 2 ]/*[ 3 ]*//*[ 2 ]*/[ 4 ] ;

	// WRc`psNZPʃCeBO^CṽsNZVF[_[( Xg͔z̍ )
	// [ VhE}bv̗L( 0: 1:L ) ]
	// /*[ }`eNX`̃uh[hAMV1_LAYERBLEND_TYPE_TRANSLUCENT Ȃǂ +1  ( 0:}`eNX`  1:uh  2:Zuh  3:Zuh  4:Zuh~2 ) ]*/
	// /*[ XyL}bv ( 0: 1: ) ]*/
	// /*[ ov}bv ( 0:Ȃ 1: ) ]*/
	// [ CgCfbNX ]
	// [ XyL̗L( 0: 1:L ) ]
	// [ sNZVF[_[̃At@eXg[h ]
	D_ID3D11VertexShader					*Base3D_PixelLighting_Normal_PS[ 2 ]/*[ 5 ]*//*[ 2 ]*//*[ 2 ]*/[ 84 ][ 2 ][ DIRECT3D11_PS_ALPHATEST_NUM ] ;



	// WRc`p̃VhE}bvւ̃_Op_VF[_[
	// /*[ bV^Cv( 0:̃bV 1:4{[XLjObV  2:8{[XLjObV ) ]*/
	// [ ov}bv̗L( 0: 1:L ) ]
	D_ID3D11VertexShader					*Base3D_ShadowMap_VS/*[ 3 ]*/[ 2 ] ;

	// WRc`p̃CeBOȂ_VF[_[
	// /*[ bV^Cv( 0:̃bV 1:4{[XLjObV  2:8{[XLjObV ) ]*/
	// [ tHO^Cv ]
	D_ID3D11VertexShader					*Base3D_NoLighting_VS/*[ 3 ]*/[ 4 ] ;

	// WRc`p̒_PʃCeBO_VF[_[
	// [ VhE}bv̗L( 0: 1:L ) ]
	// /*[ bV^Cv( 0:̃bV 1:4{[XLjObV  2:8{[XLjObV ) ]*/
	// /*[ ov}bv̗L( 0: 1:L ) ]*/
	// [ tHO^Cv ]
	// [ CgCfbNX ]
	// [ XyL̗L( 0: 1:L ) ]
	D_ID3D11VertexShader					*Base3D_VertexLighting_VS[ 2 ]/*[ 3 ]*//*[ 2 ]*/[ 4 ][ 20 ][ 2 ] ;

	// WRc`p̃VhE}bvւ̃_OpsNZVF[_[
	// [ sNZVF[_[̃At@eXg[h ]
	D_ID3D11PixelShader						*Base3D_ShadowMap_Normal_PS[ DIRECT3D11_PS_ALPHATEST_NUM ] ;

	// WRc`p̃CeBOȂsNZVF[_[
	// /*[ }`eNX`̃uh[hAMV1_LAYERBLEND_TYPE_TRANSLUCENT Ȃǂ +1  ( 0:}`eNX`  1:uh  2:Zuh  3:Zuh  4:Zuh~2 ) ]*/
	// [ sNZVF[_[̃At@eXg[h ]
	D_ID3D11PixelShader						*Base3D_NoLighting_Normal_PS/*[ 5 ]*/[ DIRECT3D11_PS_ALPHATEST_NUM ] ;

	// WRc`p̒_PʃCeBOsNZVF[_[
	// [ VhE}bv̗L( 0: 1:L ) ]
	// /* [ }`eNX`̃uh[hAMV1_LAYERBLEND_TYPE_TRANSLUCENT Ȃǂ +1  ( 0:}`eNX`  1:uh  2:Zuh  3:Zuh  4:Zuh~2 ) ] */
	// /* [ XyL}bv ( 0: 1: ) ] */
	// /* [ ov}bv ( 0:Ȃ 1: ) ] */
	// [ CgCfbNX ]
	// [ XyL̗L( 0: 1:L ) ]
	// [ sNZVF[_[̃At@eXg[h ]
	D_ID3D11PixelShader						*Base3D_VertexLighting_Normal_PS[ 2 ]/*[ 5 ]*//*[ 2 ]*//*[ 2 ]*/[ 10 ][ 2 ][ DIRECT3D11_PS_ALPHATEST_NUM ] ;
} ;


#ifndef DX_NON_MODEL

// Direct3D11 ̃f`p̃VF[_[Z߂\
struct GRAPHICS_HARDWARE_DIRECT3D11_SHADER_MODEL
{
	// f`psNZPʃCeBO^Cv̒_VF[_[( Xg͔z̍ )
	// [ VhE}bv̗L( 0: 1:L ) ]
	// [ bV^Cv( 0:̃bV 1:4{[XLjObV 2:8{[XLjObV ) ]
	// [ ov}bv̗L( 0: 1:L ) ]
	// [ tHO^Cv ]
	D_ID3D11VertexShader					*MV1_PixelLighting_VS[ 2 ][ 3 ][ 2 ][ 4 ] ;

	// f`psNZPʃCeBO^CṽgD[psNZVF[_[( Xg͔z̍ )
	// [ VhE}bv̗L( 0: 1:L ) ]
	// [ gD[_O^Cv( 0:gD[_O type 1   1:gD[_O Type 2 ) ]
	// [ gD[_ÕXtBA}bv̗Lƃuh^Cv( 0:XtBA}bv͖   1:MV1_LAYERBLEND_TYPE_MODULATE  2:MV1_LAYERBLEND_TYPE_ADDITIVE ) ]
	// [ gD[_ÕfBt[YOf[Ṽuh^Cv( 0:MV1_LAYERBLEND_TYPE_TRANSLUCENT  1:MV1_LAYERBLEND_TYPE_MODULATE ) ]
	// [ gD[_ÕXyLOf[Ṽuh^Cv( 0:MV1_LAYERBLEND_TYPE_TRANSLUCENT  1:MV1_LAYERBLEND_TYPE_ADDITIVE ) ]
	// [ XyL}bv ( 0: 1: ) ]
	// [ ov}bv ( 0:Ȃ 1: ) ]
	// [ CgCfbNX ]
	// [ XyL̗L( 0: 1:L ) ]
	// [ sNZVF[_[̃At@eXg[h ]
	D_ID3D11PixelShader						*MV1_PixelLighting_Toon_PS[ 2 ][ 2 ][ 3 ][ 2 ][ 2 ][ 2 ][ 2 ][ 84 ][ 2 ][ DIRECT3D11_PS_ALPHATEST_NUM ] ;

	// f`psNZPʃCeBO^CṽsNZVF[_[( Xg͔z̍ )
	// [ VhE}bv̗L( 0: 1:L ) ]
	// [ }`eNX`̃uh[hAMV1_LAYERBLEND_TYPE_TRANSLUCENT Ȃǂ +1  ( 0:}`eNX`  1:uh  2:Zuh  3:Zuh  4:Zuh~2 ) ]
	// [ XyL}bv ( 0: 1: ) ]
	// [ ov}bv ( 0:Ȃ 1: ) ]
	// [ CgCfbNX ]
	// [ XyL̗L( 0: 1:L ) ]
	// [ sNZVF[_[̃At@eXg[h ]
	D_ID3D11PixelShader						*MV1_PixelLighting_Normal_PS[ 2 ][ 5 ][ 2 ][ 2 ][ 84 ][ 2 ][ DIRECT3D11_PS_ALPHATEST_NUM ] ;





	// f`p̃gD[_O̗֊s`p_VF[_[
	// [ bV^Cv( 0:̃bV 1:4{[XLjObV  2:8{[XLjObV ) ]
	// [ tHO^Cv ]
	D_ID3D11VertexShader					*MV1_ToonOutLine_VS[ 3 ][ 4 ] ;

	// f`p̃VhE}bvւ̃_Op_VF[_[
	// [ bV^Cv( 0:̃bV 1:4{[XLjObV  2:8{[XLjObV ) ]
	D_ID3D11VertexShader					*MV1_ShadowMap_VS[ 3 ] ;

	// f`p̃CeBOȂ_VF[_[
	// [ bV^Cv( 0:̃bV 1:4{[XLjObV  2:8{[XLjObV ) ]
	// [ tHO^Cv ]
	D_ID3D11VertexShader					*MV1_NoLighting_VS[ 3 ][ 4 ] ;

	// f`p̒_PʃCeBO蒸_VF[_[
	// [ VhE}bv̗L( 0: 1:L ) ]
	// [ bV^Cv( 0:̃bV 1:4{[XLjObV  2:8{[XLjObV ) ]
	// [ ov}bv̗L( 0: 1:L ) ]
	// [ tHO^Cv ]
	// [ CgCfbNX ]
	// [ XyL̗L( 0: 1:L ) ]
	D_ID3D11VertexShader					*MV1_VertexLighting_VS[ 2 ][ 3 ][ 2 ][ 4 ][ 20 ][ 2 ] ;


	// f`p̃gD[_O̗֊s`psNZVF[_[
	// [ sNZVF[_[̃At@eXg[h ]
	D_ID3D11PixelShader						*MV1_ToonOutLine_PS[ DIRECT3D11_PS_ALPHATEST_NUM ] ;

	// f`p̃VhE}bvւ̃gD[_OpsNZVF[_[
	// [ gD[_O^Cv( 0:gD[_O type 1   1:gD[_O type 2 ) ]
	// [ gD[_ÕXtBA}bv̗Lƃuh^Cv( 0:XtBA}bv͖   1:MV1_LAYERBLEND_TYPE_MODULATE  2:MV1_LAYERBLEND_TYPE_ADDITIVE ) ]
	// [ gD[_ÕfBt[YOf[Ṽuh^Cv( 0:MV1_LAYERBLEND_TYPE_TRANSLUCENT  1:MV1_LAYERBLEND_TYPE_MODULATE ) ]
	// [ sNZVF[_[̃At@eXg[h ]
	D_ID3D11PixelShader						*MV1_ShadowMap_Toon_PS[ 2 ][ 3 ][ 2 ][ DIRECT3D11_PS_ALPHATEST_NUM ] ;

	// f`p̃VhE}bvւ̃_OpsNZVF[_[
	// [ sNZVF[_[̃At@eXg[h ]
	D_ID3D11PixelShader						*MV1_ShadowMap_Normal_PS[ DIRECT3D11_PS_ALPHATEST_NUM ] ;

	// f`p̃CeBOȂgD[psNZVF[_[( Xg͔z̍ )
	// [ gD[_O^Cv( 0:gD[_O type 1   1:gD[_O type 2 ) ]
	// [ gD[_ÕfBt[YOf[Ṽuh^Cv( 0:MV1_LAYERBLEND_TYPE_TRANSLUCENT  1:MV1_LAYERBLEND_TYPE_MODULATE ) ]
	// [ sNZVF[_[̃At@eXg[h ]
	D_ID3D11PixelShader						*MV1_NoLighting_Toon_PS[ 2 ][ 2 ][ DIRECT3D11_PS_ALPHATEST_NUM ] ;

	// f`p̃CeBOȂsNZVF[_[
	// [ }`eNX`̃uh[hAMV1_LAYERBLEND_TYPE_TRANSLUCENT Ȃǂ +1  ( 0:}`eNX`  1:uh  2:Zuh  3:Zuh  4:Zuh~2 ) ]
	// [ sNZVF[_[̃At@eXg[h ]
	D_ID3D11PixelShader						*MV1_NoLighting_Normal_PS[ 5 ][ DIRECT3D11_PS_ALPHATEST_NUM ] ;

	// f`p̒_PʃCeBOgD[psNZVF[_[
	// [ VhE}bv̗L( 0: 1:L ) ]
	// [ gD[_O^Cv( 0:gD[_O type 1   1:gD[_O type 2 ) ]
	// [ gD[_ÕXtBA}bv̗Lƃuh^Cv( 0:XtBA}bv͖   1:MV1_LAYERBLEND_TYPE_MODULATE  2:MV1_LAYERBLEND_TYPE_ADDITIVE ) ]
	// [ gD[_ÕfBt[YOf[Ṽuh^Cv( 0:MV1_LAYERBLEND_TYPE_TRANSLUCENT  1:MV1_LAYERBLEND_TYPE_MODULATE ) ]
	// [ gD[_ÕXyLOf[Ṽuh^Cv( 0:MV1_LAYERBLEND_TYPE_TRANSLUCENT  1:MV1_LAYERBLEND_TYPE_ADDITIVE ) ]
	// [ XyL}bv ( 0: 1: ) ]
	// [ ov}bv ( 0:Ȃ 1: ) ]
	// [ CgCfbNX ]
	// [ XyL̗L( 0: 1:L ) ]
	// [ sNZVF[_[̃At@eXg[h ]
	D_ID3D11PixelShader						*MV1_VertexLighting_Toon_PS[ 2 ][ 2 ][ 3 ][ 2 ][ 2 ][ 2 ][ 2 ][ 10 ][ 2 ][ DIRECT3D11_PS_ALPHATEST_NUM ] ;

	// f`p̒_PʃCeBOsNZVF[_[
	// [ VhE}bv̗L( 0: 1:L ) ]
	// [ }`eNX`̃uh[hAMV1_LAYERBLEND_TYPE_TRANSLUCENT Ȃǂ +1  ( 0:}`eNX`  1:uh  2:Zuh  3:Zuh  4:Zuh~2 ) ]
	// [ XyL}bv ( 0: 1: ) ]
	// [ ov}bv ( 0:Ȃ 1: ) ]
	// [ CgCfbNX ]
	// [ XyL̗L( 0: 1:L ) ]
	// [ sNZVF[_[̃At@eXg[h ]
	D_ID3D11PixelShader						*MV1_VertexLighting_Normal_PS[ 2 ][ 5 ][ 2 ][ 2 ][ 10 ][ 2 ][ DIRECT3D11_PS_ALPHATEST_NUM ] ;
} ;
#endif // DX_NON_MODEL

// Direct3D11 ̒萔Z߂\
struct GRAPHICS_HARDWARE_DIRECT3D11_CONSTANT
{
	CONSTANTBUFFER_DIRECT3D11_MANAGE			ConstantBufferManage ;			// 萔obt@

	CONSTANTBUFFER_DIRECT3D11 *					ConstBuffer_Common ;			// _VF[_[sNZVF[_[ʂ̃p[^p萔obt@( DX_D3D11_CONST_BUFFER_COMMON \ )
	int											SetNormalMaterial ;				// 萔obt@ɕW`p̃}eAp[^ݒ肳Ă邩ǂ( TRUE:ݒ肳Ă  FALSE:ݒ肳ĂȂ )

	CONSTANTBUFFER_DIRECT3D11 *					ConstBuffer_VS_Base ;			// _VF[_[{p[^p萔obt@( DX_D3D11_VS_CONST_BUFFER_BASE \ )
	int											SetNormalColorSource ;			// 萔obt@ɕW`ṕufBt[YJ[EXyLJ[}eAgp邩A_f[^gp邩v̐ݒ肪Ă邩ǂ( TRUE:ݒ肳Ă  FALSE:ݒ肳ĂȂ )

	CONSTANTBUFFER_DIRECT3D11 *					ConstBuffer_VS_OtherMatrix ;	// _VF[_[̑sp[^p萔obt@( DX_D3D11_VS_CONST_BUFFER_OTHERMATRIX \ )
	int											SetNormalTextureAddressTransformMatrix ;	// 萔obt@ɕW`p̃eNX`Wps񂪐ݒ肳Ă邩ǂ( TRUE:ݒ肳Ă  FALSE:ݒ肳ĂȂ )

	CONSTANTBUFFER_DIRECT3D11 *					ConstBuffer_PS_Base ;			// sNZVF[_[{p[^p萔obt@( DX_D3D11_PS_CONST_BUFFER_BASE \ )
	CONSTANTBUFFER_DIRECT3D11 *					ConstBuffer_PS_ShadowMap ;		// sNZVF[_[VhE}bvp萔obt@( DX_D3D11_PS_CONST_BUFFER_SHADOWMAP \ )
} ;

// Direct3D11 ̃VF[_[Z߂\
struct GRAPHICS_HARDWARE_DIRECT3D11_SHADER
{
	GRAPHICS_HARDWARE_DIRECT3D11_CONSTANT		Constant ;						// 萔Z߂\

	GRAPHICS_HARDWARE_DIRECT3D11_SHADER_BASE	Base ;							// W`揈p̃VF[_[Z߂\
	GRAPHICS_HARDWARE_DIRECT3D11_SHADER_BASE3D	Base3D ;						// WRc`揈p̃VF[_[Z߂\

#ifndef DX_NON_MODEL
	GRAPHICS_HARDWARE_DIRECT3D11_SHADER_MODEL	Model ;							// f`揈p̃VF[_[Z߂\
#endif // DX_NON_MODEL

	int											UseShadowMap ;					// VhE}bvgp邩ǂ( TRUE:gp  FALSE:gpȂ )
} ;



// Direct3D11 ̓̓CAEgZ߂\
struct GRAPHICS_HARDWARE_DIRECT3D11_INPUTLAYOUT
{
	// W`p̒_VF[_[Ŏgp钸_f[^tH[}bg
	D_ID3D11InputLayout *						BaseInputLayout[ VERTEXFVF_LAYOUT_NUM ] ;

#ifndef DX_NON_MODEL
	// ̓CAEg( Xg͔z̍ )
	// [ ov}bvtǂ( 1:ov}bvt 0:tĂȂ ) ]
	// [ XLjObVǂ( 0:̃bV 1:4{[XLjObV 2:8{[XLjObV ) ]
	D_ID3D11InputLayout *						MV1_VertexInputLayout[ 2 ][ 3 ] ;
#endif // DX_NON_MODEL
} ;







// D3D11Device ɐݒ肵ĂlZ߂\
struct GRAPHICS_HARDDATA_DIRECT3D11_DEVICE_STATE
{
	float									FactorColorPSConstantF[ 4 ] ;					// sNZVF[_[gcwCuWp FactorColor ̒l
	int										FogEnable ;										// tHOLǂ( TRUE:L  FALSE: )
	int										FogMode ;										// tHO[h
	DWORD									FogColor ;										// tHOJ[
	float									FogStart ;										// tHOJn
	float									FogEnd ;										// tHOI
	float									FogDensity ;									// tHOx
	COLOR_F									GlobalAmbientLightColor ;						// O[oArGgCgJ[
	int										LightEnableMaxIndex ;							// LȃCg̍őCfbNX
	int										LightEnableFlag[ DX_D3D11_COMMON_CONST_LIGHT_NUM ] ;// CgLǂtO( TRUE:L  FALSE: )
	LIGHTPARAM								LightParam[ DX_D3D11_COMMON_CONST_LIGHT_NUM ] ;	// Cg̃p[^
	int										Lighting ;										// CeBOsǂ̃tO( TRUE:CeBOs  FALSE:CeBOȂ )
	int										UseSpecular ;									// XyLgp邩ǂ
	MATERIALPARAM							Material ;										// }eA
	int										MaterialUseVertexDiffuseColor ;					// _̃fBt[YJ[}eÃfBt[YJ[ƂĎgp邩ǂ
	int										MaterialUseVertexSpecularColor ;				// _̃XyLJ[}eÃXyLJ[ƂĎgp邩ǂ

	int										ChangeSamplerDesc ;								// foCX̃Tv[Xe[g̐ݒɕύXǂ( TRUE:ύX  FALSE:ύX͂Ȃ )
	int										ChangeSamplerDescSlot[ USE_TEXTURESTAGE_NUM ] ;	// foCX̊eXbg̃Tv[Xe[g̐ݒɕύXǂ( TRUE:ύX  FALSE:ύX͂Ȃ )
	D_D3D11_SAMPLER_DESC					SamplerDesc[ USE_TEXTURESTAGE_NUM ] ;			// foCX̊eXbg̃Tv[Xe[g̐ݒl
	D_ID3D11SamplerState *					SamplerState[ USE_TEXTURESTAGE_NUM ] ;			// ݃foCX̊eXbgɐݒ肳ĂTv[Xe[g
	int										ChangeSamplerStateReleaseFlag[ USE_TEXTURESTAGE_NUM ] ;					// ݃foCX̊eXbgɐݒ肳ĂTv[Xe[gύXۂɃ[X邩ǂ̃tO( TRUE:[X  FALSE:[XȂ )
	D_ID3D11SamplerState *					DefaultSamplerStateArray[ DIRECT3D11_DEFAULTRS_FILTER_NUM ][ D_D3D11_TEXTURE_ADDRESS_MIRROR_ONCE + 1 ][ D_D3D11_TEXTURE_ADDRESS_MIRROR_ONCE + 1 ][ D_D3D11_TEXTURE_ADDRESS_MIRROR_ONCE + 1 ] ;	// 悭gݒ̃Tv[Xe[g̔z

	D_D3D11_VIEWPORT						Viewport ;										// r[|[g

	int										ChangeRasterizerDesc ;							// foCX̃X^CU[Xe[g̐ݒɕύXǂ( TRUE:ύX  FALSE:ύX͂Ȃ )
	D_D3D11_RASTERIZER_DESC					RasterizerDesc ;								// ݃foCXɐݒ肳Ă郉X^CU[Xe[g̐ݒl
	D_ID3D11RasterizerState *				RasterizerState ;								// ݃foCXɐݒ肳Ă郉X^CU[Xe[g
	int										ChangeRasterizerStateReleaseFlag ;				// ݃foCXɐݒ肳Ă郉X^CU[Xe[gύXۂɃ[X邩ǂ̃tO( TRUE:[X  FALSE:[XȂ )
	D_ID3D11RasterizerState *				DefaultRasterizerStateArray[ D_D3D11_CULL_BACK + 1 ][ D_D3D11_FILL_SOLID + 1 ][ 2 /* [xeXg̗L */ ][ 2 /* }`Tv̗L */ ] ;	// 悭gݒ̃X^CU[Xe[g̔z

	int										ChangeDepthStencilDesc ;						// foCX̐[xXeVXe[g̐ݒɕύXǂ( TRUE:ύX  FALSE:ύX͂Ȃ )
	D_D3D11_DEPTH_STENCIL_DESC				DepthStencilDesc ;								// ݃foCXɐݒ肳Ă[xXeVeXgXe[g̐ݒl
	D_ID3D11DepthStencilState *				DepthStencilState ;								// ݃foCXɐݒ肳Ă[xXeVXe[g
	int										ChangeDepthStencilStateReleaseFlag ;			// ݃foCXɐݒ肳Ă[xXeVXe[gύXۂɃ[X邩ǂ̃tO( TRUE:[X  FALSE:[XȂ )
	D_ID3D11DepthStencilState *				DefaultDepthStencilStateArray[ 2 /* [xeXg̗L */ ][ 2 /* [xobt@ւ݂̗̏L */ ][ D_D3D11_COMPARISON_ALWAYS + 1 ] ;	// 悭gݒ̐[xXeVXe[g̔z

	int										BlendMode ;										// ݃foCXɐݒ肳Ăuh[hAvZbg̃uh[hȊȌꍇ -1 
	int										ChangeBlendDesc ;								// foCX̃ufBOXe[g̐ݒɕύXǂ( TRUE:ύX  FALSE:ύX͂Ȃ )
	D_D3D11_BLEND_DESC						BlendDesc ;										// ݃foCXɐݒ肳ĂufBOXe[g̐ݒl
	D_ID3D11BlendState *					BlendState ;									// ݃foCXɐݒ肳ĂufBOXe[g
	int										ChangeBlendStateReleaseFlag ;					// ݃foCXɐݒ肳ĂufBOXe[gύXۂɃ[X邩ǂ̃tO( TRUE:[X  FALSE:[XȂ )
	D_ID3D11BlendState *					DefaultBlendStateArray[ DX_BLENDMODE_NUM ] ;	// 悭gݒ̃ufBOXe[g̔z

	RECT									ScissorRect ;									// VU[`
	D_ID3D11Buffer *						SetIndexBuffer ;								//  Direct3DDevice9 ɃZbgĂCfbNXobt@
	int										SetNormalVertexShader ;							// ʏ`p_VF[_[ZbgĂ邩ǂ
	int										SetNormalPixelShader ;							// ʏ`psNZVF[_[ZbgĂ邩ǂ
	CONSTANTBUFFER_DIRECT3D11 *				SetPixelShaderConstantBuffer[  D_D3D11_COMMONSHADER_CONSTANT_BUFFER_API_SLOT_COUNT ] ;	//  ID3D11DeviceContext ɃsNZVF[_[pɃZbgĂ萔obt@
	CONSTANTBUFFER_DIRECT3D11 *				SetVertexShaderConstantBuffer[ D_D3D11_COMMONSHADER_CONSTANT_BUFFER_API_SLOT_COUNT ] ;	//  ID3D11DeviceContext ɒ_VF[_[pɃZbgĂ萔obt@
	D_ID3D11PixelShader *					SetPixelShader ;								//  ID3D11DeviceContext ɃZbgĂsNZVF[_[
	D_ID3D11InputLayout *					SetVertexInputLayout ;							//  ID3D11DeviceContext ɃZbgĂ̓CAEg
	D_ID3D11VertexShader *					SetVertexShader ;								//  ID3D11DeviceContext ɃZbgĂ钸_VF[_[
	D_ID3D11Buffer *						SetVertexBuffer ;								//  ID3D11DeviceContext ɃZbgĂ钸_obt@
	int										SetVertexBufferStride ;							//  ID3D11DeviceContext ɃZbgĂ钸_obt@̃XgCh
	D_ID3D11Texture2D *						TargetTexture2D[ DX_RENDERTARGET_COUNT ] ;		// `Ώۂ̃eNX`
	D_ID3D11RenderTargetView *				TargetRTV[ DX_RENDERTARGET_COUNT ] ;			// `Ώۂ̃_O^[Qbgr[
	D_ID3D11Texture2D *						TargetDepthTexture2D ;							// `Ώۂ̐[xeNX`
	D_ID3D11DepthStencilView *				TargetDepthDSV ;								// `Ώۂ̐[xXeVr[
	int										TextureAddressTransformMatrixUse ;				// eNX`Wϊsgp邩ǂ( TRUE:gp  FALSE:gpȂ )
	MATRIX									TextureAddressTransformMatrix ;					// eNX`Wϊs
} ;


// D3D11Device ̕`揈Ɋւ̍\
struct GRAPHICS_HARDDATA_DIRECT3D11_DRAWINFO
{
	BYTE *					VertexBufferNextAddr ;					// ̃f[^i[ׂ_obt@̃AhX
	BYTE *					VertexBufferAddr[ 2 ][ 3 ] ;			// e_obt@ւ̃|C^( [ Rc_ǂ ][ _^Cv ] )
	BYTE					VertexBuffer_NoTex[     D3D11DEV_NOTEX_VERTBUFFERSIZE     ] ;	// eNX`gpȂ_obt@
	BYTE					VertexBuffer_Tex[       D3D11DEV_TEX_VERTBUFFERSIZE       ] ;	// eNX`gp钸_obt@
	BYTE					VertexBuffer_BlendTex[  D3D11DEV_BLENDTEX_VERTBUFFERSIZE  ] ;	// uheNX`gp钸_obt@
	BYTE					VertexBuffer_3D[        D3D11DEV_NOTEX_3D_VERTBUFFERSIZE  ] ;	// Rcp_obt@
	D_ID3D11Buffer *		VertexBuffer ;							// `p ID3D11Buffer
	int						Use3DVertex ;							// Rc_gpĂ邩ǂ( 1:gpĂ  0:gpĂȂ )
	int						VertexNum ; 							// _obt@Ɋi[Ă钸_̐
	int						VertexType ;							// _obt@Ɋi[Ă钸_f[^( 0:eNX`Ȃ  1:eNX`  2:uheNX` )
	D_D3D11_PRIMITIVE_TOPOLOGY PrimitiveType ;						// _obt@Ɋi[Ă钸_f[^̃v~eBu^Cv

	DWORD					DiffuseColor ;							// fBt[YJ[

	int						BeginSceneFlag ;						// Graphics_D3D11_BeginScene sĂ邩ǂ
	int						BlendMaxNotDrawFlag ;					// uhlőł邱Ƃɂ`sȂǂAtO
} ;


// D3D11Device ̉ʊ֌W̏̍\
struct GRAPHICS_HARDDATA_DIRECT3D11_SCREENINFO
{
	D_ID3D11Texture2D *				BackBufferTexture2D ;
	D_ID3D11RenderTargetView *		BackBufferRTV ;

	int								SubBackBufferTextureSizeX ;				// TuobNobt@eNX`̉
	int								SubBackBufferTextureSizeY ;				// TuobNobt@eNX`̏c
	D_ID3D11Texture2D *				SubBackBufferTexture2D ;				// ScreenCopy  GetDrawScreen 邽߂Ɏgp`\eNX`
	D_ID3D11RenderTargetView *		SubBackBufferRTV ;						// ScreenCopy  GetDrawScreen 邽߂Ɏgp`\eNX`p̃_[^[Qbgr[
	D_ID3D11ShaderResourceView *	SubBackBufferSRV ;						// ScreenCopy  GetDrawScreen 邽߂Ɏgp`\eNX`p̃VF[_[\[Xr[

	D_ID3D11Texture2D *				DepthBufferTexture2D ;
	D_ID3D11DepthStencilView *		DepthBufferDSV ;
	int								DepthBufferSizeX ;						// [xobt@T[tFX̕
	int								DepthBufferSizeY ;						// [xobt@T[tFX̍
	int								DepthBufferBitDepth ;					// [xobt@T[tFX̃rbg[x

	D_ID3D11Texture2D *				DrawScreenBufferLockSMTexture ;			// obNobt@bNۂɒڃbNłȂꍇɎgpeNX`̃|C^
	int								DrawScreenBufferLockSMTextureIndex ;	// obNobt@bNۂɒڃbNłȂꍇɎgpeNX`LbṼCfbNX
	D_ID3D11Texture2D *				DrawScreenBufferLockTexture ;			// bNobNobt@

	LONGLONG						VSyncWaitTime ;							// Ourxmb҂Ă玟Ƀ`FbN܂łɑ҂
	LONGLONG						VSyncTime ;								// Ourxmb҂

	D_ID3D11Texture2D *				SaveDrawScreen_SMTexture ;				// SaveDrawScreen ŎgpVXeeNX`
} ;


// D3D11Device ̕`ݒɊւ̍\
struct GRAPHICS_HARDDATA_DIRECT3D11_DRAWSETTING
{
	int								DrawPrepAlwaysFlag ;					// K Graphics_D3D11_DrawPreparation sǂ̃tO

	int								AlphaChannelValidFlag ;					// `lLtO
	int								AlphaTestValidFlag ;					// eXgLtO( Func ͕K D_D3DCMP_GREATEREQUAL )
	int								AlphaTestMode ;							// At@eXg[h
	int								AlphaTestParam ;						// At@eXgp[^
	int								BlendMode ;								// uh[h
	int								ChangeBlendParamFlag ;					// uhݒɊւ镔̕ύXAtO
	int								ChangeTextureFlag ;						// eNX`ύXꂽAtO
	int								IgnoreGraphColorFlag ;					// `悷摜̐F𖳎邩ǂ̃tO
	int								UseDiffuseRGBColor ;					// fBt[YJ[̂qfalgp邩AtO
	int								UseDiffuseAlphaColor ;					// fBt[YJ[̃lgp邩AtO
	int								BlendGraphType ;						// uh摜^Cv
	int								BlendGraphFadeRatio ;					// uh摜̃tF[hp[^
	int								BlendGraphBorderParam ;					// uh摜̋Ep[^(O(uh摜̉eO)@@(uh摜̉eȂ)@@PQW(uh摜̉ePOO)@@(uh摜̉e𒴂Ĕ`敔)@QTT(S`悳Ȃ) )
	int								BlendGraphBorderRange ;					// uh摜̋E(O`QTT@`L@SiK)
	float							BlendTextureWidth ;						// uheNX`̕
	float							BlendTextureHeight ;					// uheNX`̍
	float							InvBlendTextureWidth ;					// uheNX`̋̕t
	float							InvBlendTextureHeight ;					// uheNX`̍̋t

	D_ID3D11Texture2D *				RenderTexture ;							// `掞ɎgpeNX`[
	D_ID3D11ShaderResourceView *	RenderTextureSRV ;						// `掞ɎgpeNX`[̃VF[_[\[Xr[
	D_ID3D11Texture2D *				BlendTexture ;							// `掞ɕ`eNX`[ƃuh郿`leNX`[
	D_ID3D11ShaderResourceView *	BlendTextureSRV ;						// `掞ɕ`eNX`[ƃuh郿`leNX`[̃VF[_[\[Xr[

	int								CancelSettingEqualCheck ;				// ̃tOĂꍇ݂͌̐ݒƕύX̐ݒ肪ǂɊւ炸AKύXs
} ;


// D3D11Device ̔\͏\
struct GRAPHICS_HARDDATA_DIRECT3D11_DEVICE_CAPS
{
	D_DXGI_FORMAT					ScreenFormat ;										// ʃJ[tH[}bg
	D_DXGI_FORMAT					TextureFormat[ DX_GRAPHICSIMAGE_FORMAT_3D_NUM ] ;	// eNX`tH[}bg
	D_DXGI_FORMAT					MaskColorFormat ;									// }XNJ[obt@ptH[}bg
	D_DXGI_FORMAT					MaskAlphaFormat ;									// }XNAt@`lptH[}bg
	D_DXGI_FORMAT					DepthBufferTexture2DFormat[ ZBUFFER_FORMAT_NUM ] ;		// [xobt@pTexture2DtH[}bg
	D_DXGI_FORMAT					DepthBufferDepthStencilFormat[ ZBUFFER_FORMAT_NUM ] ;	// [xobt@pDepthStenciltH[}bg
} ;


// Direct3D11 g`揈Ŏgpf[^̓ D3D11Device ̃Zbg
// KvAD3D11Device ɖڂɊւZ߂\
struct GRAPHICS_HARDDATA_DIRECT3D11_DEVICE
{
	GRAPHICS_HARDDATA_DIRECT3D11_DEVICE_CAPS		Caps ;					// foCX\͏\		

	GRAPHICS_HARDDATA_DIRECT3D11_SCREENINFO			Screen ;				// ʊ֌W̏\

	GRAPHICS_HARDWARE_DIRECT3D11_SHADER				Shader ;				// VF[_[Z߂\

	GRAPHICS_HARDWARE_DIRECT3D11_INPUTLAYOUT		InputLayout ;			// ̓CAEgZ߂\

	GRAPHICS_HARDDATA_DIRECT3D11_DRAWSETTING		DrawSetting ;			// `ݒɊւZ߂\

	GRAPHICS_HARDDATA_DIRECT3D11_DRAWINFO			DrawInfo ;				// `揈ɊւZ߂\

	GRAPHICS_HARDDATA_DIRECT3D11_DEVICE_STATE		State ;					// D3D11Device ɐݒ肵ĂlZ߂\
} ;













// VF[_[R[h̏\
struct GRAPHICS_HARDWARE_DIRECT3D11_SHADERCODE_INFO
{
	void					*Binary ;								// VF[_[R[hoCĩAhX
	int						Size ;									// VF[_[R[hoCĩf[^TCY
} ;


// Direct3D11  W`p̃VF[_[R[ȟf[^Z߂\
struct GRAPHICS_HARDWARE_DIRECT3D11_SHADERCODE_BASE
{
	int						BaseShaderInitializeFlag ;				// VF[_[oCĩZbgAbvĂ邩ǂ̃tO( TRUE:Ă  FALSE:ĂȂ )

	// CgCfbNXXg
	short					LightIndexList84[ 4 ][ 4 ][ 4 ][ 4 ][ 4 ][ 4 ] ;
	short					LightIndexList20[ 4 ][ 4 ][ 4 ] ;
	short					LightIndexList10[ 3 ][ 3 ][ 3 ] ;

	void					*Base2DShaderPackageImage ;				// WQc`pVF[_[pbP[WoCiC[W

	// W`p̕GȏsȂ_VF[_[
	GRAPHICS_HARDWARE_DIRECT3D11_SHADERCODE_INFO BaseSimple_VS_Code[ VERTEXFVF_LAYOUT_NUM ] ;

	// Œ@\pCvC݊̃sNZVF[_[( eNX`Ȃ )
	// [ ( 0:ʏ`  1:Z`  2:RGB]  3:`PxS{  4:Zς݃uh[h̒ʏ`  5:Zς݃uh[hRGB]  6:Zς݃uh[h̕`Px4{ ) ]
	// [ sNZVF[_[̃At@eXg[h ]
	GRAPHICS_HARDWARE_DIRECT3D11_SHADERCODE_INFO BaseNoneTex_PS_Code[ 7 ][ DIRECT3D11_PS_ALPHATEST_NUM ] ;

	// Œ@\pCvC݊̃sNZVF[_[( eNX` )
	// [ uh摜Ƃ̃uh^Cv( 0:Ȃ  1:DX_BLENDGRAPHTYPE_NORMAL  2:DX_BLENDGRAPHTYPE_WIPE  3:DX_BLENDGRAPHTYPE_ALPHA ) ]
	// [ ( 0:ʏ`  1:Z`  2:RGB]  3:`PxS{  4:Zς݃uh[h̒ʏ`  5:Zς݃uh[hRGB]  6:Zς݃uh[h̕`Px4{ ) ]
	// [ eNX`RGB( 0:Ȃ  1: ) ]
	// [ eNX`Alpha( 0:Ȃ  1: ) ]
	// [ sNZVF[_[̃At@eXg[h ]
	GRAPHICS_HARDWARE_DIRECT3D11_SHADERCODE_INFO BaseUseTex_PS_Code[ 4 ][ 7 ][ 2 ][ 2 ][ DIRECT3D11_PS_ALPHATEST_NUM ] ;

	// }XNp̃sNZVF[_[
	GRAPHICS_HARDWARE_DIRECT3D11_SHADERCODE_INFO MaskEffect_PS_Code ;

//	DXARC					BaseShaderBinDxa ;						// W`pVF[_[IuWFNgt@Ccw`\
//	void					*BaseShaderBinDxaImage ;				// W`pVF[_[IuWFNgt@Ccw`̃oCiC[W

#ifndef DX_NON_FILTER
	DXARC					FilterShaderBinDxa ;					// tB^[VF[_[IuWFNgt@Ccw`\
	void					*FilterShaderBinDxaImage ;				// tB^[VF[_[IuWFNgt@Ccw`̃oCiC[W

	void					*RGBAMixS_ShaderPackImage ;				// RGBAMix  S ̑gݍ킹QTU̃VF[_[pbP[WoCiC[W

	// RGBAMix  S ̑gݍ킹QTU̃VF[_[[ R ][ G ][ B ][ A ]
	GRAPHICS_HARDWARE_DIRECT3D11_SHADERCODE_INFO RGBAMixS_PS_Code[ 4 ][ 4 ][ 4 ][ 4 ] ;
#endif // DX_NON_FILTER
} ;

// Direct3D11  WRc`p̃VF[_[R[ȟf[^Z߂\
struct GRAPHICS_HARDWARE_DIRECT3D11_SHADERCODE_BASE3D
{
	int						Base3DShaderInitializeFlag ;			// VF[_[oCĩZbgAbvĂ邩ǂ̃tO( TRUE:Ă  FALSE:ĂȂ )

	void					*Base3DShaderPackageImage ;				// WRc`pVF[_[pbP[WoCiC[W

	// WRc`psNZPʃCeBO^Cv̒_VF[_[( Xg͔z̍ )
	// [ VhE}bv̗L( 0: 1:L ) ]
	// /* [ bV^Cv( 0:̃bV 1:4{[XLjObV 2:8{[XLjObV ) ] */
	// /* [ ov}bv̗L( 0: 1:L ) ] */
	// [ tHO^Cv ]
	GRAPHICS_HARDWARE_DIRECT3D11_SHADERCODE_INFO Base3D_PixelLighting_VS_Code[ 2 ]/*[ 3 ]*//*[ 2 ]*/[ 4 ] ;

	// WRc`psNZPʃCeBO^CṽsNZVF[_[( Xg͔z̍ )
	// [ VhE}bv̗L( 0: 1:L ) ]
	// /*[ }`eNX`̃uh[hAMV1_LAYERBLEND_TYPE_TRANSLUCENT Ȃǂ +1  ( 0:}`eNX`  1:uh  2:Zuh  3:Zuh  4:Zuh~2 ) ]*/
	// /*[ XyL}bv ( 0: 1: ) ]*/
	// /*[ ov}bv ( 0:Ȃ 1: ) ]*/
	// [ CgCfbNX ]
	// [ XyL̗L( 0: 1:L ) ]
	// [ sNZVF[_[̃At@eXg[h ]
	GRAPHICS_HARDWARE_DIRECT3D11_SHADERCODE_INFO Base3D_PixelLighting_Normal_PS_Code[ 2 ]/*[ 5 ]*//*[ 2 ]*//*[ 2 ]*/[ 84 ][ 2 ][ DIRECT3D11_PS_ALPHATEST_NUM ] ;



	// WRc`p̃VhE}bvւ̃_Op_VF[_[
	// /*[ bV^Cv( 0:̃bV 1:4{[XLjObV  2:8{[XLjObV ) ]*/
	// [ ov}bv̗L( 0: 1:L ) ]
	GRAPHICS_HARDWARE_DIRECT3D11_SHADERCODE_INFO Base3D_ShadowMap_VS_Code/*[ 3 ]*/[ 2 ] ;

	// WRc`p̃CeBOȂ_VF[_[
	// /*[ bV^Cv( 0:̃bV 1:4{[XLjObV  2:8{[XLjObV ) ]*/
	// [ tHO^Cv ]
	GRAPHICS_HARDWARE_DIRECT3D11_SHADERCODE_INFO Base3D_NoLighting_VS_Code/*[ 3 ]*/[ 4 ] ;

	// WRc`p̒_PʃCeBO_VF[_[
	// [ VhE}bv̗L( 0: 1:L ) ]
	// /*[ bV^Cv( 0:̃bV 1:4{[XLjObV  2:8{[XLjObV ) ]*/
	// /*[ ov}bv̗L( 0: 1:L ) ]*/
	// [ tHO^Cv ]
	// [ CgCfbNX ]
	// [ XyL̗L( 0: 1:L ) ]
	GRAPHICS_HARDWARE_DIRECT3D11_SHADERCODE_INFO Base3D_VertexLighting_VS_Code[ 2 ]/*[ 3 ]*//*[ 2 ]*/[ 4 ][ 20 ][ 2 ] ;

	// WRc`p̃VhE}bvւ̃_OpsNZVF[_[
	// [ sNZVF[_[̃At@eXg[h ]
	GRAPHICS_HARDWARE_DIRECT3D11_SHADERCODE_INFO Base3D_ShadowMap_Normal_PS_Code[ DIRECT3D11_PS_ALPHATEST_NUM ] ;

	// WRc`p̃CeBOȂsNZVF[_[
	// /*[ }`eNX`̃uh[hAMV1_LAYERBLEND_TYPE_TRANSLUCENT Ȃǂ +1  ( 0:}`eNX`  1:uh  2:Zuh  3:Zuh  4:Zuh~2 ) ]*/
	// [ sNZVF[_[̃At@eXg[h ]
	GRAPHICS_HARDWARE_DIRECT3D11_SHADERCODE_INFO Base3D_NoLighting_Normal_PS_Code/*[ 5 ]*/[ DIRECT3D11_PS_ALPHATEST_NUM ] ;

	// WRc`p̒_PʃCeBOsNZVF[_[
	// [ VhE}bv̗L( 0: 1:L ) ]
	// /* [ }`eNX`̃uh[hAMV1_LAYERBLEND_TYPE_TRANSLUCENT Ȃǂ +1  ( 0:}`eNX`  1:uh  2:Zuh  3:Zuh  4:Zuh~2 ) ] */
	// /* [ XyL}bv ( 0: 1: ) ] */
	// /* [ ov}bv ( 0:Ȃ 1: ) ] */
	// [ CgCfbNX ]
	// [ XyL̗L( 0: 1:L ) ]
	// [ sNZVF[_[̃At@eXg[h ]
	GRAPHICS_HARDWARE_DIRECT3D11_SHADERCODE_INFO Base3D_VertexLighting_Normal_PS_Code[ 2 ]/*[ 5 ]*//*[ 2 ]*//*[ 2 ]*/[ 10 ][ 2 ][ DIRECT3D11_PS_ALPHATEST_NUM ] ;
} ;

#ifndef DX_NON_MODEL

// Direct3D11  f`p̃VF[_[R[ȟf[^Z߂\
struct GRAPHICS_HARDWARE_DIRECT3D11_SHADERCODE_MODEL
{
	int						ModelShaderInitializeFlag ;				// fp̃VF[_[oCĩZbgAbvĂ邩ǂ̃tO( TRUE:Ă  FALSE:ĂȂ )

	void					*ModelShaderPackImage ;					// RcfpVF[_[pbP[WoCiC[W

	// f`psNZPʃCeBO^Cv̒_VF[_[( Xg͔z̍ )
	// [ VhE}bv̗L( 0: 1:L ) ]
	// [ bV^Cv( 0:̃bV 1:4{[XLjObV 2:8{[XLjObV ) ]
	// [ ov}bv̗L( 0: 1:L ) ]
	// [ tHO^Cv ]
	GRAPHICS_HARDWARE_DIRECT3D11_SHADERCODE_INFO MV1_PixelLighting_VS_Code[ 2 ][ 3 ][ 2 ][ 4 ] ;

	// f`psNZPʃCeBO^CṽgD[psNZVF[_[( Xg͔z̍ )
	// [ VhE}bv̗L( 0: 1:L ) ]
	// [ gD[_Oǂ( 0:gD[_O type 1   1:gD[_O Type 2 ) ]
	// [ gD[_ÕXtBA}bv̗Lƃuh^Cv( 0:XtBA}bv͖   1:MV1_LAYERBLEND_TYPE_MODULATE  2:MV1_LAYERBLEND_TYPE_ADDITIVE ) ]
	// [ gD[_ÕfBt[YOf[Ṽuh^Cv( 0:MV1_LAYERBLEND_TYPE_TRANSLUCENT  1:MV1_LAYERBLEND_TYPE_MODULATE ) ]
	// [ gD[_ÕXyLOf[Ṽuh^Cv( 0:MV1_LAYERBLEND_TYPE_TRANSLUCENT  1:MV1_LAYERBLEND_TYPE_ADDITIVE ) ]
	// [ XyL}bv ( 0: 1: ) ]
	// [ ov}bv ( 0:Ȃ 1: ) ]
	// [ CgCfbNX ]
	// [ XyL̗L( 0: 1:L ) ]
	// [ sNZVF[_[̃At@eXg[h ]
	GRAPHICS_HARDWARE_DIRECT3D11_SHADERCODE_INFO MV1_PixelLighting_Toon_PS_Code[ 2 ][ 2 ][ 3 ][ 2 ][ 2 ][ 2 ][ 2 ][ 84 ][ 2 ][ DIRECT3D11_PS_ALPHATEST_NUM ] ;

	// f`psNZPʃCeBO^CṽsNZVF[_[( Xg͔z̍ )
	// [ VhE}bv̗L( 0: 1:L ) ]
	// [ }`eNX`̃uh[hAMV1_LAYERBLEND_TYPE_TRANSLUCENT Ȃǂ +1  ( 0:}`eNX`  1:uh  2:Zuh  3:Zuh  4:Zuh~2 ) ]
	// [ XyL}bv ( 0: 1: ) ]
	// [ ov}bv ( 0:Ȃ 1: ) ]
	// [ CgCfbNX ]
	// [ XyL̗L( 0: 1:L ) ]
	// [ sNZVF[_[̃At@eXg[h ]
	GRAPHICS_HARDWARE_DIRECT3D11_SHADERCODE_INFO MV1_PixelLighting_Normal_PS_Code[ 2 ][ 5 ][ 2 ][ 2 ][ 84 ][ 2 ][ DIRECT3D11_PS_ALPHATEST_NUM ] ;






	// f`p̃gD[_O̗֊s`p_VF[_[
	// [ bV^Cv( 0:̃bV 1:4{[XLjObV  2:8{[XLjObV ) ]
	// [ tHO^Cv ]
	GRAPHICS_HARDWARE_DIRECT3D11_SHADERCODE_INFO MV1_ToonOutLine_VS_Code[ 3 ][ 4 ] ;

	// f`p̃VhE}bvւ̃_Op_VF[_[
	// [ bV^Cv( 0:̃bV 1:4{[XLjObV  2:8{[XLjObV ) ]
	GRAPHICS_HARDWARE_DIRECT3D11_SHADERCODE_INFO MV1_ShadowMap_VS_Code[ 3 ] ;

	// f`p̃CeBOȂ_VF[_[
	// [ bV^Cv( 0:̃bV 1:4{[XLjObV  2:8{[XLjObV ) ]
	// [ tHO^Cv ]
	GRAPHICS_HARDWARE_DIRECT3D11_SHADERCODE_INFO MV1_NoLighting_VS_Code[ 3 ][ 4 ] ;

	// f`p̒_PʃCeBO蒸_VF[_[
	// [ VhE}bv̗L( 0: 1:L ) ]
	// [ bV^Cv( 0:̃bV 1:4{[XLjObV  2:8{[XLjObV ) ]
	// [ ov}bv̗L( 0: 1:L ) ]
	// [ tHO^Cv ]
	// [ CgCfbNX ]
	// [ XyL̗L( 0: 1:L ) ]
	GRAPHICS_HARDWARE_DIRECT3D11_SHADERCODE_INFO MV1_VertexLighting_VS_Code[ 2 ][ 3 ][ 2 ][ 4 ][ 20 ][ 2 ] ;


	// f`p̃gD[_O̗֊s`psNZVF[_[
	// [ sNZVF[_[̃At@eXg[h ]
	GRAPHICS_HARDWARE_DIRECT3D11_SHADERCODE_INFO MV1_ToonOutLine_PS_Code[ DIRECT3D11_PS_ALPHATEST_NUM ] ;

	// f`p̃VhE}bvւ̃gD[_OpsNZVF[_[
	// [ gD[_O^Cv( 0:gD[_O type 1   1:gD[_O type 2 ) ]
	// [ gD[_ÕXtBA}bv̗Lƃuh^Cv( 0:XtBA}bv͖   1:MV1_LAYERBLEND_TYPE_MODULATE  2:MV1_LAYERBLEND_TYPE_ADDITIVE ) ]
	// [ gD[_ÕfBt[YOf[Ṽuh^Cv( 0:MV1_LAYERBLEND_TYPE_TRANSLUCENT  1:MV1_LAYERBLEND_TYPE_MODULATE ) ]
	// [ sNZVF[_[̃At@eXg[h ]
	GRAPHICS_HARDWARE_DIRECT3D11_SHADERCODE_INFO MV1_ShadowMap_Toon_PS_Code[ 2 ][ 3 ][ 2 ][ DIRECT3D11_PS_ALPHATEST_NUM ] ;

	// f`p̃VhE}bvւ̃_OpsNZVF[_[
	// [ sNZVF[_[̃At@eXg[h ]
	GRAPHICS_HARDWARE_DIRECT3D11_SHADERCODE_INFO MV1_ShadowMap_Normal_PS_Code[ DIRECT3D11_PS_ALPHATEST_NUM ] ;

	// f`p̃CeBOȂgD[psNZVF[_[( Xg͔z̍ )
	// [ gD[_O^Cv( 0:gD[_O type 1   1:gD[_O type 2 ) ]
	// [ gD[_ÕfBt[YOf[Ṽuh^Cv( 0:MV1_LAYERBLEND_TYPE_TRANSLUCENT or gD[_Oł͂Ȃ  1:MV1_LAYERBLEND_TYPE_MODULATE ) ]
	// [ sNZVF[_[̃At@eXg[h ]
	GRAPHICS_HARDWARE_DIRECT3D11_SHADERCODE_INFO MV1_NoLighting_Toon_PS_Code[ 2 ][ 2 ][ DIRECT3D11_PS_ALPHATEST_NUM ] ;

	// f`p̃CeBOȂsNZVF[_[
	// [ }`eNX`̃uh[hAMV1_LAYERBLEND_TYPE_TRANSLUCENT Ȃǂ +1  ( 0:}`eNX`  1:uh  2:Zuh  3:Zuh  4:Zuh~2 ) ]
	// [ sNZVF[_[̃At@eXg[h ]
	GRAPHICS_HARDWARE_DIRECT3D11_SHADERCODE_INFO MV1_NoLighting_Normal_PS_Code[ 5 ][ DIRECT3D11_PS_ALPHATEST_NUM ] ;

	// f`p̒_PʃCeBOgD[psNZVF[_[
	// [ VhE}bv̗L( 0: 1:L ) ]
	// [ gD[_O^Cv( 0:gD[_O type 1   1:gD[_O type 2 ) ]
	// [ gD[_ÕXtBA}bv̗Lƃuh^Cv( 0:XtBA}bv͖   1:MV1_LAYERBLEND_TYPE_MODULATE  2:MV1_LAYERBLEND_TYPE_ADDITIVE ) ]
	// [ gD[_ÕfBt[YOf[Ṽuh^Cv( 0:MV1_LAYERBLEND_TYPE_TRANSLUCENT  1:MV1_LAYERBLEND_TYPE_MODULATE ) ]
	// [ gD[_ÕXyLOf[Ṽuh^Cv( 0:MV1_LAYERBLEND_TYPE_TRANSLUCENT  1:MV1_LAYERBLEND_TYPE_ADDITIVE ) ]
	// [ XyL}bv ( 0: 1: ) ]
	// [ ov}bv ( 0:Ȃ 1: ) ]
	// [ CgCfbNX ]
	// [ XyL̗L( 0: 1:L ) ]
	// [ sNZVF[_[̃At@eXg[h ]
	GRAPHICS_HARDWARE_DIRECT3D11_SHADERCODE_INFO MV1_VertexLighting_Toon_PS_Code[ 2 ][ 2 ][ 3 ][ 2 ][ 2 ][ 2 ][ 2 ][ 10 ][ 2 ][ DIRECT3D11_PS_ALPHATEST_NUM ] ;

	// f`p̒_PʃCeBOsNZVF[_[
	// [ VhE}bv̗L( 0: 1:L ) ]
	// [ }`eNX`̃uh[hAMV1_LAYERBLEND_TYPE_TRANSLUCENT Ȃǂ +1  ( 0:}`eNX`  1:uh  2:Zuh  3:Zuh  4:Zuh~2 ) ]
	// [ XyL}bv ( 0: 1: ) ]
	// [ ov}bv ( 0:Ȃ 1: ) ]
	// [ CgCfbNX ]
	// [ XyL̗L( 0: 1:L ) ]
	// [ sNZVF[_[̃At@eXg[h ]
	GRAPHICS_HARDWARE_DIRECT3D11_SHADERCODE_INFO MV1_VertexLighting_Normal_PS_Code[ 2 ][ 5 ][ 2 ][ 2 ][ 10 ][ 2 ][ DIRECT3D11_PS_ALPHATEST_NUM ] ;
} ;

#endif // DX_NON_MODEL


// VF[_[R[ȟf[^Z߂\
struct GRAPHICS_HARDWARE_DIRECT3D11_SHADERCODE
{
	GRAPHICS_HARDWARE_DIRECT3D11_SHADERCODE_BASE	Base ;				// W`揈p̃VF[_[R[hZ߂\
	GRAPHICS_HARDWARE_DIRECT3D11_SHADERCODE_BASE3D	Base3D ;			// WRc`揈p̃VF[_[R[hZ߂\

#ifndef DX_NON_MODEL
	GRAPHICS_HARDWARE_DIRECT3D11_SHADERCODE_MODEL	Model ;				// f`揈p̃VF[_[R[hZ߂\
#endif // DX_NON_MODEL
} ;


// A_v^[֌W\
struct GRAPHICS_HARDWARE_DIRECT3D11_ADAPTER
{
	int Dummy ;
} ;


// Direct3D11 ֌W̐ݒ̍\
struct GRAPHICS_HARDDATA_DIRECT3D11_SETTING
{
	D_D3D_FEATURE_LEVEL				FeatureLevel ;
	int								UserDepthBufferSizeSet ;					// O[xobt@TCY̎w肪ǂ
	int								UserDepthBufferBitDepthSet ;				// O[xobt@̃rbg[xw肪ǂ
} ;


// ǗeNX`ւ̃f[^]pVXezueNX`̏
struct GRAPHICS_HARDDATA_DIRECT3D11_SYSMEMTEXTURE
{
	int Dummy ;
} ;


// ǗeNX`ւ̃f[^]pVXezuT[tFX̏
struct GRAPHICS_HARDDATA_DIRECT3D11_SYSMEMSURFACE
{
	int Dummy ;
} ;


// Direct3D11 ̃VXeeNX`ET[tFX̍\
struct GRAPHICS_HARDDATA_DIRECT3D11_SYSMEM_TEX_SURF
{
	GRAPHICS_HARDDATA_DIRECT3D11_SYSMEMTEXTURE		Texture[ DIRECT3D11_SYSMEMTEXTURE_NUM ] ;	// ǗeNX`ւ̃f[^]pVXezueNX`
	int												TextureInitNum ;				// ς݂̃VXeeNX`̐

	GRAPHICS_HARDDATA_DIRECT3D11_SYSMEMSURFACE		Surface[ DIRECT3D11_SYSMEMSURFACE_NUM ] ;	// ǗeNX`ւ̃f[^]pVXezuT[tFX
	int												SurfaceInitNum ;				// ς݂̃VXeT[tFX̐
} ;


// Direct3D11 gOtBbNX̍\
struct GRAPHICS_HARDDATA_DIRECT3D11
{
#ifndef DX_NON_MODEL
	D_ID3D11Texture3D *								RGBtoVMaxRGBVolumeTexture ;			// RGBJ[PxőɂRGBlɕϊ邽߂̃{[eNX`
	D_ID3D11ShaderResourceView *					RGBtoVMaxRGBVolumeTextureSRV ;		// RGBJ[PxőɂRGBlɕϊ邽߂̃{[eNX`̃VF[_[\[Xr[
#endif // DX_NON_MODEL

	GRAPHICS_HARDDATA_DIRECT3D11_SETTING			Setting ;					// Direct3D11 ֌W̐ݒ

	GRAPHICS_HARDDATA_DIRECT3D11_DEVICE				Device ;					// D3D11Device ɖڂɊ֘A

	GRAPHICS_HARDWARE_DIRECT3D11_ADAPTER			Adapter ;					// A_v^[֌W

	GRAPHICS_HARDWARE_DIRECT3D11_SHADERCODE			ShaderCode ;				// D_ID3D11PixelShader  D_ID3D11VertexShader ̌ƂȂVF[_[R[hf[^Z߂\

	GRAPHICS_HARDDATA_DIRECT3D11_SYSMEM_TEX_SURF	SysMemTexSurf ;				// VXeeNX`ET[tFX
} ;


// ϐ錾 --------------------------------------------------------------

extern GRAPHICS_HARDDATA_DIRECT3D11 GraphicsHardDataDirect3D11 ;

// ֐vg^Cv錾-----------------------------------------------------------

// Direct3D11 ̏֌W
extern	int		Graphics_D3D11_Initialize( void ) ;								// Direct3D11 gpOtBbNX̏s( 0: -1:s )
extern	int		Graphics_D3D11_Terminate( void ) ;								// Direct3D11 gpOtBbNX̌ns










// VF[_[R[h֌W
extern	int		Graphics_D3D11_ShaderCode_Base_Initialize( void ) ;				// Direct3D11 ̕W`p̃VF[_[R[h̏s
extern	int		Graphics_D3D11_ShaderCode_Base_Terminate( void ) ;				// Direct3D11 ̕W`p̃VF[_[R[ȟns

extern	int		Graphics_D3D11_ShaderCode_Base3D_Initialize( void ) ;			// Direct3D11 ̕WRc`p̃VF[_[R[h̏s
extern	int		Graphics_D3D11_ShaderCode_Base3D_Terminate( void ) ;			// Direct3D11 ̕WRc`p̃VF[_[R[ȟns

#ifndef DX_NON_MODEL

extern	int		Graphics_D3D11_ShaderCode_Model_Initialize( void ) ;			// Direct3D11 ̃f`p̃VF[_[R[h̏s
extern	int		Graphics_D3D11_ShaderCode_Model_Terminate( void ) ;				// Direct3D11 ̃f`p̃VF[_[R[ȟns

#endif // DX_NON_MODEL

extern	int		Graphics_D3D11_Shader_Initialize( void ) ;						// Direct3D11 ̃VF[_[̏s
extern	int		Graphics_D3D11_Shader_Terminate( void ) ;						// Direct3D11 ̃VF[_[̌n











// _obt@ECfbNXobt@֌W










// Direct3D11 ̉ʊ֌W
extern	int		Graphics_D3D11_SetupSubBackBuffer( void ) ;						// TuobNobt@gp鏀s( 0:  -1:s )
extern	int		Graphics_D3D11_CreateDepthBuffer( void ) ;						// [xobt@IuWFNg̍쐬( 0:  -1:s )












// Direct3D11 ̐ݒ֌W







// Direct3D11 ̉摜֌W







// D3D11Device ̏֌W
extern	int		Graphics_D3D11_Device_Create( void ) ;																// Direct3DDevice11 IuWFNg̍쐬( 0:  -1:s )






// D3D11Device Xe[^X֌W
extern	void	Graphics_D3D11_DeviceState_RefreshRenderState( void ) ;												// `ݒtbV
extern	int		Graphics_D3D11_DeviceState_SetBaseState( void ) ;													// Direct3DDevice11 ̊{ݒs
extern	int		Graphics_D3D11_DeviceState_SetSampleFilterMode( D_D3D11_FILTER Filter, int Sampler = -1 ) ;			// Tv[̃eNX`tB^O[hݒ肷
extern	int		Graphics_D3D11_DeviceState_SetDepthEnable( BOOL DepthEnable )  ;											// [xobt@̗L̃Zbg
extern	int		Graphics_D3D11_DeviceState_SetDepthWriteEnable( int Flag ) ;										// [xobt@݂̗̏LZbg
extern	int		Graphics_D3D11_DeviceState_SetDepthFunc( D_D3D11_COMPARISON_FUNC DepthFunc ) ;						// [xl̔r^CvZbg
extern	int		Graphics_D3D11_DeviceState_SetDepthBias( int DepthBias ) ;											// [xl̃oCAXZbg
extern	int		Graphics_D3D11_DeviceState_SetFillMode( D_D3D11_FILL_MODE FillMode ) ;								// tB[hZbg
extern	int		Graphics_D3D11_DeviceState_SetWorldMatrix( const MATRIX *Matrix ) ;									// [hϊpsZbg
extern	int		Graphics_D3D11_DeviceState_SetViewMatrix( const MATRIX *Matrix ) ;									// r[ϊpsZbg
extern	int		Graphics_D3D11_DeviceState_SetProjectionMatrix( const MATRIX *Matrix ) ;							// eϊpsZbg
extern	int		Graphics_D3D11_DeviceState_SetLightState( int LightNumber, LIGHTPARAM *Light ) ;					// Cg̃Zbg
extern	int		Graphics_D3D11_DeviceState_SetLightEnable( int LightNumber, int EnableState ) ;						// Cg̗LAύX
extern	int		Graphics_D3D11_DeviceState_SetMaterial( MATERIALPARAM *Material ) ;									// }eÃZbg
extern	int		Graphics_D3D11_DeviceState_SetSpecularEnable( int UseFlag ) ;										// XyLgp邩ǂZbg
extern	int		Graphics_D3D11_DeviceState_SetUseVertexDiffuseColor( int UseFlag ) ;								// _̃fBt[YJ[}eÃfBt[YJ[ƂĎgp邩ǂݒ肷
extern	int		Graphics_D3D11_DeviceState_SetUseVertexSpecularColor( int UseFlag ) ;								// _̃XyLJ[}eÃXyLJ[ƂĎgp邩ǂݒ肷
extern	int		Graphics_D3D11_DeviceState_SetCullMode( int State ) ;												// JO̗LZbg 
extern	int		Graphics_D3D11_DeviceState_SetAmbient( COLOR_F *Color ) ;												// ArGgJ[̃Zbg
extern	int		Graphics_D3D11_DeviceState_SetTextureAddress( int AddressMode, int Sampler = -1 ) ;					// eNX`[̃AhbVO[hZbg
extern	int		Graphics_D3D11_DeviceState_SetTextureAddressU( int AddressMode, int Sampler = -1 ) ;				// eNX`[̃AhbVO[hZbg
extern	int		Graphics_D3D11_DeviceState_SetTextureAddressV( int AddressMode, int Sampler = -1 ) ;				// eNX`[̃AhbVO[hZbg
extern	int		Graphics_D3D11_DeviceState_SetTextureAddressW( int AddressMode, int Sampler = -1 ) ;				// eNX`[̃AhbVO[hZbg
extern	int		Graphics_D3D11_DeviceState_SetTextureAddressUVW( int AddressModeU, int AddressModeV, int AddressModeW, int Sampler = -1 ) ;		// eNX`[̃AhbVO[hZbg
extern	int		Graphics_D3D11_DeviceState_SetTextureAddressTransformMatrix( int Use, MATRIX *Matrix ) ;			// eNX`WϊsZbg
extern	int		Graphics_D3D11_DeviceState_SetFogEnable( int Flag ) ;												// tHOLɂ邩ǂݒ肷( TRUE:L  FALSE: )
extern	int		Graphics_D3D11_DeviceState_SetFogVertexMode( int Mode /* DX_FOGMODE_NONE  */ ) ;					// tHO[hݒ肷
extern	int		Graphics_D3D11_DeviceState_SetFogColor( DWORD Color ) ;												// tHOJ[ύX
extern	int		Graphics_D3D11_DeviceState_SetFogStartEnd( float Start, float End ) ;								// tHOn܂鋗ƏI鋗ݒ肷( 0.0f ` 1.0f )
extern	int		Graphics_D3D11_DeviceState_SetFogDensity( float Density ) ;											// tHO̖xݒ肷( 0.0f ` 1.0f )
extern	int		Graphics_D3D11_DeviceState_SetLighting( int UseFlag ) ;												// CeBO̗LtOZbg
extern	int		Graphics_D3D11_DeviceState_SetMaxAnisotropy( int MaxAnisotropy, int Sampler = -1 ) ;				// őٕZbg
extern	int		Graphics_D3D11_DeviceState_SetViewport( D_D3D11_VIEWPORT *Viewport ) ;											// r[|[gZbg
extern	int		Graphics_D3D11_DeviceState_SetViewportEasy( float x1, float y1, float x2, float y2 ) ;							// r[|[gZbg( ȈՔ )
extern	int		Graphics_D3D11_DeviceState_SetRenderTarget( D_ID3D11Texture2D *RenderTargetTexture, D_ID3D11RenderTargetView *RenderTargetView, int TargetIndex = 0 ) ;	// `Ώۂ̕ύX
extern	int		Graphics_D3D11_DeviceState_SetDepthStencil( D_ID3D11Texture2D *DepthStencilTexture, D_ID3D11DepthStencilView *DepthStencilView ) ;	// `Ώۂ̐[xobt@ύX
extern	int		Graphics_D3D11_DeviceState_ResetVertexShader( int SetNormalVertexShaderCancel = FALSE ) ;						// _VF[_[̎gp~߂
extern	int		Graphics_D3D11_DeviceState_ResetPixelShader( int SetNormalPixelShaderCancel = FALSE ) ;							// sNZVF[_[̎gp~߂








// `ݒ֌W֐









// 萔֌W֐
extern int Graphics_D3D11_Constant_Initialize( void ) ;												// Direct3D11 ̒萔̏s
extern int Graphics_D3D11_Constant_Terminate( void ) ;												// Direct3D11 ̒萔̌ns








// 萔obt@֌W֐
extern	CONSTANTBUFFER_DIRECT3D11 *Graphics_D3D11_ConstantBuffer_Create( DWORD Size ) ;							// 萔obt@쐬
extern	int		Graphics_D3D11_ConstantBuffer_Delete( CONSTANTBUFFER_DIRECT3D11 *ConstantBuffer ) ;				// 萔obt@폜
extern	int		Graphics_D3D11_ConstantBuffer_Update( CONSTANTBUFFER_DIRECT3D11 *ConstantBuffer ) ;				// VXẽobt@ɍsύXKp









// ̓CAEg֌W֐
extern	int		Graphics_D3D11_InputLayout_Base_Create( void ) ;		// W`p ID3D11InputLayout IuWFNg̍쐬( 0:  -1:s )
extern	int		Graphics_D3D11_InputLayout_Base_Terminate( void ) ;		// W`p ID3D11InputLayout IuWFNg̍폜( 0:  -1:s )

#ifndef DX_NON_MODEL
extern	int		Graphics_D3D11_InputLayout_Model_Create( void ) ;		// f`p ID3D11InputLayout IuWFNg̍쐬( 0:  -1:s )
extern	int		Graphics_D3D11_InputLayout_Model_Terminate( void ) ;	// f`p ID3D11InputLayout IuWFNg̍폜( 0:  -1:s )
#endif // DX_NON_MODEL








// VXeeNX`ET[tFX֌W֐











// Direct3D11 ̕`揈֌W
extern	int		Graphics_D3D11_RenderVertex( int ASyncThread = FALSE ) ;							// _obt@ɗ܂_f[^_O
extern	void	Graphics_D3D11_RenderBegin( void ) ;												// `R}hJn
extern	void	Graphics_D3D11_RenderEnd( void ) ;													// `R}hI












// Direct3D11 g`֌W
extern	int		Graphics_D3D11_DrawBillboard3D( VECTOR Pos, float cx, float cy, float Size, float Angle, IMAGEDATA *Image, IMAGEDATA *BlendImage, int TransFlag, int TurnFlag, int DrawFlag = TRUE, RECT *DrawArea = NULL ) ;	// n[hEGAANZ[^gp DrawBillboard3D
extern	int		Graphics_D3D11_DrawModiBillboard3D( VECTOR Pos, float x1, float y1, float x2, float y2, float x3, float y3, float x4, float y4, IMAGEDATA *Image, IMAGEDATA *BlendImage, int TransFlag, int DrawFlag = TRUE, RECT *DrawArea = NULL ) ;	// n[hEGAANZ[^gp DrawModiBillboard3D
extern	int		Graphics_D3D11_DrawGraph( int x, int y, float xf, float yf, IMAGEDATA *Image, IMAGEDATA *BlendImage, int TransFlag, int IntFlag ) ;																// n[hEGAANZ[^gp DrawGraph
extern	int		Graphics_D3D11_DrawExtendGraph( int x1, int y1, int x2, int y2, float x1f, float y1f, float x2f, float y2f, IMAGEDATA *Image, IMAGEDATA *BlendImage, int TransFlag, int IntFlag ) ;				// n[hEGAANZ[^gp DrawExtendGraph
extern	int		Graphics_D3D11_DrawRotaGraph( int x, int y, float xf, float yf, double ExRate, double Angle, IMAGEDATA *Image, IMAGEDATA *BlendImage, int TransFlag, int TurnFlag, int IntFlag ) ;				// n[hEGAANZ[^gp DrawRotaGraph
extern	int		Graphics_D3D11_DrawModiGraph( int x1, int y1, int x2, int y2, int x3, int y3, int x4, int y4, IMAGEDATA *Image, IMAGEDATA *BlendImage, int TransFlag, bool SimpleDrawFlag ) ;					// n[hEGAANZ[^gp DrawModiGraph
extern	int		Graphics_D3D11_DrawModiGraphF( float x1, float y1, float x2, float y2, float x3, float y3, float x4, float y4, IMAGEDATA *Image, IMAGEDATA *BlendImage, int TransFlag, bool SimpleDrawFlag ) ;	// n[hEGAANZ[^gp DrawModiGraphF
extern	void	Graphics_D3D11_DrawModiTex( float x1, float y1, float x2, float y2, float x3, float y3, float x4, float y4, IMAGEDATA_HARD_DRAW *DrawTex, bool SimpleDrawFlag ) ;								// eNX`ό`ĕ`悷
extern	int		Graphics_D3D11_DrawFillBox( int x1, int y1, int x2, int y2, int Color ) ;																		// n[hEGAANZ[^gp DrawFillBox
extern	int		Graphics_D3D11_DrawLineBox( int x1, int y1, int x2, int y2, int Color ) ;																		// n[hEGAANZ[^gp DrawLineBox

extern	int		Graphics_D3D11_DrawLine( int x1, int y1, int x2, int y2, int Color ) ;																			// n[hEGAANZ[^gp DrawLine
extern	int		Graphics_D3D11_DrawLine3D( VECTOR Pos1, VECTOR Pos2, int Color, int DrawFlag = TRUE, RECT *DrawArea = NULL ) ;									// n[hEGAANZ[^gp DrawLine3D
extern	int		Graphics_D3D11_DrawCircle_Thickness( int x, int y, int r, int Color, int Thickness ) ;															// n[hEGAANZ[^gp DrawCircle( w肠 )
extern	int		Graphics_D3D11_DrawOval_Thickness( int x, int y, int rx, int ry, int Color, int Thickness ) ;													// n[hEGAANZ[^gp DrawOval( w肠 )
extern	int		Graphics_D3D11_DrawCircle( int x, int y, int r, int Color, int FillFlag ) ;																		// n[hEGAANZ[^gp DrawCircle
extern	int		Graphics_D3D11_DrawOval( int x, int y, int rx, int ry, int Color, int FillFlag ) ;																// n[hEGAANZ[^gp DrawOval
extern	int		Graphics_D3D11_DrawTriangle( int x1, int y1, int x2, int y2, int x3, int y3, int Color, int FillFlag ) ;											// n[hEGAANZ[^gp DrawTriangle
extern	int		Graphics_D3D11_DrawTriangle3D( VECTOR Pos1, VECTOR Pos2, VECTOR Pos3, int Color, int FillFlag, int DrawFlag = TRUE, RECT *DrawArea = NULL ) ;	// n[hEGAANZ[^gp DrawTriangle3D
extern	int		Graphics_D3D11_DrawQuadrangle( int x1, int y1, int x2, int y2, int x3, int y3, int x4, int y4, int Color, int FillFlag ) ;						// n[hEGAANZ[^gp DrawQuadrangle
extern	int		Graphics_D3D11_DrawPixel( int x, int y, int Color ) ;																							// n[hEGAANZ[^gp DrawPixel
extern	int		Graphics_D3D11_DrawPixel3D( VECTOR Pos, int Color, int DrawFlag = TRUE, RECT *DrawArea = NULL ) ;												// n[hEGAANZ[^gp DrawPixel3D
extern	int		Graphics_D3D11_DrawPixelSet( const POINTDATA *PointData, int Num ) ;																				// n[hEGAANZ[^gp DrawPixelSet
extern	int		Graphics_D3D11_DrawLineSet( const LINEDATA *LineData, int Num ) ;																				// n[hEGAANZ[^gp DrawLineSet

extern	int		Graphics_D3D11_DrawPrimitive(                             const VERTEX_3D *Vertex, int VertexNum,                                    int PrimitiveType, IMAGEDATA *Image, int TransFlag ) ;
extern	int		Graphics_D3D11_DrawIndexedPrimitive(                      const VERTEX_3D *Vertex, int VertexNum, const WORD *Indices, int IndexNum, int PrimitiveType, IMAGEDATA *Image, int TransFlag ) ;
extern	int		Graphics_D3D11_DrawPrimitiveLight(                        const VERTEX3D  *Vertex, int VertexNum,                                    int PrimitiveType, IMAGEDATA *Image, int TransFlag ) ;
extern	int		Graphics_D3D11_DrawIndexedPrimitiveLight(                 const VERTEX3D  *Vertex, int VertexNum, const WORD *Indices, int IndexNum, int PrimitiveType, IMAGEDATA *Image, int TransFlag ) ;
extern	int		Graphics_D3D11_DrawPrimitiveLight_UseVertexBuffer(        VERTEXBUFFERHANDLEDATA *VertexBuffer,                                      int PrimitiveType,                 int StartVertex, int UseVertexNum, IMAGEDATA *Image, int TransFlag ) ;
extern	int		Graphics_D3D11_DrawIndexedPrimitiveLight_UseVertexBuffer( VERTEXBUFFERHANDLEDATA *VertexBuffer, INDEXBUFFERHANDLEDATA *IndexBuffer,  int PrimitiveType, int BaseVertex, int StartVertex, int UseVertexNum, int StartIndex, int UseIndexNum, IMAGEDATA *Image, int TransFlag ) ;
extern	int		Graphics_D3D11_DrawPrimitive2D(                                 VERTEX_2D *Vertex, int VertexNum,                                    int PrimitiveType, IMAGEDATA *Image, int TransFlag, int BillboardFlag, int Is3D, int TurnFlag, int TextureNo ) ;
extern	int		Graphics_D3D11_DrawIndexedPrimitive2D(                          VERTEX_2D *Vertex, int VertexNum,       WORD *Indices, int IndexNum, int PrimitiveType, IMAGEDATA *Image, int TransFlag ) ;
extern	int		Graphics_D3D11_DrawPrimitive2DUser(                       const VERTEX2D  *Vertex, int VertexNum,                                    int PrimitiveType, IMAGEDATA *Image, int TransFlag, int Is3D, int TurnFlag, int TextureNo ) ;
extern	int		Graphics_D3D11_DrawPrimitive2DUser_Billboard(                   VERTEX2D  *Vertex, int VertexNum,                                    int PrimitiveType, IMAGEDATA *Image, int TransFlag, int Is3D, int TurnFlag, int TextureNo ) ;
extern	int		Graphics_D3D11_DrawIndexedPrimitive2DUser(                const VERTEX2D  *Vertex, int VertexNum, const WORD *Indices, int IndexNum, int PrimitiveType, IMAGEDATA *Image, int TransFlag ) ;

extern	void	Graphics_D3D11_DrawPreparationToShader( int ParamFlag, int UseVertexShaderNo, int Is2D, int UseLibSubShaderConst ) ;							// VF[_[`p`OZbgAbv֐

extern	int		Graphics_D3D11_DrawPolygon2DToShader(          const VERTEX2DSHADER *Vertex, int PolygonNum ) ;																										// VF[_[gĂQc|S`悷
extern	int		Graphics_D3D11_DrawPolygon3DToShader(          const VERTEX3DSHADER *Vertex, int PolygonNum ) ;																										// VF[_[gĂRc|S`悷
extern	int		Graphics_D3D11_DrawPolygonIndexed2DToShader(   const VERTEX2DSHADER *Vertex, int VertexNum, const unsigned short *Indices, int PolygonNum ) ;														// VF[_[gĂQc|S`悷( _CfbNXgp )
extern	int		Graphics_D3D11_DrawPolygonIndexed3DToShader(   const VERTEX3DSHADER *Vertex, int VertexNum, const unsigned short *Indices, int PolygonNum ) ;														// VF[_[gĂRc|S`悷( _CfbNXgp )
extern	int		Graphics_D3D11_DrawPrimitive2DToShader(        const VERTEX2DSHADER *Vertex, int VertexNum,                                              int PrimitiveType /* DX_PRIMTYPE_TRIANGLELIST  */ ) ;		// VF[_[gĂQcv~eBu`悷
extern	int		Graphics_D3D11_DrawPrimitive3DToShader(        const VERTEX3DSHADER *Vertex, int VertexNum,                                              int PrimitiveType /* DX_PRIMTYPE_TRIANGLELIST  */ ) ;		// VF[_[gĂRcv~eBu`悷
extern	int		Graphics_D3D11_DrawPrimitiveIndexed2DToShader( const VERTEX2DSHADER *Vertex, int VertexNum, const unsigned short *Indices, int IndexNum, int PrimitiveType /* DX_PRIMTYPE_TRIANGLELIST  */ ) ;		// VF[_[gĂQcv~eBu`悷( _CfbNXgp )
extern	int		Graphics_D3D11_DrawPrimitiveIndexed3DToShader( const VERTEX3DSHADER *Vertex, int VertexNum, const unsigned short *Indices, int IndexNum, int PrimitiveType /* DX_PRIMTYPE_TRIANGLELIST  */ ) ;		// VF[_[gĂRcv~eBu`悷( _CfbNXgp )

extern	int		Graphics_D3D11_DrawPrimitive3DToShader_UseVertexBuffer(         int VertexBufHandle,                     int PrimitiveType /* DX_PRIMTYPE_TRIANGLELIST  */ ) ;										// VF[_[gĂRcv~eBu`悷( _obt@gp )
extern	int		Graphics_D3D11_DrawPrimitiveIndexed3DToShader_UseVertexBuffer(  int VertexBufHandle, int IndexBufHandle, int PrimitiveType /* DX_PRIMTYPE_TRIANGLELIST  */ ) ;										// VF[_[gĂRcv~eBu`悷( _obt@ƃCfbNXobt@gp )
extern	int		Graphics_D3D11_DrawPrimitive3DToShader_UseVertexBuffer2(        int VertexBufHandle,                     int PrimitiveType /* DX_PRIMTYPE_TRIANGLELIST  */, int StartVertex, int UseVertexNum ) ;	// VF[_[gĂRcv~eBu`悷( _obt@gp )
extern	int		Graphics_D3D11_DrawPrimitiveIndexed3DToShader_UseVertexBuffer2( int VertexBufHandle, int IndexBufHandle, int PrimitiveType /* DX_PRIMTYPE_TRIANGLELIST  */, int BaseVertex, int StartVertex, int UseVertexNum, int StartIndex, int UseIndexNum ) ;	// VF[_[gĂRcv~eBu`悷( _obt@ƃCfbNXobt@gp )








// ˑ֌W
extern	int		Graphics_D3D11_Initialize_Timing0_PF( void ) ;											// `揈̊ˑ̏s֐( sӏʂO )
extern	int		Graphics_D3D11_Initialize_Timing1_PF( void ) ;											// `揈̊ˑ̏s֐( sӏʂQ )
extern	int		Graphics_D3D11_Hardware_Initialize_PF( void ) ;											// n[hEGAANZ[^gpꍇ̊ˑ̏s
extern	int		Graphics_D3D11_Terminate_PF( void ) ;													// `揈̊ˑ̌ns֐
extern	int		Graphics_D3D11_RestoreOrChangeSetupGraphSystem_PF( int Change, int ScreenSizeX = -1, int ScreenSizeY = -1, int ColorBitDepth = -1, int RefreshRate = -1 ) ;		// OtBbNXVXe̕AA͕ύXt̍ăZbgAbvs
extern	int		Graphics_D3D11_Hardware_CheckValid_PF( void ) ;											// `pfoCXLǂ擾( ߂l  TRUE:L  FALSE: )
extern	void	Graphics_D3D11_ReleaseDirectXObject_PF( void ) ;											// DirectX ̃IuWFNg









// ˑ`ݒ֌W
extern	int		Graphics_Hardware_D3D11_SetRenderTargetToShader_PF( int TargetIndex, int DrawScreen, int SurfaceIndex ) ;	// VF[_[`ł̕`ݒ肷
extern	int		Graphics_Hardware_D3D11_SetDrawBrightToOneParam_PF( DWORD Bright ) ;											// SetDrawBright ̈
extern	int		Graphics_Hardware_D3D11_SetDrawBlendMode_PF( int BlendMode, int BlendParam ) ;								// `uh[hZbg
extern	int		Graphics_Hardware_D3D11_SetDrawAlphaTest_PF( int TestMode, int TestParam ) ;									// `掞̃At@eXg̐ݒs( TestMode:DX_CMP_GREATER( -1:ftHgɖ߂ )  TestParam:`At@lƂ̔rɎgpl )
extern	int		Graphics_Hardware_D3D11_SetDrawMode_PF( int DrawMode ) ;														// `惂[hZbg
extern	int		Graphics_Hardware_D3D11_SetDrawBright_PF( int RedBright, int GreenBright, int BlueBright ) ;					// `PxZbg
extern	int		Graphics_Hardware_D3D11_SetBlendGraphParamBase_PF( IMAGEDATA *BlendImage, int BlendType, int *Param ) ;		// SetBlendGraphParam ̉ϒp[^t
extern	int		Graphics_Hardware_D3D11_SetMaxAnisotropy_PF( int MaxAnisotropy ) ;											// őٕ̒lZbg
extern	int		Graphics_Hardware_D3D11_SetTransformToWorld_PF( const MATRIX *Matrix ) ;										// [hϊpsZbg
extern	int		Graphics_Hardware_D3D11_SetTransformToView_PF( const MATRIX *Matrix ) ;										// r[ϊpsZbg
extern	int		Graphics_Hardware_D3D11_SetTransformToProjection_PF( const MATRIX *Matrix ) ;								// eϊpsZbg
extern	int		Graphics_Hardware_D3D11_SetTransformToViewport_PF( const MATRIX *Matrix ) ;									// r[|[gsZbg
extern	int		Graphics_Hardware_D3D11_SetTextureAddressMode_PF( int Mode /* DX_TEXADDRESS_WRAP  */, int Stage ) ;		// eNX`AhX[hݒ肷
extern	int		Graphics_Hardware_D3D11_SetTextureAddressModeUV_PF( int ModeU, int ModeV, int Stage ) ;						// eNX`AhX[hݒ肷
extern	int		Graphics_Hardware_D3D11_SetTextureAddressTransformMatrix_PF( int UseFlag, MATRIX *Matrix, int Sampler = -1 ) ;// eNX`WϊsZbg
extern	int		Graphics_Hardware_D3D11_SetFogEnable_PF( int Flag ) ;														// tHOLɂ邩ǂݒ肷( TRUE:L  FALSE: )
extern	int		Graphics_Hardware_D3D11_SetFogMode_PF( int Mode /* DX_FOGMODE_NONE  */ ) ;									// tHO[hݒ肷
extern	int		Graphics_Hardware_D3D11_SetFogColor_PF( DWORD FogColor ) ;													// tHOJ[ύX
extern	int		Graphics_Hardware_D3D11_SetFogStartEnd_PF( float start, float end ) ;										// tHOn܂鋗ƏI鋗ݒ肷( 0.0f ` 1.0f )
extern	int		Graphics_Hardware_D3D11_SetFogDensity_PF( float density ) ;													// tHO̖xݒ肷( 0.0f ` 1.0f )
extern	int		Graphics_Hardware_D3D11_ApplyLigFogToHardware_PF( void ) ;													// {f[^ɐݒ肳ĂtHOn[hEFAɔf
extern	int		Graphics_Hardware_D3D11_SetUseOldDrawModiGraphCodeFlag_PF( int Flag ) ;										// ȑO DrawModiGraph ֐̃R[hgp邩ǂ̃tOZbg
extern	int		Graphics_Hardware_D3D11_RefreshAlphaChDrawMode_PF( void ) ;													// `ɐlނǂ̃tOXV
extern	void	Graphics_Hardware_D3D11_SetUse2DProjectionMatrix_PF( int Use2DProjectionMatrix ) ;							// gpˉesRcpɂ邩Qcpɂ邩ݒ肷








// ˑݒ֌W
extern	int		Graphics_Hardware_D3D11_SetUseHardwareVertexProcessing_PF( int Flag ) ;						// n[hEGA̒_Z@\gp邩ǂݒ肷
extern	int		Graphics_Hardware_D3D11_SetUsePixelLighting_PF( int Flag ) ;									// sNZPʂŃCeBOsǂݒ肷Av ShaderModel 3.0( TRUE:sNZPʂ̃CeBOs  FALSE:_Pʂ̃CeBOs( ftHg ) )
extern	int		Graphics_Hardware_D3D11_SetGraphicsDeviceRestoreCallbackFunction_PF( void (* Callback )( void *Data ), void *CallbackData ) ;			// OtBbNXfoCXXg畜AۂɌĂ΂R[obN֐ݒ肷
extern	int		Graphics_Hardware_D3D11_SetGraphicsDeviceLostCallbackFunction_PF( void (* Callback )( void *Data ), void *CallbackData ) ;			// OtBbNXfoCXXg畜AOɌĂ΂R[obN֐ݒ肷
extern	int		Graphics_Hardware_D3D11_SetUseNormalDrawShader_PF( int Flag ) ;								// ʏ`ɃvO}uVF[_[gp邩ǂݒ肷( TRUE:gp( ftHg )  FALSE:gpȂ )
extern	int		Graphics_Hardware_D3D11_SetMultiThreadFlag_PF( int Flag ) ;									// DirectDraw  Direct3D ̋x}`XbhΉɂ邩ǂZbg
extern	int		Graphics_Hardware_D3D11_GetVideoMemorySize_PF( int *AllSize, int *FreeSize ) ;				// rfI̗eʂ𓾂
extern	const D_IDirect3DDevice9 * Graphics_Hardware_D3D11_GetUseDirect3DDevice9_PF( void ) ;				// gp̂cRccXIuWFNg𓾂
extern	const D_IDirect3DSurface9* Graphics_Hardware_D3D11_GetUseDirect3D11BackBufferSurface_PF( void ) ;		// gp̃obNobt@Direct3DSurface9IuWFNg擾
extern	int		Graphics_Hardware_D3D11_RefreshDxLibDirect3DSetting_PF( void ) ;								// cwCûcRcݒȂ
extern	int		Graphics_D3D11_SetDDrawUseGuid_PF( const GUID FAR *Guid ) ;									// ccgpftchݒ肷
extern	const GUID *Graphics_D3D11_GetDirectDrawDeviceGUID_PF( int Number ) ;								// L DirectDraw foCX GUID 擾
extern	int		Graphics_D3D11_GetDirectDrawDeviceDescription_PF( int Number, char *StringBuffer ) ;			// L DirectDraw foCX̖O𓾂
extern	int		Graphics_D3D11_GetDirectDrawDeviceNum_PF( void ) ;											// L DirectDraw foCX̐擾
extern	int		Graphics_D3D11_SetUseDirectDrawDeviceIndex_PF( int Index ) ;									// gp DirectDraw foCX̃CfbNXݒ肷
extern	int		Graphics_D3D11_SetUseDirect3D11Ex_PF( int Flag ) ;											// Vistaȍ~̊ Direct3D11Ex gp邩ǂݒ肷( TRUE:gp( ftHg )  FALSE:gpȂ )








// ˑʊ֌W
extern	int		Graphics_Hardware_D3D11_SetupUseZBuffer_PF( void ) ;															// ݒɊÂĎgp[xobt@Zbg
extern	int		Graphics_Hardware_D3D11_ClearDrawScreenZBuffer_PF( const RECT *ClearRect ) ;									// ʂ̐[xobt@̏Ԃ
extern	int		Graphics_Hardware_D3D11_ClearDrawScreen_PF( const RECT *ClearRect ) ;										// ʂ̏Ԃ
extern	int		Graphics_Hardware_D3D11_SetDrawScreen_PF( int DrawScreen, int OldScreenSurface, IMAGEDATA *NewTargetImage, IMAGEDATA *OldTargetImage, SHADOWMAPDATA *NewTargetShadowMap, SHADOWMAPDATA *OldTargetShadowMap ) ;						// `ʂ̃Zbg
extern	int		Graphics_Hardware_D3D11_SetDrawScreen_Post_PF( int DrawScreen ) ;											// SetDrawScreen ̍ŌŌĂ΂֐
extern	int		Graphics_Hardware_D3D11_SetDrawArea_PF( int x1, int y1, int x2, int y2 ) ;									// `\̈̃Zbg
extern	int		Graphics_Hardware_D3D11_LockDrawScreenBuffer_PF( RECT *LockRect, BASEIMAGE *BaseImage, int TargetScreen, IMAGEDATA *TargetImage, int TargetScreenSurface, int ReadOnly, int TargetScreenTextureNo ) ;	// `obt@bN
extern	int		Graphics_Hardware_D3D11_UnlockDrawScreenBuffer_PF( void ) ;													// `obt@AbN
extern	int		Graphics_Hardware_D3D11_ScreenCopy_PF( void ) ;																// ʂ̓e\ʂɕ`悷
extern	int		Graphics_Hardware_D3D11_SaveDrawScreen_Begin_PF( int x1, int y1, int x2, int y2, BASEIMAGE *BaseImage ) ;	// ݕ`ΏۂɂȂĂʂۑ
extern	int		Graphics_Hardware_D3D11_SaveDrawScreen_Post_PF( void ) ;														// ݕ`ΏۂɂȂĂʂۑ
extern	int		Graphics_Hardware_D3D11_WaitVSync_PF( int SyncNum ) ;														// M҂
extern	int		Graphics_Hardware_D3D11_ScreenFlipBase_PF( void ) ;															// ʂƕ\ʂ
extern	int		Graphics_Hardware_D3D11_BltRectBackScreenToWindow_PF( HWND Window, RECT BackScreenRect, RECT WindowClientRect ) ;		// ʂ̎ẅ̗EChẼNCAg̈̎ẅ̗ɓ]
extern	int		Graphics_Hardware_D3D11_SetScreenFlipTargetWindow_PF( HWND TargetWindow ) ;									// ScreenFlip ŉ摜]̃EChEݒ肷( NULL w肷Ɛݒ )
extern	int		Graphics_Hardware_D3D11_SetZBufferMode_PF( int ZBufferSizeX, int ZBufferSizeY, int ZBufferBitDepth ) ;			// Cʂ̂yobt@̐ݒύX
extern	int		Graphics_Hardware_D3D11_SetDrawZBuffer_PF( int DrawScreen, IMAGEDATA *Image ) ;									// `yobt@̃Zbg








// ˑ擾֌W
extern	const COLORDATA *	Graphics_Hardware_D3D11_GetMainColorData_PF( void ) ;				// GetColor  GetColor2 ŎgpJ[f[^擾
extern	const COLORDATA *	Graphics_Hardware_D3D11_GetDispColorData_PF( void ) ;				// fBXv[̃J[f[^|C^𓾂
extern	int					Graphics_Hardware_D3D11_GetPixel_PF( int x, int y ) ;				// wW̐F擾








// ˑ摜֌W
extern	int		Graphics_Hardware_D3D11_UpdateGraphMovie_TheoraYUV_PF( MOVIEGRAPH *Movie, IMAGEDATA *Image ) ;			// YUVT[tFXg Theora ̓eOtBbNXnh̃eNX`ɓ]
extern	int		Graphics_Hardware_D3D11_GraphLock_PF( IMAGEDATA *Image, COLORDATA **ColorDataP ) ;						// OtBbN̈̃bN
extern	int		Graphics_Hardware_D3D11_GraphUnlock_PF( IMAGEDATA *Image ) ;												// OtBbN̈̃bN
extern	int		Graphics_Hardware_D3D11_CopyGraphZBufferImage_PF( IMAGEDATA *DestImage, IMAGEDATA *SrcImage ) ;			// OtBbN̂yobt@̏Ԃʂ̃OtBbN̂yobt@ɃRs[( DestGrHandle  SrcGrHandle yobt@Ă`\摜ŁAA`GCAX摜ł͂ȂƂ )
extern	int		Graphics_Hardware_D3D11_InitGraph_PF( void ) ;															// 摜f[^̏
extern	int		Graphics_Hardware_D3D11_FillGraph_PF( IMAGEDATA *Image, int Red, int Green, int Blue, int Alpha, int ASyncThread ) ;			// OtBbN̐FœhԂ
extern	int		Graphics_Hardware_D3D11_GetDrawScreenGraphBase_PF( IMAGEDATA *Image, IMAGEDATA *TargetImage, int TargetScreen, int TargetScreenSurface, int TargetScreenWidth, int TargetScreenHeight, int x1, int y1, int x2, int y2, int destX, int destY ) ;		// `\摜obNobt@ẅ̃OtBbN擾

// Direct3D11 ̃OtBbNnhɉ摜f[^]邽߂̊֐
extern	int		Graphics_Hardware_D3D11_BltBmpOrBaseImageToGraph3_PF(
	const RECT		*SrcRect,
	      int		DestX,
	      int		DestY,
	      int		GrHandle,
	const BASEIMAGE	*RgbBaseImage,
	const BASEIMAGE	*AlphaBaseImage,
	      int		RedIsAlphaFlag,
	      int		UseTransColorConvAlpha,
	      int		TargetOrig,
	      int		ASyncThread
) ;

extern	int		Graphics_Hardware_D3D11_CreateOrigTexture_PF(  IMAGEDATA_ORIG *Orig, int ASyncThread = FALSE ) ;		// IWi摜񒆂̃eNX`쐬( 0:  -1:s )
extern	int		Graphics_Hardware_D3D11_ReleaseOrigTexture_PF( IMAGEDATA_ORIG *Orig ) ;								// IWi摜񒆂̃eNX`
extern	int		Graphics_Hardware_D3D11_GetMultiSampleQuality_PF( int Samples ) ;									// w̃}`TvŎgpłőNIeBl擾








// ˑ_obt@ECfbNXobt@֌W
extern	int		Graphics_Hardware_D3D11_VertexBuffer_Create_PF( VERTEXBUFFERHANDLEDATA *VertexBuffer, int VertexSize, int VertexNum, int VertexType /* DX_VERTEX_TYPE_NORMAL_3D  */ ) ;		// _obt@nh̒_obt@쐬
extern	int		Graphics_Hardware_D3D11_VertexBuffer_Terminate_PF( VERTEXBUFFERHANDLEDATA *VertexBuffer ) ;																						// _obt@nȟn
extern	int		Graphics_Hardware_D3D11_VertexBuffer_SetData_PF( VERTEXBUFFERHANDLEDATA *VertexBuffer, int SetIndex, const void *VertexData, int VertexNum ) ;									// _obt@ɒ_f[^]
extern	int		Graphics_Hardware_D3D11_IndexBuffer_Create_PF( INDEXBUFFERHANDLEDATA *IndexBuffer, int IndexSize, int IndexNum, int IndexType /* DX_INDEX_TYPE_16BIT  */ ) ;									// CfbNXobt@nh̃ZbgAbvs
extern	int		Graphics_Hardware_D3D11_IndexBuffer_Terminate_PF( INDEXBUFFERHANDLEDATA *IndexBuffer ) ;																							// CfbNXobt@nȟn
extern	int		Graphics_Hardware_D3D11_IndexBuffer_SetData_PF( INDEXBUFFERHANDLEDATA *IndexBuffer, int SetIndex, const void *IndexData, int IndexNum ) ;										// CfbNXobt@ɃCfbNXf[^]









// ˑCg֌W
extern	int		Graphics_Hardware_D3D11_Light_SetUse_PF( int Flag ) ;															// CeBOsǂݒ肷
extern	int		Graphics_Hardware_D3D11_Light_GlobalAmbient_PF( COLOR_F *Color ) ;												// O[oArGgCgJ[ݒ肷
extern	int		Graphics_Hardware_D3D11_Light_SetState_PF( int LightNumber, LIGHTPARAM *LightParam ) ;							// Cgp[^Zbg
extern	int		Graphics_Hardware_D3D11_Light_SetEnable_PF( int LightNumber, int EnableState ) ;									// Cg̗LAύX








// ˑVhE}bv֌W
extern	int		Graphics_Hardware_D3D11_ShadowMap_CreateTexture_PF( SHADOWMAPDATA *ShadowMap, int ASyncThread = FALSE ) ;		// VhE}bvf[^ɕKvȃeNX`쐬
extern	int		Graphics_Hardware_D3D11_ShadowMap_ReleaseTexture_PF( SHADOWMAPDATA *ShadowMap ) ;								// VhE}bvf[^ɕKvȃeNX`
extern	void	Graphics_Hardware_D3D11_ShadowMap_RefreshVSParam_PF( void ) ;													// _VF[_[ɐݒ肷VhE}bv̏XV
extern	void	Graphics_Hardware_D3D11_ShadowMap_RefreshPSParam_PF( void ) ;													// sNZVF[_[ɐݒ肷VhE}bv̏XV
extern	int		Graphics_Hardware_D3D11_ShadowMap_DrawSetup_PF( SHADOWMAPDATA *ShadowMap ) ;										// VhE}bvւ̕`̏s
extern	int		Graphics_Hardware_D3D11_ShadowMap_DrawEnd_PF( SHADOWMAPDATA *ShadowMap ) ;										// VhE}bvւ̕`I
extern	int		Graphics_Hardware_D3D11_ShadowMap_SetUse_PF( int SlotIndex, SHADOWMAPDATA *ShadowMap ) ;							// `ŎgpVhE}bvw肷AXbg͂OPw\








// ˑVF[_[֌W
extern	int		Graphics_Hardware_D3D11_Shader_Create_PF( int ShaderHandle, int IsVertexShader, void *Image, int ImageSize, int ImageAfterFree, int ASyncThread ) ;		// VF[_[nh
extern	int		Graphics_Hardware_D3D11_Shader_TerminateHandle_PF( SHADERHANDLEDATA *Shader ) ;																			// VF[_[nȟn
extern	int		Graphics_Hardware_D3D11_Shader_GetValidShaderVersion_PF( void ) ;																							// gpłVF[_[̃o[W擾( 0=gȂ  200=VF[_[fQDOgp\  300=VF[_[fRDOgp\ )
extern	int		Graphics_Hardware_D3D11_Shader_GetConstIndex_PF( const TCHAR *ConstantName, SHADERHANDLEDATA *Shader ) ;													// w̖O萔gpVF[_[萔̔ԍ擾
extern	int		Graphics_Hardware_D3D11_Shader_GetConstCount_PF( const TCHAR *ConstantName, SHADERHANDLEDATA *Shader ) ;													// w̖O萔gpVF[_[萔̐擾
extern	const FLOAT4 *Graphics_Hardware_D3D11_Shader_GetConstDefaultParamF_PF( const TCHAR *ConstantName, SHADERHANDLEDATA *Shader ) ;									// w̖O_萔̃ftHgp[^i[Ă郁AhX擾
extern	int		Graphics_Hardware_D3D11_Shader_SetConst_PF(   int TypeIndex, int SetIndex, int ConstantIndex, const void *Param, int ParamNum, int UpdateUseArea ) ;	// VF[_[萔ݒ肷
extern	int		Graphics_Hardware_D3D11_Shader_ResetConst_PF( int TypeIndex, int SetIndex, int ConstantIndex, int ParamNum ) ;											// ẅ̃VF[_[萔Zbg
extern	int		Graphics_Hardware_D3D11_Shader_ModelCode_Init_PF( void ) ;																								// Rcfp̃VF[_[R[h̏s








// ˑ`֌W
extern	int		Graphics_Hardware_D3D11_Paint_PF( int x, int y, int FillColor, int BoundaryColor ) ;			// w_狫EFƂ܂œhԂ






#ifdef DX_USE_NAMESPACE

}

#endif // DX_USE_NAMESPACE

#endif // DX_NON_DIRECT3D11

#endif // __DXGRAPHICSD3D11_H__

