//-----------------------------------------------------------------------------
// 
// 		cwCu		GraphFilternvO( Direct3D9 )
// 
//  	Ver 3.13b
// 
//-----------------------------------------------------------------------------

// cwCu쐬p`
#define __DX_MAKE

// CN[h ---------------------------------------------------------------
#include "DxGraphicsFilterD3D9.h"
#include "DxGraphicsWin.h"
#include "DxWindow.h"
#include "DxWinAPI.h"
#include "DxShader_PS_D3D9.h"
#include "../DxSystem.h"
#include "../DxLog.h"
#include "../DxModel.h"
#include "../DxBaseFunc.h"
#include "../DxGraphics.h"
#include "../DxASyncLoad.h"

#ifndef DX_NON_FILTER

#ifdef DX_USE_NAMESPACE

namespace DxLib
{

#endif // DX_USE_NAMESPACE

// }N` -----------------------------------------------------------------

// \̐錾 -----------------------------------------------------------------

// tB^[֐p̃Cu̐ݒꎞIɑޔ邽߂Ɏg\
struct GRAPHFILTER_DRAWPARAMTEMP_DIRECT3D9
{
	D_IDirect3DSurface9 *	TargetSurface[ DX_RENDERTARGET_COUNT ] ;
	D_IDirect3DSurface9 *	DepthStencilSurfaece ;
	int						BlendMode ;
	int						BlendParam ;
	int						AlphaTestMode ;
	int						AlphaTestParam ;
	int						UseZBufferFlag3D ;
	int						DrawMode ;
	int						FogEnable ;
	int						LightEnable ;
} ;

struct GRAPHFILTER_SHADERPARAMTEMP_DIRECT3D9
{
	int						UserSetVertexShaderHandle ;
	int						UserSetPixelShaderHandle ;
	int						UserSetTextureGraphHandle[ 8 ] ;
	int						TextureNum ;
} ;

// f[^` -----------------------------------------------------------------


static int GraphFilterPassNum_Table[DX_GRAPH_FILTER_NUM] =
{
		1,		// DX_GRAPH_FILTER_MONO
		2,		// DX_GRAPH_FILTER_GAUSS
		1,		// DX_GRAPH_FILTER_DOWN_SCALE
		1,		// DX_GRAPH_FILTER_BRIGHT_CLIP
		2,		// DX_GRAPH_FILTER_HSB
		1,		// DX_GRAPH_FILTER_INVERT
		1,		// DX_GRAPH_FILTER_LEVEL
		1,		// DX_GRAPH_FILTER_TWO_COLOR
		1,		// DX_GRAPH_FILTER_GRADIENT_MAP
		1,		// DX_GRAPH_FILTER_PREMUL_ALPHA
		1,		// DX_GRAPH_FILTER_INTERP_ALPHA
};
static int GraphFilterUseWorkScreen_Table[DX_GRAPH_FILTER_NUM] =
{
		0,		// DX_GRAPH_FILTER_MONO
		1,		// DX_GRAPH_FILTER_GAUSS
		0,		// DX_GRAPH_FILTER_DOWN_SCALE
		0,		// DX_GRAPH_FILTER_BRIGHT_CLIP
		0,		// DX_GRAPH_FILTER_HSB
		0,		// DX_GRAPH_FILTER_INVERT
		0,		// DX_GRAPH_FILTER_LEVEL
		0,		// DX_GRAPH_FILTER_TWOCOLOR
		0,		// DX_GRAPH_FILTER_GRADIENT_MAP
		0,		// DX_GRAPH_FILTER_PREMUL_ALPHA
		0,		// DX_GRAPH_FILTER_INTERP_ALPHA
};

static int GraphBlendPassNum_Table[DX_GRAPH_BLEND_NUM] =
{
		1,		// DX_GRAPH_BLEND_NORMAL
		1,		// DX_GRAPH_BLEND_RGBA_SELECT_MIX
		1,		// DX_GRAPH_BLEND_MULTIPLE
		1,		// DX_GRAPH_BLEND_DIFFERENCE
		1,		// DX_GRAPH_BLEND_ADD
		1,		// DX_GRAPH_BLEND_SCREEN
		1,		// DX_GRAPH_BLEND_OVERLAY
		1,		// DX_GRAPH_BLEND_DODGE
		1,		// DX_GRAPH_BLEND_BURN
		1,		// DX_GRAPH_BLEND_DARKEN
		1,		// DX_GRAPH_BLEND_LIGHTEN
		1,		// DX_GRAPH_BLEND_SOFTLIGHT
		1,		// DX_GRAPH_BLEND_HARDLIGHT
		1,		// DX_GRAPH_BLEND_EXCLUSION
		1,		// DX_GRAPH_BLEND_NORMAL_ALPHACH
		1,		// DX_GRAPH_BLEND_ADD_ALPHACH
		1,		// DX_GRAPH_BLEND_MULTIPLE_A_ONLY
		1,		// DX_GRAPH_BLEND_PMA_MULTIPLE_A_ONLY
};
static int GraphBlendUseWorkScreen_Table[DX_GRAPH_BLEND_NUM] =
{
		0,		// DX_GRAPH_BLEND_NORMAL
		0,		// DX_GRAPH_BLEND_RGBA_SELECT_MIX
		0,		// DX_GRAPH_BLEND_MULTIPLE
		0,		// DX_GRAPH_BLEND_DIFFERENCE
		0,		// DX_GRAPH_BLEND_ADD
		0,		// DX_GRAPH_BLEND_SCREEN
		0,		// DX_GRAPH_BLEND_OVERLAY
		0,		// DX_GRAPH_BLEND_DODGE
		0,		// DX_GRAPH_BLEND_BURN
		0,		// DX_GRAPH_BLEND_DARKEN
		0,		// DX_GRAPH_BLEND_LIGHTEN
		0,		// DX_GRAPH_BLEND_SOFTLIGHT
		0,		// DX_GRAPH_BLEND_HARDLIGHT
		0,		// DX_GRAPH_BLEND_EXCLUSION
		0,		// DX_GRAPH_BLEND_NORMAL_ALPHACH
		0,		// DX_GRAPH_BLEND_ADD_ALPHACH
		0,		// DX_GRAPH_BLEND_MULTIPLE_A_ONLY
		0,		// DX_GRAPH_BLEND_PMA_MULTIPLE_A_ONLY
};

GRAPHFILTER_SYSTEMIFNO_DIRET3D9 GraphFilterSystemInfoD3D9 ;

// ֐錾 -------------------------------------------------------------------

static int	Direct3D9_GraphFilter_GetWorkTexture( int IsFloatType, DWORD TexSizeW, DWORD TexSizeH, DWORD HandleIndex ) ;		// tB^[Ɨp̃eNX`nh擾

static int  Direct3D9_MemLoadShaderCode( const char *ShaderName, bool IsVertexShader ) ;	// w薼̎OpӃVF[_[ǂݍ

extern void Direct3D9_GraphFilter_PushBaseDrawParam( GRAPHFILTER_DRAWPARAMTEMP_DIRECT3D9 *DrawParamTemp ) ;
extern void Direct3D9_GraphFilter_PopBaseDrawParam(  GRAPHFILTER_DRAWPARAMTEMP_DIRECT3D9 *DrawParamTemp ) ;
static void Direct3D9_GraphFilter_PushShaderParam(   GRAPHFILTER_SHADERPARAMTEMP_DIRECT3D9 *ShaderParamTemp, int TextureNum ) ;
static void Direct3D9_GraphFilter_PopShaderParam(    GRAPHFILTER_SHADERPARAMTEMP_DIRECT3D9 *ShaderParamTemp ) ;

static int	GraphFilterDestGraphSetup(  GRAPHFILTER_INFO *Info, int PassNum, int UseWorkScreen, int *UseSrcGrHandle, int *UseDestGrHandle ) ;
static int	GraphFilterDestGraphUpdate( GRAPHFILTER_INFO *Info, int UseWorkScreen, int UseDestGrHandle, int FilterResult ) ;

static int  Direct3D9_BasePolygonDraw( GRAPHFILTER_INFO *Info, int ScaleDivNum = 1 ) ;

// vO -----------------------------------------------------------------

// tB^[Ɨp̃eNX`nh擾
static int	Direct3D9_GraphFilter_GetWorkTexture( int IsFloatType, DWORD TexSizeW, DWORD TexSizeH, DWORD HandleIndex )
{
	IMAGEDATA *BaseImage ;
	DWORD       TexSizeBig ;
	DWORD       NPow ;
	int         TexSize ;

	TexSizeBig = TexSizeW > TexSizeH ? TexSizeW : TexSizeH ;
	for( NPow = 0 ; ( DWORD )( 1 << NPow ) < TexSizeBig ; NPow ++ ){}
	TexSize = ( int )( 1 << NPow ) ;

	if( GRAPHCHK( GraphFilterSystemInfoD3D9.WorkDrawValidGrHandle[ IsFloatType ][ NPow ][ HandleIndex ], BaseImage ) )
	{
		SETUP_GRAPHHANDLE_GPARAM GParam ;

		Graphics_Image_InitSetupGraphHandleGParam_Normal_DrawValid_NoneZBuffer( &GParam, 32, TRUE ) ;
		GParam.DrawValidFloatTypeGraphCreateFlag = IsFloatType ;

		GraphFilterSystemInfoD3D9.WorkDrawValidGrHandle[ IsFloatType ][ NPow ][ HandleIndex ] = Graphics_Image_MakeGraph_UseGParam( &GParam, TexSize, TexSize, FALSE, FALSE ) ;
		if( GraphFilterSystemInfoD3D9.WorkDrawValidGrHandle[ IsFloatType ][ NPow ][ HandleIndex ] < 0 )
		{
			DXST_ERRORLOGFMT_ADD(( _T( "Ɨp`\eNX`̍쐬Ɏs܂ Size:%dx%d" ), TexSize, TexSize )) ;
			return -1 ;
		}
		NS_SetDeleteHandleFlag( GraphFilterSystemInfoD3D9.WorkDrawValidGrHandle[ IsFloatType ][ NPow ][ HandleIndex ], &GraphFilterSystemInfoD3D9.WorkDrawValidGrHandle[ IsFloatType ][ NPow ][ HandleIndex ] ) ;
	}

	return GraphFilterSystemInfoD3D9.WorkDrawValidGrHandle[ IsFloatType ][ NPow ][ HandleIndex ] ;
}

// w薼̎OpӃVF[_[ǂݍ
static int Direct3D9_MemLoadShaderCode( const char *ShaderName, bool IsVertexShader )
{
	int Addr, Size ;
	BYTE *FileImage ;
	int Ret ;

	if( GD3D9.ShaderCode._2D._2DShaderInitializeFlag == FALSE ) return -1 ;

	if( DXA_GetFileInfo( &GD3D9.ShaderCode._2D.FilterShaderBinDxa, ShaderName, &Addr, &Size ) < 0 ) return -1 ;

	FileImage = ( BYTE * )DXA_GetFileImage( &GD3D9.ShaderCode._2D.FilterShaderBinDxa ) + Addr ;

	Ret = Graphics_Shader_CreateHandle_UseGParam( IsVertexShader, FileImage, Size, FALSE, FALSE ) ;

	return Ret ;
}

extern void Direct3D9_GraphFilter_PushBaseDrawParam( GRAPHFILTER_DRAWPARAMTEMP_DIRECT3D9 *DrawParamTemp )
{
	int i ;

	for( i = 0 ; i < GSYS.HardInfo.RenderTargetNum ; i ++ )
	{
		DrawParamTemp->TargetSurface[ i ] = GD3D9.Device.State.TargetSurface[ i ] ;
	}
	for( i = 1 ; i < GSYS.HardInfo.RenderTargetNum ; i ++ )
	{
		if( GD3D9.Device.State.TargetSurface[ i ] != NULL )
		{
			Graphics_D3D9_DeviceState_SetRenderTarget( NULL, i ) ;
		}
	}

	DrawParamTemp->UseZBufferFlag3D = GSYS.DrawSetting.EnableZBufferFlag3D ;
	DrawParamTemp->BlendMode        = GSYS.DrawSetting.BlendMode ;
	DrawParamTemp->BlendParam       = GSYS.DrawSetting.BlendParam ;
	DrawParamTemp->DrawMode         = GSYS.DrawSetting.DrawMode ;
	DrawParamTemp->AlphaTestMode    = GSYS.DrawSetting.AlphaTestMode ;
	DrawParamTemp->AlphaTestParam   = GSYS.DrawSetting.AlphaTestParam ;
	DrawParamTemp->FogEnable        = GSYS.DrawSetting.FogEnable ;
	DrawParamTemp->LightEnable      = GSYS.Light.ProcessDisable ? FALSE : TRUE ;
	
	NS_SetUseZBuffer3D( FALSE ) ;
	NS_SetDrawBlendMode( DX_BLENDMODE_SRCCOLOR, 255 ) ;
	NS_SetDrawMode( DX_DRAWMODE_BILINEAR ) ;
	NS_SetDrawAlphaTest( DX_CMP_ALWAYS, 0 ) ;
	NS_SetFogEnable( FALSE ) ;
	NS_SetUseLighting( FALSE ) ;
	if( Graphics_Hardware_CheckValid_PF() != 0 )
	{
		Direct3DDevice9_GetDepthStencilSurface( &DrawParamTemp->DepthStencilSurfaece ) ;
		Direct3DDevice9_SetDepthStencilSurface( NULL ) ;
	}
}

extern void Direct3D9_GraphFilter_PopBaseDrawParam( GRAPHFILTER_DRAWPARAMTEMP_DIRECT3D9 *DrawParamTemp )
{
	int i ;

	if( Graphics_Hardware_CheckValid_PF() != 0 )
	{
		Direct3DDevice9_SetDepthStencilSurface( DrawParamTemp->DepthStencilSurfaece ) ;
		Direct3D9_ObjectRelease( DrawParamTemp->DepthStencilSurfaece ) ;
		DrawParamTemp->DepthStencilSurfaece = NULL ;
	}
	for( i = 0 ; i < GSYS.HardInfo.RenderTargetNum ; i ++ )
	{
		if( DrawParamTemp->TargetSurface[ i ] != NULL )
		{
			Graphics_D3D9_DeviceState_SetRenderTarget( DrawParamTemp->TargetSurface[ i ], i ) ;
		}
	}

	GD3D9.Device.DrawSetting.CancelSettingEqualCheck = TRUE ;
	Graphics_D3D9_DeviceState_SetViewportEasy( GSYS.DrawSetting.DrawArea.left, GSYS.DrawSetting.DrawArea.top, GSYS.DrawSetting.DrawArea.right, GSYS.DrawSetting.DrawArea.bottom ) ;
	GD3D9.Device.DrawSetting.CancelSettingEqualCheck = FALSE ;

	NS_SetUseLighting(   DrawParamTemp->LightEnable ) ;
	NS_SetFogEnable(     DrawParamTemp->FogEnable ) ;
	NS_SetDrawAlphaTest( DrawParamTemp->AlphaTestMode, DrawParamTemp->AlphaTestParam ) ;
	NS_SetDrawMode(      DrawParamTemp->DrawMode ) ;
	NS_SetDrawBlendMode( DrawParamTemp->BlendMode, DrawParamTemp->BlendParam ) ;
	NS_SetUseZBuffer3D(  DrawParamTemp->UseZBufferFlag3D ) ;
}

static void Direct3D9_GraphFilter_PushShaderParam( GRAPHFILTER_SHADERPARAMTEMP_DIRECT3D9 *ShaderParamTemp, int TextureNum )
{
	ShaderParamTemp->UserSetVertexShaderHandle = GSYS.DrawSetting.UserShaderRenderInfo.SetVertexShaderHandle ;
	ShaderParamTemp->UserSetPixelShaderHandle = GSYS.DrawSetting.UserShaderRenderInfo.SetPixelShaderHandle ;
	Graphics_D3D9_ShaderConstant_InfoSet_SetUseState( &GD3D9.Device.Shader.ShaderConstantInfo, DX_SHADERCONSTANTSET_MASK_LIB | DX_SHADERCONSTANTSET_MASK_LIB_SUB ) ;
	if( TextureNum != 0 )
	{
		_MEMCPY( ShaderParamTemp->UserSetTextureGraphHandle, GSYS.DrawSetting.UserShaderRenderInfo.SetTextureGraphHandle, sizeof( int ) * TextureNum ) ;
	}
	ShaderParamTemp->TextureNum = TextureNum ;
}

static void Direct3D9_GraphFilter_PopShaderParam( GRAPHFILTER_SHADERPARAMTEMP_DIRECT3D9 *ShaderParamTemp )
{
	int i ;

	for( i = 0 ; i < ShaderParamTemp->TextureNum ; i ++ )
	{
		NS_SetUseTextureToShader( i, ShaderParamTemp->UserSetTextureGraphHandle[ i ] == 0 ? -1 : ShaderParamTemp->UserSetTextureGraphHandle[ i ] ) ;
	}
	NS_SetUseVertexShader( ShaderParamTemp->UserSetVertexShaderHandle ) ;
	NS_SetUsePixelShader( ShaderParamTemp->UserSetPixelShaderHandle ) ;
}





extern int	GraphFilter_D3D9_Mono_PF(        GRAPHFILTER_INFO *Info, float Cb, float Cr )
{
	static const char *PsoFileName[ 1 ] =
	{
		"Mono.pso",
	};
	GRAPHFILTER_SHADERPARAMTEMP_DIRECT3D9 ShaderParamTemp ;
	FLOAT4 ParamF4[ 2 ] ;

	NS_SetDrawMode( DX_DRAWMODE_NEAREST ) ;

	// gpVF[_[̃ZbgAbv
	if( GraphFilterShaderHandle.MonoPS < 0 )
	{
		GraphFilterShaderHandle.MonoPS = Direct3D9_MemLoadShaderCode( PsoFileName[ 0 ], false ) ;
		if( GraphFilterShaderHandle.MonoPS < 0 )
		{
			DXST_ERRORLOGFMT_ADD(( _T( "tB^[pVF[_[̍쐬Ɏs܂ %s" ), PsoFileName[ 0 ] )) ;
			return -1 ;
		}
		NS_SetDeleteHandleFlag( GraphFilterShaderHandle.MonoPS, &GraphFilterShaderHandle.MonoPS ) ;
	}

	Direct3D9_GraphFilter_PushShaderParam( &ShaderParamTemp, 1 ) ;

	ParamF4[ 0 ].x = 0.29900f ;
	ParamF4[ 0 ].y = 0.58700f ;
	ParamF4[ 0 ].z = 0.11400f ;
	ParamF4[ 0 ].w = 0.0f ;
	ParamF4[ 1 ].x = 1.40200f * Cr ;
	ParamF4[ 1 ].y = 0.34414f * Cb - 0.71414f * Cr ;
	ParamF4[ 1 ].z = 1.77200f * Cb ;
	ParamF4[ 1 ].w = 0.0f ;
	Graphics_D3D9_ShaderConstant_InfoSet_SetParam( &GD3D9.Device.Shader.ShaderConstantInfo, DX_SHADERCONSTANTTYPE_PS_FLOAT, DX_SHADERCONSTANTSET_LIB_SUB, 0, ParamF4, 2, FALSE ) ;

	NS_SetUsePixelShader( GraphFilterShaderHandle.MonoPS ) ;

	Direct3D9_BasePolygonDraw( Info ) ;

	Direct3D9_GraphFilter_PopShaderParam( &ShaderParamTemp ) ;

	Graphics_D3D9_ShaderConstant_InfoSet_ResetParam( &GD3D9.Device.Shader.ShaderConstantInfo, DX_SHADERCONSTANTTYPE_PS_FLOAT, DX_SHADERCONSTANTSET_LIB_SUB, 0, 2 ) ;

	// I
	return 0 ;
}

extern int	GraphFilter_D3D9_Gauss_PF( GRAPHFILTER_INFO *Info, int PixelWidth, float Param, float *Table )
{
	static const char *PsoFileName[] =
	{
		"Gauss_08Pixel_PS.pso",
		"Gauss_16Pixel_PS.pso",
		"Gauss_32Pixel_PS.pso"
	} ;
	IMAGEDATA               *SrcImage = NULL ;
	SHADOWMAPDATA           *SrcShadowMap = NULL ;
	GRAPHFILTER_SHADERPARAMTEMP_DIRECT3D9 ShaderParamTemp ;
	int                      UseShader = 0 ;
	FLOAT4                   ParamF4[ 21 ] ;
	int                      TexWidth ;
	int                      TexHeight ;

	if( GRAPHCHK(     Info->SrcGrHandle, SrcImage    ) &&
		SHADOWMAPCHK( Info->SrcGrHandle, SrcShadowMap ) )
		return -1 ;

	// PixelWidth ɂăVF[_[ύX
	switch( PixelWidth )
	{
	case 8  : UseShader = 0 ; break ;
	case 16 : UseShader = 1 ; break ;
	case 32 : UseShader = 2 ; break ;
	}

	if( Param < 0.0000001f )
	{
		IMAGEDATA *DestImage = NULL ;
		SHADOWMAPDATA *DestShadowMap = NULL ;

		if( GRAPHCHK(     Info->DestGrHandle, DestImage    ) &&
			SHADOWMAPCHK( Info->DestGrHandle, DestShadowMap ) )
			return -1 ;

		if( DestShadowMap )
		{
			Graphics_D3D9_DeviceState_SetRenderTarget( DestShadowMap->PF->D3D9.Surface ) ;
			NS_DrawGraph( 0, 0, Info->SrcGrHandle, FALSE ) ;
		}
		else
		{
			Graphics_D3D9_DeviceState_SetRenderTarget( Graphics_Image_CheckMultiSampleDrawValid( Info->DestGrHandle ) ?
										DestImage->Hard.Draw[ 0 ].Tex->PF->D3D9.RenderTargetSurface :
										DestImage->Hard.Draw[ 0 ].Tex->PF->D3D9.Surface[ 0 ] ) ;
			NS_DrawGraph( 0, 0, Info->SrcGrHandle, FALSE ) ;
			if( Graphics_Image_CheckMultiSampleDrawValid( Info->DestGrHandle ) )
			{
				Graphics_D3D9_EndScene() ;
				Graphics_D3D9_UpdateDrawTexture( DestImage->Hard.Draw[ 0 ].Tex, 0 ) ;
			}
		}
	}
	else
	{
		// gpVF[_[̃ZbgAbv
		if( GraphFilterShaderHandle.Gauss_PS[ UseShader ] < 0 )
		{
			GraphFilterShaderHandle.Gauss_PS[ UseShader ] = Direct3D9_MemLoadShaderCode( PsoFileName[ UseShader ], false ) ;
			if( GraphFilterShaderHandle.Gauss_PS[ UseShader ] < 0 )
			{
				DXST_ERRORLOGFMT_ADD(( _T( "tB^[pVF[_[̍쐬Ɏs܂ %s" ), PsoFileName[ UseShader ] )) ;
				return -1 ;
			}
			NS_SetDeleteHandleFlag( GraphFilterShaderHandle.Gauss_PS[ UseShader ], &GraphFilterShaderHandle.Gauss_PS[ UseShader ] ) ;
		}

		NS_GetGraphTextureSize( Info->SrcGrHandle, &TexWidth, &TexHeight ) ;

		Direct3D9_GraphFilter_PushShaderParam( &ShaderParamTemp, 1 ) ;

		ParamF4[  0 ].x = ( float )TexWidth ;
		ParamF4[  0 ].y = ( float )TexHeight ;
		ParamF4[  1 ].x = Table[ 0 ] ;
		ParamF4[  1 ].y = Table[ 1 ] ;
		ParamF4[  1 ].z = Table[ 2 ] ;
		ParamF4[  1 ].w = Table[ 3 ] ;
		ParamF4[  2 ].x = Table[ 4 ] ;
		ParamF4[  2 ].y = Table[ 5 ] ;
		ParamF4[  2 ].z = Table[ 6 ] ;
		ParamF4[  2 ].w = Table[ 7 ] ;
		ParamF4[  3 ].x = Table[ 8 ] ;
		ParamF4[  3 ].y = Table[ 9 ] ;
		ParamF4[  3 ].z = Table[ 10 ] ;
		ParamF4[  3 ].w = Table[ 11 ] ;
		ParamF4[  4 ].x = Table[ 12 ] ;
		ParamF4[  4 ].y = Table[ 13 ] ;
		ParamF4[  4 ].z = Table[ 14 ] ;
		ParamF4[  4 ].w = Table[ 15 ] ;

		// pXɂď𕪊
		switch( Info->Pass )
		{
		case 0 :
			ParamF4[  5 ].x =  0.0f / ParamF4[  0 ].x ; ParamF4[  5 ].y =  0.0f ; ParamF4[  5 ].z =  0.0f ; ParamF4[  5 ].w =  0.0f ;
			ParamF4[  6 ].x =  1.5f / ParamF4[  0 ].x ; ParamF4[  6 ].y =  0.0f ; ParamF4[  6 ].z =  0.0f ; ParamF4[  6 ].w =  0.0f ;
			ParamF4[  7 ].x =  3.5f / ParamF4[  0 ].x ; ParamF4[  7 ].y =  0.0f ; ParamF4[  7 ].z =  0.0f ; ParamF4[  7 ].w =  0.0f ;
			ParamF4[  8 ].x =  5.5f / ParamF4[  0 ].x ; ParamF4[  8 ].y =  0.0f ; ParamF4[  8 ].z =  0.0f ; ParamF4[  8 ].w =  0.0f ;
			ParamF4[  9 ].x =  7.5f / ParamF4[  0 ].x ; ParamF4[  9 ].y =  0.0f ; ParamF4[  9 ].z =  0.0f ; ParamF4[  9 ].w =  0.0f ;
			ParamF4[ 10 ].x =  9.5f / ParamF4[  0 ].x ; ParamF4[ 10 ].y =  0.0f ; ParamF4[ 10 ].z =  0.0f ; ParamF4[ 10 ].w =  0.0f ;
			ParamF4[ 11 ].x = 11.5f / ParamF4[  0 ].x ; ParamF4[ 11 ].y =  0.0f ; ParamF4[ 11 ].z =  0.0f ; ParamF4[ 11 ].w =  0.0f ;
			ParamF4[ 12 ].x = 13.5f / ParamF4[  0 ].x ; ParamF4[ 12 ].y =  0.0f ; ParamF4[ 12 ].z =  0.0f ; ParamF4[ 12 ].w =  0.0f ;
			ParamF4[ 13 ].x = 15.5f / ParamF4[  0 ].x ; ParamF4[ 13 ].y =  0.0f ; ParamF4[ 13 ].z =  0.0f ; ParamF4[ 13 ].w =  0.0f ;
			ParamF4[ 14 ].x = 17.5f / ParamF4[  0 ].x ; ParamF4[ 14 ].y =  0.0f ; ParamF4[ 14 ].z =  0.0f ; ParamF4[ 14 ].w =  0.0f ;
			ParamF4[ 15 ].x = 19.5f / ParamF4[  0 ].x ; ParamF4[ 15 ].y =  0.0f ; ParamF4[ 15 ].z =  0.0f ; ParamF4[ 15 ].w =  0.0f ;
			ParamF4[ 16 ].x = 21.5f / ParamF4[  0 ].x ; ParamF4[ 16 ].y =  0.0f ; ParamF4[ 16 ].z =  0.0f ; ParamF4[ 16 ].w =  0.0f ;
			ParamF4[ 17 ].x = 23.5f / ParamF4[  0 ].x ; ParamF4[ 17 ].y =  0.0f ; ParamF4[ 17 ].z =  0.0f ; ParamF4[ 17 ].w =  0.0f ;
			ParamF4[ 18 ].x = 25.5f / ParamF4[  0 ].x ; ParamF4[ 18 ].y =  0.0f ; ParamF4[ 18 ].z =  0.0f ; ParamF4[ 18 ].w =  0.0f ;
			ParamF4[ 19 ].x = 27.5f / ParamF4[  0 ].x ; ParamF4[ 19 ].y =  0.0f ; ParamF4[ 19 ].z =  0.0f ; ParamF4[ 19 ].w =  0.0f ;
			ParamF4[ 20 ].x = 29.5f / ParamF4[  0 ].x ; ParamF4[ 20 ].y =  0.0f ; ParamF4[ 20 ].z =  0.0f ; ParamF4[ 20 ].w =  0.0f ;
			break ;

		case 1 :
			ParamF4[  5 ].y =  0.0f / ParamF4[  0 ].y ; ParamF4[  5 ].x =  0.0f ; ParamF4[  5 ].z =  0.0f ; ParamF4[  5 ].w =  0.0f ;
			ParamF4[  6 ].y =  1.5f / ParamF4[  0 ].y ; ParamF4[  6 ].x =  0.0f ; ParamF4[  6 ].z =  0.0f ; ParamF4[  6 ].w =  0.0f ;
			ParamF4[  7 ].y =  3.5f / ParamF4[  0 ].y ; ParamF4[  7 ].x =  0.0f ; ParamF4[  7 ].z =  0.0f ; ParamF4[  7 ].w =  0.0f ;
			ParamF4[  8 ].y =  5.5f / ParamF4[  0 ].y ; ParamF4[  8 ].x =  0.0f ; ParamF4[  8 ].z =  0.0f ; ParamF4[  8 ].w =  0.0f ;
			ParamF4[  9 ].y =  7.5f / ParamF4[  0 ].y ; ParamF4[  9 ].x =  0.0f ; ParamF4[  9 ].z =  0.0f ; ParamF4[  9 ].w =  0.0f ;
			ParamF4[ 10 ].y =  9.5f / ParamF4[  0 ].y ; ParamF4[ 10 ].x =  0.0f ; ParamF4[ 10 ].z =  0.0f ; ParamF4[ 10 ].w =  0.0f ;
			ParamF4[ 11 ].y = 11.5f / ParamF4[  0 ].y ; ParamF4[ 11 ].x =  0.0f ; ParamF4[ 11 ].z =  0.0f ; ParamF4[ 11 ].w =  0.0f ;
			ParamF4[ 12 ].y = 13.5f / ParamF4[  0 ].y ; ParamF4[ 12 ].x =  0.0f ; ParamF4[ 12 ].z =  0.0f ; ParamF4[ 12 ].w =  0.0f ;
			ParamF4[ 13 ].y = 15.5f / ParamF4[  0 ].y ; ParamF4[ 13 ].x =  0.0f ; ParamF4[ 13 ].z =  0.0f ; ParamF4[ 13 ].w =  0.0f ;
			ParamF4[ 14 ].y = 17.5f / ParamF4[  0 ].y ; ParamF4[ 14 ].x =  0.0f ; ParamF4[ 14 ].z =  0.0f ; ParamF4[ 14 ].w =  0.0f ;
			ParamF4[ 15 ].y = 19.5f / ParamF4[  0 ].y ; ParamF4[ 15 ].x =  0.0f ; ParamF4[ 15 ].z =  0.0f ; ParamF4[ 15 ].w =  0.0f ;
			ParamF4[ 16 ].y = 21.5f / ParamF4[  0 ].y ; ParamF4[ 16 ].x =  0.0f ; ParamF4[ 16 ].z =  0.0f ; ParamF4[ 16 ].w =  0.0f ;
			ParamF4[ 17 ].y = 23.5f / ParamF4[  0 ].y ; ParamF4[ 17 ].x =  0.0f ; ParamF4[ 17 ].z =  0.0f ; ParamF4[ 17 ].w =  0.0f ;
			ParamF4[ 18 ].y = 25.5f / ParamF4[  0 ].y ; ParamF4[ 18 ].x =  0.0f ; ParamF4[ 18 ].z =  0.0f ; ParamF4[ 18 ].w =  0.0f ;
			ParamF4[ 19 ].y = 27.5f / ParamF4[  0 ].y ; ParamF4[ 19 ].x =  0.0f ; ParamF4[ 19 ].z =  0.0f ; ParamF4[ 19 ].w =  0.0f ;
			ParamF4[ 20 ].y = 29.5f / ParamF4[  0 ].y ; ParamF4[ 20 ].x =  0.0f ; ParamF4[ 20 ].z =  0.0f ; ParamF4[ 20 ].w =  0.0f ;
			break ;
		}

		Graphics_D3D9_ShaderConstant_InfoSet_SetParam( &GD3D9.Device.Shader.ShaderConstantInfo, DX_SHADERCONSTANTTYPE_PS_FLOAT, DX_SHADERCONSTANTSET_LIB_SUB, 0, ParamF4, 21, FALSE ) ;

		NS_SetUsePixelShader( GraphFilterShaderHandle.Gauss_PS[ UseShader ] ) ;

		Direct3D9_BasePolygonDraw( Info ) ;

		Direct3D9_GraphFilter_PopShaderParam( &ShaderParamTemp ) ;

		Graphics_D3D9_ShaderConstant_InfoSet_ResetParam( &GD3D9.Device.Shader.ShaderConstantInfo, DX_SHADERCONSTANTTYPE_PS_FLOAT, DX_SHADERCONSTANTSET_LIB_SUB, 0, 21 ) ;

		if( Info->Pass == 0 )
		{
			VERTEX2D Vert[ 4 ] ;
			float Width ;
			float Height ;
			int TexWidth ;
			int TexHeight ;

			GetGraphTextureSize( Info->DestGrHandle, &TexWidth, &TexHeight ) ;
			Width  = ( float )( Info->SrcX2 - Info->SrcX1 ) ;
			Height = ( float )( Info->SrcY2 - Info->SrcY1 ) ;
			Vert[ 0 ].pos.x = Info->DestX			- 0.5f ;	Vert[ 0 ].pos.y = Info->DestY + Height	- 0.5f ;	Vert[ 0 ].pos.z = 0.0f ;	Vert[ 0 ].rhw = 1.0f ;
			Vert[ 1 ].pos.x = Info->DestX + Width	- 0.5f ;	Vert[ 1 ].pos.y = Info->DestY + Height	- 0.5f ;	Vert[ 1 ].pos.z = 0.0f ;	Vert[ 1 ].rhw = 1.0f ;
			Vert[ 2 ].pos.x = Info->DestX			- 0.5f ;	Vert[ 2 ].pos.y = TexHeight				- 0.5f ;	Vert[ 2 ].pos.z = 0.0f ;	Vert[ 2 ].rhw = 1.0f ;
			Vert[ 3 ].pos.x = Info->DestX + Width	- 0.5f ;	Vert[ 3 ].pos.y = TexHeight				- 0.5f ;	Vert[ 3 ].pos.z = 0.0f ;	Vert[ 3 ].rhw = 1.0f ;
			Vert[ 0 ].u = Info->DestX             / ( float )TexWidth ;	Vert[ 0 ].v = ( float )( Info->DestY + Height - 1 ) / TexHeight ;
			Vert[ 1 ].u = ( Info->DestX + Width ) / ( float )TexWidth ;	Vert[ 1 ].v = Vert[ 0 ].v ;
			Vert[ 2 ].u = Vert[ 0 ].u ;									Vert[ 2 ].v = Vert[ 0 ].v ;
			Vert[ 3 ].u = Vert[ 1 ].u ;									Vert[ 3 ].v = Vert[ 0 ].v ;
			Vert[ 0 ].dif = GetColorU8( 255,255,255,255 ) ;
			Vert[ 1 ].dif = Vert[ 0 ].dif ;
			Vert[ 2 ].dif = Vert[ 0 ].dif ;
			Vert[ 3 ].dif = Vert[ 0 ].dif ;
			NS_DrawPrimitive2D( Vert, 4, DX_PRIMTYPE_TRIANGLESTRIP, Info->DestGrHandle, FALSE ) ;
		}
	}

	// I
	return 0 ;
}

extern int	GraphFilter_D3D9_Down_Scale_PF(  GRAPHFILTER_INFO *Info, int DivNum )
{
	static const char *PsoFileName[ 3 ] =
	{
		"DownScaleX2.pso",
		"DownScaleX4.pso",
		"DownScaleX8.pso",
	} ;
	GRAPHFILTER_SHADERPARAMTEMP_DIRECT3D9 ShaderParamTemp ;
	IMAGEDATA *SrcImage ;
	int UseShader = 0 ;
	int UseConstNum = 0 ;
	FLOAT4 ParamF4[ 16 ] ;
	float TextureW ;
	float TextureH ;
	int i ;

	if( GRAPHCHK( Info->SrcGrHandle, SrcImage ) )
		return -1 ;

	// gpVF[_[̃ZbgAbv
	switch( DivNum )
	{
	case 2 : UseShader = 0 ; break ;
	case 4 : UseShader = 1 ; break ;
	case 8 : UseShader = 2 ; break ;
	}
	if( GraphFilterShaderHandle.DownScalePS[ UseShader ] < 0 )
	{
		GraphFilterShaderHandle.DownScalePS[ UseShader ] = Direct3D9_MemLoadShaderCode( PsoFileName[ UseShader ], false ) ;
		if( GraphFilterShaderHandle.DownScalePS[ UseShader ] < 0 )
		{
			DXST_ERRORLOGFMT_ADD(( _T( "tB^[pVF[_[̍쐬Ɏs܂ %s" ), PsoFileName[ UseShader ] )) ;
			return -1 ;
		}
		NS_SetDeleteHandleFlag( GraphFilterShaderHandle.DownScalePS[ UseShader ], &GraphFilterShaderHandle.DownScalePS[ UseShader ] ) ;
	}

	Direct3D9_GraphFilter_PushShaderParam( &ShaderParamTemp, 1 ) ;

	switch( DivNum )
	{
	case 2 :
		ParamF4[  0 ].x = 0.0f ; ParamF4[  0 ].y = 0.0f ; ParamF4[  0 ].z = 0.0f ; ParamF4[  0 ].w = 0.0f ;
		UseConstNum = 1 ;
		break ;

	case 4 :
		ParamF4[  0 ].x = -1.0f ; ParamF4[  0 ].y = -1.0f ; ParamF4[  0 ].z = 0.0f ; ParamF4[  0 ].w = 0.0f ;
		ParamF4[  1 ].x =  1.0f ; ParamF4[  1 ].y = -1.0f ; ParamF4[  1 ].z = 0.0f ; ParamF4[  1 ].w = 0.0f ;
		ParamF4[  2 ].x = -1.0f ; ParamF4[  2 ].y =  1.0f ; ParamF4[  2 ].z = 0.0f ; ParamF4[  2 ].w = 0.0f ;
		ParamF4[  3 ].x =  1.0f ; ParamF4[  3 ].y =  1.0f ; ParamF4[  3 ].z = 0.0f ; ParamF4[  3 ].w = 0.0f ;
		UseConstNum = 4 ;
		break ;

	case 8 :
		ParamF4[  0 ].x = -3.0f ; ParamF4[  0 ].y = -3.0f ; ParamF4[  0 ].z = 0.0f ; ParamF4[  0 ].w = 0.0f ;
		ParamF4[  1 ].x = -1.0f ; ParamF4[  1 ].y = -3.0f ; ParamF4[  1 ].z = 0.0f ; ParamF4[  1 ].w = 0.0f ;
		ParamF4[  2 ].x =  1.0f ; ParamF4[  2 ].y = -3.0f ; ParamF4[  2 ].z = 0.0f ; ParamF4[  2 ].w = 0.0f ;
		ParamF4[  3 ].x =  3.0f ; ParamF4[  3 ].y = -3.0f ; ParamF4[  3 ].z = 0.0f ; ParamF4[  3 ].w = 0.0f ;
		ParamF4[  4 ].x = -3.0f ; ParamF4[  4 ].y = -1.0f ; ParamF4[  4 ].z = 0.0f ; ParamF4[  4 ].w = 0.0f ;
		ParamF4[  5 ].x = -1.0f ; ParamF4[  5 ].y = -1.0f ; ParamF4[  5 ].z = 0.0f ; ParamF4[  5 ].w = 0.0f ;
		ParamF4[  6 ].x =  1.0f ; ParamF4[  6 ].y = -1.0f ; ParamF4[  6 ].z = 0.0f ; ParamF4[  6 ].w = 0.0f ;
		ParamF4[  7 ].x =  3.0f ; ParamF4[  7 ].y = -1.0f ; ParamF4[  7 ].z = 0.0f ; ParamF4[  7 ].w = 0.0f ;
		ParamF4[  8 ].x = -3.0f ; ParamF4[  8 ].y =  1.0f ; ParamF4[  8 ].z = 0.0f ; ParamF4[  8 ].w = 0.0f ;
		ParamF4[  9 ].x = -1.0f ; ParamF4[  9 ].y =  1.0f ; ParamF4[  9 ].z = 0.0f ; ParamF4[  9 ].w = 0.0f ;
		ParamF4[ 10 ].x =  1.0f ; ParamF4[ 10 ].y =  1.0f ; ParamF4[ 10 ].z = 0.0f ; ParamF4[ 10 ].w = 0.0f ;
		ParamF4[ 11 ].x =  3.0f ; ParamF4[ 11 ].y =  1.0f ; ParamF4[ 11 ].z = 0.0f ; ParamF4[ 11 ].w = 0.0f ;
		ParamF4[ 12 ].x = -3.0f ; ParamF4[ 12 ].y =  3.0f ; ParamF4[ 12 ].z = 0.0f ; ParamF4[ 12 ].w = 0.0f ;
		ParamF4[ 13 ].x = -1.0f ; ParamF4[ 13 ].y =  3.0f ; ParamF4[ 13 ].z = 0.0f ; ParamF4[ 13 ].w = 0.0f ;
		ParamF4[ 14 ].x =  1.0f ; ParamF4[ 14 ].y =  3.0f ; ParamF4[ 14 ].z = 0.0f ; ParamF4[ 14 ].w = 0.0f ;
		ParamF4[ 15 ].x =  3.0f ; ParamF4[ 15 ].y =  3.0f ; ParamF4[ 15 ].z = 0.0f ; ParamF4[ 15 ].w = 0.0f ;
		UseConstNum = 16 ;
		break ;
	}
	TextureW = ( float )SrcImage->Orig->Hard.Tex[ 0 ].TexWidth ;
	TextureH = ( float )SrcImage->Orig->Hard.Tex[ 0 ].TexHeight ;
	for( i = 0 ; i < UseConstNum ; i ++ )
	{
		ParamF4[ i ].x /= TextureW ;
		ParamF4[ i ].y /= TextureH ;
	}
	Graphics_D3D9_ShaderConstant_InfoSet_SetParam( &GD3D9.Device.Shader.ShaderConstantInfo, DX_SHADERCONSTANTTYPE_PS_FLOAT, DX_SHADERCONSTANTSET_LIB_SUB, 0, ParamF4, UseConstNum, FALSE ) ;

	NS_SetUsePixelShader( GraphFilterShaderHandle.DownScalePS[ UseShader ] ) ;

	Direct3D9_BasePolygonDraw( Info, DivNum ) ;

	Direct3D9_GraphFilter_PopShaderParam( &ShaderParamTemp ) ;

	Graphics_D3D9_ShaderConstant_InfoSet_ResetParam( &GD3D9.Device.Shader.ShaderConstantInfo, DX_SHADERCONSTANTTYPE_PS_FLOAT, DX_SHADERCONSTANTSET_LIB_SUB, 0, UseConstNum ) ;

	// I
	return 0 ;
}

extern int	GraphFilter_D3D9_Bright_Clip_PF( GRAPHFILTER_INFO *Info, int CmpType, float CmpParam, int ClipFillFlag, COLOR_F *ClipFillColor )
{
	static const char *PsoFileName[ 2 ][ 2 ] =
	{
		"BrightClipLess.pso",
		"BrightClipFillLess.pso",
		"BrightClipGreater.pso",
		"BrightClipFillGreater.pso",
	} ;
	GRAPHFILTER_SHADERPARAMTEMP_DIRECT3D9 ShaderParamTemp ;
	int UseShader = 0 ;
	int UseFill ;
	FLOAT4 ParamF4[ 3 ] ;

	NS_SetDrawMode( DX_DRAWMODE_NEAREST ) ;

	// gpVF[_[̃ZbgAbv
	UseFill = ClipFillFlag == TRUE ? 1 : 0 ;
	switch( CmpType )
	{
	case DX_CMP_GREATER :
		UseShader = 1 ;
		break ;

	case DX_CMP_LESS :
		UseShader = 0 ;
		break ;
	}
	if( GraphFilterShaderHandle.BrightClipPS[ UseShader ][ UseFill ] < 0 )
	{
		GraphFilterShaderHandle.BrightClipPS[ UseShader ][ UseFill ] = Direct3D9_MemLoadShaderCode( PsoFileName[ UseShader ][ UseFill ], false ) ;
		if( GraphFilterShaderHandle.BrightClipPS[ UseShader ][ UseFill ] < 0 )
		{
			DXST_ERRORLOGFMT_ADD(( _T( "tB^[pVF[_[̍쐬Ɏs܂ %s" ), PsoFileName[ UseShader ][ UseFill ] )) ;
			return -1 ;
		}
		NS_SetDeleteHandleFlag( GraphFilterShaderHandle.BrightClipPS[ UseShader ][ UseFill ], &GraphFilterShaderHandle.BrightClipPS[ UseShader ][ UseFill ] ) ;
	}

	Direct3D9_GraphFilter_PushShaderParam( &ShaderParamTemp, 1 ) ;

	ParamF4[  0 ].x = CmpParam ;
	ParamF4[  0 ].y = CmpParam ;
	ParamF4[  0 ].z = CmpParam ;
	ParamF4[  0 ].w = CmpParam ;
	ParamF4[  1 ].x = 0.299f ;
	ParamF4[  1 ].y = 0.587f ;
	ParamF4[  1 ].z = 0.114f ;
	ParamF4[  1 ].w = 0.0f ;
	if( ClipFillColor != NULL )
	{
		ParamF4[  2 ].x = ClipFillColor->r ;
		ParamF4[  2 ].y = ClipFillColor->g ;
		ParamF4[  2 ].z = ClipFillColor->b ;
		ParamF4[  2 ].w = ClipFillColor->a ;
	}
	Graphics_D3D9_ShaderConstant_InfoSet_SetParam( &GD3D9.Device.Shader.ShaderConstantInfo, DX_SHADERCONSTANTTYPE_PS_FLOAT, DX_SHADERCONSTANTSET_LIB_SUB, 0, ParamF4, 3, FALSE ) ;

	NS_SetUsePixelShader( GraphFilterShaderHandle.BrightClipPS[ UseShader ][ UseFill ] ) ;

	Direct3D9_BasePolygonDraw( Info ) ;

	Direct3D9_GraphFilter_PopShaderParam( &ShaderParamTemp ) ;

	Graphics_D3D9_ShaderConstant_InfoSet_ResetParam( &GD3D9.Device.Shader.ShaderConstantInfo, DX_SHADERCONSTANTTYPE_PS_FLOAT, DX_SHADERCONSTANTSET_LIB_SUB, 0, 3 ) ;

	// I
	return 0 ;
}

extern int	GraphFilter_D3D9_HSB_PF(         GRAPHFILTER_INFO *Info, int HueType, float Hue, float Saturation, float Bright )
{
	static const char *PsoFileName[ 3 ] =
	{
		"Hsb_RGB_TO_HSB.pso",
		"Hsb_HSB_TO_RGB.pso",
		"Hsb_HSB_HLOCK.pso",
	} ;
	GRAPHFILTER_SHADERPARAMTEMP_DIRECT3D9 ShaderParamTemp ;
	int UseShader ;
	FLOAT4 ParamF4[ 3 ] ;

	NS_SetDrawMode( DX_DRAWMODE_NEAREST ) ;

	// gpVF[_[̃ZbgAbv
	if( HueType == 1 )
	{
		UseShader = 2 ;
	}
	else
	{
		UseShader = Info->Pass ;
	}
	if( GraphFilterShaderHandle.HsbPS[ UseShader ] < 0 )
	{
		GraphFilterShaderHandle.HsbPS[ UseShader ] = Direct3D9_MemLoadShaderCode( PsoFileName[ UseShader ], false ) ;
		if( GraphFilterShaderHandle.HsbPS[ UseShader ] < 0 )
		{
			DXST_ERRORLOGFMT_ADD(( _T( "tB^[pVF[_[̍쐬Ɏs܂ %s" ), PsoFileName[ UseShader ] )) ;
			return -1 ;
		}
		NS_SetDeleteHandleFlag( GraphFilterShaderHandle.HsbPS[ UseShader ], &GraphFilterShaderHandle.HsbPS[ UseShader ] ) ;
	}

	Direct3D9_GraphFilter_PushShaderParam( &ShaderParamTemp, 1 ) ;

	ParamF4[ 0 ].x = Hue ;
	ParamF4[ 0 ].y = Saturation > 0.0f ? Saturation * 5.0f : Saturation ;
	ParamF4[ 0 ].z = Bright ;
	ParamF4[ 0 ].w = 0.0f ;
	ParamF4[ 1 ].x = 0.5f ;
	ParamF4[ 1 ].y = 0.5f ;
	ParamF4[ 1 ].z = 0.5f ;
	ParamF4[ 1 ].w = 0.5f ;
	ParamF4[ 2 ].x = 1.0f ;
	ParamF4[ 2 ].y = 1.0f ;
	ParamF4[ 2 ].z = 1.0f ;
	ParamF4[ 2 ].w = 1.0f ;
	Graphics_D3D9_ShaderConstant_InfoSet_SetParam( &GD3D9.Device.Shader.ShaderConstantInfo, DX_SHADERCONSTANTTYPE_PS_FLOAT, DX_SHADERCONSTANTSET_LIB_SUB, 0, ParamF4, 3, FALSE ) ;

	NS_SetUsePixelShader( GraphFilterShaderHandle.HsbPS[ UseShader ] ) ;

	Direct3D9_BasePolygonDraw( Info ) ;

	Direct3D9_GraphFilter_PopShaderParam( &ShaderParamTemp ) ;

	Graphics_D3D9_ShaderConstant_InfoSet_ResetParam( &GD3D9.Device.Shader.ShaderConstantInfo, DX_SHADERCONSTANTTYPE_PS_FLOAT, DX_SHADERCONSTANTSET_LIB_SUB, 0, 3 ) ;

	// I
	return 0 ;
}

extern int	GraphFilter_D3D9_Invert_PF(      GRAPHFILTER_INFO *Info )
{
	static const char *PsoFileName[ 1 ] =
	{
		"Invert.pso",
	} ;
	GRAPHFILTER_SHADERPARAMTEMP_DIRECT3D9 ShaderParamTemp ;

	NS_SetDrawMode( DX_DRAWMODE_NEAREST ) ;

	// gpVF[_[̃ZbgAbv
	if( GraphFilterShaderHandle.InvertPS < 0 )
	{
		GraphFilterShaderHandle.InvertPS = Direct3D9_MemLoadShaderCode( PsoFileName[ 0 ], false ) ;
		if( GraphFilterShaderHandle.InvertPS < 0 )
		{
			DXST_ERRORLOGFMT_ADD(( _T( "tB^[pVF[_[̍쐬Ɏs܂ %s" ), PsoFileName[ 0 ] )) ;
			return -1 ;
		}
		NS_SetDeleteHandleFlag( GraphFilterShaderHandle.InvertPS, &GraphFilterShaderHandle.InvertPS ) ;
	}

	Direct3D9_GraphFilter_PushShaderParam( &ShaderParamTemp, 1 ) ;

	NS_SetUsePixelShader( GraphFilterShaderHandle.InvertPS ) ;

	Direct3D9_BasePolygonDraw( Info ) ;

	Direct3D9_GraphFilter_PopShaderParam( &ShaderParamTemp ) ;

	// I
	return 0 ;
}

extern int	GraphFilter_D3D9_Level_PF(       GRAPHFILTER_INFO *Info, float Min, float Max, float Gamma, float AfterMin, float AfterMax )
{
	static const char *PsoFileName[ 1 ] =
	{
		"Level.pso",
	} ;
	GRAPHFILTER_SHADERPARAMTEMP_DIRECT3D9 ShaderParamTemp ;
	FLOAT4 ParamF4[ 1 ] ;
	int Always ;

	// NS_SetDrawMode( DX_DRAWMODE_NEAREST ) ;

	// K}␳e[ũZbgAbv
	Always = FALSE ;
	if( GraphFilterShaderHandle.GammaTex < 0 )
	{
		SETUP_GRAPHHANDLE_GPARAM GParam ;

		Graphics_Image_InitSetupGraphHandleGParam_Normal_NonDrawValid( &GParam, 32, FALSE, FALSE ) ;

		GraphFilterShaderHandle.GammaTex = Graphics_Image_MakeGraph_UseGParam( &GParam, 256, 1, FALSE, FALSE ) ;
		NS_SetDeleteHandleFlag( GraphFilterShaderHandle.GammaTex, &GraphFilterShaderHandle.GammaTex ) ;
		GraphFilterShaderHandle.PrevGamma = -10000000.0f ;
		Always = TRUE ;
	}
	if( Always == TRUE || _FABS( GraphFilterShaderHandle.PrevGamma - Gamma ) > 0.0001f )
	{
		BASEIMAGE GammaBaseImage ;
		NS_CreateXRGB8ColorBaseImage( 256, 1, &GammaBaseImage ) ;
		if( GammaBaseImage.GraphData != NULL )
		{
			int i ;
			float Param ;
			float GammaRev ;
			BYTE *Dest ;

			Dest = ( BYTE * )GammaBaseImage.GraphData ;
			GammaRev = 1.0f / Gamma ;
			for( i = 0 ; i < 256 ; i ++, Dest += 4 )
			{
				Param = _POW( ( float )i / 255.0f, GammaRev ) * 255.0f ;
				if( Param > 255.0f )
				{
					*Dest = 255 ;
				}
				else
				{
					*Dest = ( BYTE )_FTOL( Param ) ;
				}
				Dest[ 1 ] = Dest[ 0 ] ;
				Dest[ 2 ] = Dest[ 0 ] ;
				Dest[ 3 ] = Dest[ 0 ] ;
			}
			NS_BltBmpOrGraphImageToGraph( NULL, NULL, NULL, FALSE, &GammaBaseImage, NULL, 0, 0, GraphFilterShaderHandle.GammaTex ) ;

			GraphFilterShaderHandle.PrevGamma = Gamma ;

			NS_ReleaseBaseImage( &GammaBaseImage ) ;
		}
	}

	// gpVF[_[̃ZbgAbv
	if( GraphFilterShaderHandle.LevelPS < 0 )
	{
		GraphFilterShaderHandle.LevelPS = Direct3D9_MemLoadShaderCode( PsoFileName[ 0 ], false ) ;
		if( GraphFilterShaderHandle.LevelPS < 0 )
		{
			DXST_ERRORLOGFMT_ADD(( _T( "tB^[pVF[_[̍쐬Ɏs܂ %s" ), PsoFileName[ 0 ] )) ;
			return -1 ;
		}
		NS_SetDeleteHandleFlag( GraphFilterShaderHandle.LevelPS, &GraphFilterShaderHandle.LevelPS ) ;
	}

	Direct3D9_GraphFilter_PushShaderParam( &ShaderParamTemp, 1 ) ;

	ParamF4[ 0 ].x = Min ;
	ParamF4[ 0 ].y = 1.0f / ( Max - Min ) ;
	ParamF4[ 0 ].z = AfterMin ;
	ParamF4[ 0 ].w = AfterMax ;
	Graphics_D3D9_ShaderConstant_InfoSet_SetParam( &GD3D9.Device.Shader.ShaderConstantInfo, DX_SHADERCONSTANTTYPE_PS_FLOAT, DX_SHADERCONSTANTSET_LIB_SUB, 0, ParamF4, 1, FALSE ) ;

	NS_SetUsePixelShader( GraphFilterShaderHandle.LevelPS ) ;

	NS_SetUseTextureToShader( 1, GraphFilterShaderHandle.GammaTex ) ;

	Direct3D9_BasePolygonDraw( Info ) ;

	Direct3D9_GraphFilter_PopShaderParam( &ShaderParamTemp ) ;

	Graphics_D3D9_ShaderConstant_InfoSet_ResetParam( &GD3D9.Device.Shader.ShaderConstantInfo, DX_SHADERCONSTANTTYPE_PS_FLOAT, DX_SHADERCONSTANTSET_LIB_SUB, 0, 1 ) ;

	// I
	return 0 ;
}

extern int	GraphFilter_D3D9_TwoColor_PF(    GRAPHFILTER_INFO *Info, float Threshold, COLOR_F *LowColor, COLOR_F *HighColor )
{
	Threshold /= 255.0f ;

	static const char *PsoFileName[ 1 ] =
	{
		"TwoColor.pso",
	} ;
	GRAPHFILTER_SHADERPARAMTEMP_DIRECT3D9 ShaderParamTemp ;
	FLOAT4 ParamF4[ 3 ] ;

	NS_SetDrawMode( DX_DRAWMODE_NEAREST ) ;

	// gpVF[_[̃ZbgAbv
	if( GraphFilterShaderHandle.TwoColorPS < 0 )
	{
		GraphFilterShaderHandle.TwoColorPS = Direct3D9_MemLoadShaderCode( PsoFileName[ 0 ], false ) ;
		if( GraphFilterShaderHandle.TwoColorPS < 0 )
		{
			DXST_ERRORLOGFMT_ADD(( _T( "tB^[pVF[_[̍쐬Ɏs܂ %s" ), PsoFileName[ 0 ] )) ;
			return -1 ;
		}
		NS_SetDeleteHandleFlag( GraphFilterShaderHandle.TwoColorPS, &GraphFilterShaderHandle.TwoColorPS ) ;
	}

	Direct3D9_GraphFilter_PushShaderParam( &ShaderParamTemp, 1 ) ;

	ParamF4[ 0 ].x = 0.29900f ;
	ParamF4[ 0 ].y = 0.58700f ;
	ParamF4[ 0 ].z = 0.11400f ;
	ParamF4[ 0 ].w = Threshold ;
	ParamF4[ 1 ].x = LowColor->r ;
	ParamF4[ 1 ].y = LowColor->g ;
	ParamF4[ 1 ].z = LowColor->b ;
	ParamF4[ 1 ].w = LowColor->a ;
	ParamF4[ 2 ].x = HighColor->r ;
	ParamF4[ 2 ].y = HighColor->g ;
	ParamF4[ 2 ].z = HighColor->b ;
	ParamF4[ 2 ].w = HighColor->a ;
	Graphics_D3D9_ShaderConstant_InfoSet_SetParam( &GD3D9.Device.Shader.ShaderConstantInfo, DX_SHADERCONSTANTTYPE_PS_FLOAT, DX_SHADERCONSTANTSET_LIB_SUB, 0, ParamF4, 3, FALSE ) ;

	NS_SetUsePixelShader( GraphFilterShaderHandle.TwoColorPS ) ;

	Direct3D9_BasePolygonDraw( Info ) ;

	Direct3D9_GraphFilter_PopShaderParam( &ShaderParamTemp ) ;

	Graphics_D3D9_ShaderConstant_InfoSet_ResetParam( &GD3D9.Device.Shader.ShaderConstantInfo, DX_SHADERCONSTANTTYPE_PS_FLOAT, DX_SHADERCONSTANTSET_LIB_SUB, 0, 3 ) ;

	// I
	return 0 ;
}

extern int	GraphFilter_D3D9_GradientMap_PF( GRAPHFILTER_INFO *Info, int MapGrHandle, int Reverse )
{
	static const char *PsoFileName[ 2 ] =
	{
		"GradientMap.pso",
		"GradientMapRev.pso",
	} ;
	int UseShader ;
	GRAPHFILTER_SHADERPARAMTEMP_DIRECT3D9 ShaderParamTemp ;
	FLOAT4 ParamF4[ 1 ] ;

	NS_SetDrawMode( DX_DRAWMODE_NEAREST ) ;

	// gpVF[_[̃ZbgAbv
	UseShader = Reverse ? 1 : 0 ;
	if( GraphFilterShaderHandle.GradientMapPS[ UseShader ] < 0 )
	{
		GraphFilterShaderHandle.GradientMapPS[ UseShader ] = Direct3D9_MemLoadShaderCode( PsoFileName[ UseShader ], false ) ;
		if( GraphFilterShaderHandle.GradientMapPS[ UseShader ] < 0 )
		{
			DXST_ERRORLOGFMT_ADD(( _T( "tB^[pVF[_[̍쐬Ɏs܂ %s" ), PsoFileName[ UseShader ] )) ;
			return -1 ;
		}
		NS_SetDeleteHandleFlag( GraphFilterShaderHandle.GradientMapPS[ UseShader ], &GraphFilterShaderHandle.GradientMapPS[ UseShader ] ) ;
	}

	Direct3D9_GraphFilter_PushShaderParam( &ShaderParamTemp, 2 ) ;

	ParamF4[ 0 ].x = 0.29900f ;
	ParamF4[ 0 ].y = 0.58700f ;
	ParamF4[ 0 ].z = 0.11400f ;
	ParamF4[ 0 ].w = 0.0f ;
	Graphics_D3D9_ShaderConstant_InfoSet_SetParam( &GD3D9.Device.Shader.ShaderConstantInfo, DX_SHADERCONSTANTTYPE_PS_FLOAT, DX_SHADERCONSTANTSET_LIB_SUB, 0, ParamF4, 1, FALSE ) ;

	NS_SetUsePixelShader( GraphFilterShaderHandle.GradientMapPS[ UseShader ] ) ;

	NS_SetUseTextureToShader( 1, MapGrHandle ) ;

	Direct3D9_BasePolygonDraw( Info ) ;

	Direct3D9_GraphFilter_PopShaderParam( &ShaderParamTemp ) ;

	Graphics_D3D9_ShaderConstant_InfoSet_ResetParam( &GD3D9.Device.Shader.ShaderConstantInfo, DX_SHADERCONSTANTTYPE_PS_FLOAT, DX_SHADERCONSTANTSET_LIB_SUB, 0, 1 ) ;

	// I
	return 0 ;
}

extern int	GraphFilter_D3D9_PremulAlpha_PF( GRAPHFILTER_INFO *Info )
{
	static const char *PsoFileName[ 1 ] =
	{
		"PremultipliedAlpha.pso",
	} ;
	int UseShader ;
	GRAPHFILTER_SHADERPARAMTEMP_DIRECT3D9 ShaderParamTemp ;

	NS_SetDrawMode( DX_DRAWMODE_NEAREST ) ;

	// gpVF[_[̃ZbgAbv
	UseShader = 0 ;
	if( GraphFilterShaderHandle.PreMulAlphaPS < 0 )
	{
		GraphFilterShaderHandle.PreMulAlphaPS = Direct3D9_MemLoadShaderCode( PsoFileName[ UseShader ], false ) ;
		if( GraphFilterShaderHandle.PreMulAlphaPS < 0 )
		{
			DXST_ERRORLOGFMT_ADD(( _T( "tB^[pVF[_[̍쐬Ɏs܂ %s" ), PsoFileName[ UseShader ] )) ;
			return -1 ;
		}
		NS_SetDeleteHandleFlag( GraphFilterShaderHandle.PreMulAlphaPS, &GraphFilterShaderHandle.PreMulAlphaPS ) ;
	}

	Direct3D9_GraphFilter_PushShaderParam( &ShaderParamTemp, 1 ) ;

	NS_SetUsePixelShader( GraphFilterShaderHandle.PreMulAlphaPS ) ;

	Direct3D9_BasePolygonDraw( Info ) ;

	Direct3D9_GraphFilter_PopShaderParam( &ShaderParamTemp ) ;

	// I
	return 0 ;
}

extern int	GraphFilter_D3D9_InterpAlpha_PF( GRAPHFILTER_INFO *Info )
{
	static const char *PsoFileName[ 1 ] =
	{
		"InterpolatedAlpha.pso",
	} ;
	int UseShader ;
	GRAPHFILTER_SHADERPARAMTEMP_DIRECT3D9 ShaderParamTemp ;

	NS_SetDrawMode( DX_DRAWMODE_NEAREST ) ;

	// gpVF[_[̃ZbgAbv
	UseShader = 0 ;
	if( GraphFilterShaderHandle.InterpAlphaPS < 0 )
	{
		GraphFilterShaderHandle.InterpAlphaPS = Direct3D9_MemLoadShaderCode( PsoFileName[ UseShader ], false ) ;
		if( GraphFilterShaderHandle.InterpAlphaPS < 0 )
		{
			DXST_ERRORLOGFMT_ADD(( _T( "tB^[pVF[_[̍쐬Ɏs܂ %s" ), PsoFileName[ UseShader ] )) ;
			return -1 ;
		}
		NS_SetDeleteHandleFlag( GraphFilterShaderHandle.InterpAlphaPS, &GraphFilterShaderHandle.InterpAlphaPS ) ;
	}

	Direct3D9_GraphFilter_PushShaderParam( &ShaderParamTemp, 1 ) ;

	NS_SetUsePixelShader( GraphFilterShaderHandle.InterpAlphaPS ) ;

	Direct3D9_BasePolygonDraw( Info ) ;

	Direct3D9_GraphFilter_PopShaderParam( &ShaderParamTemp ) ;

	// I
	return 0 ;
}


extern int	GraphBlend_D3D9_Basic_PF(           GRAPHFILTER_INFO *Info )
{
	static const char *PsoFileName[ 18 ] =
	{
		"BasBF_Normal.pso",				// DX_GRAPH_BLEND_NORMAL
		NULL,							// DX_GRAPH_BLEND_RGBA_SELECT_MIX
		"BasBF_Multiple.pso",			// DX_GRAPH_BLEND_MULTIPLE
		"BasBF_Difference.pso",			// DX_GRAPH_BLEND_DIFFERENCE
		"BasBF_Add.pso",				// DX_GRAPH_BLEND_ADD
		"BasBF_Screen.pso",				// DX_GRAPH_BLEND_SCREEN
		"BasBF_Overlay.pso",			// DX_GRAPH_BLEND_OVERLAY
		"BasBF_Dodge.pso",				// DX_GRAPH_BLEND_DODGE
		"BasBF_Burn.pso",				// DX_GRAPH_BLEND_BURN
		"BasBF_Darken.pso",				// DX_GRAPH_BLEND_DARKEN
		"BasBF_Lighten.pso",			// DX_GRAPH_BLEND_LIGHTEN
		"BasBF_SoftLight.pso",			// DX_GRAPH_BLEND_SOFTLIGHT
		"BasBF_HardLight.pso",			// DX_GRAPH_BLEND_HARDLIGHT
		"BasBF_Exclusion.pso",			// DX_GRAPH_BLEND_EXCLUSION
		"BasBF_Normal_AlphaCh.pso",		// DX_GRAPH_BLEND_NORMAL_ALPHACH
		"BasBF_Add_AlphaCh.pso",		// DX_GRAPH_BLEND_ADD_ALPHACH
		"BasBF_Multiple_AOnly.pso",		// DX_GRAPH_BLEND_MULTIPLE_A_ONLY
		"BasBF_PMA_Multiple_AOnly.pso",	// DX_GRAPH_BLEND_PMA_MULTIPLE_A_ONLY
	} ;
	GRAPHFILTER_SHADERPARAMTEMP_DIRECT3D9 ShaderParamTemp ;
	int UseShader ;
	FLOAT4 ParamF4[ 2 ] ;

//		NS_SetDrawMode( DX_DRAWMODE_NEAREST ) ;

	// gpVF[_[̃ZbgAbv
	UseShader = Info->FilterOrBlendType ;
	if( GraphFilterShaderHandle.BasicBlendPS[ UseShader ] < 0 )
	{
		GraphFilterShaderHandle.BasicBlendPS[ UseShader ] = Direct3D9_MemLoadShaderCode( PsoFileName[ UseShader ], false ) ;
		if( GraphFilterShaderHandle.BasicBlendPS[ UseShader ] < 0 )
		{
			DXST_ERRORLOGFMT_ADD(( _T( "tB^[pVF[_[̍쐬Ɏs܂ %s" ), PsoFileName[ UseShader ] )) ;
			return -1 ;
		}
		NS_SetDeleteHandleFlag( GraphFilterShaderHandle.BasicBlendPS[ UseShader ], &GraphFilterShaderHandle.BasicBlendPS[ UseShader ] ) ;
	}

	Direct3D9_GraphFilter_PushShaderParam( &ShaderParamTemp, 2 ) ;
	
	ParamF4[ 0 ].x = Info->BlendRatio ;
	ParamF4[ 0 ].y = Info->BlendRatio ;
	ParamF4[ 0 ].z = Info->BlendRatio ;
	ParamF4[ 0 ].w = Info->BlendRatio ;
	ParamF4[ 1 ].x = 1.0f ;
	ParamF4[ 1 ].y = 1.0f ;
	ParamF4[ 1 ].z = 1.0f ;
	ParamF4[ 1 ].w = 1.0f ;
	Graphics_D3D9_ShaderConstant_InfoSet_SetParam( &GD3D9.Device.Shader.ShaderConstantInfo, DX_SHADERCONSTANTTYPE_PS_FLOAT, DX_SHADERCONSTANTSET_LIB_SUB, 0, ParamF4, 2, FALSE ) ;

	NS_SetUsePixelShader( GraphFilterShaderHandle.BasicBlendPS[ UseShader ] ) ;

	Direct3D9_BasePolygonDraw( Info ) ;

	Direct3D9_GraphFilter_PopShaderParam( &ShaderParamTemp ) ;

	Graphics_D3D9_ShaderConstant_InfoSet_ResetParam( &GD3D9.Device.Shader.ShaderConstantInfo, DX_SHADERCONSTANTTYPE_PS_FLOAT, DX_SHADERCONSTANTSET_LIB_SUB, 0, 2 ) ;

	// I
	return 0 ;
}

extern int	GraphBlend_D3D9_RGBA_Select_Mix_PF( GRAPHFILTER_INFO *Info, int SelectR, int SelectG, int SelectB, int SelectA )
{
	static const char *PsoFileName[ 1 ] =
	{
		"RGBAMix_Base.pso",
	} ;
	static const char *CharTable[ 4 ] =
	{
		"R", "G", "B", "A"
	};
	int *PixelShaderHandle ;
	GRAPHFILTER_SHADERPARAMTEMP_DIRECT3D9 ShaderParamTemp ;
	FLOAT4 ParamF4[ 2 ] ;
	char FileName[ 64 ] ;
	int SrcBlendReverse = FALSE ;
	int HandleTemp ;
	int SrcOnlyFlag = FALSE ;

	NS_SetDrawMode( DX_DRAWMODE_NEAREST ) ;

	// gpVF[_[̃ZbgAbv
	if( SelectR >= DX_RGBA_SELECT_SRC_R && SelectR <= DX_RGBA_SELECT_SRC_A &&
		SelectG >= DX_RGBA_SELECT_SRC_R && SelectG <= DX_RGBA_SELECT_SRC_A &&
		SelectB >= DX_RGBA_SELECT_SRC_R && SelectB <= DX_RGBA_SELECT_SRC_A &&
		SelectA >= DX_RGBA_SELECT_SRC_R && SelectA <= DX_RGBA_SELECT_SRC_A )
	{
		SrcOnlyFlag = TRUE ;
	}
	else
	if( SelectR >= DX_RGBA_SELECT_BLEND_R && SelectR <= DX_RGBA_SELECT_BLEND_A &&
		SelectG >= DX_RGBA_SELECT_BLEND_R && SelectG <= DX_RGBA_SELECT_BLEND_A &&
		SelectB >= DX_RGBA_SELECT_BLEND_R && SelectB <= DX_RGBA_SELECT_BLEND_A &&
		SelectA >= DX_RGBA_SELECT_BLEND_R && SelectA <= DX_RGBA_SELECT_BLEND_A )
	{
		SelectR -= DX_RGBA_SELECT_BLEND_R ;
		SelectG -= DX_RGBA_SELECT_BLEND_R ;
		SelectB -= DX_RGBA_SELECT_BLEND_R ;
		SelectA -= DX_RGBA_SELECT_BLEND_R ;

		SrcOnlyFlag = TRUE ;
		SrcBlendReverse = TRUE ;

		HandleTemp = Info->BlendGrHandle ;
		Info->BlendGrHandle = Info->SrcGrHandle ;
		Info->SrcGrHandle = HandleTemp ;
	}

	if( SrcOnlyFlag )
	{
		PixelShaderHandle = &GraphFilterShaderHandle.RgbaMixS[ SelectR ][ SelectG ][ SelectB ][ SelectA ] ;
		if( *PixelShaderHandle < 0 )
		{
			if( GD3D9.ShaderCode._2D.RGBAMixS_ShaderPackImage != NULL )
			{
				*PixelShaderHandle = NS_LoadPixelShaderFromMem( GD3D9.ShaderCode._2D.RGBAMixS_ShaderAddress[ SelectR ][ SelectG ][ SelectB ][ SelectA ], GD3D9.ShaderCode._2D.RGBAMixS_ShaderSize[ SelectR ][ SelectG ][ SelectB ][ SelectA ] ) ;
				if( *PixelShaderHandle < 0 )
				{
					DXST_ERRORLOGFMT_ADD(( _T( "RGBAMixS tB^[pVF[_[̍쐬Ɏs܂" ) )) ;
					return -1 ;
				}
				NS_SetDeleteHandleFlag( *PixelShaderHandle, PixelShaderHandle ) ;
			}
		}
	}
	else
	if( SelectR == SelectG && SelectR == SelectB && SelectR != DX_RGBA_SELECT_BLEND_A && SelectR != DX_RGBA_SELECT_SRC_A )
	{
		if( SelectR >= DX_RGBA_SELECT_BLEND_R && SelectR <= DX_RGBA_SELECT_BLEND_A )
		{
			SelectR -= DX_RGBA_SELECT_BLEND_R ;
			SelectG -= DX_RGBA_SELECT_BLEND_R ;
			SelectB -= DX_RGBA_SELECT_BLEND_R ;
			SelectA += DX_RGBA_SELECT_BLEND_R ;

			SrcBlendReverse = TRUE ;

			HandleTemp = Info->BlendGrHandle ;
			Info->BlendGrHandle = Info->SrcGrHandle ;
			Info->SrcGrHandle = HandleTemp ;
		}

		PixelShaderHandle = &GraphFilterShaderHandle.RgbaMixSRRRB[ SelectR ][ SelectA - DX_RGBA_SELECT_BLEND_R ] ;
		if( *PixelShaderHandle < 0 )
		{
			_SPRINTF( FileName, "RGBAMix_S%sS%sS%sB%s.pso", CharTable[ SelectR ], CharTable[ SelectG ], CharTable[ SelectB ], CharTable[ SelectA - DX_RGBA_SELECT_BLEND_R ] ) ;
			*PixelShaderHandle = Direct3D9_MemLoadShaderCode( FileName, false ) ;
			if( *PixelShaderHandle < 0 )
			{
				DXST_ERRORLOGFMT_ADD(( _T( "RGBAMixS tB^[pVF[_[̍쐬Ɏs܂ %s" ), FileName )) ;
				return -1 ;
			}
			NS_SetDeleteHandleFlag( *PixelShaderHandle, PixelShaderHandle ) ;
		}
	}
	else
	if( ( SelectR == DX_RGBA_SELECT_SRC_R   && SelectG == DX_RGBA_SELECT_SRC_G   && SelectB == DX_RGBA_SELECT_SRC_B   ) ||
		( SelectR == DX_RGBA_SELECT_BLEND_R && SelectG == DX_RGBA_SELECT_BLEND_G && SelectB == DX_RGBA_SELECT_BLEND_B ) )
	{
		if( SelectR == DX_RGBA_SELECT_BLEND_R )
		{
			SelectR -= DX_RGBA_SELECT_BLEND_R ;
			SelectG -= DX_RGBA_SELECT_BLEND_R ;
			SelectB -= DX_RGBA_SELECT_BLEND_R ;
			SelectA += DX_RGBA_SELECT_BLEND_R ;

			SrcBlendReverse = TRUE ;

			HandleTemp = Info->BlendGrHandle ;
			Info->BlendGrHandle = Info->SrcGrHandle ;
			Info->SrcGrHandle = HandleTemp ;
		}

		PixelShaderHandle = &GraphFilterShaderHandle.RgbaMixSRGBB[ SelectA - DX_RGBA_SELECT_BLEND_R ] ;
		if( *PixelShaderHandle < 0 )
		{
			_SPRINTF( FileName, "RGBAMix_S%sS%sS%sB%s.pso", CharTable[ SelectR ], CharTable[ SelectG ], CharTable[ SelectB ], CharTable[ SelectA - DX_RGBA_SELECT_BLEND_R ] ) ;
			*PixelShaderHandle = Direct3D9_MemLoadShaderCode( FileName, false ) ;
			if( *PixelShaderHandle < 0 )
			{
				DXST_ERRORLOGFMT_ADD(( _T( "RGBAMixS tB^[pVF[_[̍쐬Ɏs܂ %s" ), FileName )) ;
				return -1 ;
			}
			NS_SetDeleteHandleFlag( *PixelShaderHandle, PixelShaderHandle ) ;
		}
	}
	else
	{
		PixelShaderHandle = &GraphFilterShaderHandle.RgbaMixBasePS ;
		if( *PixelShaderHandle < 0 )
		{
			*PixelShaderHandle = Direct3D9_MemLoadShaderCode( PsoFileName[ 0 ], false ) ;
			if( *PixelShaderHandle < 0 )
			{
				DXST_ERRORLOGFMT_ADD(( _T( "tB^[pVF[_[̍쐬Ɏs܂ %s" ), PsoFileName[ 0 ] )) ;
				return -1 ;
			}
			NS_SetDeleteHandleFlag( *PixelShaderHandle, PixelShaderHandle ) ;
		}
	}

	Direct3D9_GraphFilter_PushShaderParam( &ShaderParamTemp, 2 ) ;

	ParamF4[ 0 ].x = Info->BlendRatio ;
	ParamF4[ 0 ].y = Info->BlendRatio ;
	ParamF4[ 0 ].z = Info->BlendRatio ;
	ParamF4[ 0 ].w = Info->BlendRatio ;
	ParamF4[ 1 ].x = ( float )SelectR + 0.5f ;
	ParamF4[ 1 ].y = ( float )SelectG + 0.5f ;
	ParamF4[ 1 ].z = ( float )SelectB + 0.5f ;
	ParamF4[ 1 ].w = ( float )SelectA + 0.5f ;
	Graphics_D3D9_ShaderConstant_InfoSet_SetParam( &GD3D9.Device.Shader.ShaderConstantInfo, DX_SHADERCONSTANTTYPE_PS_FLOAT, DX_SHADERCONSTANTSET_LIB_SUB, 0, ParamF4, 2, FALSE ) ;

	NS_SetUsePixelShader( *PixelShaderHandle ) ;

	Direct3D9_BasePolygonDraw( Info ) ;

	Direct3D9_GraphFilter_PopShaderParam( &ShaderParamTemp ) ;

	if( SrcBlendReverse )
	{
		HandleTemp = Info->BlendGrHandle ;
		Info->BlendGrHandle = Info->SrcGrHandle ;
		Info->SrcGrHandle = HandleTemp ;
	}

	Graphics_D3D9_ShaderConstant_InfoSet_ResetParam( &GD3D9.Device.Shader.ShaderConstantInfo, DX_SHADERCONSTANTTYPE_PS_FLOAT, DX_SHADERCONSTANTSET_LIB_SUB, 0, 2 ) ;

	// I
	return 0 ;
}

















static int Direct3D9_BasePolygonDraw( GRAPHFILTER_INFO *Info, int ScaleDivNum )
{
	VERTEX2DSHADER Vert[ 4 ] ;
	IMAGEDATA *SrcImage = NULL ;
	IMAGEDATA *BlendImage = NULL ;
	IMAGEDATA *DestImage = NULL ;
	SHADOWMAPDATA *SrcShadowMap = NULL ;
	SHADOWMAPDATA *DestShadowMap = NULL ;
	float SrcX1F, SrcX2F, SrcY1F, SrcY2F ;
	float SrcX1TexF, SrcX2TexF, SrcY1TexF, SrcY2TexF ;
	int SrcWidth, SrcHeight ;
	float DestX1F, DestX2F, DestY1F, DestY2F ;
	float BlendX1TexF, BlendX2TexF, BlendY1TexF, BlendY2TexF ;
	int SrcTexWidth, SrcTexHeight ;

	if( GRAPHCHK(     Info->SrcGrHandle, SrcImage    ) &&
		SHADOWMAPCHK( Info->SrcGrHandle, SrcShadowMap ) )
		return -1 ;

	if( GRAPHCHK(     Info->DestGrHandle, DestImage    ) &&
		SHADOWMAPCHK( Info->DestGrHandle, DestShadowMap ) )
		return -1 ;

	if( DestShadowMap != NULL )
	{
		Graphics_D3D9_DeviceState_SetRenderTarget( DestShadowMap->PF->D3D9.Surface ) ;
	}
	else
	{
		Graphics_D3D9_DeviceState_SetRenderTarget( Graphics_Image_CheckMultiSampleDrawValid( Info->DestGrHandle ) ?
									DestImage->Hard.Draw[ 0 ].Tex->PF->D3D9.RenderTargetSurface :
									DestImage->Hard.Draw[ 0 ].Tex->PF->D3D9.Surface[ 0 ] ) ;
	}

	SrcX1F = ( float )Info->SrcX1 ;
	SrcX2F = ( float )Info->SrcX2 ;
	SrcY1F = ( float )Info->SrcY1 ;
	SrcY2F = ( float )Info->SrcY2 ;
	SrcWidth  = Info->SrcX2 - Info->SrcX1 ;
	SrcHeight = Info->SrcY2 - Info->SrcY1 ;

	if( ScaleDivNum != 1 )
	{
		DestX1F = ( float )  Info->DestX                             - 0.5f ;
		DestX2F = ( float )( Info->DestX + SrcWidth  / ScaleDivNum ) - 0.5f ;
		DestY1F = ( float )  Info->DestY                             - 0.5f ;
		DestY2F = ( float )( Info->DestY + SrcHeight / ScaleDivNum ) - 0.5f ;
	}
	else
	{
		DestX1F = ( float )  Info->DestX               - 0.5f ;
		DestX2F = ( float )( Info->DestX + SrcWidth  ) - 0.5f ;
		DestY1F = ( float )  Info->DestY               - 0.5f ;
		DestY2F = ( float )( Info->DestY + SrcHeight ) - 0.5f ;
	}

	NS_GetGraphTextureSize( Info->SrcGrHandle, &SrcTexWidth, &SrcTexHeight ) ;
	SrcX1TexF = SrcX1F / SrcTexWidth ;
	SrcX2TexF = SrcX2F / SrcTexWidth ;
	SrcY1TexF = SrcY1F / SrcTexHeight ;
	SrcY2TexF = SrcY2F / SrcTexHeight ;

	Vert[ 0 ].pos = VGet( DestX1F, DestY1F, 0.0f ) ;
	Vert[ 1 ].pos = VGet( DestX2F, DestY1F, 0.0f ) ;
	Vert[ 2 ].pos = VGet( DestX1F, DestY2F, 0.0f ) ;
	Vert[ 3 ].pos = VGet( DestX2F, DestY2F, 0.0f ) ;
	Vert[ 0 ].u = SrcX1TexF ; Vert[ 0 ].v = SrcY1TexF ;
	Vert[ 1 ].u = SrcX2TexF ; Vert[ 1 ].v = SrcY1TexF ;
	Vert[ 2 ].u = SrcX1TexF ; Vert[ 2 ].v = SrcY2TexF ;
	Vert[ 3 ].u = SrcX2TexF ; Vert[ 3 ].v = SrcY2TexF ;
	Vert[ 0 ].rhw = 1.0f ;
	Vert[ 1 ].rhw = 1.0f ;
	Vert[ 2 ].rhw = 1.0f ;
	Vert[ 3 ].rhw = 1.0f ;

	if( Info->IsBlend )
	{
		if( GRAPHCHK( Info->BlendGrHandle, BlendImage ) )
			return -1 ;

		if( Info->BlendPosEnable )
		{
			BlendX1TexF = ( float )  Info->BlendX               / BlendImage->Orig->Hard.Tex[ 0 ].TexWidth ;
			BlendX2TexF = ( float )( Info->BlendX + SrcWidth )  / BlendImage->Orig->Hard.Tex[ 0 ].TexWidth ;
			BlendY1TexF = ( float )  Info->BlendY               / BlendImage->Orig->Hard.Tex[ 0 ].TexHeight ;
			BlendY2TexF = ( float )( Info->BlendY + SrcHeight ) / BlendImage->Orig->Hard.Tex[ 0 ].TexHeight ;
		}
		else
		{
			BlendX1TexF = BlendImage->Hard.Draw[ 0 ].Vertex[ 0 ].u ;
			BlendX2TexF = BlendImage->Hard.Draw[ 0 ].Vertex[ 1 ].u ;
			BlendY1TexF = BlendImage->Hard.Draw[ 0 ].Vertex[ 0 ].v ;
			BlendY2TexF = BlendImage->Hard.Draw[ 0 ].Vertex[ 2 ].v ;
		}
		Vert[ 0 ].su = BlendX1TexF ; Vert[ 0 ].sv = BlendY1TexF ;
		Vert[ 1 ].su = BlendX2TexF ; Vert[ 1 ].sv = BlendY1TexF ;
		Vert[ 2 ].su = BlendX1TexF ; Vert[ 2 ].sv = BlendY2TexF ;
		Vert[ 3 ].su = BlendX2TexF ; Vert[ 3 ].sv = BlendY2TexF ;

		NS_SetUseTextureToShader( 1, Info->BlendGrHandle ) ;
	}

	NS_SetUseTextureToShader( 0, Info->SrcGrHandle ) ;

	// `ҋ@Ă`敨`
	DRAWSTOCKINFO

	// `̏
	Graphics_D3D9_BeginScene() ;
	Graphics_D3D9_DrawPreparationToShader( 0, FALSE, TRUE, TRUE ) ;

	// `
	Graphics_D3D9_DeviceState_SetFVF( VERTEXFVF_SHADER_2D ) ;
	Direct3DDevice9_DrawPrimitiveUP( ( D_D3DPRIMITIVETYPE )DX_PRIMTYPE_TRIANGLESTRIP, GETPRIMNUM( DX_PRIMTYPE_TRIANGLESTRIP, 4 ), Vert, sizeof( VERTEX2DSHADER ) ) ;

	if( Graphics_Image_CheckMultiSampleDrawValid( Info->DestGrHandle ) )
	{
		Graphics_D3D9_EndScene() ;
		Graphics_D3D9_UpdateDrawTexture( DestImage->Hard.Draw[ 0 ].Tex, 0 ) ;
	}

	// I
	return 0 ;
}





static int GraphFilterDestGraphSetup( GRAPHFILTER_INFO *Info, int PassNum, int UseWorkScreen, int *UseSrcGrHandle, int *UseDestGrHandle )
{
	SHADOWMAPDATA *SrcShadowMap = NULL ;
	SHADOWMAPDATA *DestShadowMap = NULL ;
	IMAGEDATA *SrcImage = NULL ;
	IMAGEDATA *DestImage = NULL ;
	IMAGEDATA *TempSrcImage = NULL ;
	int TexSizeW ;
	int TexSizeH ;
	int SrcTexFloatType ;
	int DestTexFloatType ;
	int SrcEqDestOrDestNonDrawValidHandle ;
	int AlwaysUseDestWorkHandle ;
	int UseDestWorkHandleIndex ;
	int UseSrcWorkHandleIndex ;
	int SrcGraphDivFlag ;

	if( !GRAPHCHK( Info->SrcGrHandle, SrcImage ) )
	{
		SrcTexFloatType = SrcImage->Orig->FormatDesc.FloatTypeFlag ;
	}
	else
	if( !SHADOWMAPCHK( Info->SrcGrHandle, SrcShadowMap ) )
	{
		SrcTexFloatType = SrcShadowMap->TexFormat_Float ;
	}
	else
	{
		return -1 ;
	}

	if( !GRAPHCHK( Info->DestGrHandle, DestImage ) )
	{
		DestTexFloatType = DestImage->Orig->FormatDesc.FloatTypeFlag ;
	}
	else
	if( !SHADOWMAPCHK( Info->DestGrHandle, DestShadowMap ) )
	{
		DestTexFloatType = DestShadowMap->TexFormat_Float ;
	}
	else
	{
		return -1 ;
	}

	UseSrcWorkHandleIndex = 0 ;

	// VF[_[gȂꍇ͍Ɨp摜͎gpȂ
	if( GSYS.HardInfo.UseShader == FALSE )
	{
		*UseDestGrHandle = Info->DestGrHandle ;
	}
	else
	{
		if( SrcShadowMap == NULL &&
			( ( UseWorkScreen == 1 && Info->SrcGrHandle == Info->DestGrHandle ) ||
			  DestImage->Orig->FormatDesc.DrawValidFlag == FALSE ) )
		{
			SrcEqDestOrDestNonDrawValidHandle = TRUE ;
		}
		else
		{
			SrcEqDestOrDestNonDrawValidHandle = FALSE ;
		}

		if( UseWorkScreen == 1 &&
			( ( Info->Pass % 2 == 0 && PassNum % 2 == 0 ) ||
			  ( Info->Pass % 2 == 1 && PassNum % 2 == 1 ) ) )
		{
			AlwaysUseDestWorkHandle = TRUE ;
		}
		else
		{
			AlwaysUseDestWorkHandle = FALSE ;
		}

		if(
			SrcShadowMap == NULL &&
			Info->Pass == 0 &&
			(
			  SrcImage->Hard.DrawNum != 1 ||
			  SrcImage->Hard.Draw[ 0 ].UsePosX != 0 ||
			  SrcImage->Hard.Draw[ 0 ].UsePosY != 0
			)
		  )
		{
			SrcGraphDivFlag = TRUE ;
		}
		else
		{
			SrcGraphDivFlag = FALSE ;
		}

		if( SrcEqDestOrDestNonDrawValidHandle || AlwaysUseDestWorkHandle )
		{
			if( AlwaysUseDestWorkHandle == FALSE && SrcEqDestOrDestNonDrawValidHandle == TRUE )
			{
				UseDestWorkHandleIndex = 1 ;
				UseSrcWorkHandleIndex = 0 ;
			}
			else
			{
				UseDestWorkHandleIndex = 0 ;
				UseSrcWorkHandleIndex = 1 ;
			}

			if( SrcGraphDivFlag )
			{
				TexSizeW = SrcImage->Width ;
				TexSizeH = SrcImage->Height ;
			}
			else
			{
				NS_GetGraphTextureSize( Info->SrcGrHandle, &TexSizeW, &TexSizeH ) ;
			}

			*UseDestGrHandle = Direct3D9_GraphFilter_GetWorkTexture( DestTexFloatType, ( DWORD )TexSizeW, ( DWORD )TexSizeH, ( DWORD )UseDestWorkHandleIndex ) ;
			if( *UseDestGrHandle < 0 )
				return -1 ;
		}
		else
		{
			*UseDestGrHandle = Info->DestGrHandle ;
		}

		if( SrcGraphDivFlag )
		{
			VERTEX_2D Vert[ 4 ] ;
			IMAGEDATA_HARD_VERT *TexVect ;
			int i ;

			TexSizeW = SrcImage->Width ;
			TexSizeH = SrcImage->Height ;

			*UseSrcGrHandle = Direct3D9_GraphFilter_GetWorkTexture( SrcTexFloatType, ( DWORD )TexSizeW, ( DWORD )TexSizeH, ( DWORD )UseSrcWorkHandleIndex ) ;
			if( *UseSrcGrHandle < 0 )
				return -1 ;

			GRAPHCHK( *UseSrcGrHandle, TempSrcImage ) ;
			Graphics_D3D9_DeviceState_SetRenderTarget( TempSrcImage->Hard.Draw[ 0 ].Tex->PF->D3D9.Surface[ 0 ] ) ;

			Vert[ 0 ].rhw = 1.0f ;
			Vert[ 1 ].rhw = 1.0f ;
			Vert[ 2 ].rhw = 1.0f ;
			Vert[ 3 ].rhw = 1.0f ;
			Vert[ 0 ].color = 0xffffffff ;
			Vert[ 1 ].color = 0xffffffff ;
			Vert[ 2 ].color = 0xffffffff ;
			Vert[ 3 ].color = 0xffffffff ;
			for( i = 0 ; i < SrcImage->Hard.DrawNum ; i ++ )
			{
				TexVect = SrcImage->Hard.Draw[ i ].Vertex ;

				Vert[ 0 ].pos.x = TexVect[ 0 ].x - 0.5f ;
				Vert[ 0 ].pos.y = TexVect[ 0 ].y - 0.5f ;
				Vert[ 0 ].pos.z = 0.0f ;
				Vert[ 0 ].u = TexVect[ 0 ].u ;
				Vert[ 0 ].v = TexVect[ 0 ].v ;
				Vert[ 1 ].pos.x = TexVect[ 1 ].x - 0.5f ;
				Vert[ 1 ].pos.y = TexVect[ 1 ].y - 0.5f ;
				Vert[ 1 ].pos.z = 0.0f ;
				Vert[ 1 ].u = TexVect[ 1 ].u ;
				Vert[ 1 ].v = TexVect[ 1 ].v ;
				Vert[ 2 ].pos.x = TexVect[ 2 ].x - 0.5f ;
				Vert[ 2 ].pos.y = TexVect[ 2 ].y - 0.5f ;
				Vert[ 2 ].u = TexVect[ 2 ].u ;
				Vert[ 2 ].v = TexVect[ 2 ].v ;
				Vert[ 2 ].pos.z = 0.0f ;
				Vert[ 3 ].pos.x = TexVect[ 3 ].x - 0.5f ;
				Vert[ 3 ].pos.y = TexVect[ 3 ].y - 0.5f ;
				Vert[ 3 ].pos.z = 0.0f ;
				Vert[ 3 ].u = TexVect[ 3 ].u ;
				Vert[ 3 ].v = TexVect[ 3 ].v ;
				Graphics_D3D9_DrawPrimitive2D( Vert, 4, DX_PRIMTYPE_TRIANGLESTRIP, SrcImage, TRUE, FALSE, FALSE, FALSE, i ) ;
			}
		}
	}

	return 0 ;
}

static int GraphFilterDestGraphUpdate( GRAPHFILTER_INFO *Info, int UseWorkScreen, int UseDestGrHandle, int FilterResult )
{
	if( FilterResult >= 0 )
	{
		if( GSYS.HardInfo.UseShader == TRUE )
		{
			if( ( UseWorkScreen == 1 && Info->SrcGrHandle == Info->DestGrHandle ) ||
				UseDestGrHandle != Info->DestGrHandle )
			{
				Graphics_Image_GetDrawScreenGraphBase( UseDestGrHandle, 0, Info->DestX, Info->DestY, Info->DestX + Info->SrcX2 - Info->SrcX1, Info->DestY + Info->SrcY2 - Info->SrcY1, Info->DestX, Info->DestY, Info->DestGrHandle ) ;
			}
		}
	}

	return 0 ;
}















// 摜̃tB^[t]s( ψt )
extern int GraphFilter_D3D9_RectBltBase_PF( int IsBlend, int SrcGrHandle, int BlendGrHandle, int DestGrHandle, int BlendRatio, int FilterOrBlendType, int SrcX1, int SrcY1, int SrcX2, int SrcY2, int BlendX, int BlendY, int BlendPosEnable, int DestX, int DestY, va_list ParamList )
{
	GRAPHFILTER_DRAWPARAMTEMP_DIRECT3D9 DrawParamTemp ;
	SHADOWMAPDATA *                     SrcShadowMap       = NULL ;
	SHADOWMAPDATA *                     DestShadowMap      = NULL ;
	IMAGEDATA *                         SrcImage           = NULL ;
	IMAGEDATA *                         DestImage          = NULL ;
	IMAGEDATA *                         BlendImage         = NULL ;
	IMAGEDATA *                         TargetScreenImage  = NULL ;
	int                                 UseDestGrHandle    = -1 ;
	int                                 UseSrcGrHandle ;
	int                                 SrcImageWidth ;
	int                                 SrcImageHeight ;
	int                                 DestImageWidth ;
	int                                 DestImageHeight ;
	int                                 Width ;
	int                                 Height ;
	int                                 FilterResult       = -1 ;
	int                                 Pass ;
	int                                 PassNum            = -1 ;
	int                                 UseWorkScreen ;
	GRAPHFILTER_INFO                    Info ;
	float                               BlendRatioF ;
	int                                 Down_Scale_DivNum  = 0 ;

	// G[
	if( !GRAPHCHK( SrcGrHandle, SrcImage ) )
	{
		SrcImageWidth = SrcImage->Width ;
		SrcImageHeight = SrcImage->Height ;
	}
	else
	if( !SHADOWMAPCHK( SrcGrHandle, SrcShadowMap ) )
	{
		SrcImageWidth = SrcShadowMap->BaseSizeX ;
		SrcImageHeight = SrcShadowMap->BaseSizeY ;
	}
	else
	{
		return -1 ;
	}

	if( !GRAPHCHK(     DestGrHandle, DestImage    ) )
	{
		DestImageWidth = DestImage->Width ;
		DestImageHeight = DestImage->Height ;
	}
	else
	if( !SHADOWMAPCHK( DestGrHandle, DestShadowMap ) )
	{
		DestImageWidth = DestShadowMap->BaseSizeX ;
		DestImageHeight = DestShadowMap->BaseSizeY ;
	}
	else
	{
		return -1 ;
	}

	if( Graphics_Image_CheckMultiSampleDrawValid( GSYS.DrawSetting.TargetScreen[ 0 ] ) )
	{
		GRAPHCHK( GSYS.DrawSetting.TargetScreen[ 0 ], TargetScreenImage ) ;
	}

	if( SrcX2 <= SrcX1 ||
		SrcY2 <= SrcY1 ) return -1 ;

	if( IsBlend )
	{
		if( GRAPHCHK( BlendGrHandle, BlendImage ) )
			return -1 ;

		if( FilterOrBlendType < 0 || FilterOrBlendType >= DX_GRAPH_BLEND_NUM )
			return -1;
	}
	else
	{
		if( FilterOrBlendType < 0 || FilterOrBlendType >= DX_GRAPH_FILTER_NUM )
			return -1;
	}

	// l̕␳
	if( BlendRatio < 0 )
	{
		BlendRatio = 0 ;
	}
	else
	if( BlendRatio > 255 )
	{
		BlendRatio = 255 ;
	}
	BlendRatioF = BlendRatio / 255.0f ;

	// W̕␳
	if( SrcX1 < 0 )
	{
		DestX += -SrcX1 ;
		BlendX += -SrcX1 ;
		SrcX1 = 0 ;
	}
	if( SrcY1 < 0 )
	{
		DestY += -SrcY1 ;
		BlendY += -SrcY1 ;
		SrcY1 = 0 ;
	}
	if( DestX < 0 )
	{
		SrcX1 += -DestX ;
		BlendX += -DestX ;
		DestX = 0 ;
	}
	if( DestY < 0 )
	{
		SrcY1 += -DestY ;
		BlendY += -DestY ;
		DestY = 0 ;
	}
	if( SrcX2 <= SrcX1 ||
		SrcY2 <= SrcY1 ) return 0 ;
	if( SrcX2 > SrcImageWidth )
	{
		SrcX2 = SrcImageWidth ;
	}
	if( SrcY2 > SrcImageHeight )
	{
		SrcY2 = SrcImageHeight ;
	}
	if( SrcX1 >= SrcImageWidth ||
		SrcY1 >= SrcImageHeight ||
		SrcX2 <= 0 ||
		SrcY2 <= 0 ||
		DestX >= DestImageWidth ||
		DestY >= DestImageHeight )
		return 0 ;

	Width = SrcX2 - SrcX1 ;
	Height = SrcY2 - SrcY1 ;
	if( Width <= 0 ||
		Height <= 0 )
		return 0 ;

	if( IsBlend == FALSE && FilterOrBlendType == DX_GRAPH_FILTER_DOWN_SCALE )
	{
		Down_Scale_DivNum = va_arg( ParamList, int ) ;

		if( DestX + Width / Down_Scale_DivNum > DestImageWidth )
		{
			Width = ( DestImageWidth - DestX ) * Down_Scale_DivNum ;
			SrcX2 = SrcX1 + Width ;
		}
		if( DestY + Height / Down_Scale_DivNum > DestImageHeight )
		{
			Height = ( DestImageHeight - DestY ) * Down_Scale_DivNum ;
			SrcY2 = SrcY1 + Height ;
		}
	}
	else
	{
		if( DestX + Width > DestImageWidth )
		{
			Width = DestImageWidth - DestX ;
			SrcX2 = SrcX1 + Width ;
		}
		if( DestY + Height > DestImageHeight )
		{
			Height = DestImageHeight - DestY ;
			SrcY2 = SrcY1 + Height ;
		}
	}
	if( Width <= 0 ||
		Height <= 0 )
		return 0 ;
	
	// `悪_O^[Qbgp̃T[tFXgpĂāA`̉摜uhŎgꍇ͂ŃT[tFXAbvf[g
	if( TargetScreenImage != NULL &&
		( GSYS.DrawSetting.TargetScreen[ 0 ] == SrcGrHandle ||
		  GSYS.DrawSetting.TargetScreen[ 0 ] == DestGrHandle ||
		  ( IsBlend && GSYS.DrawSetting.TargetScreen[ 0 ] == BlendGrHandle ) ) )
	{
		Graphics_D3D9_EndScene() ;
		Graphics_D3D9_UpdateDrawTexture( &TargetScreenImage->Orig->Hard.Tex[ 0 ], GSYS.DrawSetting.TargetScreenSurface[ 0 ] ) ;
	}

	// ̃Zbg
	Info.IsBlend = IsBlend ;
	Info.FilterOrBlendType = FilterOrBlendType ;
	Info.BlendGrHandle = BlendGrHandle ;
	Info.BlendRatio = BlendRatioF ;
	Info.SrcX1 = SrcX1 ;
	Info.SrcY1 = SrcY1 ;
	Info.SrcX2 = SrcX2 ;
	Info.SrcY2 = SrcY2 ;
	Info.BlendX = BlendX ;
	Info.BlendY = BlendY ;
	Info.BlendPosEnable = BlendPosEnable ;
	Info.DestX = DestX ;
	Info.DestY = DestY ;

	// tB^[̈擾
	int			Gauss_PixelWidth = 0 ;
	float		Gauss_Param = 0.0f ;
	int			Bright_Clip_CmpType = 0 ;
	float		Bright_Clip_CmpParam = 0.0f ;
	int			Bright_Clip_ClipFillFlag = 0 ;
	COLOR_F		Bright_Clip_ClipFillColor = { 0.0f } ;
	int			Hsb_HueType = 0 ;
	float		Hsb_Hue = 0.0f ;
	float		Hsb_Saturation = 0.0f ;
	float		Hsb_Bright = 0.0f ;
	float		Mono_Cb = 0.0f ;
	float		Mono_Cr = 0.0f ;
	float		Lv_Min = 0.0f ;
	float		Lv_Max = 0.0f ;
	float		Lv_Gamma = 0.0f ;
	float		Lv_AfterMin = 0.0f ;
	float		Lv_AfterMax = 0.0f ;
	float		TC_Threshold = 0.0f ;
	COLOR_F		TC_LowColor = { 0.0f } ;
	COLOR_F		TC_HighColor = { 0.0f } ;
	int			GM_MapGrHandle = 0 ;
	int			GM_Reverse = 0 ;

	int			TempR = 0, TempG = 0, TempB = 0, TempA = 0 ;

	int			RGBA_R = 0 ;
	int			RGBA_G = 0 ;
	int			RGBA_B = 0 ;
	int			RGBA_A = 0 ;
	if( IsBlend )
	{
		switch( FilterOrBlendType )
		{
		case DX_GRAPH_BLEND_RGBA_SELECT_MIX :
			RGBA_R = va_arg( ParamList, int ) ;
			RGBA_G = va_arg( ParamList, int ) ;
			RGBA_B = va_arg( ParamList, int ) ;
			RGBA_A = va_arg( ParamList, int ) ;
			break ;
		}

		// pX̐擾
		if( PassNum == -1 )
		{
			PassNum = GraphBlendPassNum_Table[ FilterOrBlendType ] ;
		}

		// ƗpeNX`gp邩ǂ擾
		UseWorkScreen = GraphBlendUseWorkScreen_Table[ FilterOrBlendType ] ;
	}
	else
	{
		switch( FilterOrBlendType )
		{
		case DX_GRAPH_FILTER_MONO :
			Mono_Cb = ( float )va_arg( ParamList, int ) * 100.0f / 255.0f ;
			Mono_Cr = ( float )va_arg( ParamList, int ) * 100.0f / 255.0f ;
			break ;

		case DX_GRAPH_FILTER_GAUSS :
			Gauss_PixelWidth = va_arg( ParamList, int ) ;
			Gauss_Param = ( float )va_arg( ParamList, int ) / 100.0f ;
			break ;

		case DX_GRAPH_FILTER_DOWN_SCALE :
//			Down_Scale_DivNum = va_arg( ParamList, int ) ;
			break ;

		case DX_GRAPH_FILTER_BRIGHT_CLIP :
			Bright_Clip_CmpType = va_arg( ParamList, int ) ;
			Bright_Clip_CmpParam = ( float )va_arg( ParamList, int ) ;
			Bright_Clip_ClipFillFlag = va_arg( ParamList, int ) ;
			if( Bright_Clip_ClipFillFlag )
			{
				NS_GetColor2( va_arg( ParamList, int ), &TempR, &TempG, &TempB ) ;
				TempA = va_arg( ParamList, int ) ;
				Bright_Clip_ClipFillColor = NS_GetColorF( TempR / 255.0f, TempG / 255.0f, TempB / 255.0f, TempA / 255.0f ) ;
			}
			break ;

		case DX_GRAPH_FILTER_HSB :
			Hsb_HueType = va_arg( ParamList, int ) ;
			Hsb_Hue = ( float )va_arg( ParamList, int ) ;
			Hsb_Saturation = ( float )va_arg( ParamList, int ) * 100.0f / 255.0f ;
			Hsb_Bright  = ( float )va_arg( ParamList, int ) * 100.0f / 255.0f ;

			if( Hsb_HueType == 1 )
			{
				PassNum = 1 ;
			}
			break ;

		case DX_GRAPH_FILTER_LEVEL :
			Lv_Min = ( float )va_arg( ParamList, int ) ;
			Lv_Max = ( float )va_arg( ParamList, int ) ;
			Lv_Gamma = ( float )va_arg( ParamList, int ) / 100.0f ;
			Lv_AfterMin = ( float )va_arg( ParamList, int ) ;
			Lv_AfterMax = ( float )va_arg( ParamList, int ) ;
			break ;

		case DX_GRAPH_FILTER_TWO_COLOR :
			TC_Threshold = ( float )va_arg( ParamList, int ) ;

			NS_GetColor2( va_arg( ParamList, int ), &TempR, &TempG, &TempB ) ;
			TempA = va_arg( ParamList, int ) ;
			TC_LowColor = NS_GetColorF( TempR / 255.0f, TempG / 255.0f, TempB / 255.0f, TempA / 255.0f ) ;

			NS_GetColor2( va_arg( ParamList, int ), &TempR, &TempG, &TempB ) ;
			TempA = va_arg( ParamList, int ) ;
			TC_HighColor = NS_GetColorF( TempR / 255.0f, TempG / 255.0f, TempB / 255.0f, TempA / 255.0f ) ;
			break ;

		case DX_GRAPH_FILTER_GRADIENT_MAP :
			GM_MapGrHandle = va_arg( ParamList, int ) ;
			GM_Reverse = va_arg( ParamList, int ) ;

			if( TargetScreenImage != NULL && GM_MapGrHandle == GSYS.DrawSetting.TargetScreen[ 0 ] )
			{
				Graphics_D3D9_EndScene() ;
				Graphics_D3D9_UpdateDrawTexture( &TargetScreenImage->Orig->Hard.Tex[ 0 ], GSYS.DrawSetting.TargetScreenSurface[ 0 ] ) ;
			}
			break ;

		case DX_GRAPH_FILTER_PREMUL_ALPHA :
			break ;

		case DX_GRAPH_FILTER_INTERP_ALPHA :
			break ;
		}

		// pX̐擾
		if( PassNum == -1 )
		{
			PassNum = GraphFilterPassNum_Table[ FilterOrBlendType ] ;
		}

		// ƗpeNX`gp邩ǂ擾
		UseWorkScreen = GraphFilterUseWorkScreen_Table[ FilterOrBlendType ] ;
	}
	if( SrcX1 != DestX || SrcY1 != DestY || GD3D9.Device.Caps.ValidRenderTargetInputTexture == FALSE )
	{
		UseWorkScreen = 1 ;
	}

	// VF[_[gȂꍇ͕KPpXŏI
	if( GSYS.HardInfo.UseShader == FALSE )
	{
		PassNum = 1 ;
	}

	if( GD3D9.Device.DrawInfo.BeginSceneFlag == FALSE ) Graphics_D3D9_BeginScene() ;

	// p[^̕ۑ
	Direct3D9_GraphFilter_PushBaseDrawParam( &DrawParamTemp ) ;

	// [v̊Jn
	UseSrcGrHandle = SrcGrHandle ;
	for( Pass = 0 ; Pass < PassNum ; Pass ++ )
	{
		Info.Pass = Pass ;

		// o͐̃ZbgAbv
		Info.SrcGrHandle = SrcGrHandle ;
		Info.DestGrHandle = DestGrHandle ;
		if( GraphFilterDestGraphSetup( &Info, PassNum, UseWorkScreen, &UseSrcGrHandle, &UseDestGrHandle ) < 0 )
			break ;

		DestImage = NULL ;
		DestShadowMap = NULL ;
		if( GRAPHCHK(     UseDestGrHandle, DestImage ) &&
			SHADOWMAPCHK( UseDestGrHandle, DestShadowMap  ) )
			break ;

		// ̃Zbg
		Info.SrcGrHandle = UseSrcGrHandle ;
		Info.DestGrHandle = UseDestGrHandle ;

		if( IsBlend )
		{
			// uh^Cvɂď𕪊
			switch( FilterOrBlendType )
			{
			case DX_GRAPH_BLEND_RGBA_SELECT_MIX :
				FilterResult = GraphBlend_RGBA_Select_Mix( &Info, RGBA_R, RGBA_G, RGBA_B, RGBA_A ) ; 
				break ;

			case DX_GRAPH_BLEND_NORMAL :
			case DX_GRAPH_BLEND_MULTIPLE :
			case DX_GRAPH_BLEND_DIFFERENCE :
			case DX_GRAPH_BLEND_ADD :
			case DX_GRAPH_BLEND_SCREEN :
			case DX_GRAPH_BLEND_OVERLAY :
			case DX_GRAPH_BLEND_DODGE :
			case DX_GRAPH_BLEND_BURN :
			case DX_GRAPH_BLEND_DARKEN :
			case DX_GRAPH_BLEND_LIGHTEN :
			case DX_GRAPH_BLEND_SOFTLIGHT :
			case DX_GRAPH_BLEND_HARDLIGHT :
			case DX_GRAPH_BLEND_EXCLUSION :
			case DX_GRAPH_BLEND_NORMAL_ALPHACH :
			case DX_GRAPH_BLEND_ADD_ALPHACH :
			case DX_GRAPH_BLEND_MULTIPLE_A_ONLY :
			case DX_GRAPH_BLEND_PMA_MULTIPLE_A_ONLY :
				FilterResult = GraphBlend_Basic( &Info ) ;
				break ;
			}
		}
		else
		{
			// tB^[ɂď𕪊
			switch( FilterOrBlendType )
			{
			case DX_GRAPH_FILTER_MONO :
				FilterResult = GraphFilter_Mono( &Info, Mono_Cb, Mono_Cr ) ;
				break ;

			case DX_GRAPH_FILTER_GAUSS :
				FilterResult = GraphFilter_Gauss( &Info, Gauss_PixelWidth, Gauss_Param ) ; 
				break ;

			case DX_GRAPH_FILTER_DOWN_SCALE :
				FilterResult = GraphFilter_Down_Scale( &Info, Down_Scale_DivNum ) ;
				break ;

			case DX_GRAPH_FILTER_BRIGHT_CLIP :
				FilterResult = GraphFilter_Bright_Clip( &Info, Bright_Clip_CmpType, Bright_Clip_CmpParam, Bright_Clip_ClipFillFlag, &Bright_Clip_ClipFillColor ) ;
				break ;

			case DX_GRAPH_FILTER_HSB :
				FilterResult = GraphFilter_HSB( &Info, Hsb_HueType, Hsb_Hue, Hsb_Saturation, Hsb_Bright ) ;
				break ;

			case DX_GRAPH_FILTER_INVERT :
				FilterResult = GraphFilter_Invert( &Info ) ;
				break ;

			case DX_GRAPH_FILTER_LEVEL :
				FilterResult = GraphFilter_Level( &Info, Lv_Min, Lv_Max, Lv_Gamma, Lv_AfterMin, Lv_AfterMax ) ;
				break ;

			case DX_GRAPH_FILTER_TWO_COLOR :
				FilterResult = GraphFilter_TwoColor( &Info, TC_Threshold, &TC_LowColor, &TC_HighColor ) ;
				break ;

			case DX_GRAPH_FILTER_GRADIENT_MAP :
				FilterResult = GraphFilter_GradientMap( &Info, GM_MapGrHandle, GM_Reverse ) ;
				break ;

			case DX_GRAPH_FILTER_PREMUL_ALPHA :
				FilterResult = GraphFilter_PremulAlpha( &Info ) ;
				break ;

			case DX_GRAPH_FILTER_INTERP_ALPHA :
				FilterResult = GraphFilter_InterpAlpha( &Info ) ;
				break ;
			}
		}

		// o͌̕ύX
		UseSrcGrHandle = UseDestGrHandle ;
	}

	// p[^̕A
	Direct3D9_GraphFilter_PopBaseDrawParam( &DrawParamTemp ) ;

	// o͐̍XV
	Info.SrcGrHandle = SrcGrHandle ;
	Info.DestGrHandle = DestGrHandle ;
	GraphFilterDestGraphUpdate( &Info, UseWorkScreen, UseDestGrHandle, FilterResult ) ;

	// I
	return Pass == PassNum ? 0 : -1 ;
}





#ifdef DX_USE_NAMESPACE

}

#endif // DX_USE_NAMESPACE

#endif // DX_NON_FILTER


