//-----------------------------------------------------------------------------
// 
// 		cwCu		`揈vO( Direct3D11 )
// 
//  	Ver 3.13b
// 
//-----------------------------------------------------------------------------

// cwCu쐬p`
#define __DX_MAKE

#include "../DxCompileConfig.h"

#ifndef DX_NON_DIRECT3D11

// CN[h ---------------------------------------------------------------
#include "DxGraphicsD3D11.h"
#include "DxGraphicsWin.h"
#include "DxMaskD3D11.h"
#include "DxWindow.h"
#include "DxWinAPI.h"
#include "../DxSystem.h"
#include "../DxLog.h"
#include "../DxModel.h"
#include "../DxMovie.h"
#include "../DxMask.h"
#include "../DxBaseFunc.h"
#include "../DxGraphics.h"
#include "../DxInput.h"
#include "../DxASyncLoad.h"

#ifdef DX_USE_NAMESPACE

namespace DxLib
{

#endif // DX_USE_NAMESPACE

// }N` -----------------------------------------------------------------

// \̐錾 -----------------------------------------------------------------

// W`p̕GȏsȂ_VF[_[̏
typedef struct tagGRAPHICS_HARDWEARE_DIRECT3D11_BASE_SIMPLE_VERTEXSHADER_INFO
{
	const char *				ShaderFileName ;						// gp钸_VF[_[t@C
	int							VertexDataSize ;						// _f[^̃oCg
	D_D3D11_INPUT_ELEMENT_DESC	InputElementDesc[ 11 ] ;				// ͒_f[^`
} GRAPHICS_HARDWEARE_DIRECT3D11_BASE_SIMPLE_VERTEXSHADER_INFO ;

// f[^` -----------------------------------------------------------------

// W`p̕GȏsȂ_VF[_[̏
static GRAPHICS_HARDWEARE_DIRECT3D11_BASE_SIMPLE_VERTEXSHADER_INFO g_BaseSimpleVertexShaderInfo[ VERTEXFVF_LAYOUT_NUM ] =
{
	// VERTEXFVF_LAYOUT_2D( VERTEX2D or VERTEX_2D )
	{
		"Base_VERTEX2D.vso",
		sizeof( VERTEX2D ),
		{
			{ "POSITION",     0, D_DXGI_FORMAT_R32G32B32_FLOAT,    0, 0,  D_D3D11_INPUT_PER_VERTEX_DATA, 0 },
			{ "COLOR",        0, D_DXGI_FORMAT_R8G8B8A8_UNORM,     0, 16, D_D3D11_INPUT_PER_VERTEX_DATA, 0 },
			{ "TEXCOORD",     0, D_DXGI_FORMAT_R32G32_FLOAT,       0, 20, D_D3D11_INPUT_PER_VERTEX_DATA, 0 },
			{ NULL },
		},
	},

	// VERTEXFVF_LAYOUT_NOTEX_2D( VERTEX_NOTEX_2D )
	{
		"Base_VERTEX_NOTEX_2D.vso",
		sizeof( VERTEX_NOTEX_2D ),
		{
			{ "POSITION",     0, D_DXGI_FORMAT_R32G32B32_FLOAT,    0, 0,  D_D3D11_INPUT_PER_VERTEX_DATA, 0 },
			{ "COLOR",        0, D_DXGI_FORMAT_R8G8B8A8_UNORM,     0, 16, D_D3D11_INPUT_PER_VERTEX_DATA, 0 },
			{ NULL },
		},
	},

	// VERTEXFVF_LAYOUT_BLENDTEX_2D( VERTEX_BLENDTEX_2D or VERTEX2DSHADER )
	{
		"Base_VERTEX_BLENDTEX_2D.vso",		
		sizeof( VERTEX_BLENDTEX_2D ),
		{
			{ "POSITION",     0, D_DXGI_FORMAT_R32G32B32_FLOAT,    0, 0,  D_D3D11_INPUT_PER_VERTEX_DATA, 0 },
			{ "COLOR",        0, D_DXGI_FORMAT_R8G8B8A8_UNORM,     0, 16, D_D3D11_INPUT_PER_VERTEX_DATA, 0 },
			{ "COLOR",        1, D_DXGI_FORMAT_R8G8B8A8_UNORM,     0, 20, D_D3D11_INPUT_PER_VERTEX_DATA, 0 },
			{ "TEXCOORD",     0, D_DXGI_FORMAT_R32G32_FLOAT,       0, 24, D_D3D11_INPUT_PER_VERTEX_DATA, 0 },
			{ "TEXCOORD",     1, D_DXGI_FORMAT_R32G32_FLOAT,       0, 32, D_D3D11_INPUT_PER_VERTEX_DATA, 0 },
			{ NULL },
		},
	},

	// VERTEXFVF_LAYOUT_NOTEX_3D( VERTEX_NOTEX_3D )
	{
		"Base_VERTEX_NOTEX_3D.vso",
		sizeof( VERTEX_NOTEX_3D ),
		{
			{ "POSITION",     0, D_DXGI_FORMAT_R32G32B32_FLOAT,    0, 0,  D_D3D11_INPUT_PER_VERTEX_DATA, 0 },
			{ "COLOR",        0, D_DXGI_FORMAT_R8G8B8A8_UNORM,     0, 12, D_D3D11_INPUT_PER_VERTEX_DATA, 0 },
			{ NULL },
		},
	},

	// VERTEXFVF_LAYOUT_3D( VERTEX_3D )
	{
		"Base_VERTEX_3D.vso",
		sizeof( VERTEX_3D ),
		{
			{ "POSITION",     0, D_DXGI_FORMAT_R32G32B32_FLOAT,    0, 0,  D_D3D11_INPUT_PER_VERTEX_DATA, 0 },
			{ "COLOR",        0, D_DXGI_FORMAT_R8G8B8A8_UNORM,     0, 12, D_D3D11_INPUT_PER_VERTEX_DATA, 0 },
			{ "TEXCOORD",     0, D_DXGI_FORMAT_R32G32_FLOAT,       0, 16, D_D3D11_INPUT_PER_VERTEX_DATA, 0 },
			{ NULL },
		},
	},

	// VERTEXFVF_LAYOUT_3D_LIGHT( VERTEX3D )
	{
		"Base_VERTEX3D.vso",
		sizeof( VERTEX3D ),
		{
			{ "POSITION",     0, D_DXGI_FORMAT_R32G32B32_FLOAT,    0, 0,  D_D3D11_INPUT_PER_VERTEX_DATA, 0 },
			{ "NORMAL",       0, D_DXGI_FORMAT_R32G32B32_FLOAT,    0, 12, D_D3D11_INPUT_PER_VERTEX_DATA, 0 },
			{ "COLOR",        0, D_DXGI_FORMAT_R8G8B8A8_UNORM,     0, 24, D_D3D11_INPUT_PER_VERTEX_DATA, 0 },
			{ "COLOR",        1, D_DXGI_FORMAT_R8G8B8A8_UNORM,     0, 28, D_D3D11_INPUT_PER_VERTEX_DATA, 0 },
			{ "TEXCOORD",     0, D_DXGI_FORMAT_R32G32_FLOAT,       0, 32, D_D3D11_INPUT_PER_VERTEX_DATA, 0 },
			{ "TEXCOORD",     1, D_DXGI_FORMAT_R32G32_FLOAT,       0, 40, D_D3D11_INPUT_PER_VERTEX_DATA, 0 },
			{ NULL },
		},
	},

	// VERTEXFVF_LAYOUT_SHADER_3D( VERTEX3DSHADER )
	{
		"Base_VERTEX3DSHADER.vso",
		sizeof( VERTEX3DSHADER ),
		{
			{ "POSITION",     0, D_DXGI_FORMAT_R32G32B32_FLOAT,    0, 0,  D_D3D11_INPUT_PER_VERTEX_DATA, 0 },
			{ "POSITION",     1, D_DXGI_FORMAT_R32G32B32A32_FLOAT, 0, 12, D_D3D11_INPUT_PER_VERTEX_DATA, 0 },
			{ "NORMAL",       0, D_DXGI_FORMAT_R32G32B32_FLOAT,    0, 28, D_D3D11_INPUT_PER_VERTEX_DATA, 0 },
			{ "TANGENT",      0, D_DXGI_FORMAT_R32G32B32_FLOAT,    0, 40, D_D3D11_INPUT_PER_VERTEX_DATA, 0 },
			{ "BINORMAL",     0, D_DXGI_FORMAT_R32G32B32_FLOAT,    0, 52, D_D3D11_INPUT_PER_VERTEX_DATA, 0 },
			{ "COLOR",        0, D_DXGI_FORMAT_R8G8B8A8_UNORM,     0, 64, D_D3D11_INPUT_PER_VERTEX_DATA, 0 },
			{ "COLOR",        1, D_DXGI_FORMAT_R8G8B8A8_UNORM,     0, 68, D_D3D11_INPUT_PER_VERTEX_DATA, 0 },
			{ "TEXCOORD",     0, D_DXGI_FORMAT_R32G32_FLOAT,       0, 72, D_D3D11_INPUT_PER_VERTEX_DATA, 0 },
			{ "TEXCOORD",     1, D_DXGI_FORMAT_R32G32_FLOAT,       0, 80, D_D3D11_INPUT_PER_VERTEX_DATA, 0 },
			{ "TEXCOORD",     2, D_DXGI_FORMAT_R32G32_FLOAT,       0, 88, D_D3D11_INPUT_PER_VERTEX_DATA, 0 },
			{ NULL },
		},
	},
} ;

// Direct3D11 gOtBbNX̍\
GRAPHICS_HARDDATA_DIRECT3D11 GraphicsHardDataDirect3D11 ;

// VF[_[oCiz
extern BYTE DxShaderCodeBin_Model_D3D11[] ;
extern BYTE DxShaderCodeBin_Filter_D3D11[] ;
extern BYTE DxShaderCodeBin_Base_D3D11[] ;
extern BYTE DxShaderCodeBin_Base3D_D3D11[] ;
extern BYTE DxShaderCodeBin_RgbaMix_D3D11[] ;

// ֐錾 -------------------------------------------------------------------

static void Graphics_D3D11_ObjectArray_Release( void **pObject, int Num ) ;							// IuWFNgz

// D3D11Device Xe[^X֌W
static int Graphics_D3D11_DeviceState_SetupSamplerState( void ) ;									// ݂̐ݒɊÂ ID3D11SamplerState ZbgAbv
static int Graphics_D3D11_DeviceState_TerminateSamplerState( void ) ;								// ID3D11SamplerState 

static int Graphics_D3D11_DeviceState_SetupRasterizerState( void ) ;								// ݂̐ݒɊÂ ID3D11RasterizerState ZbgAbv
static int Graphics_D3D11_DeviceState_TerminateRasterizerState( void ) ;							// ID3D11RasterizerState 

static int Graphics_D3D11_DeviceState_SetupDepthStencilState( void ) ;								// ݂̐ݒɊÂ ID3D11DepthStencilState ZbgAbv
static int Graphics_D3D11_DeviceState_TerminateDepthStencilState( void ) ;							// ID3D11DepthStencilState 

static int Graphics_D3D11_DeviceState_SetupBlendState( void ) ;										// ݂̐ݒɊÂ ID3D11BlendState ZbgAbv
static int Graphics_D3D11_DeviceState_TerminateBlendState( void ) ;									// ID3D11BlendState 

static int Graphics_D3D11_DeviceState_SetNormalTextureAddressTransformMatrix_ConstBuffer( void ) ;	// W`p̃eNX`Wϊs萔obt@ɃZbg
static int Graphics_D3D11_DeviceState_UpdateConstantFogParam( void ) ;								// tHO̐FȊO̒萔XV
static void Graphics_D3D11_DeviceState_RefreshAmbientAndEmissiveParam( void ) ;						// ArGgCgƃG~bVuJ[|킹p[^XV

// vO -----------------------------------------------------------------

// Direct3D11 gpOtBbNX̏s( 0: -1:s )
extern	int		Graphics_D3D11_Initialize( void )
{
	// Direct3D11.DLL ̓ǂݍ
	if( Direct3D11_LoadDLL() < 0 )
	{
		return -1 ;
	}

	// D3D11Device 쐬
	if( Graphics_D3D11_Device_Create() != 0 )
	{
		return -1 ;
	}

	// [xobt@̍쐬݂
	if( Graphics_D3D11_CreateDepthBuffer() != 0 )
	{
		return -1 ;
	}

	// VF[_[̍쐬
	if( Graphics_D3D11_Shader_Initialize() != 0 )
	{
		return -1 ;
	}

	// 萔̏
	if( Graphics_D3D11_Constant_Initialize() != 0 )
	{
		return -1 ;
	}

	// ̓CAEg̍쐬
	if( Graphics_D3D11_InputLayout_Base_Create() != 0 )
	{
		return -1 ;
	}

#ifndef DX_NON_MODEL
	// {[eNX`̍쐬
//	CreateRGBtoVMaxRGBVolumeTexture() ;
#endif // DX_NON_MODEL

	// tXN[[h̏ꍇ̓TuobNobt@̃ZbgAbvs
	if( GetWindowModeFlag() == FALSE )
	{
		if( Graphics_D3D11_SetupSubBackBuffer() != 0 )
		{
			return -1 ;
		}
	}

	GSYS.Setting.ValidHardware = TRUE ;

	// I
	return 0 ;
}

// Direct3D11 gpOtBbNX̌ns
extern int Graphics_D3D11_Terminate( void )
{
#ifndef DX_NON_MODEL
	// f̒_obt@
	MV1TerminateVertexBufferAll() ;
#endif // DX_NON_MODEL

	// Tv[Xe[g̉
	Graphics_D3D11_DeviceState_TerminateSamplerState() ;

	// X^CU[Xe[g̉
	Graphics_D3D11_DeviceState_TerminateRasterizerState() ;

	// [xXeVXe[g̉
	Graphics_D3D11_DeviceState_TerminateDepthStencilState() ;

	// uhXe[g̉
	Graphics_D3D11_DeviceState_TerminateBlendState() ;

	// ̓CAEǧn
	Graphics_D3D11_InputLayout_Base_Terminate() ;
#ifndef DX_NON_MODEL
	Graphics_D3D11_InputLayout_Model_Terminate() ;
#endif // DX_NON_MODEL

	// VF[_[̉
	Graphics_D3D11_Shader_Terminate() ;

	// 萔̌n
	Graphics_D3D11_Constant_Terminate() ;

	// Zobt@ ̉
	if( GD3D11.Device.Screen.DepthBufferDSV )
	{
		Direct3D11_ObjectRelease( GD3D11.Device.Screen.DepthBufferDSV ) ;
		GD3D11.Device.Screen.DepthBufferDSV = NULL ;
	}
	if( GD3D11.Device.Screen.DepthBufferTexture2D )
	{
		Direct3D11_ObjectRelease( GD3D11.Device.Screen.DepthBufferTexture2D ) ;
		GD3D11.Device.Screen.DepthBufferTexture2D = NULL ;
	}

	// TuobNobt@̉
	if( GD3D11.Device.Screen.SubBackBufferSRV )
	{
		Direct3D11_ObjectRelease( GD3D11.Device.Screen.SubBackBufferSRV ) ;
		GD3D11.Device.Screen.SubBackBufferSRV = NULL ;
	}
	if( GD3D11.Device.Screen.SubBackBufferRTV )
	{
		Direct3D11_ObjectRelease( GD3D11.Device.Screen.SubBackBufferRTV ) ;
		GD3D11.Device.Screen.SubBackBufferRTV = NULL ;
	}
	if( GD3D11.Device.Screen.SubBackBufferTexture2D )
	{
		Direct3D11_ObjectRelease( GD3D11.Device.Screen.SubBackBufferTexture2D ) ;
		GD3D11.Device.Screen.SubBackBufferTexture2D = NULL ;
	}

	// obNobt@̉
	if( GD3D11.Device.Screen.BackBufferRTV )
	{
		Direct3D11_ObjectRelease( GD3D11.Device.Screen.BackBufferRTV ) ;
		GD3D11.Device.Screen.BackBufferRTV = NULL ;
	}
	if( GD3D11.Device.Screen.BackBufferTexture2D )
	{
		Direct3D11_ObjectRelease( GD3D11.Device.Screen.BackBufferTexture2D ) ;
		GD3D11.Device.Screen.BackBufferTexture2D = NULL ;
	}

#ifndef DX_NON_MODEL
	// {[eNX`̉
	if( GD3D11.RGBtoVMaxRGBVolumeTexture )
	{
		Direct3D11_ObjectRelease( GD3D11.RGBtoVMaxRGBVolumeTexture ) ;
		GD3D11.RGBtoVMaxRGBVolumeTexture = NULL ;
	}
#endif // DX_NON_MODEL

	// D3D11Device ̉
	D3D11Device_Release() ;
	GD3D11.Device.DrawInfo.BeginSceneFlag = FALSE ;

	// d3d11.dll ̉
	Direct3D11_FreeDLL() ;

	// fBXvC[hpɊmۂ̉
	if( GSYS.Screen.DisplayMode )
	{
		HeapFree( GetProcessHeap(), 0, GSYS.Screen.DisplayMode ) ;
		GSYS.Screen.DisplayMode = NULL ;
	}

	// I
	return 0 ;
}
























// VF[_[R[h֌W

// VF[_[R[hpbP[WVF[_[R[hoCĩAhXƃTCY擾
static void Graphics_D3D11_ShaderCodePackage_GetInfo( WORD **pSize, BYTE **pCode, GRAPHICS_HARDWARE_DIRECT3D11_SHADERCODE_INFO *DestInfo, int Num )
{
	WORD *Size ;
	BYTE *Code ;
	int i ;

	Size = *pSize ;
	Code = *pCode ;
	for( i = 0 ; i < Num ; i ++, Size ++, DestInfo ++ )
	{
		if( *Size != 0 )
		{
			DestInfo->Binary = ( void * )Code ;
			DestInfo->Size   = *Size ;
			Code            += *Size ;
		}
	}

	*pSize = Size ;
	*pCode = Code ;
}

// Direct3D11 ̕W`p̃VF[_[R[h̏s
extern int Graphics_D3D11_ShaderCode_Base_Initialize( void )
{
	GRAPHICS_HARDWARE_DIRECT3D11_SHADERCODE_BASE *SCBASE = &GraphicsHardDataDirect3D11.ShaderCode.Base ;
	int   Size = 0 ;
	BYTE  *ShaderAddr = NULL ;
	WORD  *SizeBuf    = NULL ;

	// łɏĂ牽Ȃ
	if( SCBASE->BaseShaderInitializeFlag == TRUE )
	{
		return TRUE ;
	}

	// CgCfbNXXg̍\z
	{
		int l0, l1, l2, l3, l4, l5, ind ;

		ind = 0 ;
		for( l0 = 0 ; l0 < 4 ; l0 ++ )
		{
			for( l1 = 0 ; l1 <= l0 ; l1 ++ )
			{
				for( l2 = 0 ; l2 <= l1 ; l2 ++ )
				{
					for( l3 = 0 ; l3 <= l2 ; l3 ++ )
					{
						for( l4 = 0 ; l4 <= l3 ; l4 ++ )
						{
							for( l5 = 0 ; l5 <= l4 ; l5 ++ )
							{
								SCBASE->LightIndexList84[ l0 ][ l1 ][ l2 ][ l3 ][ l4 ][ l5 ] = ( short )ind ;
								ind ++ ;
							}
						}
					}
				}
			}
		}

		ind = 0 ;
		for( l0 = 0 ; l0 < 4 ; l0 ++ )
		{
			for( l1 = 0 ; l1 <= l0 ; l1 ++ )
			{
				for( l2 = 0 ; l2 <= l1 ; l2 ++ )
				{
					SCBASE->LightIndexList20[ l0 ][ l1 ][ l2 ] = ( short )ind ;
					ind ++ ;
				}
			}
		}

		ind = 0 ;
		for( l0 = 0 ; l0 < 3 ; l0 ++ )
		{
			for( l1 = 0 ; l1 <= l0 ; l1 ++ )
			{
				for( l2 = 0 ; l2 <= l1 ; l2 ++ )
				{
					SCBASE->LightIndexList10[ l0 ][ l1 ][ l2 ] = ( short )ind ;
					ind ++ ;
				}
			}
		}
	}

#ifndef DX_NON_FILTER
	SCBASE->FilterShaderBinDxaImage = NULL ;
	SCBASE->RGBAMixS_ShaderPackImage = NULL ;
#endif // DX_NON_FILTER

	SCBASE->Base2DShaderPackageImage = NULL ;

	// W`pVF[_[IuWFNgt@Ccw`kf[^𓀂
	{
		Size = DXA_Decode( DxShaderCodeBin_Base_D3D11, NULL ) ;
		SCBASE->Base2DShaderPackageImage = DXALLOC( Size ) ;
		if( SCBASE->Base2DShaderPackageImage == NULL )
		{
			goto ERR ;
		}

		DXA_Decode( DxShaderCodeBin_Base_D3D11, SCBASE->Base2DShaderPackageImage ) ;
	}

	// AhXXg̃Zbg
	SizeBuf    = ( WORD * )SCBASE->Base2DShaderPackageImage ;
	ShaderAddr = ( BYTE * )SCBASE->Base2DShaderPackageImage +
		sizeof( WORD ) * (
			sizeof( SCBASE->BaseSimple_VS_Code  ) / sizeof( GRAPHICS_HARDWARE_DIRECT3D11_SHADERCODE_INFO ) +
			sizeof( SCBASE->BaseNoneTex_PS_Code ) / sizeof( GRAPHICS_HARDWARE_DIRECT3D11_SHADERCODE_INFO ) +
			sizeof( SCBASE->BaseUseTex_PS_Code  ) / sizeof( GRAPHICS_HARDWARE_DIRECT3D11_SHADERCODE_INFO ) +
			sizeof( SCBASE->MaskEffect_PS_Code  ) / sizeof( GRAPHICS_HARDWARE_DIRECT3D11_SHADERCODE_INFO ) ) ;
	Graphics_D3D11_ShaderCodePackage_GetInfo( &SizeBuf, &ShaderAddr, ( GRAPHICS_HARDWARE_DIRECT3D11_SHADERCODE_INFO * )SCBASE->BaseSimple_VS_Code,  sizeof( SCBASE->BaseSimple_VS_Code )  / sizeof( GRAPHICS_HARDWARE_DIRECT3D11_SHADERCODE_INFO ) ) ;
	Graphics_D3D11_ShaderCodePackage_GetInfo( &SizeBuf, &ShaderAddr, ( GRAPHICS_HARDWARE_DIRECT3D11_SHADERCODE_INFO * )SCBASE->BaseNoneTex_PS_Code, sizeof( SCBASE->BaseNoneTex_PS_Code ) / sizeof( GRAPHICS_HARDWARE_DIRECT3D11_SHADERCODE_INFO ) ) ;
	Graphics_D3D11_ShaderCodePackage_GetInfo( &SizeBuf, &ShaderAddr, ( GRAPHICS_HARDWARE_DIRECT3D11_SHADERCODE_INFO * )SCBASE->BaseUseTex_PS_Code,  sizeof( SCBASE->BaseUseTex_PS_Code )  / sizeof( GRAPHICS_HARDWARE_DIRECT3D11_SHADERCODE_INFO ) ) ;
	Graphics_D3D11_ShaderCodePackage_GetInfo( &SizeBuf, &ShaderAddr, ( GRAPHICS_HARDWARE_DIRECT3D11_SHADERCODE_INFO * )&SCBASE->MaskEffect_PS_Code, sizeof( SCBASE->MaskEffect_PS_Code )  / sizeof( GRAPHICS_HARDWARE_DIRECT3D11_SHADERCODE_INFO ) ) ;

#ifndef DX_NON_FILTER

	// RGBAMixVF[_[pbNkt@CWJ
	{
		Size = DXA_Decode( DxShaderCodeBin_Filter_D3D11, NULL ) ;
		SCBASE->RGBAMixS_ShaderPackImage = DXALLOC( Size ) ;
		if( SCBASE->RGBAMixS_ShaderPackImage == NULL )
		{
			goto ERR ;
		}

		DXA_Decode( DxShaderCodeBin_Filter_D3D11, SCBASE->RGBAMixS_ShaderPackImage ) ;

		// AhXXg̃Zbg
		SizeBuf    = ( WORD  * )SCBASE->RGBAMixS_ShaderPackImage ;
		ShaderAddr = ( BYTE  * )SCBASE->RGBAMixS_ShaderPackImage +
			sizeof( WORD ) * (
				sizeof( SCBASE->RGBAMixS_PS_Code )  / sizeof( GRAPHICS_HARDWARE_DIRECT3D11_SHADERCODE_INFO ) ) ;
		Graphics_D3D11_ShaderCodePackage_GetInfo( &SizeBuf, &ShaderAddr, ( GRAPHICS_HARDWARE_DIRECT3D11_SHADERCODE_INFO * )SCBASE->RGBAMixS_PS_Code,  sizeof( SCBASE->RGBAMixS_PS_Code )  / sizeof( GRAPHICS_HARDWARE_DIRECT3D11_SHADERCODE_INFO ) ) ;
	}

	// tB^[VF[_[IuWFNgt@Ccw`kf[^𓀂
	{
		Size = DXA_Decode( DxShaderCodeBin_Filter_D3D11, NULL ) ;
		SCBASE->FilterShaderBinDxaImage = DXALLOC( Size ) ;
		if( SCBASE->FilterShaderBinDxaImage == NULL )
		{
			goto ERR ;
		}

		DXA_Decode( DxShaderCodeBin_Filter_D3D11, SCBASE->FilterShaderBinDxaImage ) ;

		// cw`t@CI[v
		DXA_Initialize( &SCBASE->FilterShaderBinDxa ) ;
		if( DXA_OpenArchiveFromMem( &SCBASE->FilterShaderBinDxa, SCBASE->FilterShaderBinDxaImage, Size, FALSE, FALSE ) != 0 )
		{
			goto ERR ;
		}
	}

#endif // DX_NON_FILTER

	SCBASE->BaseShaderInitializeFlag = TRUE ;

	// I
	return TRUE ;

ERR :
	if( SCBASE->Base2DShaderPackageImage != NULL )
	{
		DXFREE( SCBASE->Base2DShaderPackageImage ) ;
		SCBASE->Base2DShaderPackageImage = NULL ;
	}

#ifndef DX_NON_FILTER
	if( SCBASE->FilterShaderBinDxaImage != NULL )
	{
		DXFREE( SCBASE->FilterShaderBinDxaImage ) ;
		SCBASE->FilterShaderBinDxaImage = NULL ;
	}

	if( SCBASE->RGBAMixS_ShaderPackImage != NULL )
	{
		DXFREE( SCBASE->RGBAMixS_ShaderPackImage ) ;
		SCBASE->RGBAMixS_ShaderPackImage = NULL ;
	}
#endif // DX_NON_FILTER

	return FALSE ;
}

// Direct3D11 ̕W`p̃VF[_[R[ȟns
extern int Graphics_D3D11_ShaderCode_Base_Terminate( void )
{
	GRAPHICS_HARDWARE_DIRECT3D11_SHADERCODE_BASE *SCBASE = &GraphicsHardDataDirect3D11.ShaderCode.Base ;

	// łɌnĂ牽Ȃ
	if( SCBASE->BaseShaderInitializeFlag == FALSE )
	{
		return TRUE ;
	}

	// 𓀂VF[_[i[Ẳ
	if( SCBASE->Base2DShaderPackageImage != NULL )
	{
		DXFREE( SCBASE->Base2DShaderPackageImage ) ;
		SCBASE->Base2DShaderPackageImage = NULL ;
	}

#ifndef DX_NON_FILTER

	// tB^[VF[_[pcw`̌n
	DXA_Terminate( &SCBASE->FilterShaderBinDxa ) ;

	if( SCBASE->RGBAMixS_ShaderPackImage )
	{
		DXFREE( SCBASE->RGBAMixS_ShaderPackImage ) ;
		SCBASE->RGBAMixS_ShaderPackImage = NULL ;
	}
	if( SCBASE->FilterShaderBinDxaImage )
	{
		DXFREE( SCBASE->FilterShaderBinDxaImage ) ;
		SCBASE->FilterShaderBinDxaImage = NULL ;
	}

#endif // DX_NON_FILTER

	// tO|
	SCBASE->BaseShaderInitializeFlag = FALSE ;

	// I
	return TRUE ;
}

// Direct3D11 ̕WRc`p̃VF[_[R[h̏s
extern int Graphics_D3D11_ShaderCode_Base3D_Initialize( void )
{
	GRAPHICS_HARDWARE_DIRECT3D11_SHADERCODE_BASE3D *SCBASE3D = &GraphicsHardDataDirect3D11.ShaderCode.Base3D ;
	HANDLEMANAGE *HandleManage = &HandleManageArray[ DX_HANDLETYPE_GRAPH ] ;
	int   Size = 0 ;
	BYTE  *ShaderAddr = NULL ;
	WORD  *SizeBuf    = NULL ;

	// NeBJZNV̎擾
	CRITICALSECTION_LOCK( &HandleManage->CriticalSection ) ;

	// łɏĂ牽Ȃ
	if( SCBASE3D->Base3DShaderInitializeFlag == TRUE )
	{
		// NeBJZNV̉
		CriticalSection_Unlock( &HandleManage->CriticalSection ) ;

		return TRUE ;
	}

	SCBASE3D->Base3DShaderPackageImage = NULL ;

	// kf[^̉
	{
		Size = DXA_Decode( DxShaderCodeBin_Base3D_D3D11, NULL ) ;
		SCBASE3D->Base3DShaderPackageImage = DXCALLOC( Size ) ;
		if( SCBASE3D->Base3DShaderPackageImage == NULL )
		{
			goto ERR ;
		}

		DXA_Decode( DxShaderCodeBin_Base3D_D3D11, SCBASE3D->Base3DShaderPackageImage ) ;
	}

	// AhXXg̃Zbg
	SizeBuf    = ( WORD * )SCBASE3D->Base3DShaderPackageImage ;
	ShaderAddr = ( BYTE * )SCBASE3D->Base3DShaderPackageImage +
		sizeof( WORD ) * (
			sizeof( SCBASE3D->Base3D_PixelLighting_VS_Code         ) / sizeof( GRAPHICS_HARDWARE_DIRECT3D11_SHADERCODE_INFO ) +
			sizeof( SCBASE3D->Base3D_PixelLighting_Normal_PS_Code  ) / sizeof( GRAPHICS_HARDWARE_DIRECT3D11_SHADERCODE_INFO ) +
			sizeof( SCBASE3D->Base3D_ShadowMap_VS_Code             ) / sizeof( GRAPHICS_HARDWARE_DIRECT3D11_SHADERCODE_INFO ) +
			sizeof( SCBASE3D->Base3D_NoLighting_VS_Code            ) / sizeof( GRAPHICS_HARDWARE_DIRECT3D11_SHADERCODE_INFO ) +
			sizeof( SCBASE3D->Base3D_VertexLighting_VS_Code        ) / sizeof( GRAPHICS_HARDWARE_DIRECT3D11_SHADERCODE_INFO ) +
			sizeof( SCBASE3D->Base3D_ShadowMap_Normal_PS_Code      ) / sizeof( GRAPHICS_HARDWARE_DIRECT3D11_SHADERCODE_INFO ) +
			sizeof( SCBASE3D->Base3D_NoLighting_Normal_PS_Code     ) / sizeof( GRAPHICS_HARDWARE_DIRECT3D11_SHADERCODE_INFO ) +
			sizeof( SCBASE3D->Base3D_VertexLighting_Normal_PS_Code ) / sizeof( GRAPHICS_HARDWARE_DIRECT3D11_SHADERCODE_INFO ) ) ;
	Graphics_D3D11_ShaderCodePackage_GetInfo( &SizeBuf, &ShaderAddr, ( GRAPHICS_HARDWARE_DIRECT3D11_SHADERCODE_INFO * )SCBASE3D->Base3D_PixelLighting_VS_Code,         sizeof( SCBASE3D->Base3D_PixelLighting_VS_Code         ) / sizeof( GRAPHICS_HARDWARE_DIRECT3D11_SHADERCODE_INFO ) ) ;
	Graphics_D3D11_ShaderCodePackage_GetInfo( &SizeBuf, &ShaderAddr, ( GRAPHICS_HARDWARE_DIRECT3D11_SHADERCODE_INFO * )SCBASE3D->Base3D_PixelLighting_Normal_PS_Code,  sizeof( SCBASE3D->Base3D_PixelLighting_Normal_PS_Code  ) / sizeof( GRAPHICS_HARDWARE_DIRECT3D11_SHADERCODE_INFO ) ) ;
	Graphics_D3D11_ShaderCodePackage_GetInfo( &SizeBuf, &ShaderAddr, ( GRAPHICS_HARDWARE_DIRECT3D11_SHADERCODE_INFO * )SCBASE3D->Base3D_ShadowMap_VS_Code,             sizeof( SCBASE3D->Base3D_ShadowMap_VS_Code             ) / sizeof( GRAPHICS_HARDWARE_DIRECT3D11_SHADERCODE_INFO ) ) ;
	Graphics_D3D11_ShaderCodePackage_GetInfo( &SizeBuf, &ShaderAddr, ( GRAPHICS_HARDWARE_DIRECT3D11_SHADERCODE_INFO * )SCBASE3D->Base3D_NoLighting_VS_Code,            sizeof( SCBASE3D->Base3D_NoLighting_VS_Code            ) / sizeof( GRAPHICS_HARDWARE_DIRECT3D11_SHADERCODE_INFO ) ) ;
	Graphics_D3D11_ShaderCodePackage_GetInfo( &SizeBuf, &ShaderAddr, ( GRAPHICS_HARDWARE_DIRECT3D11_SHADERCODE_INFO * )SCBASE3D->Base3D_VertexLighting_VS_Code,        sizeof( SCBASE3D->Base3D_VertexLighting_VS_Code        ) / sizeof( GRAPHICS_HARDWARE_DIRECT3D11_SHADERCODE_INFO ) ) ;
	Graphics_D3D11_ShaderCodePackage_GetInfo( &SizeBuf, &ShaderAddr, ( GRAPHICS_HARDWARE_DIRECT3D11_SHADERCODE_INFO * )SCBASE3D->Base3D_ShadowMap_Normal_PS_Code,      sizeof( SCBASE3D->Base3D_ShadowMap_Normal_PS_Code      ) / sizeof( GRAPHICS_HARDWARE_DIRECT3D11_SHADERCODE_INFO ) ) ;
	Graphics_D3D11_ShaderCodePackage_GetInfo( &SizeBuf, &ShaderAddr, ( GRAPHICS_HARDWARE_DIRECT3D11_SHADERCODE_INFO * )SCBASE3D->Base3D_NoLighting_Normal_PS_Code,     sizeof( SCBASE3D->Base3D_NoLighting_Normal_PS_Code     ) / sizeof( GRAPHICS_HARDWARE_DIRECT3D11_SHADERCODE_INFO ) ) ;
	Graphics_D3D11_ShaderCodePackage_GetInfo( &SizeBuf, &ShaderAddr, ( GRAPHICS_HARDWARE_DIRECT3D11_SHADERCODE_INFO * )SCBASE3D->Base3D_VertexLighting_Normal_PS_Code, sizeof( SCBASE3D->Base3D_VertexLighting_Normal_PS_Code ) / sizeof( GRAPHICS_HARDWARE_DIRECT3D11_SHADERCODE_INFO ) ) ;

	SCBASE3D->Base3DShaderInitializeFlag = TRUE ;

	// NeBJZNV̉
	CriticalSection_Unlock( &HandleManage->CriticalSection ) ;

	// I
	return TRUE ;

ERR :
	if( SCBASE3D->Base3DShaderPackageImage != NULL )
	{
		DXFREE( SCBASE3D->Base3DShaderPackageImage ) ;
		SCBASE3D->Base3DShaderPackageImage = NULL ;
	}

	// NeBJZNV̉
	CriticalSection_Unlock( &HandleManage->CriticalSection ) ;

	return FALSE ;
}


// Direct3D11 ̕WRc`p̃VF[_[R[ȟns
extern int Graphics_D3D11_ShaderCode_Base3D_Terminate( void )
{
	GRAPHICS_HARDWARE_DIRECT3D11_SHADERCODE_BASE3D *SCBASE3D = &GraphicsHardDataDirect3D11.ShaderCode.Base3D ;

	// łɌnĂ牽Ȃ
	if( SCBASE3D->Base3DShaderInitializeFlag == FALSE )
	{
		return TRUE ;
	}

	if( SCBASE3D->Base3DShaderPackageImage )
	{
		DXFREE( SCBASE3D->Base3DShaderPackageImage ) ;
		SCBASE3D->Base3DShaderPackageImage = NULL ;
	}

	// tO|
	SCBASE3D->Base3DShaderInitializeFlag = FALSE ;

	// I
	return TRUE ;
}


#ifndef DX_NON_MODEL

// Direct3D11 ̃f`p̃VF[_[R[h̏s
extern	int		Graphics_D3D11_ShaderCode_Model_Initialize( void )
{
	GRAPHICS_HARDWARE_DIRECT3D11_SHADERCODE_MODEL *SCMODEL = &GraphicsHardDataDirect3D11.ShaderCode.Model ;
	HANDLEMANAGE *HandleManage = &HandleManageArray[ DX_HANDLETYPE_GRAPH ] ;
	int   Size = 0 ;
	BYTE  *ShaderAddr = NULL ;
	WORD  *SizeBuf    = NULL ;

	// NeBJZNV̎擾
	CRITICALSECTION_LOCK( &HandleManage->CriticalSection ) ;

	// łɏĂ牽Ȃ
	if( SCMODEL->ModelShaderInitializeFlag == TRUE )
	{
		// NeBJZNV̉
		CriticalSection_Unlock( &HandleManage->CriticalSection ) ;

		return TRUE ;
	}

	SCMODEL->ModelShaderPackImage = NULL ;

	// kf[^̉
	{
		Size = DXA_Decode( DxShaderCodeBin_Model_D3D11, NULL ) ;
		SCMODEL->ModelShaderPackImage = DXCALLOC( Size ) ;
		if( SCMODEL->ModelShaderPackImage == NULL )
		{
			goto ERR ;
		}

		DXA_Decode( DxShaderCodeBin_Model_D3D11, SCMODEL->ModelShaderPackImage ) ;
	}

	// AhXXg̃Zbg
	SizeBuf    = ( WORD * )SCMODEL->ModelShaderPackImage ;
	ShaderAddr = ( BYTE * )SCMODEL->ModelShaderPackImage +
		sizeof( WORD ) * (
			sizeof( SCMODEL->MV1_PixelLighting_VS_Code         ) / sizeof( GRAPHICS_HARDWARE_DIRECT3D11_SHADERCODE_INFO ) +
			sizeof( SCMODEL->MV1_PixelLighting_Toon_PS_Code    ) / sizeof( GRAPHICS_HARDWARE_DIRECT3D11_SHADERCODE_INFO ) +
			sizeof( SCMODEL->MV1_PixelLighting_Normal_PS_Code  ) / sizeof( GRAPHICS_HARDWARE_DIRECT3D11_SHADERCODE_INFO ) +
			sizeof( SCMODEL->MV1_ToonOutLine_VS_Code           ) / sizeof( GRAPHICS_HARDWARE_DIRECT3D11_SHADERCODE_INFO ) +
			sizeof( SCMODEL->MV1_ShadowMap_VS_Code             ) / sizeof( GRAPHICS_HARDWARE_DIRECT3D11_SHADERCODE_INFO ) +
			sizeof( SCMODEL->MV1_NoLighting_VS_Code            ) / sizeof( GRAPHICS_HARDWARE_DIRECT3D11_SHADERCODE_INFO ) +
			sizeof( SCMODEL->MV1_VertexLighting_VS_Code        ) / sizeof( GRAPHICS_HARDWARE_DIRECT3D11_SHADERCODE_INFO ) +
			sizeof( SCMODEL->MV1_ToonOutLine_PS_Code           ) / sizeof( GRAPHICS_HARDWARE_DIRECT3D11_SHADERCODE_INFO ) +
			sizeof( SCMODEL->MV1_ShadowMap_Toon_PS_Code        ) / sizeof( GRAPHICS_HARDWARE_DIRECT3D11_SHADERCODE_INFO ) +
			sizeof( SCMODEL->MV1_ShadowMap_Normal_PS_Code      ) / sizeof( GRAPHICS_HARDWARE_DIRECT3D11_SHADERCODE_INFO ) +
			sizeof( SCMODEL->MV1_NoLighting_Toon_PS_Code       ) / sizeof( GRAPHICS_HARDWARE_DIRECT3D11_SHADERCODE_INFO ) +
			sizeof( SCMODEL->MV1_NoLighting_Normal_PS_Code     ) / sizeof( GRAPHICS_HARDWARE_DIRECT3D11_SHADERCODE_INFO ) +
			sizeof( SCMODEL->MV1_VertexLighting_Toon_PS_Code   ) / sizeof( GRAPHICS_HARDWARE_DIRECT3D11_SHADERCODE_INFO ) +
			sizeof( SCMODEL->MV1_VertexLighting_Normal_PS_Code ) / sizeof( GRAPHICS_HARDWARE_DIRECT3D11_SHADERCODE_INFO ) ) ;
	Graphics_D3D11_ShaderCodePackage_GetInfo( &SizeBuf, &ShaderAddr, ( GRAPHICS_HARDWARE_DIRECT3D11_SHADERCODE_INFO * )SCMODEL->MV1_PixelLighting_VS_Code,         sizeof( SCMODEL->MV1_PixelLighting_VS_Code         ) / sizeof( GRAPHICS_HARDWARE_DIRECT3D11_SHADERCODE_INFO ) ) ;
	Graphics_D3D11_ShaderCodePackage_GetInfo( &SizeBuf, &ShaderAddr, ( GRAPHICS_HARDWARE_DIRECT3D11_SHADERCODE_INFO * )SCMODEL->MV1_PixelLighting_Toon_PS_Code,    sizeof( SCMODEL->MV1_PixelLighting_Toon_PS_Code    ) / sizeof( GRAPHICS_HARDWARE_DIRECT3D11_SHADERCODE_INFO ) ) ;
	Graphics_D3D11_ShaderCodePackage_GetInfo( &SizeBuf, &ShaderAddr, ( GRAPHICS_HARDWARE_DIRECT3D11_SHADERCODE_INFO * )SCMODEL->MV1_PixelLighting_Normal_PS_Code,  sizeof( SCMODEL->MV1_PixelLighting_Normal_PS_Code  ) / sizeof( GRAPHICS_HARDWARE_DIRECT3D11_SHADERCODE_INFO ) ) ;
	Graphics_D3D11_ShaderCodePackage_GetInfo( &SizeBuf, &ShaderAddr, ( GRAPHICS_HARDWARE_DIRECT3D11_SHADERCODE_INFO * )SCMODEL->MV1_ToonOutLine_VS_Code,           sizeof( SCMODEL->MV1_ToonOutLine_VS_Code           ) / sizeof( GRAPHICS_HARDWARE_DIRECT3D11_SHADERCODE_INFO ) ) ;
	Graphics_D3D11_ShaderCodePackage_GetInfo( &SizeBuf, &ShaderAddr, ( GRAPHICS_HARDWARE_DIRECT3D11_SHADERCODE_INFO * )SCMODEL->MV1_ShadowMap_VS_Code,             sizeof( SCMODEL->MV1_ShadowMap_VS_Code             ) / sizeof( GRAPHICS_HARDWARE_DIRECT3D11_SHADERCODE_INFO ) ) ;
	Graphics_D3D11_ShaderCodePackage_GetInfo( &SizeBuf, &ShaderAddr, ( GRAPHICS_HARDWARE_DIRECT3D11_SHADERCODE_INFO * )SCMODEL->MV1_NoLighting_VS_Code,            sizeof( SCMODEL->MV1_NoLighting_VS_Code            ) / sizeof( GRAPHICS_HARDWARE_DIRECT3D11_SHADERCODE_INFO ) ) ;
	Graphics_D3D11_ShaderCodePackage_GetInfo( &SizeBuf, &ShaderAddr, ( GRAPHICS_HARDWARE_DIRECT3D11_SHADERCODE_INFO * )SCMODEL->MV1_VertexLighting_VS_Code,        sizeof( SCMODEL->MV1_VertexLighting_VS_Code        ) / sizeof( GRAPHICS_HARDWARE_DIRECT3D11_SHADERCODE_INFO ) ) ;
	Graphics_D3D11_ShaderCodePackage_GetInfo( &SizeBuf, &ShaderAddr, ( GRAPHICS_HARDWARE_DIRECT3D11_SHADERCODE_INFO * )SCMODEL->MV1_ToonOutLine_PS_Code,           sizeof( SCMODEL->MV1_ToonOutLine_PS_Code           ) / sizeof( GRAPHICS_HARDWARE_DIRECT3D11_SHADERCODE_INFO ) ) ;
	Graphics_D3D11_ShaderCodePackage_GetInfo( &SizeBuf, &ShaderAddr, ( GRAPHICS_HARDWARE_DIRECT3D11_SHADERCODE_INFO * )SCMODEL->MV1_ShadowMap_Toon_PS_Code,        sizeof( SCMODEL->MV1_ShadowMap_Toon_PS_Code        ) / sizeof( GRAPHICS_HARDWARE_DIRECT3D11_SHADERCODE_INFO ) ) ;
	Graphics_D3D11_ShaderCodePackage_GetInfo( &SizeBuf, &ShaderAddr, ( GRAPHICS_HARDWARE_DIRECT3D11_SHADERCODE_INFO * )SCMODEL->MV1_ShadowMap_Normal_PS_Code,      sizeof( SCMODEL->MV1_ShadowMap_Normal_PS_Code      ) / sizeof( GRAPHICS_HARDWARE_DIRECT3D11_SHADERCODE_INFO ) ) ;
	Graphics_D3D11_ShaderCodePackage_GetInfo( &SizeBuf, &ShaderAddr, ( GRAPHICS_HARDWARE_DIRECT3D11_SHADERCODE_INFO * )SCMODEL->MV1_NoLighting_Toon_PS_Code,       sizeof( SCMODEL->MV1_NoLighting_Toon_PS_Code       ) / sizeof( GRAPHICS_HARDWARE_DIRECT3D11_SHADERCODE_INFO ) ) ;
	Graphics_D3D11_ShaderCodePackage_GetInfo( &SizeBuf, &ShaderAddr, ( GRAPHICS_HARDWARE_DIRECT3D11_SHADERCODE_INFO * )SCMODEL->MV1_NoLighting_Normal_PS_Code,     sizeof( SCMODEL->MV1_NoLighting_Normal_PS_Code     ) / sizeof( GRAPHICS_HARDWARE_DIRECT3D11_SHADERCODE_INFO ) ) ;
	Graphics_D3D11_ShaderCodePackage_GetInfo( &SizeBuf, &ShaderAddr, ( GRAPHICS_HARDWARE_DIRECT3D11_SHADERCODE_INFO * )SCMODEL->MV1_VertexLighting_Toon_PS_Code,   sizeof( SCMODEL->MV1_VertexLighting_Toon_PS_Code   ) / sizeof( GRAPHICS_HARDWARE_DIRECT3D11_SHADERCODE_INFO ) ) ;
	Graphics_D3D11_ShaderCodePackage_GetInfo( &SizeBuf, &ShaderAddr, ( GRAPHICS_HARDWARE_DIRECT3D11_SHADERCODE_INFO * )SCMODEL->MV1_VertexLighting_Normal_PS_Code, sizeof( SCMODEL->MV1_VertexLighting_Normal_PS_Code ) / sizeof( GRAPHICS_HARDWARE_DIRECT3D11_SHADERCODE_INFO ) ) ;

	SCMODEL->ModelShaderInitializeFlag = TRUE ;

	// NeBJZNV̉
	CriticalSection_Unlock( &HandleManage->CriticalSection ) ;

	// I
	return TRUE ;

ERR :
	if( SCMODEL->ModelShaderPackImage != NULL )
	{
		DXFREE( SCMODEL->ModelShaderPackImage ) ;
		SCMODEL->ModelShaderPackImage = NULL ;
	}

	// NeBJZNV̉
	CriticalSection_Unlock( &HandleManage->CriticalSection ) ;

	return FALSE ;
}

// Direct3D11 ̃f`p̃VF[_[R[ȟns
extern	int		Graphics_D3D11_ShaderCode_Model_Terminate( void )
{
	GRAPHICS_HARDWARE_DIRECT3D11_SHADERCODE_MODEL *SCMODEL = &GraphicsHardDataDirect3D11.ShaderCode.Model ;

	// łɌnĂ牽Ȃ
	if( SCMODEL->ModelShaderInitializeFlag == FALSE )
	{
		return TRUE ;
	}

	if( SCMODEL->ModelShaderPackImage )
	{
		DXFREE( SCMODEL->ModelShaderPackImage ) ;
		SCMODEL->ModelShaderPackImage = NULL ;
	}

	// tO|
	SCMODEL->ModelShaderInitializeFlag = FALSE ;

	// I
	return TRUE ;
}

#endif // DX_NON_MODEL



// VF[_[R[h璸_VF[_[쐬
static int Graphics_D3D11_VertexShader_Create( GRAPHICS_HARDWARE_DIRECT3D11_SHADERCODE_INFO *Code, D_ID3D11VertexShader **pDestShader, int Num )
{
	int i ;

	for( i = 0; i < Num; i++, Code++, pDestShader++ )
	{
		if( D3D11Device_CreateVertexShader( ( BYTE * )Code->Binary, ( SIZE_T )Code->Size, NULL, pDestShader ) != S_OK )
		{
			return -1 + i ;
		}
	}

	return 0 ;
}

// VF[_[R[hsNZVF[_[쐬
static int Graphics_D3D11_PixelShader_Create( GRAPHICS_HARDWARE_DIRECT3D11_SHADERCODE_INFO *Code, D_ID3D11PixelShader **pDestShader, int Num )
{
	int i ;

	for( i = 0; i < Num; i++, Code++, pDestShader++ )
	{
		if( D3D11Device_CreatePixelShader( ( BYTE * )Code->Binary, ( SIZE_T )Code->Size, NULL, pDestShader ) != S_OK )
		{
			return -1 + i ;
		}
	}

	return 0 ;
}

// IuWFNgz
static void Graphics_D3D11_ObjectArray_Release( void **pObject, int Num )
{
	int i ;

	for( i = 0 ; i < Num ; i++, pObject++ )
	{
		if( *pObject )
		{
			Direct3D11_ObjectRelease( *pObject ) ;
			*pObject = NULL ;
		}
	}
}

// Direct3D11 ̃VF[_[̏s
extern int Graphics_D3D11_Shader_Initialize( void )
{
	GRAPHICS_HARDWARE_DIRECT3D11_SHADERCODE      *ShaderCode = &GraphicsHardDataDirect3D11.ShaderCode ;
	GRAPHICS_HARDWARE_DIRECT3D11_SHADER          *Shader     = &GraphicsHardDataDirect3D11.Device.Shader ;
	int Result ;

	// ɍ쐬ĂƂ̂߂ɍ폜s
	//TerminateDirect3D11Shader() ;
	Graphics_D3D11_Shader_Terminate() ;

//	return 0 ;

	// Direct3D11 ̏ꍇ̓VF[_[͕Kgpł
	GSYS.HardInfo.UseShader = TRUE ;

	// W`pVF[_[R[hWJĂȂꍇ͓WJ
	if( Graphics_D3D11_ShaderCode_Base_Initialize() == FALSE )
	{
		DXST_ERRORLOGFMT_ADD( ( _T( "VF[_[R[hWJ郁̈̊mۂɎs܂\n" ) ) ) ;
		GSYS.HardInfo.UseShader = FALSE ;
		goto ERR ;
	}

	// {Iȕ`揈ɎgpVF[_[쐬
	{
		// W`p̕GȏsȂ_VF[_[̍쐬
		Result = Graphics_D3D11_VertexShader_Create( ( GRAPHICS_HARDWARE_DIRECT3D11_SHADERCODE_INFO * )ShaderCode->Base.BaseSimple_VS_Code, ( D_ID3D11VertexShader ** )Shader->Base.BaseSimple_VS, sizeof( ShaderCode->Base.BaseSimple_VS_Code ) / sizeof( GRAPHICS_HARDWARE_DIRECT3D11_SHADERCODE_INFO ) ) ;
		if( Result < 0 )
		{
			DXST_ERRORLOGFMT_ADD( ( _T( "W`p̕GȏsȂ_VF[_[IuWFNg No.%d ̍쐬Ɏs܂\n" ), -( Result + 1 ) ) ) ;
			GSYS.HardInfo.UseShader = FALSE ;
			goto ERR ;
		}

		// Œ@\pCvC݊̃sNZVF[_[( eNX`Ȃ )̍쐬
		Result = Graphics_D3D11_PixelShader_Create( ( GRAPHICS_HARDWARE_DIRECT3D11_SHADERCODE_INFO * )ShaderCode->Base.BaseNoneTex_PS_Code, ( D_ID3D11PixelShader ** )Shader->Base.BaseNoneTex_PS, sizeof( ShaderCode->Base.BaseNoneTex_PS_Code ) / sizeof( GRAPHICS_HARDWARE_DIRECT3D11_SHADERCODE_INFO ) ) ;
		if( Result < 0 )
		{
			DXST_ERRORLOGFMT_ADD( ( _T( "Œ@\pCvC݊̃sNZVF[_[IuWFNg( eNX`Ȃ ) No.%d ̍쐬Ɏs܂\n" ), -( Result + 1 ) ) ) ;
			GSYS.HardInfo.UseShader = FALSE ;
			goto ERR ;
		}

		// Œ@\pCvC݊̃sNZVF[_[( eNX` )̍쐬
		Result = Graphics_D3D11_PixelShader_Create( ( GRAPHICS_HARDWARE_DIRECT3D11_SHADERCODE_INFO * )ShaderCode->Base.BaseUseTex_PS_Code, ( D_ID3D11PixelShader ** )Shader->Base.BaseUseTex_PS, sizeof( ShaderCode->Base.BaseUseTex_PS_Code ) / sizeof( GRAPHICS_HARDWARE_DIRECT3D11_SHADERCODE_INFO ) ) ;
		if( Result < 0 )
		{
			DXST_ERRORLOGFMT_ADD( ( _T( "Œ@\pCvC݊̃sNZVF[_[IuWFNg( eNX` ) No.%d ̍쐬Ɏs܂\n" ), -( Result + 1 ) ) ) ;
			GSYS.HardInfo.UseShader = FALSE ;
			goto ERR ;
		}

		// }XNpsNZVF[_[̍쐬
		Result = Graphics_D3D11_PixelShader_Create( ( GRAPHICS_HARDWARE_DIRECT3D11_SHADERCODE_INFO * )&ShaderCode->Base.MaskEffect_PS_Code, ( D_ID3D11PixelShader ** )&Shader->Base.MaskEffect_PS, sizeof( ShaderCode->Base.MaskEffect_PS_Code ) / sizeof( GRAPHICS_HARDWARE_DIRECT3D11_SHADERCODE_INFO ) ) ;
		if( Result < 0 )
		{
			DXST_ERRORLOGFMT_ADD( ( _T( "}XNp̃sNZVF[_[IuWFNg No.%d ̍쐬Ɏs܂\n" ), -( Result + 1 ) ) ) ;
			GSYS.HardInfo.UseShader = FALSE ;
			goto ERR ;
		}
	}

	// I
	return 0 ;

ERR :

	// G[I
	return -1 ;
}


// Direct3D11 ̃VF[_[̌n
extern int Graphics_D3D11_Shader_Terminate( void )
{
	GRAPHICS_HARDDATA_DIRECT3D11_DEVICE *Device = &GraphicsHardDataDirect3D11.Device ;
	GRAPHICS_HARDWARE_DIRECT3D11_SHADER *Shader = &Device->Shader ;

	if( Graphics_Hardware_CheckValid_PF() == 0 )
	{
		return 0 ;
	}

	Graphics_D3D11_DeviceState_ResetVertexShader() ;
	Graphics_D3D11_DeviceState_ResetPixelShader() ;

	Graphics_D3D11_ObjectArray_Release( ( void ** )Shader->Base.BaseSimple_VS,  sizeof( Shader->Base.BaseSimple_VS  ) / sizeof( void * ) ) ;
	Graphics_D3D11_ObjectArray_Release( ( void ** )Shader->Base.BaseNoneTex_PS, sizeof( Shader->Base.BaseNoneTex_PS ) / sizeof( void * ) ) ;
	Graphics_D3D11_ObjectArray_Release( ( void ** )Shader->Base.BaseUseTex_PS,  sizeof( Shader->Base.BaseUseTex_PS  ) / sizeof( void * ) ) ;
	Graphics_D3D11_ObjectArray_Release( ( void ** )&Shader->Base.MaskEffect_PS, sizeof( Shader->Base.MaskEffect_PS  ) / sizeof( void * ) ) ;

	Graphics_D3D11_ObjectArray_Release( ( void ** )&Shader->Base3D.Base3D_PixelLighting_VS,         sizeof( Shader->Base3D.Base3D_PixelLighting_VS         ) / sizeof( void * ) ) ;
	Graphics_D3D11_ObjectArray_Release( ( void ** )&Shader->Base3D.Base3D_PixelLighting_Normal_PS,  sizeof( Shader->Base3D.Base3D_PixelLighting_Normal_PS  ) / sizeof( void * ) ) ;
	Graphics_D3D11_ObjectArray_Release( ( void ** )&Shader->Base3D.Base3D_ShadowMap_VS,             sizeof( Shader->Base3D.Base3D_ShadowMap_VS             ) / sizeof( void * ) ) ;
	Graphics_D3D11_ObjectArray_Release( ( void ** )&Shader->Base3D.Base3D_NoLighting_VS,            sizeof( Shader->Base3D.Base3D_NoLighting_VS            ) / sizeof( void * ) ) ;
	Graphics_D3D11_ObjectArray_Release( ( void ** )&Shader->Base3D.Base3D_VertexLighting_VS,        sizeof( Shader->Base3D.Base3D_VertexLighting_VS        ) / sizeof( void * ) ) ;
	Graphics_D3D11_ObjectArray_Release( ( void ** )&Shader->Base3D.Base3D_ShadowMap_Normal_PS,      sizeof( Shader->Base3D.Base3D_ShadowMap_Normal_PS      ) / sizeof( void * ) ) ;
	Graphics_D3D11_ObjectArray_Release( ( void ** )&Shader->Base3D.Base3D_NoLighting_Normal_PS,     sizeof( Shader->Base3D.Base3D_NoLighting_Normal_PS     ) / sizeof( void * ) ) ;
	Graphics_D3D11_ObjectArray_Release( ( void ** )&Shader->Base3D.Base3D_VertexLighting_Normal_PS, sizeof( Shader->Base3D.Base3D_VertexLighting_Normal_PS ) / sizeof( void * ) ) ;

#ifndef DX_NON_MODEL

	Graphics_D3D11_ObjectArray_Release( ( void ** )&Shader->Model.MV1_PixelLighting_VS,         sizeof( Shader->Model.MV1_PixelLighting_VS         ) / sizeof( void * ) ) ;
	Graphics_D3D11_ObjectArray_Release( ( void ** )&Shader->Model.MV1_PixelLighting_Toon_PS,    sizeof( Shader->Model.MV1_PixelLighting_Toon_PS    ) / sizeof( void * ) ) ;
	Graphics_D3D11_ObjectArray_Release( ( void ** )&Shader->Model.MV1_PixelLighting_Normal_PS,  sizeof( Shader->Model.MV1_PixelLighting_Normal_PS  ) / sizeof( void * ) ) ;
	Graphics_D3D11_ObjectArray_Release( ( void ** )&Shader->Model.MV1_ToonOutLine_VS,           sizeof( Shader->Model.MV1_ToonOutLine_VS           ) / sizeof( void * ) ) ;
	Graphics_D3D11_ObjectArray_Release( ( void ** )&Shader->Model.MV1_ShadowMap_VS,             sizeof( Shader->Model.MV1_ShadowMap_VS             ) / sizeof( void * ) ) ;
	Graphics_D3D11_ObjectArray_Release( ( void ** )&Shader->Model.MV1_NoLighting_VS,            sizeof( Shader->Model.MV1_NoLighting_VS            ) / sizeof( void * ) ) ;
	Graphics_D3D11_ObjectArray_Release( ( void ** )&Shader->Model.MV1_VertexLighting_VS,        sizeof( Shader->Model.MV1_VertexLighting_VS        ) / sizeof( void * ) ) ;
	Graphics_D3D11_ObjectArray_Release( ( void ** )&Shader->Model.MV1_ToonOutLine_PS,           sizeof( Shader->Model.MV1_ToonOutLine_PS           ) / sizeof( void * ) ) ;
	Graphics_D3D11_ObjectArray_Release( ( void ** )&Shader->Model.MV1_ShadowMap_Toon_PS,        sizeof( Shader->Model.MV1_ShadowMap_Toon_PS        ) / sizeof( void * ) ) ;
	Graphics_D3D11_ObjectArray_Release( ( void ** )&Shader->Model.MV1_ShadowMap_Normal_PS,      sizeof( Shader->Model.MV1_ShadowMap_Normal_PS      ) / sizeof( void * ) ) ;
	Graphics_D3D11_ObjectArray_Release( ( void ** )&Shader->Model.MV1_NoLighting_Toon_PS,       sizeof( Shader->Model.MV1_NoLighting_Toon_PS       ) / sizeof( void * ) ) ;
	Graphics_D3D11_ObjectArray_Release( ( void ** )&Shader->Model.MV1_NoLighting_Normal_PS,     sizeof( Shader->Model.MV1_NoLighting_Normal_PS     ) / sizeof( void * ) ) ;
	Graphics_D3D11_ObjectArray_Release( ( void ** )&Shader->Model.MV1_VertexLighting_Toon_PS,   sizeof( Shader->Model.MV1_VertexLighting_Toon_PS   ) / sizeof( void * ) ) ;
	Graphics_D3D11_ObjectArray_Release( ( void ** )&Shader->Model.MV1_VertexLighting_Normal_PS, sizeof( Shader->Model.MV1_VertexLighting_Normal_PS ) / sizeof( void * ) ) ;

#endif // DX_NON_MODEL

	// I
	return 0 ;
}


























// Direct3D11 ̉ʊ֌W

// ScreenCopy  GetDrawScreen 邽߂Ɏgpe|obt@̍쐬( 0:  -1:s )
extern	int		Graphics_D3D11_SetupSubBackBuffer( void )
{
	HRESULT                           hr ;
	D_D3D11_TEXTURE2D_DESC            Texture2DDesc ;
	D_D3D11_RENDER_TARGET_VIEW_DESC   RTVDesc ;
	D_D3D11_SHADER_RESOURCE_VIEW_DESC SRVDesc ;
	float                             ColorRGBA[ 4 ] ;

	// ɃTuobNobt@쐬Ăꍇ͉Ȃ
	if( GD3D11.Device.Screen.SubBackBufferTexture2D != NULL ) return 0 ;

	// foCX̏ꍇ͉I
	if( Graphics_Hardware_CheckValid_PF() == 0 ) return -1 ;

	// `foĂ
	Graphics_D3D11_RenderVertex() ;
	Graphics_D3D11_RenderEnd() ;

	// TuobNobt@̃TCYZbg
	GD3D11.Device.Screen.SubBackBufferTextureSizeX = GSYS.Screen.MainScreenSizeX ;
	GD3D11.Device.Screen.SubBackBufferTextureSizeY = GSYS.Screen.MainScreenSizeY ;

	// TuobNobt@peNX`̍쐬
	_MEMSET( &Texture2DDesc, 0, sizeof( Texture2DDesc ) );
	Texture2DDesc.Usage              = D_D3D11_USAGE_DEFAULT ;
	Texture2DDesc.Format             = DIRECT3D11_BACKBUFFER_FORMAT ;
	Texture2DDesc.BindFlags          = D_D3D11_BIND_RENDER_TARGET | D_D3D11_BIND_SHADER_RESOURCE ;
	Texture2DDesc.Width              = GD3D11.Device.Screen.SubBackBufferTextureSizeX ;
	Texture2DDesc.Height             = GD3D11.Device.Screen.SubBackBufferTextureSizeY ;
	Texture2DDesc.CPUAccessFlags     = 0 ;
	Texture2DDesc.MipLevels          = 1 ;
	Texture2DDesc.ArraySize          = 1 ;
	Texture2DDesc.SampleDesc.Count   = GRAWIN.Setting.FSAAMultiSampleCount == 0 ? 1 : GRAWIN.Setting.FSAAMultiSampleCount ;
	Texture2DDesc.SampleDesc.Quality = GRAWIN.Setting.FSAAMultiSampleQuality ;
	hr = D3D11Device_CreateTexture2D( &Texture2DDesc, NULL, &GD3D11.Device.Screen.SubBackBufferTexture2D ) ;
	if( FAILED( hr ) )
	{
		DXST_ERRORLOGFMT_ADD(( _T( "TuobNobt@peNX`̍쐬Ɏs܂  Format:%d  SizeX:%d  SizeY:%d \n" ),
			Texture2DDesc.Format, GD3D11.Device.Screen.SubBackBufferTextureSizeX, GD3D11.Device.Screen.SubBackBufferTextureSizeY )) ;
		return -1 ;
	}

	// TuobNobt@p_[^[Qbgr[쐬
	_MEMSET( &RTVDesc, 0, sizeof( RTVDesc ) );
	RTVDesc.Format        = DIRECT3D11_BACKBUFFER_FORMAT ;
	RTVDesc.ViewDimension = D_D3D11_RTV_DIMENSION_TEXTURE2D ;
	hr = D3D11Device_CreateRenderTargetView( GD3D11.Device.Screen.SubBackBufferTexture2D, &RTVDesc, &GD3D11.Device.Screen.SubBackBufferRTV ) ;
	if( FAILED( hr ) )
	{
		DXST_ERRORLOGFMT_ADD(( _T( "TuobNobt@p_[^[Qbgr[̍쐬Ɏs܂  Format:%d  SizeX:%d  SizeY:%d \n" ),
			Texture2DDesc.Format, GD3D11.Device.Screen.SubBackBufferTextureSizeX, GD3D11.Device.Screen.SubBackBufferTextureSizeY )) ;
		return -1 ;
	}

	// TuobNobt@p̃VF[_\[Xr[쐬
	_MEMSET( &SRVDesc, 0, sizeof( SRVDesc ) );
	SRVDesc.Format              = DIRECT3D11_BACKBUFFER_FORMAT ;
	SRVDesc.ViewDimension       = D_D3D11_SRV_DIMENSION_TEXTURE2D ;
	SRVDesc.Texture2D.MipLevels = 1 ;
	hr = D3D11Device_CreateShaderResourceView( GD3D11.Device.Screen.SubBackBufferTexture2D, &SRVDesc, &GD3D11.Device.Screen.SubBackBufferSRV ) ;
	if( FAILED( hr ) )
	{
		DXST_ERRORLOGFMT_ADD(( _T( "TuobNobt@pVF[_[\[Xr[̍쐬Ɏs܂  Format:%d  SizeX:%d  SizeY:%d \n" ),
			Texture2DDesc.Format, GD3D11.Device.Screen.SubBackBufferTextureSizeX, GD3D11.Device.Screen.SubBackBufferTextureSizeY )) ;
		return -1 ;
	}

	// {obNobt@̓e]
	// }`TvΉɂ͕`揈ɂKv
	D3D11DeviceContext_CopyResource( GD3D11.Device.Screen.SubBackBufferTexture2D, GD3D11.Device.Screen.BackBufferTexture2D ) ;

	// {obNobt@̓e
	ColorRGBA[ 0 ] = 0.0f ;
	ColorRGBA[ 1 ] = 0.0f ;
	ColorRGBA[ 2 ] = 0.0f ;
	ColorRGBA[ 3 ] = 0.0f ;
	D3D11DeviceContext_ClearRenderTargetView( GD3D11.Device.Screen.BackBufferRTV, ColorRGBA ) ;

	// _O^[Qbg̕ύX
	GD3D11.Device.DrawSetting.CancelSettingEqualCheck = TRUE ;
	Graphics_D3D11_DeviceState_SetRenderTarget( GD3D11.Device.Screen.SubBackBufferTexture2D, GD3D11.Device.Screen.SubBackBufferRTV ) ;
	GD3D11.Device.DrawSetting.CancelSettingEqualCheck = FALSE ;

	// I
	return 0 ;
}

// [xobt@IuWFNg̍쐬( 0:  -1:s )
extern	int		Graphics_D3D11_CreateDepthBuffer( void )
{
	HRESULT hr ;
	int w, h ;
	int depth ;
	int index ;

	if( Graphics_Hardware_CheckValid_PF() == 0 ) return -1 ;

	// ɍ쐬ς݂̏ꍇ͈x폜
	if( GD3D11.Device.Screen.DepthBufferTexture2D )
	{
		Direct3D11_ObjectRelease( GD3D11.Device.Screen.DepthBufferTexture2D ) ;
		GD3D11.Device.Screen.DepthBufferTexture2D = NULL ;
	}
	if( GD3D11.Device.Screen.DepthBufferDSV )
	{
		Direct3D11_ObjectRelease( GD3D11.Device.Screen.DepthBufferDSV ) ;
		GD3D11.Device.Screen.DepthBufferDSV = NULL ;
	}

	DXST_ERRORLOG_ADD( _T( "[xobt@쐬܂.... " ) ) ;

	// [xobt@̃TCY
	if( GD3D11.Setting.UserDepthBufferSizeSet == FALSE ||
		GD3D11.Device.Screen.DepthBufferSizeX == 0 ||
		GD3D11.Device.Screen.DepthBufferSizeY == 0 )
	{
		for( w = 1 ; w < GSYS.Screen.MainScreenSizeX ; w <<= 1 ){}
		for( h = 1 ; h < GSYS.Screen.MainScreenSizeY ; h <<= 1 ){}
		GD3D11.Device.Screen.DepthBufferSizeX = w ;
		GD3D11.Device.Screen.DepthBufferSizeY = h ;
	}
	else
	{
		w = GD3D11.Device.Screen.DepthBufferSizeX ;
		h = GD3D11.Device.Screen.DepthBufferSizeY ;
	}

	// [xobt@̃rbg[x
	if( GD3D11.Setting.UserDepthBufferBitDepthSet == FALSE ||
		GD3D11.Device.Screen.DepthBufferBitDepth == 0  )
	{
		depth = DEFAULT_ZBUFFER_BITDEPTH ;
		GD3D11.Device.Screen.DepthBufferBitDepth = DEFAULT_ZBUFFER_BITDEPTH ;
	}
	else
	{
		depth = GD3D11.Device.Screen.DepthBufferBitDepth ;
	}
	switch( depth )
	{
	default :
	case 16 : index = ZBUFFER_FORMAT_16BIT ; break ;
	case 24 : index = ZBUFFER_FORMAT_24BIT ; break ;
	case 32 : index = ZBUFFER_FORMAT_32BIT ; break ;
	}

	// [xobt@eNX`̍쐬
	{
		D_D3D11_TEXTURE2D_DESC Texture2DDesc ;

		_MEMSET( &Texture2DDesc, 0, sizeof( Texture2DDesc ) ) ;
		Texture2DDesc.Width              = GSYS.Screen.MainScreenSizeX ;
		Texture2DDesc.Height             = GSYS.Screen.MainScreenSizeY ;
		Texture2DDesc.MipLevels          = 1 ;
		Texture2DDesc.ArraySize          = 1 ;
//		Texture2DDesc.Format             = GD3D11.Device.Caps.DepthBufferTexture2DFormat[ index ] ;
		Texture2DDesc.Format             = GD3D11.Device.Caps.DepthBufferDepthStencilFormat[ index ] ;
		Texture2DDesc.SampleDesc.Count   = GRAWIN.Setting.FSAAMultiSampleCount ;
		Texture2DDesc.SampleDesc.Quality = GRAWIN.Setting.FSAAMultiSampleQuality ;
		Texture2DDesc.Usage              = D_D3D11_USAGE_DEFAULT ;
		Texture2DDesc.BindFlags          = D_D3D11_BIND_DEPTH_STENCIL /* | D_D3D11_BIND_SHADER_RESOURCE */ ;
		Texture2DDesc.CPUAccessFlags     = 0 ;
		Texture2DDesc.MiscFlags          = 0 ;

		// 쐬
		hr = D3D11Device_CreateTexture2D( &Texture2DDesc, NULL, &GD3D11.Device.Screen.DepthBufferTexture2D ) ;
		if( FAILED( hr ) )
		{
			DXST_ERRORLOG_ADD( _T( "[xobt@p Texture2D ̍쐬Ɏs܂\n" ) ) ;
			return -1 ;
		}
	}

	// [xXeVr[̍쐬
	{
		D_D3D11_DEPTH_STENCIL_VIEW_DESC DepthStencilViewDesc ;

		_MEMSET( &DepthStencilViewDesc, 0, sizeof( DepthStencilViewDesc ) ) ;
		DepthStencilViewDesc.Format = GD3D11.Device.Caps.DepthBufferDepthStencilFormat[ index ] ;
		if ( GRAWIN.Setting.FSAAMultiSampleCount <= 1 )
		{
			DepthStencilViewDesc.ViewDimension      = D_D3D11_DSV_DIMENSION_TEXTURE2D;
			DepthStencilViewDesc.Texture2D.MipSlice = 0;
		}
		else
		{
			DepthStencilViewDesc.ViewDimension		= D_D3D11_DSV_DIMENSION_TEXTURE2DMS;
		}

		hr = D3D11Device_CreateDepthStencilView( GD3D11.Device.Screen.DepthBufferTexture2D, &DepthStencilViewDesc, &GD3D11.Device.Screen.DepthBufferDSV ) ;
		if( FAILED( hr ) )
		{
			DXST_ERRORLOG_ADD( _T( "[xobt@p DepthStencilView ̍쐬Ɏs܂\n" ) ) ;
			return -1 ;
		}
	}

	// foCXɃZbg
	Graphics_D3D11_DeviceState_SetDepthStencil( GD3D11.Device.Screen.DepthBufferTexture2D, GD3D11.Device.Screen.DepthBufferDSV ) ;

	// NA
	D3D11DeviceContext_ClearDepthStencilView( GD3D11.Device.Screen.DepthBufferDSV, D_D3D11_CLEAR_DEPTH, 1.0f, 0 ) ;

	DXST_ERRORLOG_ADD( _T( "\n" ) ) ;

	// I
	return 0 ;
}



























// D3D11Device ̏֌W

// D3D11Device IuWFNg̍쐬( 0:  -1:s )
extern	int		Graphics_D3D11_Device_Create( void )
{
	const TCHAR *String = NULL ;

	// ɍ쐬ς݂̏ꍇ͈x폜
	D3D11Device_Release() ;
	GD3D11.Device.DrawInfo.BeginSceneFlag = FALSE ;

	// foCX̍쐬
	if( D3D11_CreateDeviceAndSwapChain() < 0 )
	{
		return -1 ;
	}

	// Zuh\ǂZbg
	GSYS.HardInfo.ValidSubBlend = TRUE ;

	// eNX`̃TCYQ̂łKv邩ǂ擾
	GSYS.HardInfo.TextureSizePow2 = FALSE ;

	// eNX``łKv邩ǂ擾
	GSYS.HardInfo.TextureSquareOnly = FALSE ;

	// tŃeNX`̃TCYQ̂łȂĂvǂ擾
	GSYS.HardInfo.TextureSizeNonPow2Conditional = TRUE ;

	// xɎgp邱Ƃ̏oő咸_擾
	GSYS.HardInfo.MaxVertexIndex = 0xffff ;

	switch( GD3D11.Setting.FeatureLevel )
	{
	case D_D3D_FEATURE_LEVEL_11_0 :
	case D_D3D_FEATURE_LEVEL_11_1 :
		// Ƀ_Oł^[Qbg̐ۑ
		GSYS.HardInfo.RenderTargetNum = 8 ;

		// eNX`̍ő啝ƍő卂ۑ
		GSYS.HardInfo.MaxTextureWidth  = 16384 ;
		GSYS.HardInfo.MaxTextureHeight = GSYS.HardInfo.MaxTextureWidth ;

		// xɕ`łőv~eBu擾
		GSYS.HardInfo.MaxPrimitiveCount = 0x7fffffff ;
		break ;

	case D_D3D_FEATURE_LEVEL_10_0 :
	case D_D3D_FEATURE_LEVEL_10_1 :
		// Ƀ_Oł^[Qbg̐ۑ
		GSYS.HardInfo.RenderTargetNum = 8 ;

		// eNX`̍ő啝ƍő卂ۑ
		GSYS.HardInfo.MaxTextureWidth  = 8192 ;
		GSYS.HardInfo.MaxTextureHeight = GSYS.HardInfo.MaxTextureWidth ;

		// xɕ`łőv~eBu擾
		GSYS.HardInfo.MaxPrimitiveCount = 0x7fffffff ;
		break ;

	case D_D3D_FEATURE_LEVEL_9_1 :
	case D_D3D_FEATURE_LEVEL_9_2 :
	case D_D3D_FEATURE_LEVEL_9_3 :
		// Ƀ_Oł^[Qbg̐ۑ
		GSYS.HardInfo.RenderTargetNum = GD3D11.Setting.FeatureLevel == D_D3D_FEATURE_LEVEL_9_3 ? 4 : 1 ;

		// eNX`̍ő啝ƍő卂ۑ
		GSYS.HardInfo.MaxTextureWidth  = GD3D11.Setting.FeatureLevel == D_D3D_FEATURE_LEVEL_9_3 ? 4096 : 2048 ;
		GSYS.HardInfo.MaxTextureHeight = GSYS.HardInfo.MaxTextureWidth ;

		// xɕ`łőv~eBu擾
		GSYS.HardInfo.MaxPrimitiveCount = GD3D11.Setting.FeatureLevel == D_D3D_FEATURE_LEVEL_9_1 ? 65535 : 1048575 ;
		break ;
	}

	// TCY̏قőTCYƂ
	GSYS.HardInfo.MaxTextureSize = GSYS.HardInfo.MaxTextureWidth < GSYS.HardInfo.MaxTextureHeight ? GSYS.HardInfo.MaxTextureWidth : GSYS.HardInfo.MaxTextureHeight ;

	// _[^[Qbg̐𒲐
	if( GSYS.HardInfo.RenderTargetNum > DX_RENDERTARGET_COUNT )
	{
		GSYS.HardInfo.RenderTargetNum = DX_RENDERTARGET_COUNT ;
	}

	// Graphics_D3D11_DrawPreparation sׂtO𗧂Ă
	GD3D11.Device.DrawSetting.DrawPrepAlwaysFlag = TRUE ;

	// hCoo
	{
		D_DXGI_ADAPTER_DESC AdapterDesc ;

		_MEMSET( &AdapterDesc, 0, sizeof( AdapterDesc ) ) ;
		DXGIAdapter_GetDesc( &AdapterDesc ) ;
		DXST_ERRORLOGFMT_ADDW(( L"Description:%s", AdapterDesc.Description )) ;
	}

	// etH[}bg𒲂ׂ
	{
		UINT FormatSupport ;

		// ʂ̃tH[}bg̎擾
		GD3D11.Device.Caps.ScreenFormat = DIRECT3D11_BACKBUFFER_FORMAT ;
		String = _T( "DXGI_FORMAT_R8G8B8A8_UNORM" ) ;
		DXST_ERRORLOGFMT_ADD(( _T( "ʂ̃tH[}bg %s ł" ), String )) ;

		// 16rbg[xobt@tH[}bg̐ݒ
		GD3D11.Device.Caps.DepthBufferTexture2DFormat[ ZBUFFER_FORMAT_16BIT ]    = DIRECT3D11_DEPTHBUFFER_TEXTURE2D_FORMAT ;
		GD3D11.Device.Caps.DepthBufferDepthStencilFormat[ ZBUFFER_FORMAT_16BIT ] = DIRECT3D11_DEPTHBUFFER_DEPTHSTENCIL_FORMAT ;
		String = _T( "DXGI_FORMAT_D16_UNORM" ) ;
		DXST_ERRORLOGFMT_ADD(( _T( "16bit Zobt@tH[}bg %s ł" ), String )) ;

		// 24rbg[xobt@tH[}bg̑I
		if( /*D3D11Device_CheckFormatSupport( D_DXGI_FORMAT_R24G8_TYPELESS, &FormatSupport ) == S_OK &&
			( FormatSupport & D_D3D11_FORMAT_SUPPORT_RENDER_TARGET ) != 0 &&*/
			D3D11Device_CheckFormatSupport( D_DXGI_FORMAT_D24_UNORM_S8_UINT, &FormatSupport ) == S_OK &&
			( FormatSupport & D_D3D11_FORMAT_SUPPORT_DEPTH_STENCIL ) != 0 )
		{
			GD3D11.Device.Caps.DepthBufferTexture2DFormat[ ZBUFFER_FORMAT_24BIT ]    = D_DXGI_FORMAT_R24G8_TYPELESS ;
			GD3D11.Device.Caps.DepthBufferDepthStencilFormat[ ZBUFFER_FORMAT_24BIT ] = D_DXGI_FORMAT_D24_UNORM_S8_UINT ;
			String = _T( "DXGI_FORMAT_D24_UNORM_S8_UINT" ) ;
		}
		else
		{
			GD3D11.Device.Caps.DepthBufferTexture2DFormat[ ZBUFFER_FORMAT_24BIT ]    = GD3D11.Device.Caps.DepthBufferTexture2DFormat[ ZBUFFER_FORMAT_16BIT ] ;
			GD3D11.Device.Caps.DepthBufferDepthStencilFormat[ ZBUFFER_FORMAT_24BIT ] = GD3D11.Device.Caps.DepthBufferDepthStencilFormat[ ZBUFFER_FORMAT_16BIT ] ;
		}
		DXST_ERRORLOGFMT_ADD(( _T( "24bit Zobt@tH[}bg %s ł" ), String )) ;

		// 32rbg[xobt@tH[}bg̐ݒ
		if( /*D3D11Device_CheckFormatSupport( D_DXGI_FORMAT_R32_TYPELESS, &FormatSupport ) == S_OK &&
			( FormatSupport & D_D3D11_FORMAT_SUPPORT_RENDER_TARGET ) != 0 &&*/
			D3D11Device_CheckFormatSupport( D_DXGI_FORMAT_D32_FLOAT, &FormatSupport ) == S_OK &&
			( FormatSupport & D_D3D11_FORMAT_SUPPORT_DEPTH_STENCIL ) != 0 )
		{
			GD3D11.Device.Caps.DepthBufferTexture2DFormat[ ZBUFFER_FORMAT_32BIT ]    = D_DXGI_FORMAT_R32_TYPELESS ;
			GD3D11.Device.Caps.DepthBufferDepthStencilFormat[ ZBUFFER_FORMAT_32BIT ] = D_DXGI_FORMAT_D32_FLOAT ;
			String = _T( "DXGI_FORMAT_D32_FLOAT" ) ;
		}
		else
		{
			GD3D11.Device.Caps.DepthBufferTexture2DFormat[ ZBUFFER_FORMAT_32BIT ]    = GD3D11.Device.Caps.DepthBufferTexture2DFormat[ ZBUFFER_FORMAT_24BIT ] ;
			GD3D11.Device.Caps.DepthBufferDepthStencilFormat[ ZBUFFER_FORMAT_32BIT ] = GD3D11.Device.Caps.DepthBufferDepthStencilFormat[ ZBUFFER_FORMAT_24BIT ] ;
		}
		DXST_ERRORLOGFMT_ADD(( _T( "32bit Zobt@tH[}bg %s ł" ), String )) ;


		// J[tH[}bg̃`FbN
		if( D3D11Device_CheckFormatSupport( D_DXGI_FORMAT_R8G8B8A8_UNORM, &FormatSupport ) != S_OK ||
			( FormatSupport & D_D3D11_FORMAT_SUPPORT_TEXTURE2D ) == 0 )
		{
			DXST_ERRORLOG_ADD( _T( "gpłJ[tH[}bg܂ł\n" ) ) ;
			return -1 ;
		}
		GD3D11.Device.Caps.TextureFormat[ DX_GRAPHICSIMAGE_FORMAT_3D_RGB16           ] = D_DXGI_FORMAT_R8G8B8A8_UNORM ;
		GD3D11.Device.Caps.TextureFormat[ DX_GRAPHICSIMAGE_FORMAT_3D_RGB32           ] = D_DXGI_FORMAT_R8G8B8A8_UNORM ;
		GD3D11.Device.Caps.TextureFormat[ DX_GRAPHICSIMAGE_FORMAT_3D_ALPHA_RGB16     ] = D_DXGI_FORMAT_R8G8B8A8_UNORM ;
		GD3D11.Device.Caps.TextureFormat[ DX_GRAPHICSIMAGE_FORMAT_3D_ALPHA_RGB32     ] = D_DXGI_FORMAT_R8G8B8A8_UNORM ;
		GD3D11.Device.Caps.TextureFormat[ DX_GRAPHICSIMAGE_FORMAT_3D_ALPHATEST_RGB16 ] = D_DXGI_FORMAT_R8G8B8A8_UNORM ;
		GD3D11.Device.Caps.TextureFormat[ DX_GRAPHICSIMAGE_FORMAT_3D_ALPHATEST_RGB32 ] = D_DXGI_FORMAT_R8G8B8A8_UNORM ;
		String = _T( "DXGI_FORMAT_R8G8B8A8_UNORM" ) ;
		DXST_ERRORLOGFMT_ADD(( _T( "J[tH[}bg %s ł" ), String )) ;

		// BC1tH[}bg̃`FbN
		if( D3D11Device_CheckFormatSupport( D_DXGI_FORMAT_BC1_UNORM, &FormatSupport ) == S_OK &&
			( FormatSupport & D_D3D11_FORMAT_SUPPORT_TEXTURE2D ) != 0 )
		{
			GD3D11.Device.Caps.TextureFormat[ DX_GRAPHICSIMAGE_FORMAT_3D_DXT1 ] = D_DXGI_FORMAT_BC1_UNORM ;
			String = _T( " DXGI_FORMAT_BC1_UNORM ł" ) ;
		}
		else
		{
			GD3D11.Device.Caps.TextureFormat[ DX_GRAPHICSIMAGE_FORMAT_3D_DXT1 ] = GD3D11.Device.Caps.TextureFormat[ DX_GRAPHICSIMAGE_FORMAT_3D_ALPHATEST_RGB16 ] ;
			String = _T( "g܂" ) ;
		}
		DXST_ERRORLOGFMT_ADD(( _T( "abPeNX`tH[}bg%s" ), String )) ;

		// BC2tH[}bg̃`FbN
		if( D3D11Device_CheckFormatSupport( D_DXGI_FORMAT_BC2_UNORM, &FormatSupport ) == S_OK &&
			( FormatSupport & D_D3D11_FORMAT_SUPPORT_TEXTURE2D ) != 0 )
		{
			GD3D11.Device.Caps.TextureFormat[ DX_GRAPHICSIMAGE_FORMAT_3D_DXT2 ] = D_DXGI_FORMAT_BC2_UNORM ;
			String = _T( " DXGI_FORMAT_BC2_UNORM ł" ) ;
		}
		else
		{
			GD3D11.Device.Caps.TextureFormat[ DX_GRAPHICSIMAGE_FORMAT_3D_DXT2 ] = GD3D11.Device.Caps.TextureFormat[ DX_GRAPHICSIMAGE_FORMAT_3D_ALPHA_RGB32 ] ;
			String = _T( "g܂" ) ;
		}
		DXST_ERRORLOGFMT_ADD(( _T( "abQeNX`tH[}bg%s" ), String )) ;

		// BC3tH[}bg̃`FbN
		if( D3D11Device_CheckFormatSupport( D_DXGI_FORMAT_BC3_UNORM, &FormatSupport ) == S_OK &&
			( FormatSupport & D_D3D11_FORMAT_SUPPORT_TEXTURE2D ) != 0 )
		{
			GD3D11.Device.Caps.TextureFormat[ DX_GRAPHICSIMAGE_FORMAT_3D_DXT3 ] = D_DXGI_FORMAT_BC3_UNORM ;
			String = _T( " DXGI_FORMAT_BC3_UNORM ł" ) ;
		}
		else
		{
			GD3D11.Device.Caps.TextureFormat[ DX_GRAPHICSIMAGE_FORMAT_3D_DXT3 ] = GD3D11.Device.Caps.TextureFormat[ DX_GRAPHICSIMAGE_FORMAT_3D_ALPHA_RGB32 ] ;
			String = _T( "g܂" ) ;
		}
		DXST_ERRORLOGFMT_ADD(( _T( "abReNX`tH[}bg%s" ), String )) ;

		// BC4tH[}bg̃`FbN
		if( D3D11Device_CheckFormatSupport( D_DXGI_FORMAT_BC4_UNORM, &FormatSupport ) == S_OK &&
			( FormatSupport & D_D3D11_FORMAT_SUPPORT_TEXTURE2D ) != 0 )
		{
			GD3D11.Device.Caps.TextureFormat[ DX_GRAPHICSIMAGE_FORMAT_3D_DXT4 ] = D_DXGI_FORMAT_BC4_UNORM ;
			String = _T( " DXGI_FORMAT_BC4_UNORM ł" ) ;
		}
		else
		{
			GD3D11.Device.Caps.TextureFormat[ DX_GRAPHICSIMAGE_FORMAT_3D_DXT4 ] = GD3D11.Device.Caps.TextureFormat[ DX_GRAPHICSIMAGE_FORMAT_3D_ALPHA_RGB32 ] ;
			String = _T( "g܂" ) ;
		}
		DXST_ERRORLOGFMT_ADD(( _T( "abSeNX`tH[}bg%s" ), String )) ;

		// BC5tH[}bg̃`FbN
		if( D3D11Device_CheckFormatSupport( D_DXGI_FORMAT_BC5_UNORM, &FormatSupport ) == S_OK &&
			( FormatSupport & D_D3D11_FORMAT_SUPPORT_TEXTURE2D ) != 0 )
		{
			GD3D11.Device.Caps.TextureFormat[ DX_GRAPHICSIMAGE_FORMAT_3D_DXT5 ] = D_DXGI_FORMAT_BC5_UNORM ;
			String = _T( " DXGI_FORMAT_BC5_UNORM ł" ) ;
		}
		else
		{
			GD3D11.Device.Caps.TextureFormat[ DX_GRAPHICSIMAGE_FORMAT_3D_DXT5 ] = GD3D11.Device.Caps.TextureFormat[ DX_GRAPHICSIMAGE_FORMAT_3D_ALPHA_RGB32 ] ;
			String = _T( "g܂" ) ;
		}
		DXST_ERRORLOGFMT_ADD(( _T( "abTeNX`tH[}bg%s" ), String )) ;

		// `\J[tH[}bg̑I
		if( D3D11Device_CheckFormatSupport( D_DXGI_FORMAT_R8G8B8A8_UNORM, &FormatSupport ) != S_OK ||
			( FormatSupport & D_D3D11_FORMAT_SUPPORT_TEXTURE2D     ) == 0 ||
			( FormatSupport & D_D3D11_FORMAT_SUPPORT_RENDER_TARGET ) == 0 )
		{
			DXST_ERRORLOG_ADD( _T( "gpł`\J[tH[}bg܂ł\n" ) ) ;
			return -1 ;
		}
		GD3D11.Device.Caps.TextureFormat[ DX_GRAPHICSIMAGE_FORMAT_3D_DRAWVALID_RGB16       ] = D_DXGI_FORMAT_R8G8B8A8_UNORM ;
		GD3D11.Device.Caps.TextureFormat[ DX_GRAPHICSIMAGE_FORMAT_3D_DRAWVALID_RGB32       ] = D_DXGI_FORMAT_R8G8B8A8_UNORM ;
		GD3D11.Device.Caps.TextureFormat[ DX_GRAPHICSIMAGE_FORMAT_3D_DRAWVALID_ALPHA_RGB32 ] = D_DXGI_FORMAT_R8G8B8A8_UNORM ;
		String = _T( "DXGI_FORMAT_R8G8B8A8_UNORM" ) ;
		DXST_ERRORLOGFMT_ADD(( _T( "`pJ[tH[}bg %s ł" ), String )) ;

		// `\ ARGB16rbg^J[tH[}bg̑I
		if( D3D11Device_CheckFormatSupport( D_DXGI_FORMAT_R16G16B16A16_UNORM, &FormatSupport ) == S_OK &&
			( FormatSupport & D_D3D11_FORMAT_SUPPORT_TEXTURE2D     ) != 0 &&
			( FormatSupport & D_D3D11_FORMAT_SUPPORT_RENDER_TARGET ) != 0 )
		{
			GD3D11.Device.Caps.TextureFormat[ DX_GRAPHICSIMAGE_FORMAT_3D_DRAWVALID_ABGR_I16 ] = D_DXGI_FORMAT_R16G16B16A16_UNORM ;
			String = _T( "DXGI_FORMAT_R16G16B16A16_UNORM" ) ;
		}
		else
		{
			DXST_ERRORLOG_ADD( _T( "gpł`pABGR16rbg^J[tH[}bg܂ł\n" ) ) ;
			GD3D11.Device.Caps.TextureFormat[ DX_GRAPHICSIMAGE_FORMAT_3D_DRAWVALID_ABGR_I16 ] = D_DXGI_FORMAT_UNKNOWN ;
		}

		if( GD3D11.Device.Caps.TextureFormat[ DX_GRAPHICSIMAGE_FORMAT_3D_DRAWVALID_ABGR_I16 ] != D_DXGI_FORMAT_UNKNOWN )
		{
			DXST_ERRORLOGFMT_ADD(( _T( "`pABGR16rbg^J[tH[}bg %s ł" ), String )) ;
		}

		// `\ ARGB_16rbg^J[tH[}bg̑I
		if( D3D11Device_CheckFormatSupport( D_DXGI_FORMAT_R16G16B16A16_FLOAT, &FormatSupport ) == S_OK &&
			( FormatSupport & D_D3D11_FORMAT_SUPPORT_TEXTURE2D     ) != 0 &&
			( FormatSupport & D_D3D11_FORMAT_SUPPORT_RENDER_TARGET ) != 0 )
		{
			GD3D11.Device.Caps.TextureFormat[ DX_GRAPHICSIMAGE_FORMAT_3D_DRAWVALID_ABGR_F16 ] = D_DXGI_FORMAT_R16G16B16A16_FLOAT ;
			String = _T( "DXGI_FORMAT_R16G16B16A16_FLOAT" ) ;
		}
		else
		{
			DXST_ERRORLOG_ADD( _T( "gpł`pABGR_16rbg^J[tH[}bg܂ł\n" ) ) ;
			GD3D11.Device.Caps.TextureFormat[ DX_GRAPHICSIMAGE_FORMAT_3D_DRAWVALID_ABGR_F16 ] = D_DXGI_FORMAT_UNKNOWN ;
		}

		if( GD3D11.Device.Caps.TextureFormat[ DX_GRAPHICSIMAGE_FORMAT_3D_DRAWVALID_ABGR_F16 ] != D_DXGI_FORMAT_UNKNOWN )
		{
			DXST_ERRORLOGFMT_ADD(( _T( "`pABGR_16rbg^J[tH[}bg %s ł" ), String )) ;
		}

		// `\ ARGB_32rbg^J[tH[}bg̑I
		if( D3D11Device_CheckFormatSupport( D_DXGI_FORMAT_R32G32B32A32_FLOAT, &FormatSupport ) == S_OK &&
			( FormatSupport & D_D3D11_FORMAT_SUPPORT_TEXTURE2D     ) != 0 &&
			( FormatSupport & D_D3D11_FORMAT_SUPPORT_RENDER_TARGET ) != 0 )
		{
			GD3D11.Device.Caps.TextureFormat[ DX_GRAPHICSIMAGE_FORMAT_3D_DRAWVALID_ABGR_F32 ] = D_DXGI_FORMAT_R32G32B32A32_FLOAT ;
			String = _T( "DXGI_FORMAT_R32G32B32A32_FLOAT" ) ;
		}
		else
		if( D3D11Device_CheckFormatSupport( D_DXGI_FORMAT_R16G16B16A16_FLOAT, &FormatSupport ) == S_OK &&
			( FormatSupport & D_D3D11_FORMAT_SUPPORT_TEXTURE2D     ) != 0 &&
			( FormatSupport & D_D3D11_FORMAT_SUPPORT_RENDER_TARGET ) != 0 )
		{
			GD3D11.Device.Caps.TextureFormat[ DX_GRAPHICSIMAGE_FORMAT_3D_DRAWVALID_ABGR_F32 ] = D_DXGI_FORMAT_R16G16B16A16_FLOAT ;
			String = _T( "DXGI_FORMAT_R16G16B16A16_FLOAT" ) ;
		}
		else
		{
			DXST_ERRORLOG_ADD( _T( "gpł`pABGR_32rbg^J[tH[}bg܂ł\n" ) ) ;
			GD3D11.Device.Caps.TextureFormat[ DX_GRAPHICSIMAGE_FORMAT_3D_DRAWVALID_ABGR_F32 ] = D_DXGI_FORMAT_UNKNOWN ;
		}

		if( GD3D11.Device.Caps.TextureFormat[ DX_GRAPHICSIMAGE_FORMAT_3D_DRAWVALID_ABGR_F32 ] != D_DXGI_FORMAT_UNKNOWN )
		{
			DXST_ERRORLOGFMT_ADD(( _T( "`pABGR_32rbg^J[tH[}bg %s ł" ), String )) ;
		}

		// `\ P`l8rbg^J[tH[}bg̑I
		if( D3D11Device_CheckFormatSupport( D_DXGI_FORMAT_R8_UNORM, &FormatSupport ) == S_OK &&
			( FormatSupport & D_D3D11_FORMAT_SUPPORT_TEXTURE2D     ) != 0 &&
			( FormatSupport & D_D3D11_FORMAT_SUPPORT_RENDER_TARGET ) != 0 )
		{
			GD3D11.Device.Caps.TextureFormat[ DX_GRAPHICSIMAGE_FORMAT_3D_DRAWVALID_ONE_I8 ] = D_DXGI_FORMAT_R8_UNORM ;
			String = _T( "DXGI_FORMAT_R8_UNORM" ) ;
		}
		else
		if( D3D11Device_CheckFormatSupport( D_DXGI_FORMAT_R8G8_UNORM, &FormatSupport ) == S_OK &&
			( FormatSupport & D_D3D11_FORMAT_SUPPORT_TEXTURE2D     ) != 0 &&
			( FormatSupport & D_D3D11_FORMAT_SUPPORT_RENDER_TARGET ) != 0 )
		{
			GD3D11.Device.Caps.TextureFormat[ DX_GRAPHICSIMAGE_FORMAT_3D_DRAWVALID_ONE_I8 ] = D_DXGI_FORMAT_R8G8_UNORM ;
			String = _T( "DXGI_FORMAT_R8G8_UNORM" ) ;
		}
		else
		if( D3D11Device_CheckFormatSupport( D_DXGI_FORMAT_R8G8B8A8_UNORM, &FormatSupport ) == S_OK &&
			( FormatSupport & D_D3D11_FORMAT_SUPPORT_TEXTURE2D     ) != 0 &&
			( FormatSupport & D_D3D11_FORMAT_SUPPORT_RENDER_TARGET ) != 0 )
		{
			GD3D11.Device.Caps.TextureFormat[ DX_GRAPHICSIMAGE_FORMAT_3D_DRAWVALID_ONE_I8 ] = D_DXGI_FORMAT_R8G8B8A8_UNORM ;
			String = _T( "DXGI_FORMAT_R8G8B8A8_UNORM" ) ;
		}
		else
		{
			DXST_ERRORLOG_ADD( _T( "gpł`pP`l8rbg^J[tH[}bg܂ł\n" ) ) ;
			GD3D11.Device.Caps.TextureFormat[ DX_GRAPHICSIMAGE_FORMAT_3D_DRAWVALID_ONE_I8 ] = D_DXGI_FORMAT_UNKNOWN ;
		}

		if( GD3D11.Device.Caps.TextureFormat[ DX_GRAPHICSIMAGE_FORMAT_3D_DRAWVALID_ONE_I8 ] != D_DXGI_FORMAT_UNKNOWN )
		{
			DXST_ERRORLOGFMT_ADD(( _T( "`pP`l8rbg^J[tH[}bg %s ł" ), String )) ;
		}

		// `\ P`l16rbg^J[tH[}bg̑I
		if( D3D11Device_CheckFormatSupport( D_DXGI_FORMAT_R16_UNORM, &FormatSupport ) == S_OK &&
			( FormatSupport & D_D3D11_FORMAT_SUPPORT_TEXTURE2D     ) != 0 &&
			( FormatSupport & D_D3D11_FORMAT_SUPPORT_RENDER_TARGET ) != 0 )
		{
			GD3D11.Device.Caps.TextureFormat[ DX_GRAPHICSIMAGE_FORMAT_3D_DRAWVALID_ONE_I16 ] = D_DXGI_FORMAT_R16_UNORM ;
			String = _T( "DXGI_FORMAT_R16_UNORM" ) ;
		}
		else
		if( D3D11Device_CheckFormatSupport( D_DXGI_FORMAT_R16G16_UNORM, &FormatSupport ) == S_OK &&
			( FormatSupport & D_D3D11_FORMAT_SUPPORT_TEXTURE2D     ) != 0 &&
			( FormatSupport & D_D3D11_FORMAT_SUPPORT_RENDER_TARGET ) != 0 )
		{
			GD3D11.Device.Caps.TextureFormat[ DX_GRAPHICSIMAGE_FORMAT_3D_DRAWVALID_ONE_I16 ] = D_DXGI_FORMAT_R16G16_UNORM ;
			String = _T( "DXGI_FORMAT_R16G16_UNORM" ) ;
		}
		else
		if( D3D11Device_CheckFormatSupport( D_DXGI_FORMAT_R16G16B16A16_UNORM, &FormatSupport ) == S_OK &&
			( FormatSupport & D_D3D11_FORMAT_SUPPORT_TEXTURE2D     ) != 0 &&
			( FormatSupport & D_D3D11_FORMAT_SUPPORT_RENDER_TARGET ) != 0 )
		{
			GD3D11.Device.Caps.TextureFormat[ DX_GRAPHICSIMAGE_FORMAT_3D_DRAWVALID_ONE_I16 ] = D_DXGI_FORMAT_R16G16B16A16_UNORM ;
			String = _T( "DXGI_FORMAT_R16G16B16A16_UNORM" ) ;
		}
		else
		{
			DXST_ERRORLOG_ADD( _T( "gpł`pP`l16rbg^J[tH[}bg܂ł\n" ) ) ;
			GD3D11.Device.Caps.TextureFormat[ DX_GRAPHICSIMAGE_FORMAT_3D_DRAWVALID_ONE_I16 ] = D_DXGI_FORMAT_UNKNOWN ;
		}

		if( GD3D11.Device.Caps.TextureFormat[ DX_GRAPHICSIMAGE_FORMAT_3D_DRAWVALID_ONE_I16 ] != D_DXGI_FORMAT_UNKNOWN )
		{
			DXST_ERRORLOGFMT_ADD(( _T( "`pP`l16rbg^J[tH[}bg %s ł" ), String )) ;
		}

		// `\ P`l_16rbg^J[tH[}bg̑I
		if( D3D11Device_CheckFormatSupport( D_DXGI_FORMAT_R16_FLOAT, &FormatSupport ) == S_OK &&
			( FormatSupport & D_D3D11_FORMAT_SUPPORT_TEXTURE2D     ) != 0 &&
			( FormatSupport & D_D3D11_FORMAT_SUPPORT_RENDER_TARGET ) != 0 )
		{
			GD3D11.Device.Caps.TextureFormat[ DX_GRAPHICSIMAGE_FORMAT_3D_DRAWVALID_ONE_F16 ] = D_DXGI_FORMAT_R16_FLOAT ;
			String = _T( "DXGI_FORMAT_R16_FLOAT" ) ;
		}
		else
		if( D3D11Device_CheckFormatSupport( D_DXGI_FORMAT_R16G16_FLOAT, &FormatSupport ) == S_OK &&
			( FormatSupport & D_D3D11_FORMAT_SUPPORT_TEXTURE2D     ) != 0 &&
			( FormatSupport & D_D3D11_FORMAT_SUPPORT_RENDER_TARGET ) != 0 )
		{
			GD3D11.Device.Caps.TextureFormat[ DX_GRAPHICSIMAGE_FORMAT_3D_DRAWVALID_ONE_F16 ] = D_DXGI_FORMAT_R16G16_FLOAT ;
			String = _T( "DXGI_FORMAT_R16G16_FLOAT" ) ;
		}
		else
		if( D3D11Device_CheckFormatSupport( D_DXGI_FORMAT_R16G16B16A16_FLOAT, &FormatSupport ) == S_OK &&
			( FormatSupport & D_D3D11_FORMAT_SUPPORT_TEXTURE2D     ) != 0 &&
			( FormatSupport & D_D3D11_FORMAT_SUPPORT_RENDER_TARGET ) != 0 )
		{
			GD3D11.Device.Caps.TextureFormat[ DX_GRAPHICSIMAGE_FORMAT_3D_DRAWVALID_ONE_F16 ] = D_DXGI_FORMAT_R16G16B16A16_FLOAT ;
			String = _T( "DXGI_FORMAT_R16G16B16A16_FLOAT" ) ;
		}
		else
		if( D3D11Device_CheckFormatSupport( D_DXGI_FORMAT_R32G32B32A32_FLOAT, &FormatSupport ) == S_OK &&
			( FormatSupport & D_D3D11_FORMAT_SUPPORT_TEXTURE2D     ) != 0 &&
			( FormatSupport & D_D3D11_FORMAT_SUPPORT_RENDER_TARGET ) != 0 )
		{
			GD3D11.Device.Caps.TextureFormat[ DX_GRAPHICSIMAGE_FORMAT_3D_DRAWVALID_ONE_F16 ] = D_DXGI_FORMAT_R32G32B32A32_FLOAT ;
			String = _T( "DXGI_FORMAT_R32G32B32A32_FLOAT" ) ;
		}
		else
		{
			DXST_ERRORLOG_ADD( _T( "gpł`pP`l_16rbg^J[tH[}bg܂ł\n" ) ) ;
			GD3D11.Device.Caps.TextureFormat[ DX_GRAPHICSIMAGE_FORMAT_3D_DRAWVALID_ONE_F16 ] = D_DXGI_FORMAT_UNKNOWN ;
		}

		if( GD3D11.Device.Caps.TextureFormat[ DX_GRAPHICSIMAGE_FORMAT_3D_DRAWVALID_ONE_F16 ] != D_DXGI_FORMAT_UNKNOWN )
		{
			DXST_ERRORLOGFMT_ADD(( _T( "`pP`l_16rbg^J[tH[}bg %s ł" ), String )) ;
		}

		// `\ P`l_32rbg^J[tH[}bg̑I
		if( D3D11Device_CheckFormatSupport( D_DXGI_FORMAT_R32_FLOAT, &FormatSupport ) == S_OK &&
			( FormatSupport & D_D3D11_FORMAT_SUPPORT_TEXTURE2D     ) != 0 &&
			( FormatSupport & D_D3D11_FORMAT_SUPPORT_RENDER_TARGET ) != 0 )
		{
			GD3D11.Device.Caps.TextureFormat[ DX_GRAPHICSIMAGE_FORMAT_3D_DRAWVALID_ONE_F32 ] = D_DXGI_FORMAT_R32_FLOAT ;
			String = _T( "DXGI_FORMAT_R32_FLOAT" ) ;
		}
		else
		if( D3D11Device_CheckFormatSupport( D_DXGI_FORMAT_R32G32_FLOAT, &FormatSupport ) == S_OK &&
			( FormatSupport & D_D3D11_FORMAT_SUPPORT_TEXTURE2D     ) != 0 &&
			( FormatSupport & D_D3D11_FORMAT_SUPPORT_RENDER_TARGET ) != 0 )
		{
			GD3D11.Device.Caps.TextureFormat[ DX_GRAPHICSIMAGE_FORMAT_3D_DRAWVALID_ONE_F32 ] = D_DXGI_FORMAT_R32G32_FLOAT ;
			String = _T( "DXGI_FORMAT_R32G32_FLOAT" ) ;
		}
		else
		if( D3D11Device_CheckFormatSupport( D_DXGI_FORMAT_R32G32B32A32_FLOAT, &FormatSupport ) == S_OK &&
			( FormatSupport & D_D3D11_FORMAT_SUPPORT_TEXTURE2D     ) != 0 &&
			( FormatSupport & D_D3D11_FORMAT_SUPPORT_RENDER_TARGET ) != 0 )
		{
			GD3D11.Device.Caps.TextureFormat[ DX_GRAPHICSIMAGE_FORMAT_3D_DRAWVALID_ONE_F32 ] = D_DXGI_FORMAT_R32G32B32A32_FLOAT ;
			String = _T( "DXGI_FORMAT_R32G32B32A32_FLOAT" ) ;
		}
		else
		if( D3D11Device_CheckFormatSupport( D_DXGI_FORMAT_R16G16B16A16_FLOAT, &FormatSupport ) == S_OK &&
			( FormatSupport & D_D3D11_FORMAT_SUPPORT_TEXTURE2D     ) != 0 &&
			( FormatSupport & D_D3D11_FORMAT_SUPPORT_RENDER_TARGET ) != 0 )
		{
			GD3D11.Device.Caps.TextureFormat[ DX_GRAPHICSIMAGE_FORMAT_3D_DRAWVALID_ONE_F32 ] = D_DXGI_FORMAT_R16G16B16A16_FLOAT ;
			String = _T( "DXGI_FORMAT_R16G16B16A16_FLOAT" ) ;
		}
		else
		{
			DXST_ERRORLOG_ADD( _T( "gpł`pP`l_32rbg^J[tH[}bg܂ł\n" ) ) ;
			GD3D11.Device.Caps.TextureFormat[ DX_GRAPHICSIMAGE_FORMAT_3D_DRAWVALID_ONE_F32 ] = D_DXGI_FORMAT_UNKNOWN ;
		}

		if( GD3D11.Device.Caps.TextureFormat[ DX_GRAPHICSIMAGE_FORMAT_3D_DRAWVALID_ONE_F32 ] != D_DXGI_FORMAT_UNKNOWN )
		{
			DXST_ERRORLOGFMT_ADD(( _T( "`pP`l_32rbg^J[tH[}bg %s ł" ), String )) ;
		}

		// `\ Q`l8rbg^J[tH[}bg̑I
		if( D3D11Device_CheckFormatSupport( D_DXGI_FORMAT_R8G8_UNORM, &FormatSupport ) == S_OK &&
			( FormatSupport & D_D3D11_FORMAT_SUPPORT_TEXTURE2D     ) != 0 &&
			( FormatSupport & D_D3D11_FORMAT_SUPPORT_RENDER_TARGET ) != 0 )
		{
			GD3D11.Device.Caps.TextureFormat[ DX_GRAPHICSIMAGE_FORMAT_3D_DRAWVALID_TWO_I8 ] = D_DXGI_FORMAT_R8G8_UNORM ;
			String = _T( "DXGI_FORMAT_R8G8_UNORM" ) ;
		}
		else
		if( D3D11Device_CheckFormatSupport( D_DXGI_FORMAT_R8G8B8A8_UNORM, &FormatSupport ) == S_OK &&
			( FormatSupport & D_D3D11_FORMAT_SUPPORT_TEXTURE2D     ) != 0 &&
			( FormatSupport & D_D3D11_FORMAT_SUPPORT_RENDER_TARGET ) != 0 )
		{
			GD3D11.Device.Caps.TextureFormat[ DX_GRAPHICSIMAGE_FORMAT_3D_DRAWVALID_TWO_I8 ] = D_DXGI_FORMAT_R8G8B8A8_UNORM ;
			String = _T( "DXGI_FORMAT_R8G8B8A8_UNORM" ) ;
		}
		else
		{
			DXST_ERRORLOG_ADD( _T( "gpł`pQ`l8rbg^J[tH[}bg܂ł\n" ) ) ;
			GD3D11.Device.Caps.TextureFormat[ DX_GRAPHICSIMAGE_FORMAT_3D_DRAWVALID_TWO_I8 ] = D_DXGI_FORMAT_UNKNOWN ;
		}

		if( GD3D11.Device.Caps.TextureFormat[ DX_GRAPHICSIMAGE_FORMAT_3D_DRAWVALID_TWO_I8 ] != D_DXGI_FORMAT_UNKNOWN )
		{
			DXST_ERRORLOGFMT_ADD(( _T( "`pQ`l8rbg^J[tH[}bg %s ł" ), String )) ;
		}

		// `\ Q`l16rbg^J[tH[}bg̑I
		if( D3D11Device_CheckFormatSupport( D_DXGI_FORMAT_R16G16_UNORM, &FormatSupport ) == S_OK &&
			( FormatSupport & D_D3D11_FORMAT_SUPPORT_TEXTURE2D     ) != 0 &&
			( FormatSupport & D_D3D11_FORMAT_SUPPORT_RENDER_TARGET ) != 0 )
		{
			GD3D11.Device.Caps.TextureFormat[ DX_GRAPHICSIMAGE_FORMAT_3D_DRAWVALID_TWO_I16 ] = D_DXGI_FORMAT_R16G16_UNORM ;
			String = _T( "DXGI_FORMAT_R16G16_UNORM" ) ;
		}
		else
		if( D3D11Device_CheckFormatSupport( D_DXGI_FORMAT_R16G16B16A16_UNORM, &FormatSupport ) == S_OK &&
			( FormatSupport & D_D3D11_FORMAT_SUPPORT_TEXTURE2D     ) != 0 &&
			( FormatSupport & D_D3D11_FORMAT_SUPPORT_RENDER_TARGET ) != 0 )
		{
			GD3D11.Device.Caps.TextureFormat[ DX_GRAPHICSIMAGE_FORMAT_3D_DRAWVALID_TWO_I16 ] = D_DXGI_FORMAT_R16G16B16A16_UNORM ;
			String = _T( "DXGI_FORMAT_R16G16B16A16_UNORM" ) ;
		}
		else
		{
			DXST_ERRORLOG_ADD( _T( "gpł`pQ`l16rbg^J[tH[}bg܂ł\n" ) ) ;
			GD3D11.Device.Caps.TextureFormat[ DX_GRAPHICSIMAGE_FORMAT_3D_DRAWVALID_TWO_I16 ] = D_DXGI_FORMAT_UNKNOWN ;
		}

		if( GD3D11.Device.Caps.TextureFormat[ DX_GRAPHICSIMAGE_FORMAT_3D_DRAWVALID_TWO_I16 ] != D_DXGI_FORMAT_UNKNOWN )
		{
			DXST_ERRORLOGFMT_ADD(( _T( "`pQ`l16rbg^J[tH[}bg %s ł" ), String )) ;
		}

		// `\ Q`l_16rbg^J[tH[}bg̑I
		if( D3D11Device_CheckFormatSupport( D_DXGI_FORMAT_R16G16_FLOAT, &FormatSupport ) == S_OK &&
			( FormatSupport & D_D3D11_FORMAT_SUPPORT_TEXTURE2D     ) != 0 &&
			( FormatSupport & D_D3D11_FORMAT_SUPPORT_RENDER_TARGET ) != 0 )
		{
			GD3D11.Device.Caps.TextureFormat[ DX_GRAPHICSIMAGE_FORMAT_3D_DRAWVALID_TWO_F16 ] = D_DXGI_FORMAT_R16G16_FLOAT ;
			String = _T( "DXGI_FORMAT_R16G16_FLOAT" ) ;
		}
		else
		if( D3D11Device_CheckFormatSupport( D_DXGI_FORMAT_R16G16B16A16_FLOAT, &FormatSupport ) == S_OK &&
			( FormatSupport & D_D3D11_FORMAT_SUPPORT_TEXTURE2D     ) != 0 &&
			( FormatSupport & D_D3D11_FORMAT_SUPPORT_RENDER_TARGET ) != 0 )
		{
			GD3D11.Device.Caps.TextureFormat[ DX_GRAPHICSIMAGE_FORMAT_3D_DRAWVALID_TWO_F16 ] = D_DXGI_FORMAT_R16G16B16A16_FLOAT ;
			String = _T( "DXGI_FORMAT_R16G16B16A16_FLOAT" ) ;
		}
		else
		if( D3D11Device_CheckFormatSupport( D_DXGI_FORMAT_R32G32B32A32_FLOAT, &FormatSupport ) == S_OK &&
			( FormatSupport & D_D3D11_FORMAT_SUPPORT_TEXTURE2D     ) != 0 &&
			( FormatSupport & D_D3D11_FORMAT_SUPPORT_RENDER_TARGET ) != 0 )
		{
			GD3D11.Device.Caps.TextureFormat[ DX_GRAPHICSIMAGE_FORMAT_3D_DRAWVALID_TWO_F16 ] = D_DXGI_FORMAT_R32G32B32A32_FLOAT ;
			String = _T( "DXGI_FORMAT_R32G32B32A32_FLOAT" ) ;
		}
		else
		{
			DXST_ERRORLOG_ADD( _T( "gpł`pQ`l_16rbg^J[tH[}bg܂ł\n" ) ) ;
			GD3D11.Device.Caps.TextureFormat[ DX_GRAPHICSIMAGE_FORMAT_3D_DRAWVALID_TWO_F16 ] = D_DXGI_FORMAT_UNKNOWN ;
		}

		if( GD3D11.Device.Caps.TextureFormat[ DX_GRAPHICSIMAGE_FORMAT_3D_DRAWVALID_TWO_F16 ] != D_DXGI_FORMAT_UNKNOWN )
		{
			DXST_ERRORLOGFMT_ADD(( _T( "`pQ`l_16rbg^J[tH[}bg %s ł" ), String )) ;
		}

		// `\ Q`l_32rbg^J[tH[}bg̑I
		if( D3D11Device_CheckFormatSupport( D_DXGI_FORMAT_R32G32_FLOAT, &FormatSupport ) == S_OK &&
			( FormatSupport & D_D3D11_FORMAT_SUPPORT_TEXTURE2D     ) != 0 &&
			( FormatSupport & D_D3D11_FORMAT_SUPPORT_RENDER_TARGET ) != 0 )
		{
			GD3D11.Device.Caps.TextureFormat[ DX_GRAPHICSIMAGE_FORMAT_3D_DRAWVALID_TWO_F32 ] = D_DXGI_FORMAT_R32G32_FLOAT ;
			String = _T( "DXGI_FORMAT_R32G32_FLOAT" ) ;
		}
		else
		if( D3D11Device_CheckFormatSupport( D_DXGI_FORMAT_R32G32B32A32_FLOAT, &FormatSupport ) == S_OK &&
			( FormatSupport & D_D3D11_FORMAT_SUPPORT_TEXTURE2D     ) != 0 &&
			( FormatSupport & D_D3D11_FORMAT_SUPPORT_RENDER_TARGET ) != 0 )
		{
			GD3D11.Device.Caps.TextureFormat[ DX_GRAPHICSIMAGE_FORMAT_3D_DRAWVALID_TWO_F32 ] = D_DXGI_FORMAT_R32G32B32A32_FLOAT ;
			String = _T( "DXGI_FORMAT_R32G32B32A32_FLOAT" ) ;
		}
		else
		if( D3D11Device_CheckFormatSupport( D_DXGI_FORMAT_R16G16B16A16_FLOAT, &FormatSupport ) == S_OK &&
			( FormatSupport & D_D3D11_FORMAT_SUPPORT_TEXTURE2D     ) != 0 &&
			( FormatSupport & D_D3D11_FORMAT_SUPPORT_RENDER_TARGET ) != 0 )
		{
			GD3D11.Device.Caps.TextureFormat[ DX_GRAPHICSIMAGE_FORMAT_3D_DRAWVALID_TWO_F32 ] = D_DXGI_FORMAT_R16G16B16A16_FLOAT ;
			String = _T( "DXGI_FORMAT_R16G16B16A16_FLOAT" ) ;
		}
		else
		{
			DXST_ERRORLOG_ADD( _T( "gpł`pQ`l_32rbg^J[tH[}bg܂ł\n" ) ) ;
			GD3D11.Device.Caps.TextureFormat[ DX_GRAPHICSIMAGE_FORMAT_3D_DRAWVALID_TWO_F32 ] = D_DXGI_FORMAT_UNKNOWN ;
		}

		if( GD3D11.Device.Caps.TextureFormat[ DX_GRAPHICSIMAGE_FORMAT_3D_DRAWVALID_TWO_F32 ] != D_DXGI_FORMAT_UNKNOWN )
		{
			DXST_ERRORLOGFMT_ADD(( _T( "`pQ`l_32rbg^J[tH[}bg %s ł" ), String )) ;
		}

		// }XNJ[obt@ptH[}bg̑I
		GD3D11.Device.Caps.MaskColorFormat = GSYS.Screen.MainScreenColorBitDepth == 32 ? GD3D11.Device.Caps.TextureFormat[ DX_GRAPHICSIMAGE_FORMAT_3D_DRAWVALID_RGB32 ] : GD3D11.Device.Caps.TextureFormat[ DX_GRAPHICSIMAGE_FORMAT_3D_DRAWVALID_RGB16 ] ;

		// }XNAt@tH[}bg̑I
		GD3D11.Device.Caps.MaskAlphaFormat = GSYS.Screen.MainScreenColorBitDepth == 32 ? GD3D11.Device.Caps.TextureFormat[ DX_GRAPHICSIMAGE_FORMAT_3D_ALPHATEST_RGB32 ] : GD3D11.Device.Caps.TextureFormat[ DX_GRAPHICSIMAGE_FORMAT_3D_ALPHATEST_RGB16 ] ;
	}

	// o
	{
		switch( GD3D11.Setting.FeatureLevel )
		{
		case D_D3D_FEATURE_LEVEL_9_1 :
			String = _T( "D3D_FEATURE_LEVEL_9_1" ) ;
			break ;

		case D_D3D_FEATURE_LEVEL_9_2 :
			String = _T( "D3D_FEATURE_LEVEL_9_2" ) ;
			break ;

		case D_D3D_FEATURE_LEVEL_9_3 :
			String = _T( "D3D_FEATURE_LEVEL_9_3" ) ;
			break ;

		case D_D3D_FEATURE_LEVEL_10_0 :
			String = _T( "D3D_FEATURE_LEVEL_10_0" ) ;
			break ;

		case D_D3D_FEATURE_LEVEL_10_1 :
			String = _T( "D3D_FEATURE_LEVEL_10_1" ) ;
			break ;

		case D_D3D_FEATURE_LEVEL_11_0 :
			String = _T( "D3D_FEATURE_LEVEL_11_0" ) ;
			break ;

		case D_D3D_FEATURE_LEVEL_11_1 :
			String = _T( "D3D_FEATURE_LEVEL_11_1" ) ;
			break ;
		}
		DXST_ERRORLOGFMT_ADD(( _T( "ΉĂ@\x:%s" ), String )) ;
//		DXST_ERRORLOGFMT_ADD(( _T( "ΉĂő咸_CfbNX:%d" ),     GSYS.HardInfo.MaxVertexIndex )) ;
		DXST_ERRORLOGFMT_ADD(( _T( "Ƀ_Ołobt@̐:%d" ), GSYS.HardInfo.RenderTargetNum )) ;
		DXST_ERRORLOGFMT_ADD(( _T( "őeNX`TCY@:%d :%d" ), GSYS.HardInfo.MaxTextureWidth, GSYS.HardInfo.MaxTextureHeight )) ;
	}

	// I
	return 0 ;
}





































// D3D11Device Xe[^X֌W

// `ݒtbV
extern	void	Graphics_D3D11_DeviceState_RefreshRenderState( void )
{
/*	if( Graphics_Hardware_CheckValid_PF() == 0 ) return ;

	// tO𗧂Ă
	GD3D11.Device.DrawSetting.CancelSettingEqualCheck = TRUE ;

	// Graphics_D3D11_DrawPreparation sׂtO𗧂Ă
	GD3D11.Device.DrawSetting.DrawPrepAlwaysFlag = TRUE ;

	// ݒ̃tbV
	Graphics_D3D11_DeviceState_SetFogEnable             ( GD3D11.Device.State.FogEnable           ) ;
	Graphics_D3D11_DeviceState_SetViewport              ( &GD3D11.Device.State.Viewport           ) ;
	Graphics_D3D11_DeviceState_SetScissorRect           ( &GD3D11.Device.State.ScissorRect        ) ;
	Graphics_D3D11_DrawSetting_SetTexture               ( GD3D11.Device.DrawSetting.RenderTexture ) ;
	Graphics_D3D11_DeviceState_SetBaseState             (                                        ) ;
	Graphics_D3D11_DeviceState_SetDrawMode              ( GD3D11.Device.State.DrawMode            ) ;
//	Graphics_D3D11_DrawSetting_SetDrawBlendMode         ( GD3D11.Device.DrawSetting.BlendMode, GD3D11.Device.DrawSetting.AlphaChannelValidFlag  ) ;
	Graphics_D3D11_DeviceState_RefreshBlendState        (                                        ) ;
	Graphics_D3D11_DeviceState_SetZEnable               ( GD3D11.Device.State.ZEnable             ) ;
	Graphics_D3D11_DeviceState_SetZWriteEnable          ( GD3D11.Device.State.ZWriteEnable        ) ;
	Graphics_D3D11_DeviceState_SetZFunc                 ( GD3D11.Device.State.ZFunc               ) ;
	Graphics_D3D11_DeviceState_SetDepthBias             ( GD3D11.Device.State.DepthBias           ) ;
	Graphics_D3D11_DeviceState_SetFillMode              ( GD3D11.Device.State.FillMode            ) ;
	Graphics_D3D11_DeviceState_SetCullMode              ( GD3D11.Device.State.CullMode            ) ;
	Graphics_D3D11_DeviceState_SetShadeMode             ( GD3D11.Device.State.ShadeMode           ) ;
	Graphics_D3D11_DeviceState_SetMaterial              ( &GD3D11.Device.State.Material           ) ;
	Graphics_D3D11_DeviceState_SetSpecularEnable        ( GD3D11.Device.State.UseSpecular         ) ;
	Graphics_D3D11_DeviceState_SetDiffuseMaterialSource ( GD3D11.Device.State.MaterialUseVertexDiffuseColor ) ;
	Graphics_D3D11_DeviceState_SetSpecularMaterialSource( GD3D11.Device.State.MaterialUseVertexSpecularColor ) ;

	if( Graphics_Hardware_CheckValid_PF() != 0 )
	{
		Direct3DDevice9_SetVertexShaderConstantF( 0, ( float * )GD3D11.Device.Shader.ShaderConstantInfo.FixInfo[ DX_SHADERCONSTANTTYPE_VS_FLOAT ].Float4, 256 ) ;
		Direct3DDevice9_SetVertexShaderConstantI( 0, ( int   * )GD3D11.Device.Shader.ShaderConstantInfo.FixInfo[ DX_SHADERCONSTANTTYPE_VS_INT   ].Int4,   16  ) ;
		Direct3DDevice9_SetVertexShaderConstantB( 0, ( BOOL  * )GD3D11.Device.Shader.ShaderConstantInfo.FixInfo[ DX_SHADERCONSTANTTYPE_VS_BOOL  ].Bool,   16  ) ;

		Direct3DDevice9_SetPixelShaderConstantF( 0, ( float * )GD3D11.Device.Shader.ShaderConstantInfo.FixInfo[ DX_SHADERCONSTANTTYPE_PS_FLOAT ].Float4, 224 ) ;
		Direct3DDevice9_SetPixelShaderConstantI( 0, ( int   * )GD3D11.Device.Shader.ShaderConstantInfo.FixInfo[ DX_SHADERCONSTANTTYPE_PS_INT   ].Int4,   16  ) ;
		Direct3DDevice9_SetPixelShaderConstantB( 0, ( BOOL  * )GD3D11.Device.Shader.ShaderConstantInfo.FixInfo[ DX_SHADERCONSTANTTYPE_PS_BOOL  ].Bool,   16  ) ;
	}

	// tO|
	GD3D11.Device.DrawSetting.CancelSettingEqualCheck = FALSE ;
*/
}

// Direct3DDevice11 ̊{ݒs
extern int Graphics_D3D11_DeviceState_SetBaseState( void )
{
	if( Graphics_Hardware_CheckValid_PF() == 0 ) return -1 ;

	GD3D11.Device.DrawSetting.CancelSettingEqualCheck = FALSE ;

	// o
	Graphics_D3D11_RenderVertex() ;

	// Tv[ݒăZbgAbv
	Graphics_D3D11_DeviceState_SetupSamplerState() ;

	// JOݒ
//	Direct3DDevice9_SetRenderState( D_D3DRS_CULLMODE, D_D3DCULL_NONE ) ;

	// fBUOnee
//	Direct3DDevice9_SetRenderState( D_D3DRS_DITHERENABLE, FALSE ) ;

	// I
	return 0 ;
}

// Tv[̃eNX`tB^O[hݒ肷
extern int Graphics_D3D11_DeviceState_SetSampleFilterMode( D_D3D11_FILTER Filter, int Sampler )
{
	int						i ;
	D_D3D11_SAMPLER_DESC	*SamplerDesc ;

	if( Graphics_Hardware_CheckValid_PF() == 0 )
	{
		return 0 ;
	}

	if( Sampler < 0 )
	{
		if( GD3D11.Device.DrawSetting.CancelSettingEqualCheck != FALSE )
		{
			SamplerDesc = GD3D11.Device.State.SamplerDesc ;
			for( i = 0 ; i < USE_TEXTURESTAGE_NUM ; i ++, SamplerDesc ++ )
			{
				if( SamplerDesc->Filter != Filter )
				{
					break ;
				}
			}
			if( i == USE_TEXTURESTAGE_NUM )
			{
				return 0 ;
			}
		}

		Graphics_D3D11_RenderVertex() ;

		SamplerDesc = GD3D11.Device.State.SamplerDesc ;
		for( i = 0 ; i < USE_TEXTURESTAGE_NUM ; i ++, SamplerDesc ++ )
		{
			if( SamplerDesc->Filter == Filter &&
				GD3D11.Device.DrawSetting.CancelSettingEqualCheck != FALSE )
			{
				continue ;
			}

			GD3D11.Device.State.ChangeSamplerDescSlot[ i ] = TRUE ;
			GD3D11.Device.State.ChangeSamplerDesc = TRUE ;

			SamplerDesc->Filter = Filter ;
		}
	}
	else
	{
		if( Sampler < 0 || Sampler >= USE_TEXTURESTAGE_NUM )
		{
			return 0 ;
		}

		SamplerDesc = &GD3D11.Device.State.SamplerDesc[ Sampler ] ;
		if( SamplerDesc->Filter == Filter &&
			GD3D11.Device.DrawSetting.CancelSettingEqualCheck == FALSE )
		{
			return 0 ;
		}

		Graphics_D3D11_RenderVertex() ;

		GD3D11.Device.State.ChangeSamplerDescSlot[ Sampler ] = TRUE ;
		GD3D11.Device.State.ChangeSamplerDesc = TRUE ;

		SamplerDesc->Filter = Filter ;
	}

	GD3D11.Device.DrawSetting.DrawPrepAlwaysFlag = TRUE ;

	return Graphics_D3D11_DeviceState_SetupSamplerState() ;
}

// [xobt@̗L̃Zbg
extern int Graphics_D3D11_DeviceState_SetDepthEnable( BOOL DepthEnable )
{
	if( Graphics_Hardware_CheckValid_PF() == 0 )
	{
		return 0 ;
	}

	// [h牽I
	if( GD3D11.Device.State.DepthStencilDesc.DepthEnable == DepthEnable &&
		GD3D11.Device.DrawSetting.CancelSettingEqualCheck == FALSE )
	{
		return 0 ;
	}
	
	Graphics_D3D11_RenderVertex() ;

	GD3D11.Device.State.ChangeDepthStencilDesc = TRUE ;

	GD3D11.Device.State.DepthStencilDesc.DepthEnable = DepthEnable ;

	GD3D9.Device.DrawSetting.DrawPrepAlwaysFlag = TRUE ;

	return Graphics_D3D11_DeviceState_SetupDepthStencilState() ;
}

// [xobt@݂̗̏LZbg
extern int Graphics_D3D11_DeviceState_SetDepthWriteEnable( int Flag )
{
	D_D3D11_DEPTH_WRITE_MASK DepthWriteMask ;

	if( Graphics_Hardware_CheckValid_PF() == 0 )
	{
		return 0 ;
	}

	DepthWriteMask = Flag == FALSE ? D_D3D11_DEPTH_WRITE_MASK_ZERO : D_D3D11_DEPTH_WRITE_MASK_ALL ;

	// [h牽I
	if( GD3D11.Device.State.DepthStencilDesc.DepthWriteMask == DepthWriteMask &&
		GD3D11.Device.DrawSetting.CancelSettingEqualCheck == FALSE )
	{
		return 0 ;
	}
	
	Graphics_D3D11_RenderVertex() ;

	GD3D11.Device.State.ChangeDepthStencilDesc = TRUE ;

	GD3D11.Device.State.DepthStencilDesc.DepthWriteMask = DepthWriteMask ;

	GD3D9.Device.DrawSetting.DrawPrepAlwaysFlag = TRUE ;

	return Graphics_D3D11_DeviceState_SetupDepthStencilState() ;
}

// [xl̔r^CvZbg
extern int Graphics_D3D11_DeviceState_SetDepthFunc( D_D3D11_COMPARISON_FUNC DepthFunc )
{
	if( Graphics_Hardware_CheckValid_PF() == 0 )
	{
		return 0 ;
	}

	// [h牽I
	if( GD3D11.Device.State.DepthStencilDesc.DepthFunc == DepthFunc &&
		GD3D11.Device.DrawSetting.CancelSettingEqualCheck == FALSE )
	{
		return 0 ;
	}
	
	Graphics_D3D11_RenderVertex() ;

	GD3D11.Device.State.ChangeDepthStencilDesc = TRUE ;

	GD3D11.Device.State.DepthStencilDesc.DepthFunc = DepthFunc ;

	GD3D9.Device.DrawSetting.DrawPrepAlwaysFlag = TRUE ;

	return Graphics_D3D11_DeviceState_SetupDepthStencilState() ;
}

// [xl̃oCAXZbg
extern int Graphics_D3D11_DeviceState_SetDepthBias( int DepthBias )
{
	if( Graphics_Hardware_CheckValid_PF() == 0 )
	{
		return 0 ;
	}

	// [h牽I
	if( GD3D11.Device.State.RasterizerDesc.DepthBias == DepthBias &&
		GD3D11.Device.DrawSetting.CancelSettingEqualCheck == FALSE )
	{
		return 0 ;
	}
	
	Graphics_D3D11_RenderVertex() ;

	GD3D11.Device.State.ChangeRasterizerDesc = TRUE ;

	GD3D11.Device.State.RasterizerDesc.DepthBias = DepthBias ;

	GD3D9.Device.DrawSetting.DrawPrepAlwaysFlag = TRUE ;

	return Graphics_D3D11_DeviceState_SetupRasterizerState() ;
}

// tB[hZbg
extern int Graphics_D3D11_DeviceState_SetFillMode( D_D3D11_FILL_MODE FillMode )
{
	if( Graphics_Hardware_CheckValid_PF() == 0 )
	{
		return 0 ;
	}

	// [h牽I
	if( GD3D11.Device.State.RasterizerDesc.FillMode == FillMode &&
		GD3D11.Device.DrawSetting.CancelSettingEqualCheck == FALSE )
	{
		return 0 ;
	}
	
	Graphics_D3D11_RenderVertex() ;

	GD3D11.Device.State.ChangeRasterizerDesc = TRUE ;

	GD3D11.Device.State.RasterizerDesc.FillMode = FillMode ;

	GD3D9.Device.DrawSetting.DrawPrepAlwaysFlag = TRUE ;

	return Graphics_D3D11_DeviceState_SetupRasterizerState() ;
}

// [hϊpsZbg
extern int Graphics_D3D11_DeviceState_SetWorldMatrix( const MATRIX *Matrix )
{
	DX_D3D11_VS_CONST_BUFFER_BASE *ConstantVSBase = ( DX_D3D11_VS_CONST_BUFFER_BASE * )GD3D11.Device.Shader.Constant.ConstBuffer_VS_Base->SysmemBuffer ;

	if( Graphics_Hardware_CheckValid_PF() == 0 )
	{
		return 0 ;
	}

	// 萔f[^ɔf
	ConstantVSBase->LocalWorldMatrix[ 0 ][ 0 ] = Matrix->m[ 0 ][ 0 ] ;
	ConstantVSBase->LocalWorldMatrix[ 0 ][ 1 ] = Matrix->m[ 1 ][ 0 ] ;
	ConstantVSBase->LocalWorldMatrix[ 0 ][ 2 ] = Matrix->m[ 2 ][ 0 ] ;
	ConstantVSBase->LocalWorldMatrix[ 0 ][ 3 ] = Matrix->m[ 3 ][ 0 ] ;
	ConstantVSBase->LocalWorldMatrix[ 1 ][ 0 ] = Matrix->m[ 0 ][ 1 ] ;
	ConstantVSBase->LocalWorldMatrix[ 1 ][ 1 ] = Matrix->m[ 1 ][ 1 ] ;
	ConstantVSBase->LocalWorldMatrix[ 1 ][ 2 ] = Matrix->m[ 2 ][ 1 ] ;
	ConstantVSBase->LocalWorldMatrix[ 1 ][ 3 ] = Matrix->m[ 3 ][ 1 ] ;
	ConstantVSBase->LocalWorldMatrix[ 2 ][ 0 ] = Matrix->m[ 0 ][ 2 ] ;
	ConstantVSBase->LocalWorldMatrix[ 2 ][ 1 ] = Matrix->m[ 1 ][ 2 ] ;
	ConstantVSBase->LocalWorldMatrix[ 2 ][ 2 ] = Matrix->m[ 2 ][ 2 ] ;
	ConstantVSBase->LocalWorldMatrix[ 2 ][ 3 ] = Matrix->m[ 3 ][ 2 ] ;

	GD3D11.Device.Shader.Constant.ConstBuffer_VS_Base->ChangeFlag = TRUE ;

	// 萔obt@XV
	Graphics_D3D11_ConstantBuffer_Update( GD3D11.Device.Shader.Constant.ConstBuffer_VS_Base ) ;

	// I
	return 0 ;
}

// r[ϊpsZbg
extern int Graphics_D3D11_DeviceState_SetViewMatrix( const MATRIX *Matrix )
{
	DX_D3D11_VS_CONST_BUFFER_BASE *ConstantVSBase = ( DX_D3D11_VS_CONST_BUFFER_BASE * )GD3D11.Device.Shader.Constant.ConstBuffer_VS_Base->SysmemBuffer ;

	if( Graphics_Hardware_CheckValid_PF() == 0 )
	{
		return 0 ;
	}

	// Cg̈ʒuE̍ČvZ
	{
		DX_D3D11_CONST_BUFFER_COMMON  *ConstantCommon = ( DX_D3D11_CONST_BUFFER_COMMON  * )GD3D11.Device.Shader.Constant.ConstBuffer_Common->SysmemBuffer ;
		DX_D3D11_CONST_LIGHT          *ConstantLight ;
		int                           i ;
		VECTOR                        Direction ;
		VECTOR                        Position ;

		ConstantLight = ConstantCommon->Light ;
		for( i = 0 ; i < DX_D3D11_COMMON_CONST_LIGHT_NUM ; i ++, ConstantLight ++ )
		{
			VectorTransformSR( &Direction, &GD3D11.Device.State.LightParam[ i ].Direction, Matrix ) ;
			VectorTransform(   &Position,  &GD3D11.Device.State.LightParam[ i ].Position,  Matrix ) ;
			ConstantLight->Position[ 0 ]  = Position.x ;
			ConstantLight->Position[ 1 ]  = Position.y ;
			ConstantLight->Position[ 2 ]  = Position.z ;
			ConstantLight->Direction[ 0 ] = Direction.x ;
			ConstantLight->Direction[ 1 ] = Direction.y ;
			ConstantLight->Direction[ 2 ] = Direction.z ;
		}

		GD3D11.Device.Shader.Constant.ConstBuffer_Common->ChangeFlag = TRUE ;

		// 萔obt@XV
		Graphics_D3D11_ConstantBuffer_Update( GD3D11.Device.Shader.Constant.ConstBuffer_Common ) ;
	}

	// 萔f[^ɔf
	ConstantVSBase->ViewMatrix[ 0 ][ 0 ] = Matrix->m[ 0 ][ 0 ] ;
	ConstantVSBase->ViewMatrix[ 0 ][ 1 ] = Matrix->m[ 1 ][ 0 ] ;
	ConstantVSBase->ViewMatrix[ 0 ][ 2 ] = Matrix->m[ 2 ][ 0 ] ;
	ConstantVSBase->ViewMatrix[ 0 ][ 3 ] = Matrix->m[ 3 ][ 0 ] ;
	ConstantVSBase->ViewMatrix[ 1 ][ 0 ] = Matrix->m[ 0 ][ 1 ] ;
	ConstantVSBase->ViewMatrix[ 1 ][ 1 ] = Matrix->m[ 1 ][ 1 ] ;
	ConstantVSBase->ViewMatrix[ 1 ][ 2 ] = Matrix->m[ 2 ][ 1 ] ;
	ConstantVSBase->ViewMatrix[ 1 ][ 3 ] = Matrix->m[ 3 ][ 1 ] ;
	ConstantVSBase->ViewMatrix[ 2 ][ 0 ] = Matrix->m[ 0 ][ 2 ] ;
	ConstantVSBase->ViewMatrix[ 2 ][ 1 ] = Matrix->m[ 1 ][ 2 ] ;
	ConstantVSBase->ViewMatrix[ 2 ][ 2 ] = Matrix->m[ 2 ][ 2 ] ;
	ConstantVSBase->ViewMatrix[ 2 ][ 3 ] = Matrix->m[ 3 ][ 2 ] ;

	GD3D11.Device.Shader.Constant.ConstBuffer_VS_Base->ChangeFlag = TRUE ;

	// 萔obt@XV
	Graphics_D3D11_ConstantBuffer_Update( GD3D11.Device.Shader.Constant.ConstBuffer_VS_Base ) ;

	// I
	return 0 ;
}

// eϊpsZbg
extern int Graphics_D3D11_DeviceState_SetProjectionMatrix( const MATRIX *Matrix )
{
	DX_D3D11_VS_CONST_BUFFER_BASE *ConstantVSBase = ( DX_D3D11_VS_CONST_BUFFER_BASE * )GD3D11.Device.Shader.Constant.ConstBuffer_VS_Base->SysmemBuffer ;

	if( Graphics_Hardware_CheckValid_PF() == 0 )
	{
		return 0 ;
	}

	// 萔f[^ɔf
	ConstantVSBase->ProjectionMatrix[ 0 ][ 0 ] = Matrix->m[ 0 ][ 0 ] ;
	ConstantVSBase->ProjectionMatrix[ 0 ][ 1 ] = Matrix->m[ 1 ][ 0 ] ;
	ConstantVSBase->ProjectionMatrix[ 0 ][ 2 ] = Matrix->m[ 2 ][ 0 ] ;
	ConstantVSBase->ProjectionMatrix[ 0 ][ 3 ] = Matrix->m[ 3 ][ 0 ] ;
	ConstantVSBase->ProjectionMatrix[ 1 ][ 0 ] = Matrix->m[ 0 ][ 1 ] ;
	ConstantVSBase->ProjectionMatrix[ 1 ][ 1 ] = Matrix->m[ 1 ][ 1 ] ;
	ConstantVSBase->ProjectionMatrix[ 1 ][ 2 ] = Matrix->m[ 2 ][ 1 ] ;
	ConstantVSBase->ProjectionMatrix[ 1 ][ 3 ] = Matrix->m[ 3 ][ 1 ] ;
	ConstantVSBase->ProjectionMatrix[ 2 ][ 0 ] = Matrix->m[ 0 ][ 2 ] ;
	ConstantVSBase->ProjectionMatrix[ 2 ][ 1 ] = Matrix->m[ 1 ][ 2 ] ;
	ConstantVSBase->ProjectionMatrix[ 2 ][ 2 ] = Matrix->m[ 2 ][ 2 ] ;
	ConstantVSBase->ProjectionMatrix[ 2 ][ 3 ] = Matrix->m[ 3 ][ 2 ] ;
	ConstantVSBase->ProjectionMatrix[ 3 ][ 0 ] = Matrix->m[ 0 ][ 3 ] ;
	ConstantVSBase->ProjectionMatrix[ 3 ][ 1 ] = Matrix->m[ 1 ][ 3 ] ;
	ConstantVSBase->ProjectionMatrix[ 3 ][ 2 ] = Matrix->m[ 2 ][ 3 ] ;
	ConstantVSBase->ProjectionMatrix[ 3 ][ 3 ] = Matrix->m[ 3 ][ 3 ] ;

	GD3D11.Device.Shader.Constant.ConstBuffer_VS_Base->ChangeFlag = TRUE ;

	// 萔obt@XV
	Graphics_D3D11_ConstantBuffer_Update( GD3D11.Device.Shader.Constant.ConstBuffer_VS_Base ) ;

	// I
	return 0 ;
}

// ArGgCgƃG~bVuJ[|킹p[^XV
extern void Graphics_D3D11_DeviceState_RefreshAmbientAndEmissiveParam( void )
{
	DX_D3D11_CONST_BUFFER_COMMON  *ConstantCommon = ( DX_D3D11_CONST_BUFFER_COMMON  * )GD3D11.Device.Shader.Constant.ConstBuffer_Common->SysmemBuffer ;
	DX_D3D11_CONST_LIGHT          *ConstantLight ;
	int                           i ;

	// LȃCg̃ArGgJ[ƃ}eÃArGgJ[ẐVF[_[ɃZbg
	ConstantLight = ConstantCommon->Light ;
	for( i = 0 ; i <= GD3D11.Device.State.LightEnableMaxIndex ; i ++, ConstantLight ++ )
	{
		if( GD3D11.Device.State.LightEnableFlag[ i ] == FALSE )
		{
			continue ;
		}

		// 萔obt@ɔf
		ConstantLight->Ambient[ 0 ] = GD3D11.Device.State.LightParam[ i ].Ambient.r * GD3D11.Device.State.Material.Ambient.r ;
		ConstantLight->Ambient[ 1 ] = GD3D11.Device.State.LightParam[ i ].Ambient.g * GD3D11.Device.State.Material.Ambient.g ;
		ConstantLight->Ambient[ 2 ] = GD3D11.Device.State.LightParam[ i ].Ambient.b * GD3D11.Device.State.Material.Ambient.b ;
		ConstantLight->Ambient[ 3 ] = GD3D11.Device.State.LightParam[ i ].Ambient.a * GD3D11.Device.State.Material.Ambient.a ;
	}

	// O[oArGgCgJ[ƃ}eAArGgJ[ẐƃG~bVuJ[Ẑ쐬
	ConstantCommon->Material.Ambient_Emissive[ 0 ] = GD3D11.Device.State.GlobalAmbientLightColor.r * GD3D11.Device.State.Material.Ambient.r + GD3D11.Device.State.Material.Emissive.r ;
	ConstantCommon->Material.Ambient_Emissive[ 1 ] = GD3D11.Device.State.GlobalAmbientLightColor.g * GD3D11.Device.State.Material.Ambient.g + GD3D11.Device.State.Material.Emissive.g ;
	ConstantCommon->Material.Ambient_Emissive[ 2 ] = GD3D11.Device.State.GlobalAmbientLightColor.b * GD3D11.Device.State.Material.Ambient.b + GD3D11.Device.State.Material.Emissive.b ;
	ConstantCommon->Material.Ambient_Emissive[ 3 ] = GD3D11.Device.State.GlobalAmbientLightColor.a * GD3D11.Device.State.Material.Ambient.a + GD3D11.Device.State.Material.Emissive.a ;

	GD3D11.Device.Shader.Constant.ConstBuffer_Common->ChangeFlag = TRUE ;		
}

// Cg̃Zbg
extern int Graphics_D3D11_DeviceState_SetLightState( int LightNumber, LIGHTPARAM *Light )
{
	DX_D3D11_CONST_BUFFER_COMMON  *ConstantCommon = ( DX_D3D11_CONST_BUFFER_COMMON  * )GD3D11.Device.Shader.Constant.ConstBuffer_Common->SysmemBuffer ;
	DX_D3D11_CONST_LIGHT          *ConstantLight ;
	VECTOR                        Direction ;
	VECTOR                        Position ;
	float                         ThetaSin ;
	float                         ThetaCos ;
	float                         PhiSin ;
	float                         PhiCos ;

	if( Graphics_Hardware_CheckValid_PF() == 0 )
	{
		return 0 ;
	}

	if( LightNumber < 0 || LightNumber >= DX_D3D11_COMMON_CONST_LIGHT_NUM )
	{
		return -1 ;
	}

	if( _MEMCMP( &GD3D11.Device.State.LightParam[ LightNumber ], Light, sizeof( LIGHTPARAM ) ) == 0 &&
		GD3D11.Device.DrawSetting.CancelSettingEqualCheck == FALSE )
	{
		return 0 ;
	}

	Graphics_D3D11_RenderVertex() ;

	// p[^̕ۑ
	GD3D11.Device.State.LightParam[ LightNumber ] = *Light ;

	// 萔f[^ɔf
	ConstantLight = &ConstantCommon->Light[ LightNumber ] ;

	_SINCOS( Light->Theta / 2.0f, &ThetaSin, &ThetaCos ) ;
	_SINCOS( Light->Phi   / 2.0f, &PhiSin,   &PhiCos ) ;

	VectorTransformSR( &Direction, &Light->Direction, &GSYS.DrawSetting.ViewMatrix ) ;
	VectorTransform(   &Position,  &Light->Position,  &GSYS.DrawSetting.ViewMatrix ) ;
	ConstantLight->Position[ 0 ]  = Position.x ;
	ConstantLight->Position[ 1 ]  = Position.y ;
	ConstantLight->Position[ 2 ]  = Position.z ;
	ConstantLight->Range          = Light->Range ;
	ConstantLight->Direction[ 0 ] = Direction.x ;
	ConstantLight->Direction[ 1 ] = Direction.y ;
	ConstantLight->Direction[ 2 ] = Direction.z ;
	ConstantLight->FallOff        = Light->Falloff ;
	ConstantLight->Diffuse[ 0 ]   = Light->Diffuse.r ;
	ConstantLight->Diffuse[ 1 ]   = Light->Diffuse.g ;
	ConstantLight->Diffuse[ 2 ]   = Light->Diffuse.b ;
	ConstantLight->SpotParam0     = PhiCos ;
	ConstantLight->Specular[ 0 ]  = Light->Specular.r ;
	ConstantLight->Specular[ 1 ]  = Light->Specular.g ;
	ConstantLight->Specular[ 2 ]  = Light->Specular.b ;
	ConstantLight->SpotParam1     = 1.0f / ( ThetaCos - PhiCos ) ;
	ConstantLight->Ambient[ 0 ]   = Light->Ambient.r ;
	ConstantLight->Ambient[ 1 ]   = Light->Ambient.g ;
	ConstantLight->Ambient[ 2 ]   = Light->Ambient.b ;
	ConstantLight->Ambient[ 3 ]   = Light->Ambient.a ;
	ConstantLight->Attenuation0   = Light->Attenuation0 ;
	ConstantLight->Attenuation1   = Light->Attenuation1 ;
	ConstantLight->Attenuation2   = Light->Attenuation2 ;
	GD3D11.Device.Shader.Constant.ConstBuffer_Common->ChangeFlag = TRUE ;

	// ArGgJ[ƃG~bVuJ[|킹XV
	Graphics_D3D11_DeviceState_RefreshAmbientAndEmissiveParam() ;

	// 萔obt@XV
	Graphics_D3D11_ConstantBuffer_Update( GD3D11.Device.Shader.Constant.ConstBuffer_Common ) ;

	// I
	return 0 ;
}

// Cg̗LAύX
extern int Graphics_D3D11_DeviceState_SetLightEnable( int LightNumber, int EnableState )
{
	if( Graphics_Hardware_CheckValid_PF() == 0 )
	{
		return 0 ;
	}

	if( LightNumber < 0 || LightNumber >= DX_D3D11_COMMON_CONST_LIGHT_NUM )
	{
		return -1 ;
	}

	if( GD3D11.Device.State.LightEnableFlag[ LightNumber ] == EnableState &&
		GD3D11.Device.DrawSetting.CancelSettingEqualCheck == FALSE )
	{
		return 0 ;
	}

	Graphics_D3D11_RenderVertex() ;

	GD3D11.Device.State.LightEnableFlag[ LightNumber ] = EnableState ;

	// LȃCg̍őCfbNXXV
	if( EnableState == TRUE )
	{
		if( GD3D11.Device.State.LightEnableMaxIndex < LightNumber )
			GD3D11.Device.State.LightEnableMaxIndex = LightNumber ;
	}
	else
	{
		if( GD3D11.Device.State.LightEnableMaxIndex == LightNumber )
		{
			int i ;

			for( i = LightNumber ; i > 0 && GD3D11.Device.State.LightEnableFlag[ i ] == FALSE ; i -- ){}
			GD3D11.Device.State.LightEnableMaxIndex = i ;
		}
	}

	// ArGgJ[ƃG~bVuJ[|킹XV
	Graphics_D3D11_DeviceState_RefreshAmbientAndEmissiveParam() ;

	// 萔obt@XV
	Graphics_D3D11_ConstantBuffer_Update( GD3D11.Device.Shader.Constant.ConstBuffer_Common ) ;

	GD3D11.Device.DrawSetting.DrawPrepAlwaysFlag = TRUE ;

	// I
	return 0 ;
}

// }eÃZbg
extern int Graphics_D3D11_DeviceState_SetMaterial( MATERIALPARAM *Material )
{
	DX_D3D11_CONST_BUFFER_COMMON *ConstantCommon = ( DX_D3D11_CONST_BUFFER_COMMON * )GD3D11.Device.Shader.Constant.ConstBuffer_Common->SysmemBuffer ;

	if( Graphics_Hardware_CheckValid_PF() == 0 )
	{
		return 0 ;
	}

	if( _MEMCMP( Material, &GD3D11.Device.State.Material, sizeof( MATERIALPARAM ) ) == 0 &&
		GD3D11.Device.DrawSetting.CancelSettingEqualCheck == FALSE )
	{
		return 0 ;
	}

	Graphics_D3D11_RenderVertex() ;

	GD3D11.Device.State.Material = *Material ;

	// 萔f[^ɔf
	ConstantCommon->Material.Diffuse[ 0 ]  = Material->Diffuse.r ;
	ConstantCommon->Material.Diffuse[ 1 ]  = Material->Diffuse.g ;
	ConstantCommon->Material.Diffuse[ 2 ]  = Material->Diffuse.b ;
	ConstantCommon->Material.Diffuse[ 3 ]  = Material->Diffuse.a ;
	ConstantCommon->Material.Specular[ 0 ] = Material->Specular.r ;
	ConstantCommon->Material.Specular[ 1 ] = Material->Specular.g ;
	ConstantCommon->Material.Specular[ 2 ] = Material->Specular.b ;
	ConstantCommon->Material.Specular[ 3 ] = Material->Specular.a ;
	ConstantCommon->Material.Power         = Material->Power ;
	GD3D11.Device.Shader.Constant.ConstBuffer_Common->ChangeFlag = TRUE ;

	// ArGgJ[ƃG~bVuJ[|킹XV
	Graphics_D3D11_DeviceState_RefreshAmbientAndEmissiveParam() ;

	// 萔obt@XV
	Graphics_D3D11_ConstantBuffer_Update( GD3D11.Device.Shader.Constant.ConstBuffer_Common ) ;

	GD3D11.Device.DrawSetting.DrawPrepAlwaysFlag = TRUE ;

	// I
	return 0 ;
}

// XyLgp邩ǂZbg
extern int Graphics_D3D11_DeviceState_SetSpecularEnable( int UseFlag )
{
	if( Graphics_Hardware_CheckValid_PF() == 0 )
	{
		return 0 ;
	}

	// ̃p[^Ɠꍇ͉Ȃ
	if( GD3D11.Device.State.UseSpecular == UseFlag &&
		GD3D11.Device.DrawSetting.CancelSettingEqualCheck == FALSE )
	{
		return 0 ;
	}

	Graphics_D3D11_RenderVertex() ;

	GD3D11.Device.State.UseSpecular = UseFlag ;

	GD3D11.Device.DrawSetting.DrawPrepAlwaysFlag = TRUE ;

	// I
	return 0 ;
}

// _̃fBt[YJ[}eÃfBt[YJ[ƂĎgp邩ǂݒ肷
extern int Graphics_D3D11_DeviceState_SetUseVertexDiffuseColor( int UseFlag )
{
	DX_D3D11_VS_CONST_BUFFER_BASE *ConstantVSBase = ( DX_D3D11_VS_CONST_BUFFER_BASE * )GD3D11.Device.Shader.Constant.ConstBuffer_VS_Base->SysmemBuffer ;

	if( Graphics_Hardware_CheckValid_PF() == 0 )
	{
		return 0 ;
	}

	if( UseFlag == GD3D11.Device.State.MaterialUseVertexDiffuseColor &&
		GD3D11.Device.DrawSetting.CancelSettingEqualCheck == FALSE )
	{
		return 0 ;
	}

	Graphics_D3D11_RenderVertex() ;

	// 萔f[^ɔf
	ConstantVSBase->DiffuseSource = UseFlag ? 1.0f : 0.0f ;
	GD3D11.Device.Shader.Constant.ConstBuffer_VS_Base->ChangeFlag = TRUE ;

	// 萔obt@XV
	Graphics_D3D11_ConstantBuffer_Update( GD3D11.Device.Shader.Constant.ConstBuffer_VS_Base ) ;

	GD3D11.Device.State.MaterialUseVertexDiffuseColor = UseFlag ;

	GD3D11.Device.DrawSetting.DrawPrepAlwaysFlag = TRUE ;

	// I
	return 0 ;
}

// _̃XyLJ[}eÃXyLJ[ƂĎgp邩ǂݒ肷
extern int Graphics_D3D11_DeviceState_SetUseVertexSpecularColor( int UseFlag )
{
	DX_D3D11_VS_CONST_BUFFER_BASE *ConstantVSBase = ( DX_D3D11_VS_CONST_BUFFER_BASE * )GD3D11.Device.Shader.Constant.ConstBuffer_VS_Base->SysmemBuffer ;

	if( Graphics_Hardware_CheckValid_PF() == 0 )
	{
		return 0 ;
	}

	if( UseFlag == GD3D11.Device.State.MaterialUseVertexSpecularColor &&
		GD3D11.Device.DrawSetting.CancelSettingEqualCheck == FALSE )
	{
		return 0 ;
	}

	Graphics_D3D11_RenderVertex() ;

	// 萔f[^ɔf
	ConstantVSBase->SpecularSource = UseFlag ? 1.0f : 0.0f ;
	GD3D11.Device.Shader.Constant.ConstBuffer_VS_Base->ChangeFlag = TRUE ;

	// 萔obt@XV
	Graphics_D3D11_ConstantBuffer_Update( GD3D11.Device.Shader.Constant.ConstBuffer_VS_Base ) ;

	GD3D11.Device.State.MaterialUseVertexSpecularColor = UseFlag ;

	GD3D11.Device.DrawSetting.DrawPrepAlwaysFlag = TRUE ;

	// I
	return 0 ;
}

// JO̗LZbg 
extern int Graphics_D3D11_DeviceState_SetCullMode( int State )
{
	D_D3D11_CULL_MODE D3DCullMode ;

	if( Graphics_Hardware_CheckValid_PF() == 0 )
	{
		return 0 ;
	}

	switch( State )
	{
	case 0 :
	default :
		D3DCullMode = D_D3D11_CULL_NONE ;
		break ;

	case 1 :
		D3DCullMode = D_D3D11_CULL_BACK ;
		break ;

	case 2 :
		D3DCullMode = D_D3D11_CULL_FRONT ;
		break ;
	}

	// [h牽I
	if( GD3D11.Device.State.RasterizerDesc.CullMode == D3DCullMode &&
		GD3D11.Device.DrawSetting.CancelSettingEqualCheck == FALSE )
	{
		return 0 ;
	}
	
	Graphics_D3D11_RenderVertex() ;

	GD3D11.Device.State.ChangeRasterizerDesc = TRUE ;

	GD3D11.Device.State.RasterizerDesc.CullMode = D3DCullMode ;

	GD3D9.Device.DrawSetting.DrawPrepAlwaysFlag = TRUE ;

	return Graphics_D3D11_DeviceState_SetupRasterizerState() ;
}

// ArGgJ[̃Zbg
extern int Graphics_D3D11_DeviceState_SetAmbient( COLOR_F *Color )
{
	DX_D3D11_CONST_BUFFER_COMMON *ConstantCommon = ( DX_D3D11_CONST_BUFFER_COMMON * )GD3D11.Device.Shader.Constant.ConstBuffer_Common->SysmemBuffer ;

	if( Graphics_Hardware_CheckValid_PF() == 0 )
	{
		return 0 ;
	}

	if( _MEMCMP( Color, &GD3D11.Device.State.GlobalAmbientLightColor, sizeof( COLOR_F ) ) == 0 &&
		GD3D11.Device.DrawSetting.CancelSettingEqualCheck == FALSE )
	{
		return 0 ;
	}

	Graphics_D3D11_RenderVertex() ;

	GD3D11.Device.State.GlobalAmbientLightColor = *Color ;

	// ArGgJ[ƃG~bVuJ[|킹XV
	Graphics_D3D11_DeviceState_RefreshAmbientAndEmissiveParam() ;

	// 萔obt@XV
	Graphics_D3D11_ConstantBuffer_Update( GD3D11.Device.Shader.Constant.ConstBuffer_Common ) ;

	GD3D11.Device.DrawSetting.DrawPrepAlwaysFlag = TRUE ;

	// I
	return 0 ;
}

// O̃tB^[^Cv D_D3D11_FILTER 擾
static D_D3D11_FILTER Graphics_D3D11_DeviceState_GetFilter( int MinFilter /* DX_DRAWMODE_NEAREST  */, int MagFilter, int MipFilter )
{
	if( MagFilter == DX_DRAWMODE_ANISOTROPIC ||
		MinFilter == DX_DRAWMODE_ANISOTROPIC ||
		MipFilter == DX_DRAWMODE_ANISOTROPIC )
	{
		return D_D3D11_FILTER_ANISOTROPIC ;
	}
	else
	{
		// 0:Point  1:Linear
		static D_D3D11_FILTER FilterTable[ 2 /* Min */ ][ 2 /* Mag */ ][ 2 /* Mip */ ] =
		{
			{
				{
					D_D3D11_FILTER_MIN_MAG_MIP_POINT,
					D_D3D11_FILTER_MIN_MAG_POINT_MIP_LINEAR
				},

				{
					D_D3D11_FILTER_MIN_POINT_MAG_LINEAR_MIP_POINT,
					D_D3D11_FILTER_MIN_POINT_MAG_MIP_LINEAR,
				},
			},

			{
				{
					D_D3D11_FILTER_MIN_LINEAR_MAG_MIP_POINT,
					D_D3D11_FILTER_MIN_LINEAR_MAG_POINT_MIP_LINEAR
				},

				{
					D_D3D11_FILTER_MIN_MAG_LINEAR_MIP_POINT,
					D_D3D11_FILTER_MIN_MAG_MIP_LINEAR,
				},
			},
		} ;

		return FilterTable[ MinFilter != DX_DRAWMODE_NEAREST ? 1 : 0 ][ MagFilter != DX_DRAWMODE_NEAREST ? 1 : 0 ][ MipFilter != DX_DRAWMODE_NEAREST ? 1 : 0 ] ;
	}
}

// ݂̐ݒɊÂ ID3D11SamplerState ZbgAbv
static int Graphics_D3D11_DeviceState_SetupSamplerState( void )
{
	int                     i ;
	int                     SetLength ;
	D_D3D11_SAMPLER_DESC	*SamplerDesc ;
	D_ID3D11SamplerState	*NewSamplerState ;
	D_ID3D11SamplerState	**DefaultSamplerState ;
	HRESULT                 hr ;
	static int				DefaultFilterIndexTableInitialize = FALSE ;
	static int				DefaultFilterIndexTable[ D_D3D11_FILTER_ANISOTROPIC + 1 ] ;

	// D_D3D11_FILTER CfbNX擾邽߂̃e[uĂȂꍇ͏
	if( DefaultFilterIndexTableInitialize == FALSE )
	{
		DefaultFilterIndexTableInitialize = TRUE ;

		DefaultFilterIndexTable[ D_D3D11_FILTER_MIN_MAG_MIP_POINT                          ] = 0 ;
		DefaultFilterIndexTable[ D_D3D11_FILTER_MIN_MAG_POINT_MIP_LINEAR                   ] = 1 ;
		DefaultFilterIndexTable[ D_D3D11_FILTER_MIN_POINT_MAG_LINEAR_MIP_POINT             ] = 2 ;
		DefaultFilterIndexTable[ D_D3D11_FILTER_MIN_POINT_MAG_MIP_LINEAR                   ] = 3 ;
		DefaultFilterIndexTable[ D_D3D11_FILTER_MIN_LINEAR_MAG_MIP_POINT                   ] = 4 ;
		DefaultFilterIndexTable[ D_D3D11_FILTER_MIN_LINEAR_MAG_POINT_MIP_LINEAR            ] = 5 ;
		DefaultFilterIndexTable[ D_D3D11_FILTER_MIN_MAG_LINEAR_MIP_POINT                   ] = 6 ;
		DefaultFilterIndexTable[ D_D3D11_FILTER_MIN_MAG_MIP_LINEAR                         ] = 7 ;
		DefaultFilterIndexTable[ D_D3D11_FILTER_ANISOTROPIC                                ] = 8 ;
		DefaultFilterIndexTable[ D_D3D11_FILTER_COMPARISON_MIN_MAG_MIP_POINT               ] = 9 ;
		DefaultFilterIndexTable[ D_D3D11_FILTER_COMPARISON_MIN_MAG_POINT_MIP_LINEAR        ] = 10 ;
		DefaultFilterIndexTable[ D_D3D11_FILTER_COMPARISON_MIN_POINT_MAG_LINEAR_MIP_POINT  ] = 11 ;
		DefaultFilterIndexTable[ D_D3D11_FILTER_COMPARISON_MIN_POINT_MAG_MIP_LINEAR        ] = 12 ;
		DefaultFilterIndexTable[ D_D3D11_FILTER_COMPARISON_MIN_LINEAR_MAG_MIP_POINT        ] = 13 ;
		DefaultFilterIndexTable[ D_D3D11_FILTER_COMPARISON_MIN_LINEAR_MAG_POINT_MIP_LINEAR ] = 14 ;
		DefaultFilterIndexTable[ D_D3D11_FILTER_COMPARISON_MIN_MAG_LINEAR_MIP_POINT        ] = 15 ;
		DefaultFilterIndexTable[ D_D3D11_FILTER_COMPARISON_MIN_MAG_MIP_LINEAR              ] = 16 ;
		DefaultFilterIndexTable[ D_D3D11_FILTER_COMPARISON_ANISOTROPIC                     ] = 17 ;
	}

	// ݒɕύXꍇ͉ɏI
	if( GD3D11.Device.State.ChangeSamplerDesc == FALSE &&
		GD3D11.Device.DrawSetting.CancelSettingEqualCheck != FALSE )
	{
		return 0 ;
	}

	// ύXǂ̃tO|
	GD3D11.Device.State.ChangeSamplerDesc = FALSE ;

	// Tv[Xbg̐JԂ
	SamplerDesc = GD3D11.Device.State.SamplerDesc ;
	SetLength     = 0 ;
	for( i = 0 ; i < USE_TEXTURESTAGE_NUM ; i ++, SamplerDesc ++ )
	{
		// ݒlɕύXAKĐݒstO|Ă玟̃[v
		if( GD3D11.Device.State.ChangeSamplerDescSlot[ i ] == FALSE &&
			GD3D11.Device.DrawSetting.CancelSettingEqualCheck == FALSE )
		{
			// ύXݒ̐Oł͂Ȃꍇ̓Tv[Xe[gfoCXReLXgɐݒ肷
			if( SetLength > 0 )
			{
				D3D11DeviceContext_PSSetSamplers( i - SetLength, SetLength, &GD3D11.Device.State.SamplerState[ i - SetLength ] ) ;
				SetLength = 0 ;
			}
			continue ;
		}

		// ύXǂ̃tO|
		GD3D11.Device.State.ChangeSamplerDescSlot[ i ] = FALSE ;

		// ݐݒ肳ĂTv[ꍇ͉
		if( GD3D11.Device.State.SamplerState[ i ] != NULL )
		{
			// ݂̐ݒύXۂɃTv[Xe[g[XwɂȂĂ烊[X
			if( GD3D11.Device.State.ChangeSamplerStateReleaseFlag[ i ] )
			{
				Direct3D11_ObjectRelease( GD3D11.Device.State.SamplerState[ i ] ) ;
			}

			GD3D11.Device.State.SamplerState[ i ] = NULL ;
		}

		// ݒύXۂɃTv[Xe[g[X邩ǂ̃tO|
		GD3D11.Device.State.ChangeSamplerStateReleaseFlag[ i ] = FALSE ;

		// 悭gݒ̃Tv[Xe[gǂ𔻒肷
		if(	SamplerDesc->MipLODBias       != 0.0f ||
			SamplerDesc->MaxAnisotropy    != 16 ||
			SamplerDesc->ComparisonFunc   != D_D3D11_COMPARISON_ALWAYS ||
			SamplerDesc->BorderColor[ 0 ] != 0.0f ||
			SamplerDesc->BorderColor[ 1 ] != 0.0f ||
			SamplerDesc->BorderColor[ 2 ] != 0.0f ||
			SamplerDesc->BorderColor[ 3 ] != 0.0f ||
			SamplerDesc->MinLOD           != -D_D3D11_FLOAT32_MAX ||
			SamplerDesc->MaxLOD           !=  D_D3D11_FLOAT32_MAX )
		{
			// 悭gݒ̃Tv[Xe[gł͂Ȃꍇ͂ŃTv[Xe[g쐬
			hr = D3D11Device_CreateSamplerState( SamplerDesc, &NewSamplerState ) ;
			if( hr != S_OK )
			{
				DXST_ERRORLOGFMT_ADD( ( _T( "ID3D11SamplerState ̍쐬Ɏs܂@ӏP\n" ) ) ) ;
				return -1 ;
			}

			// 쐬Tv[Xe[gݒ
			GD3D11.Device.State.SamplerState[ i ] = NewSamplerState ;

			// ̃Tv[Xe[g͈ꎞIȂ̂Ȃ̂ŁAIɃ[X悤ɂ
			GD3D11.Device.State.ChangeSamplerStateReleaseFlag[ i ] = TRUE ;
		}
		else
		{
			// 悭gݒ̃Tv[Xe[g̏ꍇ

			// ŵ悭gݒ̃Tv[Xe[g܂쐬ĂȂ쐬
			DefaultSamplerState = &GD3D11.Device.State.DefaultSamplerStateArray[ DefaultFilterIndexTable[ SamplerDesc->Filter ] ][ SamplerDesc->AddressU ][ SamplerDesc->AddressV ][ SamplerDesc->AddressW ] ;
			if( *DefaultSamplerState == NULL )
			{
				hr = D3D11Device_CreateSamplerState( SamplerDesc, &NewSamplerState ) ;
				if( hr != S_OK )
				{
					DXST_ERRORLOGFMT_ADD( ( _T( "ID3D11SamplerState ̍쐬Ɏs܂@ӏQ\n" ) ) ) ;
					return -1 ;
				}
				*DefaultSamplerState = NewSamplerState ;
			}

			// 悭gݒ̃Tv[Xe[gݒ
			GD3D11.Device.State.SamplerState[ i ] = *DefaultSamplerState ;
		}

		// ύXݒ̐CNg
		SetLength ++ ;
	}

	// ύXݒ̐Oł͂Ȃꍇ̓Tv[Xe[gfoCXReLXgɐݒ肷
	if( SetLength > 0 )
	{
		D3D11DeviceContext_PSSetSamplers( i - SetLength, SetLength, &GD3D11.Device.State.SamplerState[ i - SetLength ] ) ;
		SetLength = 0 ;
	}

	// I
	return 0 ;
}

// ID3D11SamplerState 
static int Graphics_D3D11_DeviceState_TerminateSamplerState( void )
{
	int i ;

	GD3D11.Device.State.ChangeSamplerDesc = FALSE ;

	_MEMSET( GD3D11.Device.State.ChangeSamplerDescSlot, 0, sizeof( GD3D11.Device.State.ChangeSamplerDescSlot ) ) ;
	_MEMSET( GD3D11.Device.State.SamplerDesc, 0, sizeof( GD3D11.Device.State.SamplerDesc ) ) ;

	for( i = 0 ; i < USE_TEXTURESTAGE_NUM ; i ++ )
	{
		if( GD3D11.Device.State.SamplerState[ i ] == NULL )
		{
			continue ;
		}

		if( GD3D11.Device.State.ChangeSamplerStateReleaseFlag[ i ] )
		{
			Direct3D11_ObjectRelease( GD3D11.Device.State.SamplerState[ i ] ) ;
			GD3D11.Device.State.ChangeSamplerStateReleaseFlag[ i ] = FALSE ;
		}
		GD3D11.Device.State.SamplerState[ i ] = NULL ;
	}

	Graphics_D3D11_ObjectArray_Release( ( void ** )GD3D11.Device.State.DefaultSamplerStateArray, sizeof( GD3D11.Device.State.DefaultSamplerStateArray ) / sizeof( void * ) ) ;

	// I
	return 0 ;
}

// ݂̐ݒɊÂ ID3D11RasterizerState ZbgAbv
static int Graphics_D3D11_DeviceState_SetupRasterizerState( void )
{
	D_D3D11_RASTERIZER_DESC *RasterizerDesc ;
	D_ID3D11RasterizerState *NewRasterizerState ;
	D_ID3D11RasterizerState **DefaultRasterizerState ;
	HRESULT                  hr ;

	// ݒɕύXAKĐݒstO|Ă牽I
	if( GD3D11.Device.State.ChangeRasterizerDesc == FALSE &&
		GD3D11.Device.DrawSetting.CancelSettingEqualCheck == FALSE )
	{
		return 0 ;
	}

	// ݒɕύXǂ̃tO|
	GD3D11.Device.State.ChangeRasterizerDesc = FALSE ;

	// ݐݒ肳Ă郉X^CU[Xe[gꍇ͉
	if( GD3D11.Device.State.RasterizerState != NULL )
	{
		// ݂̐ݒύXۂɃX^CU[Xe[g[XwɂȂĂ烊[X
		if( GD3D11.Device.State.ChangeRasterizerStateReleaseFlag )
		{
			Direct3D11_ObjectRelease( GD3D11.Device.State.RasterizerState ) ;
		}

		GD3D11.Device.State.RasterizerState = NULL ;
	}

	// ݒύXۂɃX^CU[Xe[g[X邩ǂ̃tO|
	GD3D11.Device.State.ChangeRasterizerStateReleaseFlag = FALSE ;

	// 悭gݒ̃X^CU[Xe[gǂ𔻒肷
	RasterizerDesc = &GD3D11.Device.State.RasterizerDesc ;
	if( RasterizerDesc->FrontCounterClockwise != FALSE ||
		RasterizerDesc->DepthBias             != 0 ||
		RasterizerDesc->DepthBiasClamp        != 0.0f ||
		RasterizerDesc->SlopeScaledDepthBias  != 0.0f ||
		RasterizerDesc->ScissorEnable         != FALSE ||
		RasterizerDesc->AntialiasedLineEnable != FALSE )
	{
		// 悭gݒ̃X^CU[Xe[gł͂Ȃꍇ͂ŃX^CU[Xe[g쐬
		hr = D3D11Device_CreateRasterizerState( RasterizerDesc, &NewRasterizerState ) ;
		if( hr != S_OK )
		{
			DXST_ERRORLOGFMT_ADD( ( _T( "ID3D11RasterizerState ̍쐬Ɏs܂@ӏP\n" ) ) ) ;
			return -1 ;
		}

		// 쐬X^CU[Xe[gݒ
		GD3D11.Device.State.RasterizerState = NewRasterizerState ;

		// ̃X^CU[Xe[g͈ꎞIȂ̂Ȃ̂ŁAIɃ[X悤ɂ
		GD3D11.Device.State.ChangeRasterizerStateReleaseFlag = TRUE ;
	}
	else
	{
		// 悭gݒ̃X^CU[Xe[g̏ꍇ

		// ŵ悭gݒ̃X^CU[Xe[g܂쐬ĂȂ쐬
		DefaultRasterizerState = &GD3D11.Device.State.DefaultRasterizerStateArray[ RasterizerDesc->CullMode ][ RasterizerDesc->FillMode ][ RasterizerDesc->DepthClipEnable ][ RasterizerDesc->MultisampleEnable ] ;
		if( *DefaultRasterizerState == NULL )
		{
			hr = D3D11Device_CreateRasterizerState( RasterizerDesc, &NewRasterizerState ) ;
			if( hr != S_OK )
			{
				DXST_ERRORLOGFMT_ADD( ( _T( "ID3D11RasterizerState ̍쐬Ɏs܂@ӏQ\n" ) ) ) ;
				return -1 ;
			}
			*DefaultRasterizerState = NewRasterizerState ;
		}

		// 悭gݒ̃X^CU[Xe[gݒ
		GD3D11.Device.State.RasterizerState = *DefaultRasterizerState ;
	}

	// X^CU[Xe[gfoCXReLXgɐݒ肷
	D3D11DeviceContext_RSSetState( GD3D11.Device.State.RasterizerState ) ;

	// I
	return 0 ;
}

// ID3D11RasterizerState 
static int Graphics_D3D11_DeviceState_TerminateRasterizerState( void )
{
	GD3D11.Device.State.ChangeRasterizerDesc = FALSE ;

	_MEMSET( &GD3D11.Device.State.RasterizerDesc, 0, sizeof( GD3D11.Device.State.RasterizerDesc ) ) ;

	if( GD3D11.Device.State.ChangeRasterizerStateReleaseFlag )
	{
		Direct3D11_ObjectRelease( GD3D11.Device.State.RasterizerState ) ;
		GD3D11.Device.State.ChangeRasterizerStateReleaseFlag = FALSE ;
	}
	GD3D11.Device.State.RasterizerState = NULL ;

	Graphics_D3D11_ObjectArray_Release( ( void ** )GD3D11.Device.State.DefaultRasterizerStateArray, sizeof( GD3D11.Device.State.DefaultRasterizerStateArray ) / sizeof( void * ) ) ;

	// I
	return 0 ;
}

// ݂̐ݒɊÂ ID3D11DepthStencilState ZbgAbv
static int Graphics_D3D11_DeviceState_SetupDepthStencilState( void )
{
	D_D3D11_DEPTH_STENCIL_DESC *DepthStencilDesc ;
	D_ID3D11DepthStencilState  *NewDepthStencilState ;
	D_ID3D11DepthStencilState  **DefaultDepthStencilState ;
	HRESULT                     hr ;

	// ݒɕύXAKĐݒstO|Ă牽I
	if( GD3D11.Device.State.ChangeDepthStencilDesc == FALSE &&
		GD3D11.Device.DrawSetting.CancelSettingEqualCheck == FALSE )
	{
		return 0 ;
	}

	// ݒɕύXǂ̃tO|
	GD3D11.Device.State.ChangeDepthStencilDesc = FALSE ;

	// ݐݒ肳Ă[xXeVXe[gꍇ͉
	if( GD3D11.Device.State.DepthStencilState != NULL )
	{
		// ݂̐ݒύXۂɐ[xXeVXe[g[XwɂȂĂ烊[X
		if( GD3D11.Device.State.ChangeDepthStencilStateReleaseFlag )
		{
			Direct3D11_ObjectRelease( GD3D11.Device.State.DepthStencilState ) ;
		}

		GD3D11.Device.State.DepthStencilState = NULL ;
	}

	// ݒύXۂɐ[xXeVXe[g[X邩ǂ̃tO|
	GD3D11.Device.State.ChangeDepthStencilStateReleaseFlag = FALSE ;

	// 悭gݒ̐[xXeVXe[gǂ𔻒肷
	DepthStencilDesc = &GD3D11.Device.State.DepthStencilDesc ;
	if( DepthStencilDesc->StencilEnable					!= FALSE ||
		DepthStencilDesc->StencilReadMask				!= D3D11_DEFAULT_STENCIL_READ_MASK ||
		DepthStencilDesc->StencilWriteMask				!= D3D11_DEFAULT_STENCIL_WRITE_MASK ||
		DepthStencilDesc->FrontFace.StencilFailOp		!= D_D3D11_STENCIL_OP_KEEP ||
		DepthStencilDesc->FrontFace.StencilDepthFailOp	!= D_D3D11_STENCIL_OP_KEEP ||
		DepthStencilDesc->FrontFace.StencilPassOp		!= D_D3D11_STENCIL_OP_KEEP ||
		DepthStencilDesc->FrontFace.StencilFunc			!= D_D3D11_COMPARISON_ALWAYS ||
		DepthStencilDesc->BackFace.StencilFailOp		!= D_D3D11_STENCIL_OP_KEEP ||
		DepthStencilDesc->BackFace.StencilDepthFailOp	!= D_D3D11_STENCIL_OP_KEEP ||
		DepthStencilDesc->BackFace.StencilPassOp		!= D_D3D11_STENCIL_OP_KEEP ||
		DepthStencilDesc->BackFace.StencilFunc			!= D_D3D11_COMPARISON_ALWAYS )
	{
		// 悭gݒ̐[xXeVXe[gł͂Ȃꍇ͂Ő[xXeVXe[g쐬
		hr = D3D11Device_CreateDepthStencilState( DepthStencilDesc, &NewDepthStencilState ) ;
		if( hr != S_OK )
		{
			DXST_ERRORLOGFMT_ADD( ( _T( "ID3D11DepthStencilState ̍쐬Ɏs܂@ӏP\n" ) ) ) ;
			return -1 ;
		}

		// 쐬[xXeVXe[gݒ
		GD3D11.Device.State.DepthStencilState = NewDepthStencilState ;

		// ̐[xXeVXe[g͈ꎞIȂ̂Ȃ̂ŁAIɃ[X悤ɂ
		GD3D11.Device.State.ChangeDepthStencilStateReleaseFlag = TRUE ;
	}
	else
	{
		// 悭gݒ̐[xXeVXe[g̏ꍇ

		// ŵ悭gݒ̐[xXeVXe[g܂쐬ĂȂ쐬
		DefaultDepthStencilState = &GD3D11.Device.State.DefaultDepthStencilStateArray[ DepthStencilDesc->DepthEnable ][ DepthStencilDesc->DepthWriteMask == D_D3D11_DEPTH_WRITE_MASK_ALL ? 1 : 0 ][ DepthStencilDesc->DepthFunc ] ;
		if( *DefaultDepthStencilState == NULL )
		{
			hr = D3D11Device_CreateDepthStencilState( DepthStencilDesc, &NewDepthStencilState ) ;
			if( hr != S_OK )
			{
				DXST_ERRORLOGFMT_ADD( ( _T( "ID3D11DepthStencilState ̍쐬Ɏs܂@ӏQ\n" ) ) ) ;
				return -1 ;
			}
			*DefaultDepthStencilState = NewDepthStencilState ;
		}

		// 悭gݒ̐[xXeVXe[gݒ
		GD3D11.Device.State.DepthStencilState = *DefaultDepthStencilState ;
	}

	// [xXeVXe[gfoCXReLXgɐݒ肷
	D3D11DeviceContext_OMSetDepthStencilState( GD3D11.Device.State.DepthStencilState, 0 ) ;

	// I
	return 0 ;
}

// ID3D11DepthStencilState 
static int Graphics_D3D11_DeviceState_TerminateDepthStencilState( void )
{
	GD3D11.Device.State.ChangeDepthStencilDesc = FALSE ;

	_MEMSET( &GD3D11.Device.State.DepthStencilDesc, 0, sizeof( GD3D11.Device.State.DepthStencilDesc ) ) ;

	if( GD3D11.Device.State.ChangeDepthStencilStateReleaseFlag )
	{
		Direct3D11_ObjectRelease( GD3D11.Device.State.DepthStencilState ) ;
		GD3D11.Device.State.ChangeDepthStencilStateReleaseFlag = FALSE ;
	}
	GD3D11.Device.State.DepthStencilState = NULL ;

	Graphics_D3D11_ObjectArray_Release( ( void ** )GD3D11.Device.State.DefaultDepthStencilStateArray, sizeof( GD3D11.Device.State.DefaultDepthStencilStateArray ) / sizeof( void * ) ) ;

	// I
	return 0 ;
}

// ݂̐ݒɊÂ ID3D11BlendState ZbgAbv
static int Graphics_D3D11_DeviceState_SetupBlendState( void )
{
	D_D3D11_BLEND_DESC *BlendDesc ;
	D_ID3D11BlendState *NewBlendState ;
	D_ID3D11BlendState **DefaultBlendState ;
	HRESULT            hr ;

	// ݒɕύXAKĐݒstO|Ă牽I
	if( GD3D11.Device.State.ChangeBlendDesc == FALSE &&
		GD3D11.Device.DrawSetting.CancelSettingEqualCheck == FALSE )
	{
		return 0 ;
	}

	// ݒɕύXǂ̃tO|
	GD3D11.Device.State.ChangeBlendDesc = FALSE ;

	// ݐݒ肳ĂuhXe[gꍇ͉
	if( GD3D11.Device.State.BlendState != NULL )
	{
		// ݂̐ݒύXۂɃuhXe[g[XwɂȂĂ烊[X
		if( GD3D11.Device.State.ChangeBlendStateReleaseFlag )
		{
			Direct3D11_ObjectRelease( GD3D11.Device.State.BlendState ) ;
		}

		GD3D11.Device.State.BlendState = NULL ;
	}

	// ݒύXۂɃuhXe[g[X邩ǂ̃tO|
	GD3D11.Device.State.ChangeBlendStateReleaseFlag = FALSE ;

	// 悭gݒ̃uhXe[gǂ𔻒肷
	BlendDesc = &GD3D11.Device.State.BlendDesc ;
	if( GD3D11.Device.State.BlendMode == -1 )
	{
		// 悭gݒ̃uhXe[gł͂Ȃꍇ͂ŃuhXe[g쐬
		hr = D3D11Device_CreateBlendState( BlendDesc, &NewBlendState ) ;
		if( hr != S_OK )
		{
			DXST_ERRORLOGFMT_ADD( ( _T( "ID3D11BlendState ̍쐬Ɏs܂@ӏP\n" ) ) ) ;
			return -1 ;
		}

		// 쐬uhXe[gݒ
		GD3D11.Device.State.BlendState = NewBlendState ;

		// ̃uhXe[g͈ꎞIȂ̂Ȃ̂ŁAIɃ[X悤ɂ
		GD3D11.Device.State.ChangeBlendStateReleaseFlag = TRUE ;
	}
	else
	{
		// 悭gݒ̃uhXe[g̏ꍇ

		// ŵ悭gݒ̃uhXe[g܂쐬ĂȂ쐬
		DefaultBlendState = &GD3D11.Device.State.DefaultBlendStateArray[ GD3D11.Device.State.BlendMode ] ;
		if( *DefaultBlendState == NULL )
		{
			hr = D3D11Device_CreateBlendState( BlendDesc, &NewBlendState ) ;
			if( hr != S_OK )
			{
				DXST_ERRORLOGFMT_ADD( ( _T( "ID3D11BlendState ̍쐬Ɏs܂@ӏQ\n" ) ) ) ;
				return -1 ;
			}
			*DefaultBlendState = NewBlendState ;
		}

		// 悭gݒ̃uhXe[gݒ
		GD3D11.Device.State.BlendState = *DefaultBlendState ;
	}

	// uhXe[gfoCXReLXgɐݒ肷
	static FLOAT BlendFactor[ 4 ] = { 0.0f } ;
	D3D11DeviceContext_OMSetBlendState( GD3D11.Device.State.BlendState, BlendFactor, 0xffffffff ) ;

	// I
	return 0 ;
}

// ID3D11BlendState 
static int Graphics_D3D11_DeviceState_TerminateBlendState( void )
{
	GD3D11.Device.State.ChangeBlendDesc = FALSE ;

	_MEMSET( &GD3D11.Device.State.BlendDesc, 0, sizeof( GD3D11.Device.State.BlendDesc ) ) ;

	if( GD3D11.Device.State.ChangeBlendStateReleaseFlag )
	{
		Direct3D11_ObjectRelease( GD3D11.Device.State.BlendState ) ;
		GD3D11.Device.State.ChangeBlendStateReleaseFlag = FALSE ;
	}
	GD3D11.Device.State.BlendState = NULL ;

	Graphics_D3D11_ObjectArray_Release( ( void ** )GD3D11.Device.State.DefaultBlendStateArray, sizeof( GD3D11.Device.State.DefaultBlendStateArray ) / sizeof( void * ) ) ;

	// I
	return 0 ;
}

// eNX`[̃AhbVO[hZbg
extern int  Graphics_D3D11_DeviceState_SetTextureAddress( int AddressMode, int Sampler )
{
	int								i ;
	D_D3D11_SAMPLER_DESC			*SamplerDesc ;
	D_D3D11_TEXTURE_ADDRESS_MODE	D3D11AddressMode ;

	if( Graphics_Hardware_CheckValid_PF() == 0 )
	{
		return 0 ;
	}

	D3D11AddressMode = ( D_D3D11_TEXTURE_ADDRESS_MODE )AddressMode ;

	if( Sampler < 0 )
	{
		if( GD3D11.Device.DrawSetting.CancelSettingEqualCheck != FALSE )
		{
			SamplerDesc = GD3D11.Device.State.SamplerDesc ;
			for( i = 0 ; i < USE_TEXTURESTAGE_NUM ; i ++, SamplerDesc ++ )
			{
				if( D3D11AddressMode != SamplerDesc->AddressU ||
					D3D11AddressMode != SamplerDesc->AddressV ||
					D3D11AddressMode != SamplerDesc->AddressW )
				{
					break ;
				}
			}
			if( i == USE_TEXTURESTAGE_NUM )
			{
				return 0 ;
			}
		}

		Graphics_D3D11_RenderVertex() ;

		SamplerDesc = GD3D11.Device.State.SamplerDesc ;
		for( i = 0 ; i < USE_TEXTURESTAGE_NUM ; i ++, SamplerDesc ++ )
		{
			if( D3D11AddressMode == SamplerDesc->AddressU &&
				D3D11AddressMode == SamplerDesc->AddressV &&
				D3D11AddressMode == SamplerDesc->AddressW &&
				GD3D11.Device.DrawSetting.CancelSettingEqualCheck != FALSE )
			{
				continue ;
			}

			GD3D11.Device.State.ChangeSamplerDescSlot[ i ] = TRUE ;
			GD3D11.Device.State.ChangeSamplerDesc = TRUE ;

			SamplerDesc->AddressU = D3D11AddressMode ;
			SamplerDesc->AddressV = D3D11AddressMode ;
			SamplerDesc->AddressW = D3D11AddressMode ;
		}
	}
	else
	{
		if( Sampler < 0 || Sampler >= USE_TEXTURESTAGE_NUM )
		{
			return -1 ;
		}

		SamplerDesc = &GD3D11.Device.State.SamplerDesc[ Sampler ] ;
		if( D3D11AddressMode == SamplerDesc->AddressU &&
			D3D11AddressMode == SamplerDesc->AddressV &&
			D3D11AddressMode == SamplerDesc->AddressW &&
			GD3D11.Device.DrawSetting.CancelSettingEqualCheck == FALSE )
		{
			return 0 ;
		}

		Graphics_D3D11_RenderVertex() ;

		GD3D11.Device.State.ChangeSamplerDescSlot[ Sampler ] = TRUE ;
		GD3D11.Device.State.ChangeSamplerDesc = TRUE ;

		SamplerDesc->AddressU = D3D11AddressMode ;
		SamplerDesc->AddressV = D3D11AddressMode ;
		SamplerDesc->AddressW = D3D11AddressMode ;
	}

	GD3D11.Device.DrawSetting.DrawPrepAlwaysFlag = TRUE ;

	return Graphics_D3D11_DeviceState_SetupSamplerState() ;
}

// eNX`[̃AhbVO[hZbg
extern int Graphics_D3D11_DeviceState_SetTextureAddressU( int AddressMode, int Sampler )
{
	int								i ;
	D_D3D11_SAMPLER_DESC			*SamplerDesc ;
	D_D3D11_TEXTURE_ADDRESS_MODE	D3D11AddressMode ;

	if( Graphics_Hardware_CheckValid_PF() == 0 )
	{
		return 0 ;
	}

	D3D11AddressMode = ( D_D3D11_TEXTURE_ADDRESS_MODE )AddressMode ;

	if( Sampler == -1 )
	{
		if( GD3D11.Device.DrawSetting.CancelSettingEqualCheck != FALSE )
		{
			SamplerDesc = GD3D11.Device.State.SamplerDesc ;
			for( i = 0 ; i < USE_TEXTURESTAGE_NUM ; i ++, SamplerDesc ++ )
			{
				if( D3D11AddressMode != SamplerDesc->AddressU )
				{
					break ;
				}
			}
			if( i == USE_TEXTURESTAGE_NUM )
			{
				return 0 ;
			}
		}

		Graphics_D3D11_RenderVertex() ;

		SamplerDesc = GD3D11.Device.State.SamplerDesc ;
		for( i = 0 ; i < USE_TEXTURESTAGE_NUM ; i ++, SamplerDesc ++ )
		{
			if( D3D11AddressMode == SamplerDesc->AddressU &&
				GD3D11.Device.DrawSetting.CancelSettingEqualCheck != FALSE )
			{
				continue ;
			}

			GD3D11.Device.State.ChangeSamplerDescSlot[ i ] = TRUE ;
			GD3D11.Device.State.ChangeSamplerDesc = TRUE ;

			SamplerDesc->AddressU = D3D11AddressMode ;
		}
	}
	else
	{
		if( Sampler < 0 || Sampler >= USE_TEXTURESTAGE_NUM )
		{
			return -1 ;
		}

		SamplerDesc = &GD3D11.Device.State.SamplerDesc[ Sampler ] ;
		if( D3D11AddressMode == SamplerDesc->AddressU &&
			GD3D11.Device.DrawSetting.CancelSettingEqualCheck == FALSE )
		{
			return 0 ;
		}

		Graphics_D3D11_RenderVertex() ;

		GD3D11.Device.State.ChangeSamplerDescSlot[ Sampler ] = TRUE ;
		GD3D11.Device.State.ChangeSamplerDesc = TRUE ;

		SamplerDesc->AddressU = D3D11AddressMode ;
	}

	GD3D11.Device.DrawSetting.DrawPrepAlwaysFlag = TRUE ;

	return Graphics_D3D11_DeviceState_SetupSamplerState() ;
}

// eNX`[̃AhbVO[hZbg
extern int Graphics_D3D11_DeviceState_SetTextureAddressV( int AddressMode, int Sampler )
{
	int								i ;
	D_D3D11_SAMPLER_DESC			*SamplerDesc ;
	D_D3D11_TEXTURE_ADDRESS_MODE	D3D11AddressMode ;

	if( Graphics_Hardware_CheckValid_PF() == 0 )
	{
		return 0 ;
	}

	D3D11AddressMode = ( D_D3D11_TEXTURE_ADDRESS_MODE )AddressMode ;

	if( Sampler == -1 )
	{
		if( GD3D11.Device.DrawSetting.CancelSettingEqualCheck != FALSE )
		{
			SamplerDesc = GD3D11.Device.State.SamplerDesc ;
			for( i = 0 ; i < USE_TEXTURESTAGE_NUM ; i ++, SamplerDesc ++ )
			{
				if( D3D11AddressMode != SamplerDesc->AddressV )
				{
					break ;
				}
			}
			if( i == USE_TEXTURESTAGE_NUM )
			{
				return 0 ;
			}
		}

		Graphics_D3D11_RenderVertex() ;

		SamplerDesc = GD3D11.Device.State.SamplerDesc ;
		for( i = 0 ; i < USE_TEXTURESTAGE_NUM ; i ++, SamplerDesc ++ )
		{
			if( D3D11AddressMode == SamplerDesc->AddressV &&
				GD3D11.Device.DrawSetting.CancelSettingEqualCheck != FALSE )
			{
				continue ;
			}

			GD3D11.Device.State.ChangeSamplerDescSlot[ i ] = TRUE ;
			GD3D11.Device.State.ChangeSamplerDesc = TRUE ;

			SamplerDesc->AddressV = D3D11AddressMode ;
		}
	}
	else
	{
		if( Sampler < 0 || Sampler >= USE_TEXTURESTAGE_NUM )
		{
			return -1 ;
		}

		SamplerDesc = &GD3D11.Device.State.SamplerDesc[ Sampler ] ;
		if( D3D11AddressMode == SamplerDesc->AddressV &&
			GD3D11.Device.DrawSetting.CancelSettingEqualCheck == FALSE )
		{
			return 0 ;
		}

		Graphics_D3D11_RenderVertex() ;

		GD3D11.Device.State.ChangeSamplerDescSlot[ Sampler ] = TRUE ;
		GD3D11.Device.State.ChangeSamplerDesc = TRUE ;

		SamplerDesc->AddressV = D3D11AddressMode ;
	}

	GD3D11.Device.DrawSetting.DrawPrepAlwaysFlag = TRUE ;

	return Graphics_D3D11_DeviceState_SetupSamplerState() ;
}

// eNX`[̃AhbVO[hZbg
extern int Graphics_D3D11_DeviceState_SetTextureAddressW( int AddressMode, int Sampler )
{
	int								i ;
	D_D3D11_SAMPLER_DESC			*SamplerDesc ;
	D_D3D11_TEXTURE_ADDRESS_MODE	D3D11AddressMode ;

	if( Graphics_Hardware_CheckValid_PF() == 0 )
	{
		return 0 ;
	}

	D3D11AddressMode = ( D_D3D11_TEXTURE_ADDRESS_MODE )AddressMode ;

	if( Sampler == -1 )
	{
		if( GD3D11.Device.DrawSetting.CancelSettingEqualCheck != FALSE )
		{
			SamplerDesc = GD3D11.Device.State.SamplerDesc ;
			for( i = 0 ; i < USE_TEXTURESTAGE_NUM ; i ++, SamplerDesc ++ )
			{
				if( D3D11AddressMode != SamplerDesc->AddressW )
				{
					break ;
				}
			}
			if( i == USE_TEXTURESTAGE_NUM )
			{
				return 0 ;
			}
		}

		Graphics_D3D11_RenderVertex() ;

		SamplerDesc = GD3D11.Device.State.SamplerDesc ;
		for( i = 0 ; i < USE_TEXTURESTAGE_NUM ; i ++, SamplerDesc ++ )
		{
			if( D3D11AddressMode == SamplerDesc->AddressW &&
				GD3D11.Device.DrawSetting.CancelSettingEqualCheck != FALSE )
			{
				continue ;
			}

			GD3D11.Device.State.ChangeSamplerDescSlot[ i ] = TRUE ;
			GD3D11.Device.State.ChangeSamplerDesc = TRUE ;

			SamplerDesc->AddressW = D3D11AddressMode ;
		}
	}
	else
	{
		if( Sampler < 0 || Sampler >= USE_TEXTURESTAGE_NUM )
		{
			return -1 ;
		}

		SamplerDesc = &GD3D11.Device.State.SamplerDesc[ Sampler ] ;
		if( D3D11AddressMode == SamplerDesc->AddressW &&
			GD3D11.Device.DrawSetting.CancelSettingEqualCheck == FALSE )
		{
			return 0 ;
		}

		Graphics_D3D11_RenderVertex() ;

		GD3D11.Device.State.ChangeSamplerDescSlot[ Sampler ] = TRUE ;
		GD3D11.Device.State.ChangeSamplerDesc = TRUE ;

		SamplerDesc->AddressW = D3D11AddressMode ;

	}

	GD3D11.Device.DrawSetting.DrawPrepAlwaysFlag = TRUE ;

	return Graphics_D3D11_DeviceState_SetupSamplerState() ;
}

// eNX`[̃AhbVO[hZbg
extern int Graphics_D3D11_DeviceState_SetTextureAddressUVW( int AddressModeU, int AddressModeV, int AddressModeW, int Sampler )
{
	if( Graphics_D3D11_DeviceState_SetTextureAddressU( AddressModeU, Sampler ) < 0 )
	{
		return -1 ;
	}

	if( Graphics_D3D11_DeviceState_SetTextureAddressV( AddressModeV, Sampler ) < 0 )
	{
		return -1 ;
	}

	if( Graphics_D3D11_DeviceState_SetTextureAddressW( AddressModeW, Sampler ) < 0 )
	{
		return -1 ;
	}

	return 0 ;
}

// W`p̃eNX`Wϊs萔obt@ɃZbg
static int Graphics_D3D11_DeviceState_SetNormalTextureAddressTransformMatrix_ConstBuffer( void )
{
	DX_D3D11_VS_CONST_BUFFER_OTHERMATRIX *ConstOtherMatrix = ( DX_D3D11_VS_CONST_BUFFER_OTHERMATRIX * )GD3D11.Device.Shader.Constant.ConstBuffer_VS_OtherMatrix->SysmemBuffer ;

	// 萔f[^ɔf
	ConstOtherMatrix->TextureMatrix[ 0 ][ 0 ][ 0 ] = GD3D11.Device.State.TextureAddressTransformMatrix.m[ 0 ][ 0 ] ;
	ConstOtherMatrix->TextureMatrix[ 0 ][ 0 ][ 1 ] = GD3D11.Device.State.TextureAddressTransformMatrix.m[ 1 ][ 0 ] ;
	ConstOtherMatrix->TextureMatrix[ 0 ][ 0 ][ 2 ] = GD3D11.Device.State.TextureAddressTransformMatrix.m[ 2 ][ 0 ] ;
	ConstOtherMatrix->TextureMatrix[ 0 ][ 0 ][ 3 ] = GD3D11.Device.State.TextureAddressTransformMatrix.m[ 3 ][ 0 ] ;
	ConstOtherMatrix->TextureMatrix[ 0 ][ 1 ][ 0 ] = GD3D11.Device.State.TextureAddressTransformMatrix.m[ 0 ][ 1 ] ;
	ConstOtherMatrix->TextureMatrix[ 0 ][ 1 ][ 1 ] = GD3D11.Device.State.TextureAddressTransformMatrix.m[ 1 ][ 1 ] ;
	ConstOtherMatrix->TextureMatrix[ 0 ][ 1 ][ 2 ] = GD3D11.Device.State.TextureAddressTransformMatrix.m[ 2 ][ 1 ] ;
	ConstOtherMatrix->TextureMatrix[ 0 ][ 1 ][ 3 ] = GD3D11.Device.State.TextureAddressTransformMatrix.m[ 3 ][ 1 ] ;
	GD3D11.Device.Shader.Constant.ConstBuffer_VS_OtherMatrix->ChangeFlag = TRUE ;

	// 萔obt@XV
	Graphics_D3D11_ConstantBuffer_Update( GD3D11.Device.Shader.Constant.ConstBuffer_VS_OtherMatrix ) ;

	// W`p̃eNX`p[^ݒ肳Ă邩ǂtO𗧂Ă
	GD3D11.Device.Shader.Constant.SetNormalTextureAddressTransformMatrix = TRUE ;

	// I
	return 0 ;
}

// eNX`WϊsZbg
extern int  Graphics_D3D11_DeviceState_SetTextureAddressTransformMatrix( int Use, MATRIX *Matrix )
{
	if( Graphics_Hardware_CheckValid_PF() == 0 )
	{
		return 0 ;
	}

	if( GD3D11.Device.State.TextureAddressTransformMatrixUse == FALSE &&
		Use == FALSE && 
		GD3D11.Device.DrawSetting.CancelSettingEqualCheck == FALSE )
	{
		return 0 ;
	}

	Graphics_D3D11_RenderVertex() ;

	// eNX`Wϊsgp邩ǂۑ
	GD3D11.Device.State.TextureAddressTransformMatrixUse = Use ;

	// eNX`WϊsZbg
	if( Use == TRUE )
	{
		GD3D11.Device.State.TextureAddressTransformMatrix = *Matrix ;
	}
	else
	{
		CreateIdentityMatrix( &GD3D11.Device.State.TextureAddressTransformMatrix ) ;
	}

	// 萔obt@ɔf
	Graphics_D3D11_DeviceState_SetNormalTextureAddressTransformMatrix_ConstBuffer() ;

	return 0 ;
}

// tHOLɂ邩ǂݒ肷( TRUE:L  FALSE: )
extern int  Graphics_D3D11_DeviceState_SetFogEnable( int Flag )
{
	if( Graphics_Hardware_CheckValid_PF() == 0 )
	{
		return 0 ;
	}

	if( Flag == GD3D11.Device.State.FogEnable &&
		GD3D11.Device.DrawSetting.CancelSettingEqualCheck == FALSE )
	{
		return 0 ;
	}

	Graphics_D3D11_RenderVertex() ;

	GD3D11.Device.State.FogEnable = Flag ;

	GD3D11.Device.DrawSetting.DrawPrepAlwaysFlag = TRUE ;

	// I
	return 0 ;
}

// tHO[hݒ肷
extern int  Graphics_D3D11_DeviceState_SetFogVertexMode( int Mode /* DX_FOGMODE_NONE  */ )
{
	if( Graphics_Hardware_CheckValid_PF() == 0 )
	{
		return 0 ;
	}

	if( Mode == GD3D11.Device.State.FogMode &&
		GD3D11.Device.DrawSetting.CancelSettingEqualCheck == FALSE )
	{
		return 0 ;
	}

	Graphics_D3D11_RenderVertex() ;

	GD3D11.Device.State.FogMode = Mode ;

	GD3D11.Device.DrawSetting.DrawPrepAlwaysFlag = TRUE ;

	// I
	return 0 ;
}

// tHOJ[ύX
extern int  Graphics_D3D11_DeviceState_SetFogColor( DWORD Color )
{
	DX_D3D11_CONST_BUFFER_COMMON *ConstantCommon = ( DX_D3D11_CONST_BUFFER_COMMON * )GD3D11.Device.Shader.Constant.ConstBuffer_Common->SysmemBuffer ;

	if( Graphics_Hardware_CheckValid_PF() == 0 )
	{
		return 0 ;
	}

	if( Color == GD3D11.Device.State.FogColor &&
		GD3D11.Device.DrawSetting.CancelSettingEqualCheck == FALSE )
	{
		return 0 ;
	}

	Graphics_D3D11_RenderVertex() ;

	// 萔f[^ɔf
	ConstantCommon->Fog.Color[ 0 ] = ( ( Color >> 16 ) & 0xff ) / 255.0f ;
	ConstantCommon->Fog.Color[ 1 ] = ( ( Color >>  8 ) & 0xff ) / 255.0f ;
	ConstantCommon->Fog.Color[ 2 ] = ( ( Color >>  0 ) & 0xff ) / 255.0f ;
	ConstantCommon->Fog.Color[ 3 ] = 1.0f ;
	GD3D11.Device.Shader.Constant.ConstBuffer_Common->ChangeFlag = TRUE ;

	// 萔obt@XV
	Graphics_D3D11_ConstantBuffer_Update( GD3D11.Device.Shader.Constant.ConstBuffer_Common ) ;

	GD3D11.Device.State.FogColor = Color ;

	GD3D11.Device.DrawSetting.DrawPrepAlwaysFlag = TRUE ;

	// I
	return 0 ;
}

// tHO̐FȊO̒萔XV
static int Graphics_D3D11_DeviceState_UpdateConstantFogParam( void )
{
	DX_D3D11_CONST_BUFFER_COMMON *ConstantCommon = ( DX_D3D11_CONST_BUFFER_COMMON * )GD3D11.Device.Shader.Constant.ConstBuffer_Common->SysmemBuffer ;

	// 萔f[^ɔf
	ConstantCommon->Fog.LinearAdd = GD3D11.Device.State.FogEnd / ( GD3D11.Device.State.FogEnd - GD3D11.Device.State.FogStart ) ;
	ConstantCommon->Fog.LinearDiv = -1.0f / ( GD3D11.Device.State.FogEnd - GD3D11.Device.State.FogStart ) ;
	ConstantCommon->Fog.Density   = GD3D11.Device.State.FogDensity ;
	ConstantCommon->Fog.E         = 2.71828183f ;
	GD3D11.Device.Shader.Constant.ConstBuffer_Common->ChangeFlag = TRUE ;

	// 萔obt@XV
	Graphics_D3D11_ConstantBuffer_Update( GD3D11.Device.Shader.Constant.ConstBuffer_Common ) ;

	// I
	return 0 ;
}

// tHOn܂鋗ƏI鋗ݒ肷( 0.0f ` 1.0f )
extern int  Graphics_D3D11_DeviceState_SetFogStartEnd( float Start, float End )
{
	int UpdateFlag ;

	if( Graphics_Hardware_CheckValid_PF() == 0 )
	{
		return 0 ;
	}

	Graphics_D3D11_RenderVertex() ;

	UpdateFlag = FALSE ;

	if( Start != GD3D11.Device.State.FogStart ||
		GD3D11.Device.DrawSetting.CancelSettingEqualCheck == TRUE )
	{
		GD3D11.Device.State.FogStart = Start ;
		UpdateFlag = TRUE ;
	}

	if( End != GD3D11.Device.State.FogEnd ||
		GD3D11.Device.DrawSetting.CancelSettingEqualCheck == TRUE )
	{
		GD3D11.Device.State.FogEnd = End ;
		UpdateFlag = TRUE ;
	}

	if( UpdateFlag )
	{
		// 萔XV
		Graphics_D3D11_DeviceState_UpdateConstantFogParam() ;
	}

	GD3D11.Device.DrawSetting.DrawPrepAlwaysFlag = TRUE ;

	// I
	return 0 ;
}

// tHO̖xݒ肷( 0.0f ` 1.0f )
extern int  Graphics_D3D11_DeviceState_SetFogDensity( float Density )
{
	if( Graphics_Hardware_CheckValid_PF() == 0 )
	{
		return 0 ;
	}

	if( Density == GD3D11.Device.State.FogDensity &&
		GD3D11.Device.DrawSetting.CancelSettingEqualCheck == FALSE )
	{
		return 0 ;
	}

	Graphics_D3D11_RenderVertex() ;

	GD3D11.Device.State.FogDensity = Density ;

	// 萔XV
	Graphics_D3D11_DeviceState_UpdateConstantFogParam() ;

	GD3D11.Device.DrawSetting.DrawPrepAlwaysFlag = TRUE ;

	// I
	return 0 ;
}

// CeBO̗LtOZbg
extern int  Graphics_D3D11_DeviceState_SetLighting( int UseFlag )
{
	if( Graphics_Hardware_CheckValid_PF() == 0 )
	{
		return 0 ;
	}

	if( UseFlag == GD3D11.Device.State.Lighting &&
		GD3D11.Device.DrawSetting.CancelSettingEqualCheck == FALSE )
	{
		return 0 ;
	}

	Graphics_D3D11_RenderVertex() ;

	GD3D11.Device.State.Lighting = UseFlag ;

	GD3D11.Device.DrawSetting.DrawPrepAlwaysFlag = TRUE ;

	// I
	return 0 ;
}

// őٕZbg
extern	int		Graphics_D3D11_DeviceState_SetMaxAnisotropy( int MaxAnisotropy, int Sampler )
{
	int						i ;
	D_D3D11_SAMPLER_DESC	*SamplerDesc ;

	if( Graphics_Hardware_CheckValid_PF() == 0 )
	{
		return 0 ;
	}

	// l̕␳
	if( MaxAnisotropy < 1 )
	{
		MaxAnisotropy = 1 ;
	}

	if( Sampler < 0 )
	{
		if( GD3D11.Device.DrawSetting.CancelSettingEqualCheck != FALSE )
		{
			SamplerDesc = GD3D11.Device.State.SamplerDesc ;
			for( i = 0 ; i < USE_TEXTURESTAGE_NUM ; i ++, SamplerDesc ++ )
			{
				if( SamplerDesc->MaxAnisotropy != MaxAnisotropy )
				{
					break ;
				}
			}
			if( i == USE_TEXTURESTAGE_NUM )
			{
				return 0 ;
			}
		}

		Graphics_D3D11_RenderVertex() ;

		SamplerDesc = GD3D11.Device.State.SamplerDesc ;
		for( i = 0 ; i < USE_TEXTURESTAGE_NUM ; i ++, SamplerDesc ++ )
		{
			if( SamplerDesc->MaxAnisotropy == MaxAnisotropy &&
				GD3D11.Device.DrawSetting.CancelSettingEqualCheck != FALSE )
			{
				continue ;
			}

			GD3D11.Device.State.ChangeSamplerDescSlot[ i ] = TRUE ;
			GD3D11.Device.State.ChangeSamplerDesc = TRUE ;

			SamplerDesc->MaxAnisotropy = MaxAnisotropy ;
		}
	}
	else
	{
		if( Sampler < 0 || Sampler >= USE_TEXTURESTAGE_NUM )
		{
			return 0 ;
		}

		SamplerDesc = &GD3D11.Device.State.SamplerDesc[ Sampler ] ;
		if( SamplerDesc->MaxAnisotropy == MaxAnisotropy &&
			GD3D11.Device.DrawSetting.CancelSettingEqualCheck == FALSE )
		{
			return 0 ;
		}

		Graphics_D3D11_RenderVertex() ;

		GD3D11.Device.State.ChangeSamplerDescSlot[ Sampler ] = TRUE ;
		GD3D11.Device.State.ChangeSamplerDesc = TRUE ;

		SamplerDesc->MaxAnisotropy = MaxAnisotropy ;
	}

	GD3D11.Device.DrawSetting.DrawPrepAlwaysFlag = TRUE ;

	return Graphics_D3D11_DeviceState_SetupSamplerState() ;
}

// r[|[gZbg
extern	int		Graphics_D3D11_DeviceState_SetViewport( D_D3D11_VIEWPORT *Viewport )
{
	if( Graphics_Hardware_CheckValid_PF() == 0 ) return -1 ;

	if( Viewport->TopLeftX == GD3D11.Device.State.Viewport.TopLeftX &&
		Viewport->TopLeftY == GD3D11.Device.State.Viewport.TopLeftY &&
		Viewport->Width    == GD3D11.Device.State.Viewport.Width    &&
		Viewport->Height   == GD3D11.Device.State.Viewport.Height   &&
		GD3D11.Device.DrawSetting.CancelSettingEqualCheck == FALSE ) return 0 ;

	// o
	if( GD3D11.Device.DrawSetting.CancelSettingEqualCheck == FALSE )
	{
		Graphics_D3D11_RenderVertex() ;
	}

	// `IĂ
	Graphics_D3D11_RenderEnd() ;

	// r[|[g̃ZbeBO
	D3D11DeviceContext_RSSetViewports( 1, Viewport ) ;

	// r[|[g̏̕ۑ
	GD3D11.Device.State.Viewport = *Viewport ;

	// I
	return 0 ;
}

// r[|[gZbg( ȈՔ )
extern	int		Graphics_D3D11_DeviceState_SetViewportEasy( float x1, float y1, float x2, float y2 )
{
	D_D3D11_VIEWPORT Viewport ;

	Viewport.TopLeftX = x1 ;
	Viewport.TopLeftY = y1 ;
	Viewport.Width    = x2 - x1 ;
	Viewport.Height   = y2 - y1 ;
	Viewport.MinDepth = 0.0f ;
	Viewport.MaxDepth = 1.0f ;

	return Graphics_D3D11_DeviceState_SetViewport( &Viewport ) ;
}

// `Ώۂ̕ύX
extern	int		Graphics_D3D11_DeviceState_SetRenderTarget( D_ID3D11Texture2D *RenderTargetTexture, D_ID3D11RenderTargetView *RenderTargetView, int TargetIndex )
{
	D_D3D11_TEXTURE2D_DESC      Texture2DDesc ;

	if( Graphics_Hardware_CheckValid_PF() == 0 ) return -1 ;

	if( TargetIndex < 0 || TargetIndex >= DX_RENDERTARGET_COUNT ) return -1 ;

	if( GD3D11.Device.State.TargetTexture2D[ TargetIndex ] == RenderTargetTexture &&
		GD3D11.Device.State.TargetRTV[ TargetIndex ]       == RenderTargetView &&
		GD3D11.Device.DrawSetting.CancelSettingEqualCheck  == FALSE ) return 0 ;

	// _o
	Graphics_D3D11_RenderVertex() ;

	// _O^[Qbg̕ۑ
	GD3D11.Device.State.TargetTexture2D[ TargetIndex ] = RenderTargetTexture ;
	GD3D11.Device.State.TargetRTV[ TargetIndex ]       = RenderTargetView ;

	// _O^[Qbg̕ύX
	D3D11DeviceContext_OMSetRenderTargets( DX_RENDERTARGET_COUNT, GD3D11.Device.State.TargetRTV, GD3D11.Device.State.TargetDepthDSV ) ;

	// r[|[g̐ݒlXV
	if( TargetIndex == 0 )
	{
		D3D11Texture2D_GetDesc( RenderTargetTexture, &Texture2DDesc ) ; 
		Graphics_D3D11_DeviceState_SetViewportEasy( 0.0f, 0.0f, ( float )Texture2DDesc.Width, ( float )Texture2DDesc.Height ) ;
	}

	// I
	return  0 ;
}

// `Ώۂ̐[xobt@ύX
extern	int		Graphics_D3D11_DeviceState_SetDepthStencil( D_ID3D11Texture2D *DepthStencilTexture, D_ID3D11DepthStencilView *DepthStencilView )
{
	if( Graphics_Hardware_CheckValid_PF() == 0 ) return -1 ;

	if( GD3D11.Device.State.TargetDepthTexture2D == DepthStencilTexture &&
		GD3D11.Device.State.TargetDepthDSV       == DepthStencilView &&
		GD3D11.Device.DrawSetting.CancelSettingEqualCheck  == FALSE ) return 0 ;

	// _o
	Graphics_D3D11_RenderVertex() ;

	// gp[xobt@̕ۑ
	GD3D11.Device.State.TargetDepthTexture2D = DepthStencilTexture ;
	GD3D11.Device.State.TargetDepthDSV       = DepthStencilView ;

	// _O^[Qbg̕ύX
	D3D11DeviceContext_OMSetRenderTargets( DX_RENDERTARGET_COUNT, GD3D11.Device.State.TargetRTV, GD3D11.Device.State.TargetDepthDSV ) ;

	// I
	return  0 ;
}

// _VF[_[̎gp~߂
extern	int		Graphics_D3D11_DeviceState_ResetVertexShader( int SetNormalVertexShaderCancel )
{
	if( GD3D11.Device.State.SetNormalVertexShader &&
		SetNormalVertexShaderCancel &&
		GD3D11.Device.DrawSetting.CancelSettingEqualCheck == FALSE )
	{
		return 0 ;
	}

	if( GD3D11.Device.DrawSetting.CancelSettingEqualCheck == FALSE &&
		GD3D11.Device.State.SetVertexShader == NULL &&
		GD3D11.Device.State.SetVertexInputLayout == NULL )
	{
		return 0 ;
	}

	if( Graphics_Hardware_CheckValid_PF() == 0 ) return -1 ;

	if( GD3D11.Device.DrawSetting.CancelSettingEqualCheck || GD3D11.Device.State.SetVertexShader != NULL )
	{
		D3D11DeviceContext_VSSetShader( NULL, NULL, 0 ) ;
		GD3D11.Device.State.SetVertexShader = NULL ;
	}

	if( GD3D11.Device.DrawSetting.CancelSettingEqualCheck || GD3D11.Device.State.SetVertexInputLayout != NULL )
	{
		D3D11DeviceContext_IASetInputLayout( NULL ) ;
		GD3D11.Device.State.SetVertexInputLayout = NULL ;
	}

	GD3D11.Device.State.SetNormalVertexShader    = FALSE ;
	GD3D11.Device.DrawSetting.DrawPrepAlwaysFlag = TRUE ;

	// I
	return 0 ;
}

// sNZVF[_[̎gp~߂
extern	int		Graphics_D3D11_DeviceState_ResetPixelShader( int SetNormalPixelShaderCancel )
{
	if( GD3D11.Device.State.SetNormalPixelShader &&
		SetNormalPixelShaderCancel &&
		GD3D11.Device.DrawSetting.CancelSettingEqualCheck == FALSE )
	{
		return 0 ;
	}

	if( GD3D11.Device.DrawSetting.CancelSettingEqualCheck == FALSE &&
		GD3D11.Device.State.SetPixelShader == NULL )
	{
		return 0 ;
	}

	if( Graphics_Hardware_CheckValid_PF() == 0 ) return -1 ;

	if( GD3D11.Device.DrawSetting.CancelSettingEqualCheck || GD3D11.Device.State.SetPixelShader != NULL )
	{
		D3D11DeviceContext_PSSetShader( NULL, NULL, 0 ) ;
		GD3D11.Device.State.SetPixelShader = NULL ;
	}

	GD3D11.Device.State.SetNormalPixelShader     = FALSE ;
	GD3D11.Device.DrawSetting.DrawPrepAlwaysFlag = TRUE ;

	// I
	return 0 ;
}



























// 萔֌W֐

// Direct3D11 ̒萔̏s
extern int Graphics_D3D11_Constant_Initialize( void )
{
	// e萔obt@쐬
	GD3D11.Device.Shader.Constant.ConstBuffer_Common = Graphics_D3D11_ConstantBuffer_Create( sizeof( DX_D3D11_CONST_BUFFER_COMMON ) ) ;
	if( GD3D11.Device.Shader.Constant.ConstBuffer_Common == NULL )
	{
		goto ERR ;
	}

	GD3D11.Device.Shader.Constant.ConstBuffer_VS_Base = Graphics_D3D11_ConstantBuffer_Create( sizeof( DX_D3D11_VS_CONST_BUFFER_BASE ) ) ;
	if( GD3D11.Device.Shader.Constant.ConstBuffer_VS_Base == NULL )
	{
		goto ERR ;
	}

	GD3D11.Device.Shader.Constant.ConstBuffer_VS_OtherMatrix = Graphics_D3D11_ConstantBuffer_Create( sizeof( DX_D3D11_VS_CONST_BUFFER_OTHERMATRIX ) ) ;
	if( GD3D11.Device.Shader.Constant.ConstBuffer_VS_OtherMatrix == NULL )
	{
		goto ERR ;
	}

	GD3D11.Device.Shader.Constant.ConstBuffer_PS_Base = Graphics_D3D11_ConstantBuffer_Create( sizeof( DX_D3D11_PS_CONST_BUFFER_BASE ) ) ;
	if( GD3D11.Device.Shader.Constant.ConstBuffer_PS_Base == NULL )
	{
		goto ERR ;
	}

	GD3D11.Device.Shader.Constant.ConstBuffer_PS_ShadowMap = Graphics_D3D11_ConstantBuffer_Create( sizeof( DX_D3D11_PS_CONST_BUFFER_SHADOWMAP ) ) ;
	if( GD3D11.Device.Shader.Constant.ConstBuffer_PS_ShadowMap == NULL )
	{
		goto ERR ;
	}

	// I
	return 0 ;

ERR :
	if( GD3D11.Device.Shader.Constant.ConstBuffer_Common != NULL )
	{
		Graphics_D3D11_ConstantBuffer_Delete( GD3D11.Device.Shader.Constant.ConstBuffer_Common ) ;
		GD3D11.Device.Shader.Constant.ConstBuffer_Common = NULL ;
	}

	if( GD3D11.Device.Shader.Constant.ConstBuffer_VS_Base != NULL )
	{
		Graphics_D3D11_ConstantBuffer_Delete( GD3D11.Device.Shader.Constant.ConstBuffer_VS_Base ) ;
		GD3D11.Device.Shader.Constant.ConstBuffer_VS_Base = NULL ;
	}

	if( GD3D11.Device.Shader.Constant.ConstBuffer_VS_OtherMatrix != NULL )
	{
		Graphics_D3D11_ConstantBuffer_Delete( GD3D11.Device.Shader.Constant.ConstBuffer_VS_OtherMatrix ) ;
		GD3D11.Device.Shader.Constant.ConstBuffer_VS_OtherMatrix = NULL ;
	}

	if( GD3D11.Device.Shader.Constant.ConstBuffer_PS_Base != NULL )
	{
		Graphics_D3D11_ConstantBuffer_Delete( GD3D11.Device.Shader.Constant.ConstBuffer_PS_Base ) ;
		GD3D11.Device.Shader.Constant.ConstBuffer_PS_Base = NULL ;
	}

	if( GD3D11.Device.Shader.Constant.ConstBuffer_PS_ShadowMap != NULL )
	{
		Graphics_D3D11_ConstantBuffer_Delete( GD3D11.Device.Shader.Constant.ConstBuffer_PS_ShadowMap ) ;
		GD3D11.Device.Shader.Constant.ConstBuffer_PS_ShadowMap = NULL ;
	}

	DXST_ERRORLOGFMT_ADD( ( _T( "萔obt@̍쐬Ɏs܂\n" ) ) ) ;

	// G[I
	return -1 ;
}

// Direct3D11 ̒萔̌ns
extern int Graphics_D3D11_Constant_Terminate( void )
{
	if( GD3D11.Device.Shader.Constant.ConstBuffer_Common != NULL )
	{
		Graphics_D3D11_ConstantBuffer_Delete( GD3D11.Device.Shader.Constant.ConstBuffer_Common ) ;
		GD3D11.Device.Shader.Constant.ConstBuffer_Common = NULL ;
	}

	if( GD3D11.Device.Shader.Constant.ConstBuffer_VS_Base != NULL )
	{
		Graphics_D3D11_ConstantBuffer_Delete( GD3D11.Device.Shader.Constant.ConstBuffer_VS_Base ) ;
		GD3D11.Device.Shader.Constant.ConstBuffer_VS_Base = NULL ;
	}

	if( GD3D11.Device.Shader.Constant.ConstBuffer_VS_OtherMatrix != NULL )
	{
		Graphics_D3D11_ConstantBuffer_Delete( GD3D11.Device.Shader.Constant.ConstBuffer_VS_OtherMatrix ) ;
		GD3D11.Device.Shader.Constant.ConstBuffer_VS_OtherMatrix = NULL ;
	}

	if( GD3D11.Device.Shader.Constant.ConstBuffer_PS_Base != NULL )
	{
		Graphics_D3D11_ConstantBuffer_Delete( GD3D11.Device.Shader.Constant.ConstBuffer_PS_Base ) ;
		GD3D11.Device.Shader.Constant.ConstBuffer_PS_Base = NULL ;
	}

	if( GD3D11.Device.Shader.Constant.ConstBuffer_PS_ShadowMap != NULL )
	{
		Graphics_D3D11_ConstantBuffer_Delete( GD3D11.Device.Shader.Constant.ConstBuffer_PS_ShadowMap ) ;
		GD3D11.Device.Shader.Constant.ConstBuffer_PS_ShadowMap = NULL ;
	}

	// I
	return 0 ;
}

































// 萔obt@֌W֐

// 萔obt@쐬
extern	CONSTANTBUFFER_DIRECT3D11 *Graphics_D3D11_ConstantBuffer_Create( DWORD Size )
{
	CONSTANTBUFFER_DIRECT3D11	*NewBuffer = NULL ;
	DWORD						AllocSize ;
	D_D3D11_BUFFER_DESC			BufferDesc ;

	// TCY`FbN
	if( Size % 16 != 0 )
	{
		DXST_ERRORLOGFMT_ADD( ( _T( "萔obt@̃TCY͂PU̔{łKv܂\n" ) ) ) ;
		goto ERR ;
	}

	// ̊m
	AllocSize = Size + sizeof( CONSTANTBUFFER_DIRECT3D11 ) ;
	NewBuffer = ( CONSTANTBUFFER_DIRECT3D11 * )DXALLOC( AllocSize ) ;
	if( NewBuffer == NULL )
	{
		DXST_ERRORLOGFMT_ADD( ( _T( "萔obt@i[郁̈̊mۂɎs܂\n" ) ) ) ;
		goto ERR ;
	}

	// 돉
	_MEMSET( NewBuffer, 0, AllocSize ) ;

	// ID3D11Buffer ̍쐬
	_MEMSET( &BufferDesc, 0, sizeof( BufferDesc ) ) ;
	BufferDesc.ByteWidth      = Size ;
	BufferDesc.Usage          = D_D3D11_USAGE_DEFAULT ;
	BufferDesc.BindFlags      = D_D3D11_BIND_CONSTANT_BUFFER ;
	BufferDesc.CPUAccessFlags = 0 ;
	if( D3D11Device_CreateBuffer( &BufferDesc, NULL, &NewBuffer->ConstantBuffer ) != S_OK )
	{
		DXST_ERRORLOGFMT_ADD( ( _T( "萔obt@p ID3D11Buffer ̍쐬Ɏs܂\n" ) ) ) ;
		goto ERR ;
	}

	// Zbg
	NewBuffer->Size         = Size ;
	NewBuffer->SysmemBuffer = NewBuffer + 1 ;
	NewBuffer->ChangeFlag   = FALSE ;

	// Xgɒǉ
	if( GD3D11.Device.Shader.Constant.ConstantBufferManage.FirstBuffer != NULL )
	{
		NewBuffer->NextData = GD3D11.Device.Shader.Constant.ConstantBufferManage.FirstBuffer ;
		GD3D11.Device.Shader.Constant.ConstantBufferManage.FirstBuffer->PrevData = NewBuffer ;
	}
	GD3D11.Device.Shader.Constant.ConstantBufferManage.FirstBuffer = NewBuffer ;

	// obt@̐𑝂₷
	GD3D11.Device.Shader.Constant.ConstantBufferManage.BufferNum ++ ;

	// I
	return NewBuffer ;


	// G[
ERR :
	if( NewBuffer != NULL )
	{
		if( NewBuffer->ConstantBuffer != NULL )
		{
			Direct3D11_ObjectRelease( NewBuffer->ConstantBuffer ) ;
			NewBuffer->ConstantBuffer = NULL ;
		}

		DXFREE( NewBuffer ) ;
	}

	// G[I
	return NULL ;
}

// 萔obt@폜
extern int Graphics_D3D11_ConstantBuffer_Delete( CONSTANTBUFFER_DIRECT3D11 *ConstantBuffer )
{
	int i ;

	// foCXŎgpĂO
	for( i = 0 ; i < D_D3D11_COMMONSHADER_CONSTANT_BUFFER_API_SLOT_COUNT ; i ++ )
	{
		if( GD3D11.Device.State.SetPixelShaderConstantBuffer[ i ] == ConstantBuffer )
		{
			GD3D11.Device.State.SetPixelShaderConstantBuffer[ i ] = NULL ;
		}

		if( GD3D11.Device.State.SetVertexShaderConstantBuffer[ i ] == ConstantBuffer )
		{
			GD3D11.Device.State.SetVertexShaderConstantBuffer[ i ] = NULL ;
		}
	}

	// ID3D11Buffer 
	if( ConstantBuffer->ConstantBuffer != NULL )
	{
		Direct3D11_ObjectRelease( ConstantBuffer->ConstantBuffer ) ;
		ConstantBuffer->ConstantBuffer = NULL ;
	}

	// XgO
	if( GD3D11.Device.Shader.Constant.ConstantBufferManage.FirstBuffer == ConstantBuffer )
	{
		GD3D11.Device.Shader.Constant.ConstantBufferManage.FirstBuffer = ConstantBuffer->NextData ;
		if( ConstantBuffer->NextData != NULL )
		{
			ConstantBuffer->NextData->PrevData = NULL ;
		}
	}
	else
	{
		ConstantBuffer->PrevData->NextData = ConstantBuffer->NextData ;
		if( ConstantBuffer->NextData != NULL )
		{
			ConstantBuffer->NextData->PrevData = ConstantBuffer->PrevData ;
		}
	}

	// ̉
	DXFREE( ConstantBuffer ) ;

	// obt@̐炷
	GD3D11.Device.Shader.Constant.ConstantBufferManage.BufferNum -- ;

	// I
	return 0 ;
}

// VXẽobt@ɍsύXKp
extern int Graphics_D3D11_ConstantBuffer_Update( CONSTANTBUFFER_DIRECT3D11 *ConstantBuffer )
{
	// ύXꍇ͉ɏI
	if( ConstantBuffer->ChangeFlag == FALSE )
	{
		return 0 ;
	}

	// XV
	D3D11DeviceContext_UpdateSubresource( ConstantBuffer->ConstantBuffer, 0, NULL, ConstantBuffer->SysmemBuffer, 0, 0 ) ;

	// ύXtO|
	ConstantBuffer->ChangeFlag = FALSE ;

	// I
	return 0 ;
}































// ̓CAEg֌W֐

static D_D3D11_INPUT_ELEMENT_DESC MakeD3D11InputElement( LPCSTR SemanticName, UINT SemanticIndex, D_DXGI_FORMAT Format, UINT InputSlot, UINT AlignedByteOffset )
{
	D_D3D11_INPUT_ELEMENT_DESC Result = 
	{
		SemanticName,
		SemanticIndex,
		Format,
		InputSlot,
		AlignedByteOffset,
		D_D3D11_INPUT_PER_VERTEX_DATA,
		0
	} ;
	return Result ;
}

// W`p ID3D11InputLayout IuWFNg̍쐬( 0:  -1:s )
extern int Graphics_D3D11_InputLayout_Base_Create( void )
{
	int							i ;
	int							ElementNum ;
	HRESULT						hr ;
	GRAPHICS_HARDWEARE_DIRECT3D11_BASE_SIMPLE_VERTEXSHADER_INFO *BSVI ;
	GRAPHICS_HARDWARE_DIRECT3D11_SHADERCODE_INFO                *Code ;

	// ɍ쐬ĂƂ̂߂ɍ폜s
	Graphics_D3D11_InputLayout_Base_Terminate() ;

	// W`p̃VF[_[Ŏgp钸_f[^`쐬
	BSVI = g_BaseSimpleVertexShaderInfo ;
	Code = GraphicsHardDataDirect3D11.ShaderCode.Base.BaseSimple_VS_Code ;
	for( i = 0 ; i < VERTEXFVF_LAYOUT_NUM ; i++, BSVI++, Code++ )
	{
		// _Ɋ܂܂̐𐔂
		for( ElementNum = 0 ; BSVI->InputElementDesc[ ElementNum ].SemanticName != NULL ; ElementNum ++ ){}

		// _f[^tH[}bg쐬
		hr = D3D11Device_CreateInputLayout( BSVI->InputElementDesc, ElementNum, Code->Binary, ( SIZE_T )Code->Size, &GD3D11.Device.InputLayout.BaseInputLayout[ i ] ) ;
		if( hr != S_OK )
		{
			return -1 ;
		}
	}

	// I
	return 0 ;
}

// W`p ID3D11InputLayout IuWFNg̍폜( 0:  -1:s )
extern int Graphics_D3D11_InputLayout_Base_Terminate( void )
{
	int							i ;
	GRAPHICS_HARDWEARE_DIRECT3D11_BASE_SIMPLE_VERTEXSHADER_INFO *BSVI ;

	if( Graphics_Hardware_CheckValid_PF() == 0 )
	{
		return 0 ;
	}

	// W`p̃VF[_[Ŏgp钸_f[^`
	BSVI = g_BaseSimpleVertexShaderInfo ;
	for( i = 0 ; i < VERTEXFVF_LAYOUT_NUM ; i++, BSVI++ )
	{
		if( GD3D11.Device.InputLayout.BaseInputLayout[ i ] != NULL )
		{
			Direct3D11_ObjectRelease( GD3D11.Device.InputLayout.BaseInputLayout[ i ] ) ;
			GD3D11.Device.InputLayout.BaseInputLayout[ i ] = NULL ;
		}
	}

	// I
	return 0 ;
}

#ifndef DX_NON_MODEL

// f`p ID3D11InputLayout IuWFNg̍쐬( 0:  -1:s )
extern int Graphics_D3D11_InputLayout_Model_Create( void )
{
	// ɍ쐬ĂƂ̂߂ɍ폜s
	Graphics_D3D11_InputLayout_Model_Terminate() ;
/*
	{
		D_D3D11_INPUT_ELEMENT_DESC *IE, InputElement[ 64 ] = 
		{
			{ "POSITION",     0, D_DXGI_FORMAT_R32G32B32_FLOAT,    0,  0, D_D3D11_INPUT_PER_VERTEX_DATA, 0 },
			{ "BLENDWEIGHT",  0, D_DXGI_FORMAT_R32G32B32A32_FLOAT, 0, 12, D_D3D11_INPUT_PER_VERTEX_DATA, 0 },
			{ "BLENDINDICES", 0, D_DXGI_FORMAT_R8G8B8A8_UINT,      0, 28, D_D3D11_INPUT_PER_VERTEX_DATA, 0 },
			{ "NORMAL",       0, D_DXGI_FORMAT_R32G32B32_FLOAT,    0, 32, D_D3D11_INPUT_PER_VERTEX_DATA, 0 },
			{ "COLOR",        0, D_DXGI_FORMAT_R8G8B8A8_UNORM,     0, 44, D_D3D11_INPUT_PER_VERTEX_DATA, 0 },
			{ "COLOR",        1, D_DXGI_FORMAT_R8G8B8A8_UNORM,     0, 48, D_D3D11_INPUT_PER_VERTEX_DATA, 0 },
			{ "TEXCOORD",     0, D_DXGI_FORMAT_R32G32B32A32_FLOAT, 0, 52, D_D3D11_INPUT_PER_VERTEX_DATA, 0 },
		} ;
		int offset, index ;
		int i, j, k, l ;
		void *ShaderCode ;
		UINT ShaderCodeSize ;

		// ov}bvǂłQ[v
		for( i = 0 ; i < 2 ; i ++ )
		{
			// XLjObV^CvɂĂR[v
			for( j = 0 ; j < 3 ; j ++ )
			{
				if( i == 0 )
				{
					switch( j )
					{
					case 0 :
						// ov}bv񖳂̃bV
						InputElement[ 0 ] = MakeD3D11InputElement( "POSITION",     0, D_DXGI_FORMAT_R32G32B32_FLOAT,    0, 0  ) ;
						InputElement[ 1 ] = MakeD3D11InputElement( "NORMAL",       0, D_DXGI_FORMAT_R32G32B32_FLOAT,    0, 12 ) ;
						InputElement[ 2 ] = MakeD3D11InputElement( "COLOR",        0, D_DXGI_FORMAT_R8G8B8A8_UNORM,     0, 24 ) ;
						InputElement[ 3 ] = MakeD3D11InputElement( "COLOR",        1, D_DXGI_FORMAT_R8G8B8A8_UNORM,     0, 28 ) ;
						offset = 32 ;
						index = 4 ;
						break ;

					case 1 :
						// ov}bv񖳂S{[XLjObV
						InputElement[ 0 ] = MakeD3D11InputElement( "POSITION",     0, D_DXGI_FORMAT_R32G32B32_FLOAT,    0, 0  ) ;
						InputElement[ 1 ] = MakeD3D11InputElement( "BLENDINDICES", 0, D_DXGI_FORMAT_R8G8B8A8_UINT,      0, 12 ) ;
						InputElement[ 2 ] = MakeD3D11InputElement( "BLENDWEIGHT",  0, D_DXGI_FORMAT_R32G32B32A32_FLOAT, 0, 16 ) ;
						InputElement[ 3 ] = MakeD3D11InputElement( "NORMAL",       0, D_DXGI_FORMAT_R32G32B32_FLOAT,    0, 32 ) ;
						InputElement[ 4 ] = MakeD3D11InputElement( "COLOR",        0, D_DXGI_FORMAT_R8G8B8A8_UNORM,     0, 44 ) ;
						InputElement[ 5 ] = MakeD3D11InputElement( "COLOR",        1, D_DXGI_FORMAT_R8G8B8A8_UNORM,     0, 48 ) ;
						offset = 52 ;
						index = 6 ;
						break ;

					case 2 :
						// ov}bv񖳂W{[XLjObV
						InputElement[ 0 ] = MakeD3D11InputElement( "POSITION",     0, D_DXGI_FORMAT_R32G32B32_FLOAT,    0, 0  ) ;
						InputElement[ 1 ] = MakeD3D11InputElement( "BLENDINDICES", 0, D_DXGI_FORMAT_R8G8B8A8_UINT,      0, 12 ) ;
						InputElement[ 2 ] = MakeD3D11InputElement( "BLENDINDICES", 1, D_DXGI_FORMAT_R8G8B8A8_UINT,      0, 16 ) ;
						InputElement[ 3 ] = MakeD3D11InputElement( "BLENDWEIGHT",  0, D_DXGI_FORMAT_R32G32B32A32_FLOAT, 0, 20 ) ;
						InputElement[ 4 ] = MakeD3D11InputElement( "BLENDWEIGHT",  1, D_DXGI_FORMAT_R32G32B32A32_FLOAT, 0, 36 ) ;
						InputElement[ 5 ] = MakeD3D11InputElement( "NORMAL",       0, D_DXGI_FORMAT_R32G32B32_FLOAT,    0, 52 ) ;
						InputElement[ 6 ] = MakeD3D11InputElement( "COLOR",        0, D_DXGI_FORMAT_R8G8B8A8_UNORM,     0, 64 ) ;
						InputElement[ 7 ] = MakeD3D11InputElement( "COLOR",        1, D_DXGI_FORMAT_R8G8B8A8_UNORM,     0, 68 ) ;
						offset = 72 ;
						index = 8 ;
						break ;
					}
				}
				else
				{
					switch( j )
					{
					case 0 :
						// ov}bvL荄̃bV
						InputElement[ 0 ] = MakeD3D11InputElement( "POSITION",     0, D_DXGI_FORMAT_R32G32B32_FLOAT,    0, 0  ) ;
						InputElement[ 1 ] = MakeD3D11InputElement( "TANGENT",      0, D_DXGI_FORMAT_R32G32B32_FLOAT,    0, 12 ) ;
						InputElement[ 2 ] = MakeD3D11InputElement( "BINORMAL",     0, D_DXGI_FORMAT_R32G32B32_FLOAT,    0, 24 ) ;
						InputElement[ 3 ] = MakeD3D11InputElement( "NORMAL",       0, D_DXGI_FORMAT_R32G32B32_FLOAT,    0, 36 ) ;
						InputElement[ 4 ] = MakeD3D11InputElement( "COLOR",        0, D_DXGI_FORMAT_R8G8B8A8_UNORM,     0, 48 ) ;
						InputElement[ 5 ] = MakeD3D11InputElement( "COLOR",        1, D_DXGI_FORMAT_R8G8B8A8_UNORM,     0, 52 ) ;
						offset = 56 ;
						index = 6 ;
						break ;

					case 1 :
						// ov}bvLS{[XLjObV
						InputElement[ 0 ] = MakeD3D11InputElement( "POSITION",     0, D_DXGI_FORMAT_R32G32B32_FLOAT,    0, 0  ) ;
						InputElement[ 1 ] = MakeD3D11InputElement( "BLENDINDICES", 0, D_DXGI_FORMAT_R8G8B8A8_UINT,      0, 12 ) ;
						InputElement[ 2 ] = MakeD3D11InputElement( "BLENDWEIGHT",  0, D_DXGI_FORMAT_R32G32B32A32_FLOAT, 0, 16 ) ;
						InputElement[ 3 ] = MakeD3D11InputElement( "TANGENT",      0, D_DXGI_FORMAT_R32G32B32_FLOAT,    0, 32 ) ;
						InputElement[ 4 ] = MakeD3D11InputElement( "BINORMAL",     0, D_DXGI_FORMAT_R32G32B32_FLOAT,    0, 44 ) ;
						InputElement[ 5 ] = MakeD3D11InputElement( "NORMAL",       0, D_DXGI_FORMAT_R32G32B32_FLOAT,    0, 56 ) ;
						InputElement[ 6 ] = MakeD3D11InputElement( "COLOR",        0, D_DXGI_FORMAT_R8G8B8A8_UNORM,     0, 68 ) ;
						InputElement[ 7 ] = MakeD3D11InputElement( "COLOR",        1, D_DXGI_FORMAT_R8G8B8A8_UNORM,     0, 72 ) ;
						offset = 76 ;
						index = 8 ;
						break ;

					case 2 :
						// ov}bvLW{[XLjObV
						InputElement[ 0 ] = MakeD3D11InputElement( "POSITION",     0, D_DXGI_FORMAT_R32G32B32_FLOAT,    0, 0  ) ;
						InputElement[ 1 ] = MakeD3D11InputElement( "BLENDINDICES", 0, D_DXGI_FORMAT_R8G8B8A8_UINT,      0, 12 ) ;
						InputElement[ 2 ] = MakeD3D11InputElement( "BLENDINDICES", 1, D_DXGI_FORMAT_R8G8B8A8_UINT,      0, 16 ) ;
						InputElement[ 3 ] = MakeD3D11InputElement( "BLENDWEIGHT",  0, D_DXGI_FORMAT_R32G32B32A32_FLOAT, 0, 20 ) ;
						InputElement[ 4 ] = MakeD3D11InputElement( "BLENDWEIGHT",  1, D_DXGI_FORMAT_R32G32B32A32_FLOAT, 0, 36 ) ;
						InputElement[ 5 ] = MakeD3D11InputElement( "TANGENT",      0, D_DXGI_FORMAT_R32G32B32_FLOAT,    0, 52 ) ;
						InputElement[ 6 ] = MakeD3D11InputElement( "BINORMAL",     0, D_DXGI_FORMAT_R32G32B32_FLOAT,    0, 64 ) ;
						InputElement[ 7 ] = MakeD3D11InputElement( "NORMAL",       0, D_DXGI_FORMAT_R32G32B32_FLOAT,    0, 76 ) ;
						InputElement[ 8 ] = MakeD3D11InputElement( "COLOR",        0, D_DXGI_FORMAT_R8G8B8A8_UNORM,     0, 88 ) ;
						InputElement[ 9 ] = MakeD3D11InputElement( "COLOR",        1, D_DXGI_FORMAT_R8G8B8A8_UNORM,     0, 92 ) ;
						offset = 96 ;
						index = 10 ;
						break ;
					}
				}

				Shader = GD3D11.Device.Shader.Model.MV1_LightingVertexShader[ 0 ][ j ][ i ][ 0 ][ 0 ][ 0 ] ;

				for( k = 0 ; k < 3 ; k ++ )
				{
					IE = &InputElement[ index ] ;
					for( l = 0 ; l < k ; l ++, IE ++ )
					{
						IE->SemanticName         = "TEXCOORD" ;
						IE->SemanticIndex        = ( UINT )l ;
						IE->Format               = D_DXGI_FORMAT_R32G32B32A32_FLOAT ;
						IE->InputSlot            = 0 ;
						IE->AlignedByteOffset    = ( WORD )( offset + sizeof( float ) * 4 * l ) ;
						IE->InputSlotClass       = D_D3D11_INPUT_PER_VERTEX_DATA ;
						IE->InstanceDataStepRate = 0 ;
					}

					D3D11Device_CreateInputLayout( InputElement, index + k, &GD3D9.Device.VertexDeclaration.MV1_VertexDeclaration[ i ][ j ][ k ] ) ;
				}
			}
		}
	}*/

	// I
	return 0 ;
}

// f`p ID3D11InputLayout IuWFNg̍폜( 0:  -1:s )
extern int Graphics_D3D11_InputLayout_Model_Terminate( void )
{
	return 0 ;
}

#endif // DX_NON_MODEL























// Direct3D11 ̕`揈֌W

#ifndef DX_NON_ASYNCLOAD
static int Graphics_D3D11_RenderVertexASyncCallback( ASYNCLOAD_MAINTHREAD_REQUESTINFO * /*Info*/ )
{
	return Graphics_D3D11_RenderVertex( FALSE ) ;
}
#endif // DX_NON_ASYNCLOAD

// _obt@ɗ܂_f[^_O
extern	int		Graphics_D3D11_RenderVertex( int ASyncThread )
{
#ifndef DX_NON_ASYNCLOAD
	if( ASyncThread )
	{
		ASYNCLOAD_MAINTHREAD_REQUESTINFO AInfo ;

		AInfo.Function = Graphics_D3D11_RenderVertexASyncCallback ;
		return AddASyncLoadRequestMainThreadInfo( &AInfo ) ;
	}
#endif // DX_NON_ASYNCLOAD
/*
	if( Graphics_Hardware_CheckValid_PF() == 0 ) return -1 ;

	// _`͍sȂ
	if( GD3D9.Device.DrawInfo.VertexNum != 0 && DxLib_GetEndRequest() == FALSE )
	{
		// Graphics_D3D9_BeginScene ĂȂ炷
		if( GD3D9.Device.DrawInfo.BeginSceneFlag == FALSE ) Graphics_D3D9_BeginScene() ;

		// `tOĂȂ΃_O
		if( GD3D9.Device.DrawInfo.BlendMaxNotDrawFlag == FALSE )
		{
			int PrimNum ;

			PrimNum = 0 ;
			switch( GD3D9.Device.DrawInfo.PrimitiveType )
			{
			case D_D3DPT_POINTLIST     : PrimNum = GD3D9.Device.DrawInfo.VertexNum ;     break ;
			case D_D3DPT_LINELIST      : PrimNum = GD3D9.Device.DrawInfo.VertexNum / 2 ; break ;
			case D_D3DPT_LINESTRIP     : PrimNum = GD3D9.Device.DrawInfo.VertexNum - 1 ; break ;
			case D_D3DPT_TRIANGLELIST  : PrimNum = GD3D9.Device.DrawInfo.VertexNum / 3 ; break ;
			case D_D3DPT_TRIANGLESTRIP : PrimNum = GD3D9.Device.DrawInfo.VertexNum - 2 ; break ;
			case D_D3DPT_TRIANGLEFAN   : PrimNum = GD3D9.Device.DrawInfo.VertexNum - 2 ; break ;
			}

//			SETFVF( D3DDev_VertexType[ GD3D9.Device.DrawInfo.Use3DVertex ][ GD3D9.Device.DrawInfo.VertexType ] );
//			Graphics_D3D9_DeviceState_SetFVF( D3DDev_VertexType[ GD3D9.Device.DrawInfo.Use3DVertex ][ GD3D9.Device.DrawInfo.VertexType ] ) ;
			Graphics_Hardware_D3D9_SetFVF_UseTable( D3DDev_VertexDeclaration[ GD3D9.Device.DrawInfo.Use3DVertex ][ GD3D9.Device.DrawInfo.VertexType ] ) ;
			if( GD3D9.Device.DrawInfo.Use3DVertex )
			{
				Graphics_D3D9_DeviceState_SetWorldMatrix( &GlobalIdentMatrix ) ;
			}
			Direct3DDevice9_DrawPrimitiveUP(
				GD3D9.Device.DrawInfo.PrimitiveType,
				PrimNum,
				GD3D9.Device.DrawInfo.VertexBufferAddr[ GD3D9.Device.DrawInfo.Use3DVertex ][ GD3D9.Device.DrawInfo.VertexType ],
				D3DDev_VertexSize[ GD3D9.Device.DrawInfo.Use3DVertex ][ GD3D9.Device.DrawInfo.VertexType ] ) ;

			if( GD3D9.Device.DrawInfo.Use3DVertex )
			{
				Graphics_D3D9_DeviceState_SetWorldMatrix( &GSYS.DrawSetting.WorldMatrix ) ;
			}
//			RenderVertexDrawPrimitive_PF() ;
		}
	}

	GD3D9.Device.DrawInfo.VertexNum = 0 ;
	GD3D9.Device.DrawInfo.VertexBufferNextAddr = GD3D9.Device.DrawInfo.VertexBufferAddr[ GD3D9.Device.DrawInfo.Use3DVertex ][ GD3D9.Device.DrawInfo.VertexType ] ;
*/
	// I
	return 0 ;
}

// `R}hJn
extern	void	Graphics_D3D11_RenderBegin( void )
{
	if( D3D11Device_IsValid() == 0 || GD3D11.Device.DrawInfo.BeginSceneFlag == TRUE ) return ;

//	D3D11DeviceContext_Begin() ;
	GD3D11.Device.DrawInfo.BeginSceneFlag = TRUE ;
	GD3D11.Device.DrawSetting.DrawPrepAlwaysFlag = TRUE ;
}

// `R}hI
extern	void	Graphics_D3D11_RenderEnd( void )
{
	if( D3D11Device_IsValid() == 0 || GD3D11.Device.DrawInfo.BeginSceneFlag == FALSE ) return ;

//	D3D11DeviceContext_End() ;
	GD3D11.Device.DrawInfo.BeginSceneFlag = FALSE ;
}




























// Direct3D11 g`֌W

// n[hEGAANZ[^gp DrawBillboard3D
extern	int		Graphics_D3D11_DrawBillboard3D( VECTOR Pos, float cx, float cy, float Size, float Angle, IMAGEDATA *Image, IMAGEDATA *BlendImage, int TransFlag, int TurnFlag, int DrawFlag, RECT *DrawArea )
{
	// I
	return 0 ;
}

// n[hEGAANZ[^gp DrawModiBillboard3D
extern	int		Graphics_D3D11_DrawModiBillboard3D( VECTOR Pos, float x1, float y1, float x2, float y2, float x3, float y3, float x4, float y4, IMAGEDATA *Image, IMAGEDATA *BlendImage, int TransFlag, int DrawFlag, RECT *DrawArea )
{
	// I
	return 0 ;
}

// n[hEGAANZ[^gp DrawGraph
extern	int		Graphics_D3D11_DrawGraph( int x, int y, float xf, float yf, IMAGEDATA *Image, IMAGEDATA *BlendImage, int TransFlag, int IntFlag )
{
	// I
	return 0 ;
}

// n[hEGAANZ[^gp DrawExtendGraph
extern	int		Graphics_D3D11_DrawExtendGraph( int x1, int y1, int x2, int y2, float x1f, float y1f, float x2f, float y2f, IMAGEDATA *Image, IMAGEDATA *BlendImage, int TransFlag, int IntFlag )
{
	// I
	return 0 ;
}

// n[hEGAANZ[^gp DrawRotaGraph
extern	int		Graphics_D3D11_DrawRotaGraph( int x, int y, float xf, float yf, double ExRate, double Angle, IMAGEDATA *Image, IMAGEDATA *BlendImage, int TransFlag, int TurnFlag, int IntFlag )
{
	// I
	return 0 ;
}

// n[hEGAANZ[^gp DrawModiGraph
extern	int		Graphics_D3D11_DrawModiGraph( int x1, int y1, int x2, int y2, int x3, int y3, int x4, int y4, IMAGEDATA *Image, IMAGEDATA *BlendImage, int TransFlag, bool SimpleDrawFlag )
{
	// I
	return 0 ;
}

// n[hEGAANZ[^gp DrawModiGraphF
extern	int		Graphics_D3D11_DrawModiGraphF( float x1, float y1, float x2, float y2, float x3, float y3, float x4, float y4, IMAGEDATA *Image, IMAGEDATA *BlendImage, int TransFlag, bool SimpleDrawFlag )
{
	// I
	return 0 ;
}

// QzIɔzuꂽ_f[^𒸓_obt@ɒǉ
static int SetPlaneVertexHardware( VERTEX_2D *GraphVert, int xnum, int ynum )
{
	// I
	return 0 ;
}

// eNX`ό`ĕ`悷
extern	void	Graphics_D3D11_DrawModiTex( float x1, float y1, float x2, float y2, float x3, float y3, float x4, float y4, IMAGEDATA_HARD_DRAW *DrawTex, bool SimpleDrawFlag )
{
}

// n[hEGAANZ[^gp DrawFillBox
extern	int		Graphics_D3D11_DrawFillBox( int x1, int y1, int x2, int y2, int Color )
{
	// I
	return 0 ;
}

// n[hEGAANZ[^gp DrawLineBox
extern	int		Graphics_D3D11_DrawLineBox( int x1, int y1, int x2, int y2, int Color )
{
	// I
	return 0 ;
}

// n[hEGAANZ[^gp DrawLine
extern	int		Graphics_D3D11_DrawLine( int x1, int y1, int x2, int y2, int Color )
{
	// I
	return 0 ;
}

// n[hEGAANZ[^gp DrawLine3D
extern	int		Graphics_D3D11_DrawLine3D( VECTOR Pos1, VECTOR Pos2, int Color, int DrawFlag, RECT *DrawArea )
{
	// I
	return 0 ;
}



#define CIRCLE_VERTEX_NUM			(2000)

#define DX_3D_CIRCLE_THICKNESS												\
	if( x1 < DrawRect.left      ) x1 = DrawRect.left ;						\
	if( x2 > DrawRect.right - 1 ) x2 = DrawRect.right - 1 ;					\
																			\
	VectBuf[ VectNum ].pos.x  = ( float )x1 ;								\
	VectBuf[ VectNum ].pos.y  = y1f ;										\
	VectBuf[ VectNum ].color = Color ;										\
	VectBuf[ VectNum ].rhw   = 1.0f ;										\
	*((DWORD *)&VectBuf[ VectNum ].pos.z) = drawz ;							\
	VectNum ++ ;															\
																			\
	VectBuf[ VectNum ].pos.x =  ( float )( x2 + 1 ) ;						\
	VectBuf[ VectNum ].pos.y =  y1f ;										\
	VectBuf[ VectNum ].color = Color ;										\
	VectBuf[ VectNum ].rhw   = 1.0f ;										\
	*((DWORD *)&VectBuf[ VectNum ].pos.z) = drawz ;							\
	VectNum  ++ ;															\
																			\
	if( VectNum >= CIRCLE_VERTEX_NUM )										\
	{																		\
		Direct3DDevice9_DrawPrimitiveUP( D_D3DPT_LINELIST, VectNum / 2, VectBuf, sizeof( VERTEX_NOTEX_2D ) ) ;\
		VectNum = 0 ;														\
	}																		

// n[hEGAANZ[^gp DrawCircle( w肠 )
extern	int		Graphics_D3D11_DrawCircle_Thickness( int x, int y, int r, int Color, int Thickness )
{
	// I
	return 0 ;
}

// n[hEGAANZ[^gp DrawOval( w肠 )
extern	int		Graphics_D3D11_DrawOval_Thickness( int x, int y, int rx, int ry, int Color, int Thickness )
{
	// I
	return 0 ;
}




#define DX_3D_CIRCLE																\
			if( !( ( x2 < DrawRect.left ) || ( x1 >= DrawRect.right  ) ||				\
			       ( y1 < DrawRect.top  ) || ( y1 >= DrawRect.bottom ) || LineDrawBuf[ y1 ] ) )			\
			{																			\
				if( x1 < DrawRect.left ) x1 = DrawRect.left ;							\
				if( x2 > DrawRect.right - 1 ) x2 = DrawRect.right - 1 ;					\
																						\
				VectBuf[ VectNum ].pos.x  = ( float )x1 ;								\
				VectBuf[ VectNum ].pos.y  = ( float )y1 ;								\
				VectBuf[ VectNum ].color = Color ;										\
				VectBuf[ VectNum ].rhw   = 1.0f ;										\
				*((DWORD *)&VectBuf[ VectNum ].pos.z) = drawz ;							\
				VectNum ++ ;															\
				LineDrawBuf[y1] = TRUE ;												\
																						\
				VectBuf[ VectNum ].pos.x =  ( float )( x2 + 1 );						\
				VectBuf[ VectNum ].pos.y =  ( float )y1 ;								\
				VectBuf[ VectNum ].color = Color ;										\
				VectBuf[ VectNum ].rhw   = 1.0f ;										\
				*((DWORD *)&VectBuf[ VectNum ].pos.z) = drawz ;							\
				VectNum  ++ ;															\
																						\
				if( VectNum >= CIRCLE_VERTEX_NUM )										\
				{																		\
					Direct3DDevice9_DrawPrimitiveUP( D_D3DPT_LINELIST, VectNum / 2, VectBuf, sizeof( VERTEX_NOTEX_2D ) ) ;\
					VectNum = 0 ;														\
				}																		\
			}

#define DX_3D_CIRCLE_PSET															\
			if( !( ( ( unsigned int )( x1 ) >= ( unsigned int )( DrawRect.right ) ) ||	\
				( y1 < DrawRect.top ) || ( y1 >= DrawRect.bottom ) ) )					\
			{																			\
				VectBuf[ VectNum ].pos.x  = ( float )x1 ;								\
				VectBuf[ VectNum ].pos.y  = ( float )y1 ;								\
				VectBuf[ VectNum ].color = Color ;										\
				VectBuf[ VectNum ].rhw   = 1.0f ;										\
				*((DWORD *)&VectBuf[ VectNum ].pos.z) = drawz ;							\
				VectNum ++ ;															\
																						\
				if( VectNum >= CIRCLE_VERTEX_NUM )										\
				{																		\
					Direct3DDevice9_DrawPrimitiveUP( D_D3DPT_POINTLIST, VectNum, VectBuf, sizeof( VERTEX_NOTEX_2D ) ) ;\
					VectNum = 0 ;														\
				}																		\
			}

// n[hEGAANZ[^gp DrawCircle
extern	int		Graphics_D3D11_DrawCircle( int x, int y, int r, int Color, int FillFlag )
{
	// I
	return 0 ;
}

// n[hEGAANZ[^gp DrawOval
extern	int		Graphics_D3D11_DrawOval( int x, int y, int rx, int ry, int Color, int FillFlag )
{
	// I
	return 0 ;
}

// n[hEGAANZ[^gp DrawTriangle
extern	int		Graphics_D3D11_DrawTriangle( int x1, int y1, int x2, int y2, int x3, int y3, int Color, int FillFlag )
{
	// I
	return 0 ;
}

// n[hEGAANZ[^gp DrawTriangle3D
extern	int		Graphics_D3D11_DrawTriangle3D( VECTOR Pos1, VECTOR Pos2, VECTOR Pos3, int Color, int FillFlag, int DrawFlag, RECT *DrawArea )
{
	// I
	return 0 ;
}

// n[hEGAANZ[^gp DrawQuadrangle
extern	int		Graphics_D3D11_DrawQuadrangle( int x1, int y1, int x2, int y2, int x3, int y3, int x4, int y4, int Color, int FillFlag )
{
	// I
	return 0 ;
}

// n[hEGAANZ[^gp DrawPixel
extern	int		Graphics_D3D11_DrawPixel( int x, int y, int Color )
{
	// I
	return 0 ;
}

// n[hEGAANZ[^gp DrawPixel3D
extern	int		Graphics_D3D11_DrawPixel3D( VECTOR Pos, int Color, int DrawFlag, RECT *DrawArea )
{
	// I
	return 0 ;
}

// n[hEGAANZ[^gp DrawPixelSet
extern	int		Graphics_D3D11_DrawPixelSet( const POINTDATA *PointData, int Num )
{
	// I
	return 0;
}

// n[hEGAANZ[^gp DrawLineSet
extern	int		Graphics_D3D11_DrawLineSet( const LINEDATA *LineData, int Num )
{
	// I
	return 0;
}
















extern	int		Graphics_D3D11_DrawPrimitive( const VERTEX_3D *Vertex, int VertexNum, int PrimitiveType, IMAGEDATA *Image, int TransFlag )
{
	// I
	return 0 ;
}

extern	int		Graphics_D3D11_DrawIndexedPrimitive( const VERTEX_3D *Vertex, int VertexNum, const WORD *Indices, int IndexNum, int PrimitiveType, IMAGEDATA *Image, int TransFlag )
{
	// I
	return 0 ;
}

extern	int		Graphics_D3D11_DrawPrimitiveLight( const VERTEX3D *Vertex, int VertexNum, int PrimitiveType, IMAGEDATA *Image, int TransFlag )
{
	// I
	return 0 ;
}

extern	int		Graphics_D3D11_DrawIndexedPrimitiveLight( const VERTEX3D *Vertex, int VertexNum, const WORD *Indices, int IndexNum, int PrimitiveType, IMAGEDATA *Image, int TransFlag )
{
	// I
	return 0 ;
}

extern	int		Graphics_D3D11_DrawPrimitiveLight_UseVertexBuffer( 
	VERTEXBUFFERHANDLEDATA *VertexBuffer,
	int						PrimitiveType,
	int						StartVertex,
	int						UseVertexNum,
	IMAGEDATA *			Image,
	int						TransFlag 
)
{
	// I
	return 0 ;
}

extern	int		Graphics_D3D11_DrawIndexedPrimitiveLight_UseVertexBuffer(
	VERTEXBUFFERHANDLEDATA *	VertexBuffer,
	INDEXBUFFERHANDLEDATA *		IndexBuffer,
	int							PrimitiveType,
	int							BaseVertex,
	int							StartVertex,
	int							UseVertexNum,
	int							StartIndex,
	int							UseIndexNum,
	IMAGEDATA *				Image,
	int							TransFlag
)
{
	// I
	return 0 ;
}

extern	int		Graphics_D3D11_DrawPrimitive2D( VERTEX_2D *Vertex, int VertexNum, int PrimitiveType, IMAGEDATA *Image, int TransFlag, int BillboardFlag, int Is3D, int TurnFlag, int TextureNo )
{
	// I
	return 0 ;
}

extern	int		Graphics_D3D11_DrawIndexedPrimitive2D( VERTEX_2D *Vertex, int VertexNum, WORD *Indices, int IndexNum, int PrimitiveType, IMAGEDATA *Image, int TransFlag )
{
	// I
	return 0 ;
}

extern	int		Graphics_D3D11_DrawPrimitive2DUser( const VERTEX2D *Vertex, int VertexNum, int PrimitiveType, IMAGEDATA *Image, int TransFlag, int Is3D, int TurnFlag, int TextureNo )
{
	// I
	return 0 ;
}

extern	int		Graphics_D3D11_DrawPrimitive2DUser_Billboard( VERTEX2D *Vertex, int VertexNum, int PrimitiveType, IMAGEDATA *Image, int TransFlag, int Is3D, int TurnFlag, int TextureNo )
{
	// I
	return 0 ;
}

extern	int		Graphics_D3D11_DrawIndexedPrimitive2DUser( const VERTEX2D *Vertex, int VertexNum, const WORD *Indices, int IndexNum, int PrimitiveType, IMAGEDATA *Image, int TransFlag )
{
	// I
	return 0 ;
}












// VF[_[`p`OZbgAbv֐
extern void Graphics_D3D11_DrawPreparationToShader( int ParamFlag, int UseVertexShaderNo, int Is2D, int UseLibSubShaderConst )
{
}


// VF[_[gĂQc|S`悷
extern	int		Graphics_D3D11_DrawPolygon2DToShader(          const VERTEX2DSHADER *Vertex, int PolygonNum )
{
	// I
	return 0 ;
}

// VF[_[gĂRc|S`悷
extern	int		Graphics_D3D11_DrawPolygon3DToShader(          const VERTEX3DSHADER *Vertex, int PolygonNum )
{
	// I
	return 0 ;
}

// VF[_[gĂQc|S`悷( _CfbNXgp )
extern	int		Graphics_D3D11_DrawPolygonIndexed2DToShader(   const VERTEX2DSHADER *Vertex, int VertexNum, const unsigned short *Indices, int PolygonNum )
{
	// I
	return 0 ;
}

// VF[_[gĂRc|S`悷( _CfbNXgp )
extern	int		Graphics_D3D11_DrawPolygonIndexed3DToShader(   const VERTEX3DSHADER *Vertex, int VertexNum, const unsigned short *Indices, int PolygonNum )
{
	// I
	return 0 ;
}

// VF[_[gĂQcv~eBu`悷
extern	int		Graphics_D3D11_DrawPrimitive2DToShader(        const VERTEX2DSHADER *Vertex, int VertexNum,                                              int PrimitiveType /* DX_PRIMTYPE_TRIANGLELIST  */ )
{
	// I
	return 0 ;
}

// VF[_[gĂRcv~eBu`悷
extern	int		Graphics_D3D11_DrawPrimitive3DToShader(        const VERTEX3DSHADER *Vertex, int VertexNum,                                              int PrimitiveType /* DX_PRIMTYPE_TRIANGLELIST  */ )
{
	// I
	return 0 ;
}

// VF[_[gĂQcv~eBu`悷( _CfbNXgp )
extern	int		Graphics_D3D11_DrawPrimitiveIndexed2DToShader( const VERTEX2DSHADER *Vertex, int VertexNum, const unsigned short *Indices, int IndexNum, int PrimitiveType /* DX_PRIMTYPE_TRIANGLELIST  */ )
{
	// I
	return 0 ;
}

// VF[_[gĂRcv~eBu`悷( _CfbNXgp )
extern	int		Graphics_D3D11_DrawPrimitiveIndexed3DToShader( const VERTEX3DSHADER *Vertex, int VertexNum, const unsigned short *Indices, int IndexNum, int PrimitiveType /* DX_PRIMTYPE_TRIANGLELIST  */ )
{
	// I
	return 0 ;
}

// VF[_[gĂRcv~eBu`悷( _obt@gp )
extern	int		Graphics_D3D11_DrawPrimitive3DToShader_UseVertexBuffer(         int VertexBufHandle,                     int PrimitiveType /* DX_PRIMTYPE_TRIANGLELIST  */ )
{
	VERTEXBUFFERHANDLEDATA *VertexBuffer ;

	// G[
	if( VERTEXBUFFERCHK( VertexBufHandle, VertexBuffer ) )
		return -1 ;

	return NS_DrawPrimitive3DToShader_UseVertexBuffer2( VertexBufHandle, PrimitiveType, 0, VertexBuffer->Num ) ;
}

// VF[_[gĂRcv~eBu`悷( _obt@ƃCfbNXobt@gp )
extern	int		Graphics_D3D11_DrawPrimitiveIndexed3DToShader_UseVertexBuffer(  int VertexBufHandle, int IndexBufHandle, int PrimitiveType /* DX_PRIMTYPE_TRIANGLELIST  */ )
{
	VERTEXBUFFERHANDLEDATA *VertexBuffer ;
	INDEXBUFFERHANDLEDATA *IndexBuffer ;

	// G[
	if( VERTEXBUFFERCHK( VertexBufHandle, VertexBuffer ) )
		return -1 ;
	if( INDEXBUFFERCHK( IndexBufHandle, IndexBuffer ) )
		return -1 ;

	return NS_DrawPrimitiveIndexed3DToShader_UseVertexBuffer2( VertexBufHandle, IndexBufHandle, PrimitiveType, 0, 0, VertexBuffer->Num, 0, IndexBuffer->Num ) ;
}

// VF[_[gĂRcv~eBu`悷( _obt@gp )
extern	int		Graphics_D3D11_DrawPrimitive3DToShader_UseVertexBuffer2(        int VertexBufHandle,                     int PrimitiveType /* DX_PRIMTYPE_TRIANGLELIST  */, int StartVertex, int UseVertexNum )
{
	// I
	return 0 ;
}

// VF[_[gĂRcv~eBu`悷( _obt@ƃCfbNXobt@gp )
extern	int		Graphics_D3D11_DrawPrimitiveIndexed3DToShader_UseVertexBuffer2( int VertexBufHandle, int IndexBufHandle, int PrimitiveType /* DX_PRIMTYPE_TRIANGLELIST  */, int BaseVertex, int StartVertex, int UseVertexNum, int StartIndex, int UseIndexNum )
{
	// I
	return 0 ;
}
















// Direct3D ̃A_v^񋓂
static int EnumDirect3DAdapter()
{
	// I
	return 0 ;
}





















// ˑ֌W

// `揈̊ˑ̏s֐( sӏʂO )
extern	int		Graphics_D3D11_Initialize_Timing0_PF( void )
{
	// Direct3D11 gpOtBbNX̏
	if( Graphics_D3D11_Initialize() == -1 )
	{
		return -1 ;
	}

	// I
	return 0 ;
}

// `揈̊ˑ̏s֐( sӏʂQ )
extern	int		Graphics_D3D11_Initialize_Timing1_PF( void )
{
	// foCX̐ݒtbV
	Graphics_D3D11_DeviceState_RefreshRenderState() ;

	// I
	return 0 ;
}

// n[hEGAANZ[^gpꍇ̊ˑ̏s
extern	int		Graphics_D3D11_Hardware_Initialize_PF( void )
{
	return 0 ;
}

// `揈̊ˑ̌ns֐
extern	int		Graphics_D3D11_Terminate_PF( void )
{
	// I
	return 0 ;
}

// OtBbNXVXe̕AA͕ύXt̍ăZbgAbvs
extern	int		Graphics_D3D11_RestoreOrChangeSetupGraphSystem_PF( int Change, int ScreenSizeX, int ScreenSizeY, int ColorBitDepth, int RefreshRate )
{
	// I
	return 0 ;
}

// `pfoCXLǂ擾( ߂l  TRUE:L  FALSE: )
extern	int		Graphics_D3D11_Hardware_CheckValid_PF( void )
{
	return D3D11Device_IsValid() ;
}

// DirectX ̃IuWFNg
extern	void	Graphics_D3D11_ReleaseDirectXObject_PF( void )
{
}























// ˑ`ݒ֌W

// VF[_[`ł̕`ݒ肷
extern	int		Graphics_Hardware_D3D11_SetRenderTargetToShader_PF( int TargetIndex, int DrawScreen, int SurfaceIndex )
{
	// I
	return 0 ;
}

// SetDrawBright ̈
extern	int		Graphics_Hardware_D3D11_SetDrawBrightToOneParam_PF( DWORD Bright )
{
	// I
	return 0 ;
}

// `uh[hZbg
extern	int		Graphics_Hardware_D3D11_SetDrawBlendMode_PF( int BlendMode, int BlendParam )
{
	// I
	return 0 ;
}

// `掞̃At@eXg̐ݒs( TestMode:DX_CMP_GREATER( -1:ftHgɖ߂ )  TestParam:`At@lƂ̔rɎgpl )
extern	int		Graphics_Hardware_D3D11_SetDrawAlphaTest_PF( int TestMode, int TestParam )
{
	// I
	return 0 ;
}

// `惂[hZbg
extern	int		Graphics_Hardware_D3D11_SetDrawMode_PF( int DrawMode )
{
	// I
	return 0 ;
}

// `PxZbg
extern	int		Graphics_Hardware_D3D11_SetDrawBright_PF( int RedBright, int GreenBright, int BlueBright )
{
	// I
	return 0 ;
}

// SetBlendGraphParam ̉ϒp[^t
extern	int		Graphics_Hardware_D3D11_SetBlendGraphParamBase_PF( IMAGEDATA *BlendImage, int BlendType, int *Param )
{
	// I
	return 0 ;
}

// őٕ̒lZbg
extern	int		Graphics_Hardware_D3D11_SetMaxAnisotropy_PF( int MaxAnisotropy )
{
	// I
	return 0 ;
}

// [hϊpsZbg
extern	int		Graphics_Hardware_D3D11_SetTransformToWorld_PF( const MATRIX *Matrix )
{
	// I
	return 0 ;
}

// r[ϊpsZbg
extern	int		Graphics_Hardware_D3D11_SetTransformToView_PF( const MATRIX *Matrix )
{
	// I
	return 0 ;
}

// eϊpsZbg
extern	int		Graphics_Hardware_D3D11_SetTransformToProjection_PF( const MATRIX *Matrix )
{
	// I
	return 0 ;
}

// r[|[gsZbg
extern	int		Graphics_Hardware_D3D11_SetTransformToViewport_PF( const MATRIX *Matrix )
{
	// I
	return 0 ;
}

// eNX`AhX[hݒ肷
extern	int		Graphics_Hardware_D3D11_SetTextureAddressMode_PF( int Mode /* DX_TEXADDRESS_WRAP  */, int Stage )
{
	// I
	return 0 ;
}

// eNX`AhX[hݒ肷
extern	int		Graphics_Hardware_D3D11_SetTextureAddressModeUV_PF( int ModeU, int ModeV, int Stage )
{
	// I
	return 0 ;
}

// eNX`WϊsZbg
extern	int		Graphics_Hardware_D3D11_SetTextureAddressTransformMatrix_PF( int UseFlag, MATRIX *Matrix, int Sampler )
{
	// I
	return 0 ;
}

// tHOLɂ邩ǂݒ肷( TRUE:L  FALSE: )
extern	int		Graphics_Hardware_D3D11_SetFogEnable_PF( int Flag )
{
	// I
	return 0 ;
}

// tHO[hݒ肷
extern	int		Graphics_Hardware_D3D11_SetFogMode_PF( int Mode /* DX_FOGMODE_NONE  */ )
{
	// I
	return 0 ;
}

// tHOJ[ύX
extern	int		Graphics_Hardware_D3D11_SetFogColor_PF( DWORD FogColor )
{
	// I
	return 0 ;
}

// tHOn܂鋗ƏI鋗ݒ肷( 0.0f ` 1.0f )
extern	int		Graphics_Hardware_D3D11_SetFogStartEnd_PF( float start, float end )
{
	// I
	return 0 ;
}

// tHO̖xݒ肷( 0.0f ` 1.0f )
extern	int		Graphics_Hardware_D3D11_SetFogDensity_PF( float density )
{
	// I
	return 0 ;
}

// {f[^ɐݒ肳ĂtHOn[hEFAɔf
extern	int		Graphics_Hardware_D3D11_ApplyLigFogToHardware_PF( void )
{
	// I
	return 0 ;
}

// ȑO DrawModiGraph ֐̃R[hgp邩ǂ̃tOZbg
extern	int		Graphics_Hardware_D3D11_SetUseOldDrawModiGraphCodeFlag_PF( int Flag )
{
	// I
	return 0 ;
}

// `ɐlނǂ̃tOXV
extern	int		Graphics_Hardware_D3D11_RefreshAlphaChDrawMode_PF( void )
{
	// I
	return 0 ;
}

// gpˉesRcpɂ邩Qcpɂ邩ݒ肷
extern	void	Graphics_Hardware_D3D11_SetUse2DProjectionMatrix_PF( int Use2DProjectionMatrix )
{
}
























// ˑݒ֌W

// n[hEGA̒_Z@\gp邩ǂݒ肷
extern	int		Graphics_Hardware_D3D11_SetUseHardwareVertexProcessing_PF( int Flag )
{
	// I
	return 0 ;
}

// sNZPʂŃCeBOsǂݒ肷Av ShaderModel 3.0( TRUE:sNZPʂ̃CeBOs  FALSE:_Pʂ̃CeBOs( ftHg ) )
extern	int		Graphics_Hardware_D3D11_SetUsePixelLighting_PF( int Flag )
{
	// I
	return 0 ;
}

// OtBbNXfoCXXg畜AۂɌĂ΂R[obN֐ݒ肷
extern	int		Graphics_Hardware_D3D11_SetGraphicsDeviceRestoreCallbackFunction_PF( void (* Callback )( void *Data ), void *CallbackData )
{
	// I
	return 0 ;
}

// OtBbNXfoCXXg畜AOɌĂ΂R[obN֐ݒ肷
extern	int		Graphics_Hardware_D3D11_SetGraphicsDeviceLostCallbackFunction_PF( void (* Callback )( void *Data ), void *CallbackData )
{
	// I
	return 0 ;
}

// ʏ`ɃvO}uVF[_[gp邩ǂݒ肷( TRUE:gp( ftHg )  FALSE:gpȂ )
extern	int		Graphics_Hardware_D3D11_SetUseNormalDrawShader_PF( int Flag )
{
	// I
	return 0 ;
}

// DirectDraw  Direct3D ̋x}`XbhΉɂ邩ǂZbg
extern	int		Graphics_Hardware_D3D11_SetMultiThreadFlag_PF( int Flag )
{
	// I
	return 0 ;
}

// rfI̗eʂ𓾂
extern	int		Graphics_Hardware_D3D11_GetVideoMemorySize_PF( int *AllSize, int *FreeSize )
{
	return 0 ;
}

// gp̂cRccXIuWFNg𓾂
extern	const D_IDirect3DDevice9 * Graphics_Hardware_D3D11_GetUseDirect3DDevice9_PF( void )
{
	return 0 ;
}

// gp̃obNobt@Direct3DSurface9IuWFNg擾
extern	const D_IDirect3DSurface9* Graphics_Hardware_D3D11_GetUseDirect3D11BackBufferSurface_PF( void )
{
	return 0 ;
}

// cwCûcRcݒȂ
extern	int		Graphics_Hardware_D3D11_RefreshDxLibDirect3DSetting_PF( void )
{
	// I
	return 0 ;
}

// ccgpftchݒ肷
extern	int		Graphics_D3D11_SetDDrawUseGuid_PF( const GUID FAR *Guid )
{
	// I
	return 0 ;
}

// L DirectDraw foCX GUID 擾
extern	const GUID *Graphics_D3D11_GetDirectDrawDeviceGUID_PF( int Number )
{
	return 0 ;
}

// L DirectDraw foCX̖O𓾂
extern	int		Graphics_D3D11_GetDirectDrawDeviceDescription_PF( int Number, char *StringBuffer )
{
	// I
	return 0 ;
}

// L DirectDraw foCX̐擾
extern	int		Graphics_D3D11_GetDirectDrawDeviceNum_PF( void )
{
	return 0 ;
}

// gp DirectDraw foCX̃CfbNXݒ肷
extern	int		Graphics_D3D11_SetUseDirectDrawDeviceIndex_PF( int Index )
{
	// I
	return 0 ;
}

// Vistaȍ~̊ Direct3D11Ex gp邩ǂݒ肷( TRUE:gp( ftHg )  FALSE:gpȂ )
extern	int		Graphics_D3D11_SetUseDirect3D11Ex_PF( int Flag )
{
	// I
	return 0 ;
}
































// ˑʊ֌W

// ݒɊÂĎgpyobt@Zbg
extern	int		Graphics_Hardware_D3D11_SetupUseZBuffer_PF( void )
{
	// I
	return 0 ;
}

// ʂ̂yobt@̏Ԃ
extern	int		Graphics_Hardware_D3D11_ClearDrawScreenZBuffer_PF( const RECT *ClearRect )
{
	// I
	return 0 ;
}

// ʂ̏Ԃ
extern	int		Graphics_Hardware_D3D11_ClearDrawScreen_PF( const RECT *ClearRect )
{
	// I
	return 0 ;
}

// `ʂ̃Zbg
extern	int		Graphics_Hardware_D3D11_SetDrawScreen_PF( int DrawScreen, int OldScreenSurface, IMAGEDATA *NewTargetImage, IMAGEDATA *OldTargetImage, SHADOWMAPDATA *NewTargetShadowMap, SHADOWMAPDATA *OldTargetShadowMap )
{
	// I
	return 0 ;
}

// SetDrawScreen ̍ŌŌĂ΂֐
extern	int		Graphics_Hardware_D3D11_SetDrawScreen_Post_PF( int DrawScreen )
{
	// I
	return 0 ;
}

// `\̈̃Zbg
extern	int		Graphics_Hardware_D3D11_SetDrawArea_PF( int x1, int y1, int x2, int y2 )
{
	// I
	return 0 ;
}

// `obt@bN
extern	int		Graphics_Hardware_D3D11_LockDrawScreenBuffer_PF( RECT *LockRect, BASEIMAGE *BaseImage, int TargetScreen, IMAGEDATA *TargetImage, int TargetScreenSurface, int ReadOnly, int TargetScreenTextureNo )
{
	// I
	return 0 ;
}

// `obt@AbN
extern	int		Graphics_Hardware_D3D11_UnlockDrawScreenBuffer_PF( void )
{
	// I
	return 0 ;
}

// ʂ̓e\ʂɕ`悷
extern	int		Graphics_Hardware_D3D11_ScreenCopy_PF( void )
{
	// I
	return 0 ;
}

// ݕ`ΏۂɂȂĂʂۑ
extern	int		Graphics_Hardware_D3D11_SaveDrawScreen_Begin_PF( int x1, int y1, int x2, int y2, BASEIMAGE *BaseImage )
{
	// I
	return 0 ;
}

// ݕ`ΏۂɂȂĂʂۑ
extern	int		Graphics_Hardware_D3D11_SaveDrawScreen_Post_PF( void )
{
	// I
	return 0 ;
}

// M҂
extern	int		Graphics_Hardware_D3D11_WaitVSync_PF( int SyncNum )
{
	return 0 ;
}

// ʂƕ\ʂ
extern	int		Graphics_Hardware_D3D11_ScreenFlipBase_PF( void )
{
	return 0 ;
}

// ʂ̎ẅ̗EChẼNCAg̈̎ẅ̗ɓ]
extern	int		Graphics_Hardware_D3D11_BltRectBackScreenToWindow_PF( HWND Window, RECT BackScreenRect, RECT WindowClientRect )
{
	return 0 ;
}

// ScreenFlip ŉ摜]̃EChEݒ肷( NULL w肷Ɛݒ )
extern	int		Graphics_Hardware_D3D11_SetScreenFlipTargetWindow_PF( HWND TargetWindow )
{
	return 0 ;
}

// Cʂ̂yobt@̐ݒύX
extern	int		Graphics_Hardware_D3D11_SetZBufferMode_PF( int ZBufferSizeX, int ZBufferSizeY, int ZBufferBitDepth )
{
	// I
	return 0 ;
}

// `yobt@̃Zbg
extern	int		Graphics_Hardware_D3D11_SetDrawZBuffer_PF( int DrawScreen, IMAGEDATA *Image )
{
	// I
	return 0 ;
}
























// ˑ擾֌W

// GetColor  GetColor2 ŎgpJ[f[^擾
extern const COLORDATA *Graphics_Hardware_D3D11_GetMainColorData_PF( void )
{
	return 0 ;
}

// fBXv[̃J[f[^|C^𓾂
extern	const COLORDATA *Graphics_Hardware_D3D11_GetDispColorData_PF( void )
{
	return 0 ;
}

// wW̐F擾
extern	int Graphics_Hardware_D3D11_GetPixel_PF( int x, int y )
{
	return 0 ;
}


























// ˑ摜֌W

// YUVT[tFXg Theora ̓eOtBbNXnh̃eNX`ɓ]
extern	int		Graphics_Hardware_D3D11_UpdateGraphMovie_TheoraYUV_PF( MOVIEGRAPH *Movie, IMAGEDATA *Image )
{
	// I
	return 0 ;
}

// OtBbN̈̃bN
extern	int		Graphics_Hardware_D3D11_GraphLock_PF( IMAGEDATA *Image, COLORDATA **ColorDataP )
{
	// I
	return 0 ;
}

// OtBbN̈̃bN
extern	int		Graphics_Hardware_D3D11_GraphUnlock_PF( IMAGEDATA *Image )
{
	// I
	return 0 ;
}

// OtBbN̂yobt@̏Ԃʂ̃OtBbN̂yobt@ɃRs[( DestGrHandle  SrcGrHandle yobt@Ă`\摜ŁAA`GCAX摜ł͂ȂƂ )
extern	int		Graphics_Hardware_D3D11_CopyGraphZBufferImage_PF( IMAGEDATA *DestImage, IMAGEDATA *SrcImage )
{
	// I
	return 0 ;
}

// 摜f[^̏
extern	int		Graphics_Hardware_D3D11_InitGraph_PF( void )
{
	// I
	return 0 ;
}

// OtBbN̐FœhԂ
extern	int		Graphics_Hardware_D3D11_FillGraph_PF( IMAGEDATA *Image, int Red, int Green, int Blue, int Alpha, int ASyncThread )
{
	// I
	return 0 ;
}

// `\摜obNobt@ẅ̃OtBbN擾
extern	int		Graphics_Hardware_D3D11_GetDrawScreenGraphBase_PF( IMAGEDATA *Image, IMAGEDATA *TargetImage, int TargetScreen, int TargetScreenSurface, int TargetScreenWidth, int TargetScreenHeight, int x1, int y1, int x2, int y2, int destX, int destY )
{
	// I
	return 0 ;
}

static int Graphics_D3D11_BltBmpOrBaseImageToGraph3_MipMapBlt(
	      IMAGEDATA_ORIG			*Orig,
	const RECT						*SrcRect,
	const RECT						*DestRect,
	      int						UseSysMemSurface,
	      D_IDirect3DBaseTexture9	*UseTex,
	      int						TexWidth,
	      int						TexHeight,
	const BASEIMAGE					*RgbBaseImage,
	const BASEIMAGE					*AlphaBaseImage,
	const COLORDATA					*DestColor,
	      int						RedIsAlphaFlag,
	      int						UseTransColorConvAlpha,
	      int						ASyncThread
)
{
	// I
	return 0 ;
}

static int Graphics_D3D11_BltBmpOrBaseImageToGraph3_NoMipMapBlt(
	      IMAGEDATA_ORIG			*Orig,
	const RECT						*SrcRect,
	const RECT						*DestRect,
	      int						UseSysMemSurface,
	      D_IDirect3DBaseTexture9	*UseTex,
	      int						TexWidth,
	      int						TexHeight,
	      int						TexUseWidth,
	      int						TexUseHeight,
	const BASEIMAGE					*RgbBaseImage,
	const BASEIMAGE					*AlphaBaseImage,
	const COLORDATA					*DestColor,
	      int						RedIsAlphaFlag,
	      int						UseTransColorConvAlpha,
	      int						ASyncThread
)
{
	// I
	return 0 ;
}

// Direct3D11 ̃OtBbNnhɉ摜f[^]邽߂̊֐
extern	int		Graphics_Hardware_D3D11_BltBmpOrBaseImageToGraph3_PF(
	const RECT		*SrcRect,
	      int		DestX,
	      int		DestY,
	      int		GrHandle,
	const BASEIMAGE	*RgbBaseImage,
	const BASEIMAGE	*AlphaBaseImage,
	      int		RedIsAlphaFlag,
	      int		UseTransColorConvAlpha,
	      int		TargetOrig,
	      int		ASyncThread
)
{
	return -1 ;
}

// IWi摜񒆂̃eNX`쐬( 0:  -1:s )
extern	int		Graphics_Hardware_D3D11_CreateOrigTexture_PF(  IMAGEDATA_ORIG *Orig, int ASyncThread )
{
	// I
	return 0 ;
}

// IWi摜񒆂̃eNX`
extern	int		Graphics_Hardware_D3D11_ReleaseOrigTexture_PF( IMAGEDATA_ORIG *Orig )
{
	// I
	return 0 ;
}

// w̃}`TvŎgpłőNIeBl擾
extern	int		Graphics_Hardware_D3D11_GetMultiSampleQuality_PF( int Samples )
{
	return 0 ;
}




























// ˑ_obt@ECfbNXobt@֌W

// _obt@nh̒_obt@쐬
extern	int		Graphics_Hardware_D3D11_VertexBuffer_Create_PF( VERTEXBUFFERHANDLEDATA *VertexBuffer, int VertexSize, int VertexNum, int VertexType /* DX_VERTEX_TYPE_NORMAL_3D  */ )
{
	// I
	return 0 ;
}

// _obt@nȟn
extern	int		Graphics_Hardware_D3D11_VertexBuffer_Terminate_PF( VERTEXBUFFERHANDLEDATA *VertexBuffer )
{
	// I
	return 0 ;
}

// _obt@ɒ_f[^]
extern	int		Graphics_Hardware_D3D11_VertexBuffer_SetData_PF( VERTEXBUFFERHANDLEDATA *VertexBuffer, int SetIndex, const void *VertexData, int VertexNum )
{
	// I
	return 0 ;
}

// CfbNXobt@nh̃ZbgAbvs
extern	int		Graphics_Hardware_D3D11_IndexBuffer_Create_PF( INDEXBUFFERHANDLEDATA *IndexBuffer, int IndexSize, int IndexNum, int IndexType /* DX_INDEX_TYPE_16BIT  */ )
{
	// I
	return 0 ;
}

// CfbNXobt@nȟn
extern	int		Graphics_Hardware_D3D11_IndexBuffer_Terminate_PF( INDEXBUFFERHANDLEDATA *IndexBuffer )
{
	// I
	return 0 ;
}

// CfbNXobt@ɃCfbNXf[^]
extern	int		Graphics_Hardware_D3D11_IndexBuffer_SetData_PF( INDEXBUFFERHANDLEDATA *IndexBuffer, int SetIndex, const void *IndexData, int IndexNum )
{
	// I
	return 0 ;
}























// ˑCg֌W

// CeBOsǂݒ肷
extern	int		Graphics_Hardware_D3D11_Light_SetUse_PF( int Flag )
{
	return 0 ;
}

// O[oArGgCgJ[ݒ肷
extern	int		Graphics_Hardware_D3D11_Light_GlobalAmbient_PF( COLOR_F *Color )
{
	return 0 ;
}

// Cgp[^Zbg
extern	int		Graphics_Hardware_D3D11_Light_SetState_PF( int LightNumber, LIGHTPARAM *LightParam )
{
	return 0 ;
}

// Cg̗LAύX
extern	int		Graphics_Hardware_D3D11_Light_SetEnable_PF( int LightNumber, int EnableState )
{
	return 0 ;
}




























// ˑVhE}bv֌W

// VhE}bvf[^ɕKvȃeNX`쐬
extern	int		Graphics_Hardware_D3D11_ShadowMap_CreateTexture_PF( SHADOWMAPDATA *ShadowMap, int ASyncThread )
{
	// I
	return 0 ;
}

// VhE}bvf[^ɕKvȃeNX`
extern	int		Graphics_Hardware_D3D11_ShadowMap_ReleaseTexture_PF( SHADOWMAPDATA *ShadowMap )
{
	// I
	return 0 ;
}

// _VF[_[ɐݒ肷VhE}bv̏XV
extern	void	Graphics_Hardware_D3D11_ShadowMap_RefreshVSParam_PF( void )
{
}

// sNZVF[_[ɐݒ肷VhE}bv̏XV
extern	void	Graphics_Hardware_D3D11_ShadowMap_RefreshPSParam_PF( void )
{
}

// VhE}bvւ̕`̏s
extern	int		Graphics_Hardware_D3D11_ShadowMap_DrawSetup_PF( SHADOWMAPDATA *ShadowMap )
{
	// I
	return 0 ;
}

// VhE}bvւ̕`I
extern	int		Graphics_Hardware_D3D11_ShadowMap_DrawEnd_PF( SHADOWMAPDATA *ShadowMap )
{
	// I
	return 0 ;
}

// `ŎgpVhE}bvw肷( Xbg͂OPw\ )
extern	int		Graphics_Hardware_D3D11_ShadowMap_SetUse_PF( int SlotIndex, SHADOWMAPDATA *ShadowMap )
{
	// I
	return 0 ;
}































// ˑVF[_[֌W

// VF[_[nh
extern	int		Graphics_Hardware_D3D11_Shader_Create_PF( int ShaderHandle, int IsVertexShader, void *Image, int ImageSize, int ImageAfterFree, int ASyncThread )
{
	// I
	return 0 ;
}

// VF[_[nȟn
extern	int		Graphics_Hardware_D3D11_Shader_TerminateHandle_PF( SHADERHANDLEDATA *Shader )
{
	// I
	return 0 ;
}

// gpłVF[_[̃o[W擾( 0=gȂ  200=VF[_[fQDOgp\  300=VF[_[fRDOgp\ )
extern	int		Graphics_Hardware_D3D11_Shader_GetValidShaderVersion_PF( void )
{
	return 0 ;
}

// w̖O萔gpVF[_[萔̔ԍ擾
extern	int		Graphics_Hardware_D3D11_Shader_GetConstIndex_PF( const TCHAR *ConstantName, SHADERHANDLEDATA *Shader )
{
	return 0 ;
}

// w̖O萔gpVF[_[萔̐擾
extern	int		Graphics_Hardware_D3D11_Shader_GetConstCount_PF( const TCHAR *ConstantName, SHADERHANDLEDATA *Shader )
{
	return 0 ;
}

// w̖O_萔̃ftHgp[^i[Ă郁AhX擾
extern	const FLOAT4 *Graphics_Hardware_D3D11_Shader_GetConstDefaultParamF_PF( const TCHAR *ConstantName, SHADERHANDLEDATA *Shader )
{
	return 0 ;
}

// VF[_[萔ݒ肷
extern	int		Graphics_Hardware_D3D11_Shader_SetConst_PF( int TypeIndex, int SetIndex, int ConstantIndex, const void *Param, int ParamNum, int UpdateUseArea )
{
	// I
	return 0 ;
}

// ẅ̃VF[_[萔Zbg
extern	int		Graphics_Hardware_D3D11_Shader_ResetConst_PF( int TypeIndex, int SetIndex, int ConstantIndex, int ParamNum )
{
	// I
	return 0 ;
}

// Rcfp̃VF[_[R[h̏s
extern	int		Graphics_Hardware_D3D11_Shader_ModelCode_Init_PF( void )
{
	// I
	return 0 ;
}




































// ˑ`֌W

// w_狫EFƂ܂œhԂ
extern	int		Graphics_Hardware_D3D11_Paint_PF( int x, int y, int FillColor, int BoundaryColor )
{
	// I
	return 0 ;
}


























#ifdef DX_USE_NAMESPACE

}

#endif // DX_USE_NAMESPACE

#endif // DX_NON_DIRECT3D11



